SystemOrganization addCategory: #'XML-Tests-Parser'!
SystemOrganization addCategory: 'XML-Tests-Parser-DOM'!
SystemOrganization addCategory: 'XML-Tests-Parser-Factories'!

XMLDocument subclass: #XMLFDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Factories'!

!XMLFDocument commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLDocument!

SAXHandler subclass: #SAXElementEventRecordingHandler
	instanceVariableNames: 'messageRecorder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!SAXElementEventRecordingHandler commentStamp: 'monty 6/18/2015 00:41' prior: 0!
This class records the final element events (startElement:attributes: and #endElement:) used when no others are defined.!

!SAXElementEventRecordingHandler methodsFor: 'handling - content' stamp: 'monty 4/12/2015 08:07'!
endElement: aQualifiedName
	self messageRecorder
		recordMessageReceiver: self
		selector: #endElement:
		arguments: (Array with: aQualifiedName)! !

!SAXElementEventRecordingHandler methodsFor: 'accessing' stamp: 'monty 4/12/2015 08:04'!
messageRecorder
	^ messageRecorder ifNil: [messageRecorder := XMLMessageRecorder new]! !

!SAXElementEventRecordingHandler methodsFor: 'handling - content' stamp: 'monty 4/12/2015 08:06'!
startElement: aQualifiedName attributes: aDictionary
	self messageRecorder
		recordMessageReceiver: self
		selector: #startElement:attributes:
		arguments: (Array with: aQualifiedName with: aDictionary)! !

SAXElementEventRecordingHandler subclass: #SAXElementPrefixURIEventRecordingHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!SAXElementPrefixURIEventRecordingHandler commentStamp: 'monty 6/18/2015 00:41' prior: 0!
This class records the second element events (#startElement:prefix:uri:attributes: and #endElement:prefix:uri:) used when the first aren't defined.!

!SAXElementPrefixURIEventRecordingHandler methodsFor: 'handling - content' stamp: 'monty 4/12/2015 08:08'!
endElement: aQualifiedName prefix: aPrefix uri: aURI
	self messageRecorder
		recordMessageReceiver: self
		selector: #endElement:prefix:uri:
		arguments:
			(Array
				with: aQualifiedName
				with: aPrefix
				with: aURI)! !

!SAXElementPrefixURIEventRecordingHandler methodsFor: 'handling - content' stamp: 'monty 4/12/2015 08:08'!
startElement: aQualifiedName prefix: aPrefix uri: aURI attributes: aDictionary
	self messageRecorder
		recordMessageReceiver: self
		selector: #startElement:prefix:uri:attributes:
		arguments:
			(Array
				with: aQualifiedName
				with: aPrefix
				with: aURI
				with: aDictionary)! !

SAXElementPrefixURIEventRecordingHandler subclass: #SAXElementPrefixURILocalNameEventRecordingHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!SAXElementPrefixURILocalNameEventRecordingHandler commentStamp: 'monty 6/18/2015 00:57' prior: 0!
This class records the first element events (#startElement:prefix:uri:attributes:localName: and #endElement:prefix:uri:localName:) sent before the others.!

!SAXElementPrefixURILocalNameEventRecordingHandler methodsFor: 'handling - content' stamp: 'monty 4/12/2015 10:09'!
endElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName
	self messageRecorder
		recordMessageReceiver: self
		selector: #endElement:prefix:uri:localName:
		arguments:
			(Array
				with: aQualifiedName
				with: aPrefix
				with: aURI
				with: aLocalName)! !

!SAXElementPrefixURILocalNameEventRecordingHandler methodsFor: 'handling - content' stamp: 'monty 4/13/2015 02:31'!
startElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName attributes: aDictionary
	self messageRecorder
		recordMessageReceiver: self
		selector: #startElement:prefix:uri:localName:attributes:
		arguments:
			(OrderedCollection new
				add: aQualifiedName;
				add: aPrefix;
				add: aURI;
				add: aLocalName;
				add: aDictionary;
				asArray)! !

XMLString subclass: #XMLFString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Factories'!

!XMLFString commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLString!

XMLElement subclass: #XMLFDateElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Factories'!

!XMLFDateElement commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLElement!

XMLElement subclass: #XMLFElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Factories'!

!XMLFElement commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLElement!

XMLElement subclass: #XMLFRealNameElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Factories'!

!XMLFRealNameElement commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLElement!

XMLElement subclass: #XMLFSerializationFormatElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Factories'!

!XMLFSerializationFormatElement commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLElement!

XMLElement subclass: #XMLFTableElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Factories'!

!XMLFTableElement commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLElement!

XMLElement subclass: #XMLFUserElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Factories'!

!XMLFUserElement commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLElement!

XMLElement subclass: #XMLFUsernameElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Factories'!

!XMLFUsernameElement commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLElement!

XMLElement subclass: #XMLFWrongElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Factories'!

!XMLFWrongElement commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLElement!

XMLCData subclass: #XMLFCData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Factories'!

!XMLFCData commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLCData!

XMLComment subclass: #XMLFComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Factories'!

!XMLFComment commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLComment!

XMLPI subclass: #XMLFPI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Factories'!

!XMLFPI commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLPI!

TestCase subclass: #XMLCharacterMethodsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLCharacterMethodsTest methodsFor: 'tests' stamp: 'monty 4/5/2015 03:22'!
testSplit
	self
		assert: ($: xmlParserSplit: '') = (OrderedCollection with: '');
		assert: ($: xmlParserSplit: 'abc') = (OrderedCollection with: 'abc');
		assert: ($: xmlParserSplit: ':') = #('' '') asOrderedCollection;
		assert: ($: xmlParserSplit: '::') = #('' '' '') asOrderedCollection;
		assert: ($: xmlParserSplit: 'a:bc:') = #('a' 'bc' '') asOrderedCollection;
		assert: ($: xmlParserSplit: ':ab:c:') = #('' 'ab' 'c' '') asOrderedCollection;
		assert: ($: xmlParserSplit: 'a:bc:') = #('a' 'bc' '') asOrderedCollection;
		assert: ($: xmlParserSplit: 'ab::cd::ef') = #('ab'  '' 'cd' '' 'ef') asOrderedCollection;
		assert:
			($: xmlParserSplit: '::ab:::cd:::ef::') =
				#('' '' 'ab'  '' '' 'cd' '' '' 'ef' '' '') asOrderedCollection! !

!XMLCharacterMethodsTest methodsFor: 'tests' stamp: 'monty 4/17/2015 14:25'!
testXMLParserASCIIValue
	| characterSet |

	characterSet := BitmapCharacterSet new.
	self
		assert: nil xmlParserASCIIValue isZero;
		deny: (characterSet xmlParserIncludes: nil).
	(0 to: 16rF0000) do: [:each | | char |
		char := each asCharacter.
		self
			assert: char xmlParserASCIIValue = each;
			deny: (characterSet xmlParserIncludes: char).
		characterSet add: char.
		self assert: (characterSet xmlParserIncludes: char)].
	self assert: (characterSet xmlParserIncludes: nil).! !

!XMLCharacterMethodsTest methodsFor: 'tests' stamp: 'monty 4/7/2015 09:24'!
testXMLParserIsSeparator
	| separators |

	separators := Character xmlParserSeparators.
	0 to: 255 do: [:each | | char |
		char := each asCharacter.
		(separators includes: char)
			ifTrue: [self assert: char xmlParserIsSeparator]
			ifFalse: [self deny: char xmlParserIsSeparator]].! !

!XMLCharacterMethodsTest methodsFor: 'tests' stamp: 'monty 4/7/2015 09:24'!
testXMLParserIsWhitespace
	| whitespace |

	whitespace := Character xmlParserWhitespace.
	0 to: 255 do: [:each | | char |
		char := each asCharacter.
		(whitespace includes: char)
			ifTrue: [self assert: char xmlParserIsWhitespace]
			ifFalse: [self deny: char xmlParserIsWhitespace]].! !

TestCase subclass: #XMLDFALimitsTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLDFALimitsTests methodsFor: 'tests' stamp: 'monty 4/22/2015 15:51'!
testDFAStateCacheLimit
	| names contentModel firstState currentState visitedStates |

	names :=
		(1 to: XMLDFAStateCache new maxCachedDFAStates) collect: [:each |
			'test', each printString].

	contentModel := String streamContents: [:stream |
		stream nextPut: $(.
		names withIndexDo: [:each :i |
			i > 1
				ifTrue: [stream nextPut: $,].
			stream nextPutAll: each].
		stream nextPut: $)].

	firstState :=
		(DTDDFAContentModelParser
			element: 'test'
			contentModel: contentModel) parse dfa.
	currentState := firstState.
	visitedStates := Set new.
	names withIndexDo: [:name :i | | previousState |
		visitedStates add: currentState.
		previousState := currentState.
		currentState := currentState detectNextStateMatching: name.
		self assert: currentState notNil.
		i = names size
			ifTrue: [
				visitedStates do: [:each |
					each = previousState
						ifFalse: [self assert: each dfaStateTransitions isEmpty]].
				self
					assert: firstState dfaStateTransitions isEmpty;
					assert: firstState dfaStateCache cachedDFAStates size = 2;
					assert: currentState isAccepting]
			ifFalse: [
				visitedStates do: [:each | self deny: each dfaStateTransitions isEmpty].
				self
					assert: firstState dfaStateTransitions notEmpty;
					assert: firstState dfaStateCache cachedDFAStates size = (i + 1);
					deny: currentState isAccepting]].

	currentState := firstState.
	names withIndexDo: [:each :i |
		currentState := currentState detectNextStateMatching: each.
		self deny: currentState isNil.
		i = names size
			ifTrue: [self assert: currentState isAccepting]
			ifFalse: [self deny: currentState isAccepting]].! !

!XMLDFALimitsTests methodsFor: 'tests' stamp: 'monty 4/22/2015 14:51'!
testDFAStateTransitionLimit
	| dfaState elementName |

	dfaState :=
		(DTDDFAContentModelParser
			element: 'test'
			contentModel: '(test)') parse dfa.
	1 to: dfaState maxDFAStateTransitions do: [:i |
		elementName := 'test', i printString.
		dfaState detectNextStateMatching: elementName.
		self
			assert: (dfaState dfaStateTransitions includesKey: elementName);
			assert: dfaState dfaStateTransitions size = i].

	elementName := 'test', (dfaState maxDFAStateTransitions + 1) printString.
	dfaState detectNextStateMatching: elementName.
	self
		assert: (dfaState dfaStateTransitions includesKey: elementName);
		assert: dfaState dfaStateTransitions size = 1.! !

TestCase subclass: #XMLEncodingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLEncodingTest methodsFor: 'private' stamp: 'monty 12/13/2014 20:16'!
convertableStreamOn: aString
	^ aString readStream! !

!XMLEncodingTest methodsFor: 'source' stamp: 'monty 11/8/2014 19:48'!
encodingDeclaration: anEncoding
	^ '<?xml version="1.0" encoding="', anEncoding, '"?>'! !

!XMLEncodingTest methodsFor: 'source' stamp: 'monty 3/22/2015 03:30'!
encodingDeclaration: anEncoding withUTF16XML: aSourceString littleEndian: aBoolean
	^ ((self encodingDeclaration: anEncoding) allButLast: 2),
		(self toUTF16: '?>', aSourceString littleEndian: aBoolean)! !

!XMLEncodingTest methodsFor: 'source' stamp: 'monty 3/22/2015 03:31'!
encodingDeclaration: anEncoding withUTF32XML: aSourceString littleEndian: aBoolean
	^ ((self encodingDeclaration: anEncoding) allButLast: 2),
		(self toUTF32: '?>', aSourceString littleEndian: aBoolean)! !

!XMLEncodingTest methodsFor: 'source' stamp: 'monty 4/26/2015 14:55'!
sourceXML
	^ self sourceXMLWith: 'encoding test'! !

!XMLEncodingTest methodsFor: 'source' stamp: 'monty 11/20/2014 03:29'!
sourceXMLWith: aCharacterOrString
	^ '<encoding-test>', aCharacterOrString asString, '</encoding-test>'! !

!XMLEncodingTest methodsFor: 'private' stamp: 'monty 12/14/2014 07:05'!
stringFromValues: aCollection
	"avoid asString for portability"
	^ String withAll: (aCollection collect: [:each | Character value: each])! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 3/22/2015 17:31'!
testBinaryDecoding
	| xml xmlInBinary |
	
	xml := XMLParserTest addressBookXML.
	xmlInBinary := xml asArray collect: [:each | each asciiValue].
	self assert:
		(XMLDOMParser parse: xmlInBinary) printString =
			(XMLDOMParser parse: xml) printString.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 5/25/2015 20:30'!
testDecodingCharacters
	| xml document  |

	xml := '<?xml version="1.0" encoding="UTF-8"?>
			<test-data>&#{1};</test-data>'.

	document := XMLDOMParser parse: (xml format: (Array with: '8230')).
	self assert: document root contentString first asciiValue = 8230.

	self
		should: [XMLDOMParser parse: (xml format: (Array with: ''))]
		raise: XMLWellFormednessException.
	self
		should: [XMLDOMParser parse: (xml format: (Array with: '0'))]
		raise: XMLWellFormednessException.
	self
		should: [XMLDOMParser parse: (xml format: (Array with: '-1'))]
		raise: XMLWellFormednessException.
	self
		should: [XMLDOMParser parse: (xml format: (Array with: '9:'))]
		raise: XMLWellFormednessException.
	self
		should: [XMLDOMParser parse: (xml format: (Array with: 'xFG'))]
		raise: XMLWellFormednessException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 5/8/2015 22:42'!
testDecodingDisabledEncodingDeclaration
	| xml |

	xml := 
		self
			encodingDeclaration: 'UTF-16-BE'
			withUTF16XML: self sourceXML
			littleEndian: false.
	self
		should: [
			(SAXHandler on: (self convertableStreamOn: xml))
				decodesCharacters: false;
				parseDocument]
		raise: XMLParserException.
	self
		shouldnt: [
			(SAXHandler on: (self convertableStreamOn: xml))
				decodesCharacters: true;
				parseDocument]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 5/8/2015 22:42'!
testDecodingDisabledEncodingDetection
	| xml |

	xml := self toUTF16: self sourceXML littleEndian: true.
	self
		should: [
			(SAXHandler on: (self convertableStreamOn: xml))
				decodesCharacters: false;
				parseDocument]
		raise: XMLParserException.
	self
		shouldnt: [
			(SAXHandler on: (self convertableStreamOn: xml))
				decodesCharacters: true;
				parseDocument]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 12/14/2014 07:05'!
testEncodingDeclarationLatin1
	| xml |

	"avoid asString for portability"
	xml := self sourceXMLWith: (String withAll: (#(126 127 128) collect: [:each | each asCharacter])).
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					self utf8BOM, (self encodingDeclaration: 'UTF-8'), xml)]
		raise: XMLEncodingException.
	self
		shouldnt: [
			SAXHandler parse:
				(self convertableStreamOn:
					self utf8BOM, (self encodingDeclaration: 'latin-1'), xml)]
		raise: XMLEncodingException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/20/2014 03:30'!
testEncodingDeclarationUTF16BE
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						encodingDeclaration: 'UTF-16-BE'
						withUTF16XML: self sourceXML
						littleEndian: true))]
		raise: XMLParserException.
	self
		shouldnt: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						encodingDeclaration: 'UTF-16-BE'
						withUTF16XML: self sourceXML
						littleEndian: false))]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/20/2014 03:30'!
testEncodingDeclarationUTF16LE
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						encodingDeclaration: 'UTF-16LE'
						withUTF16XML: self sourceXML
						littleEndian: false))]
		raise: XMLParserException.
	self
		shouldnt: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						encodingDeclaration: 'UTF-16LE'
						withUTF16XML: self sourceXML
						littleEndian: true))]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/20/2014 03:31'!
testEncodingDeclarationUTF32BE
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						encodingDeclaration: 'utf-32be'
						withUTF32XML: self sourceXML
						littleEndian: true))]
		raise: XMLParserException.
	self
		shouldnt: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						encodingDeclaration: 'utf-32be'
						withUTF32XML: self sourceXML
						littleEndian: false))]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/20/2014 03:30'!
testEncodingDeclarationUTF32LE
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						encodingDeclaration: 'utf-32-le'
						withUTF32XML: self sourceXML
						littleEndian: false))]
		raise: XMLParserException.
	self
		shouldnt: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						encodingDeclaration: 'utf-32-le'
						withUTF32XML: self sourceXML
						littleEndian: true))]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/20/2014 03:32'!
testEncodingDeclarationUTF8
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						encodingDeclaration: 'UTF8'
						withUTF16XML: self sourceXML
						littleEndian: false))]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						encodingDeclaration: 'UTF-8'
						withUTF16XML: self sourceXML
						littleEndian: true))]
		raise: XMLParserException.
	self
		shouldnt: [
			SAXHandler parse:
				(self convertableStreamOn: (self encodingDeclaration: 'UTF-8'), self sourceXML)]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 5/25/2015 02:03'!
testExternalReadStreamDecoder
	| readStreamAdapter |

	readStreamAdapter :=
		XMLDecodingReadStreamAdapter onExternalStream: 
			(self convertableStreamOn:
				self utf16LittleEndianBOM, (self toUTF16: self sourceXML littleEndian: true)).

	self
		shouldnt: [SAXHandler parse: readStreamAdapter]
		raise: XMLParserException.

	self
		assert: readStreamAdapter atEnd;
		assert: (readStreamAdapter streamDecoder isKindOf: XMLUTF16StreamDecoder).! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 5/3/2015 18:23'!
testExternalSubsetByteOrderMarkDetection
	| xml uri |

	xml := '<!!ELEMENT name EMPTY>'.
	uri := '/external.xml'.
	self
		shouldnt: [
			((SAXHandler on: '') parser driver
				externalSubsetParserOn:
					(self convertableStreamOn:
						self utf16LittleEndianBOM, (self toUTF16: xml littleEndian: true))
				documentURI: uri) parseDocument]
		raise: XMLParserException.
	self
		shouldnt: [
			((SAXHandler on: '') parser driver
				externalSubsetParserOn:
					(self convertableStreamOn:
						self utf16BigEndianBOM, (self toUTF16: xml littleEndian: false))
				documentURI: uri) parseDocument]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 5/3/2015 18:22'!
testExternalSubsetImplicitEncodingDetection
	| xml uri |

	xml := '<!!ELEMENT name EMPTY>'.
	uri := '/external.xml'.
	self
		shouldnt: [
			((SAXHandler on: '') parser driver
				externalSubsetParserOn:
					(self convertableStreamOn: (self toUTF16: xml littleEndian: true))
				documentURI: uri) parseDocument]
		raise: XMLParserException.
	self
		shouldnt: [
			((SAXHandler on: '') parser driver
				externalSubsetParserOn:
					(self convertableStreamOn: (self toUTF16: xml littleEndian: false))
				documentURI: uri) parseDocument]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/20/2014 03:31'!
testImplicitUTF16EncodingDetection
	self
		shouldnt: [
			SAXHandler parse:
				(self convertableStreamOn: (self toUTF16: self sourceXML littleEndian: true))]
		raise: XMLParserException.
	self
		shouldnt: [
			SAXHandler parse:
				(self convertableStreamOn: (self toUTF16: self sourceXML littleEndian: false))]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/20/2014 03:32'!
testImplicitUTF32EncodingDetection
	self
		shouldnt: [
			SAXHandler parse:
				(self convertableStreamOn: (self toUTF32: self sourceXML littleEndian: true))]
		raise: XMLParserException.
	self
		shouldnt: [
			SAXHandler parse:
				(self convertableStreamOn: (self toUTF32: self sourceXML littleEndian: false))]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/20/2014 03:32'!
testUTF16BigEndianByteOrderMarkDetection
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					self utf16BigEndianBOM, self sourceXML)]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					self utf16BigEndianBOM, (self toUTF16: self sourceXML littleEndian: true))]
		raise: XMLParserException.
	self
		shouldnt: [
			SAXHandler parse:
				(self convertableStreamOn:
					self utf16BigEndianBOM, (self toUTF16: self sourceXML littleEndian: false))]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/20/2014 03:29'!
testUTF16Characters
	| document source decoded |

	source :=
		self stringFromValues:
			#(256
				16rD7FF
				16rE000
				16rFFFF
				16rD800 16rDC00 "first surrogate"
				16rDBFF 16rDFFF). "last surrogate"
	decoded := self stringFromValues: #(256 16rD7FF 16rE000 16rFFFF 16r10000 16r10FFFF).

	document :=
		XMLDOMParser parse:
			(self
				encodingDeclaration: 'UTF-16LE'
				withUTF16XML: (self sourceXMLWith: source)
				littleEndian: true).
	self assert: document firstElement contentString = decoded.

	document :=
		XMLDOMParser parse:
			(self
				encodingDeclaration: 'UTF-16BE'
				withUTF16XML: (self sourceXMLWith: source)
				littleEndian: false).
	self assert: document firstElement contentString = decoded.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/20/2014 03:32'!
testUTF16LittleEndianByteOrderMarkDetection
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					self utf16LittleEndianBOM, self sourceXML)]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					self utf16LittleEndianBOM, (self toUTF16: self sourceXML littleEndian: false))]
		raise: XMLParserException.
	self
		shouldnt: [
			SAXHandler parse:
				(self convertableStreamOn:
					self utf16LittleEndianBOM, (self toUTF16: self sourceXML littleEndian: true))]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/20/2014 03:32'!
testUTF32BigEndianByteOrderMarkDetection
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					self utf32BigEndianBOM, self sourceXML)]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					self utf32BigEndianBOM, (self toUTF32: self sourceXML littleEndian: true))]
		raise: XMLParserException.
	self
		shouldnt: [
			SAXHandler parse:
				(self convertableStreamOn:
					self utf32BigEndianBOM, (self toUTF32: self sourceXML littleEndian: false))]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 12/13/2014 19:34'!
testUTF32Characters
	| document source decoded |

	source :=
		self stringFromValues:
			#(16r000000FE
				16r0000D7FE
				16r0010FFFF).
	decoded := self stringFromValues: #(16rFE 16rD7FE 16r10FFFF).

	document :=
		XMLDOMParser parse:
			(self
				encodingDeclaration: 'UTF-32-LE'
				withUTF32XML: (self sourceXMLWith: source)
				littleEndian: true).
	self assert: document firstElement contentString = decoded.

	document :=
		XMLDOMParser parse:
			(self
				encodingDeclaration: 'UTF-32BE'
				withUTF32XML: (self sourceXMLWith: source)
				littleEndian: false).
	self assert: document firstElement contentString = decoded.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/20/2014 03:31'!
testUTF32LittleEndianByteOrderMarkDetection
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					self utf32LittleEndianBOM, self sourceXML)]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					self utf32LittleEndianBOM, (self toUTF32: self sourceXML littleEndian: false))]
		raise: XMLParserException.
	self
		shouldnt: [
			SAXHandler parse:
				(self convertableStreamOn:
					self utf32LittleEndianBOM, (self toUTF32: self sourceXML littleEndian: true))]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/20/2014 03:31'!
testUTF8ByteOrderMarkDetection
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					self utf8BOM, (self toUTF16: self sourceXML littleEndian: true))]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					self utf8BOM, (self toUTF16: self sourceXML littleEndian: false))]
		raise: XMLParserException.
	self
		shouldnt: [
			SAXHandler parse:
				(self convertableStreamOn: self utf8BOM, self sourceXML)]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/20/2014 03:29'!
testUTF8Characters
	| document source decoded |

	source :=
		self stringFromValues:
			#(16r7F
				16rC2 16r80
				16rDF 16rBF
				16rE0 16rA0 16r80
				16rEF 16rBF 16rBF
				16rF0 16r90 16r80 16r80
				16rF4 16r8F 16rBF 16rBF).
	decoded := self stringFromValues: #(16r7F 16r80 16r7FF 16r800 16rFFFF 16r10000 16r10FFFF).

	document :=
		XMLDOMParser parse:
			self utf8BOM, (self encodingDeclaration: 'UTF-8'), (self sourceXMLWith: source).
	self assert: document firstElement contentString = decoded.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 2/2/2015 03:58'!
testWideCharacterNames
	| wideNames document |

	(wideNames := OrderedCollection new)
		addLast: (self wideStringFrom: #(16rC0 16rD6 16rD8 16rF6 16rF8 16r2FF $- $.));
		addLast: (self wideStringFrom: #(16r370 16r37D 16r37F 16r1FFF 16r200C $0 $9));
		addLast: (self wideStringFrom: #(16r200D 16r2070 16r218F 16r2C00 16r2FEF 16rB7));
		addLast: (self wideStringFrom: #(16r3001 16rD7FF 16rF900 16rFDCF 16rFDF0 16r0300));
		addLast: (self wideStringFrom: #(16rFFFD 16r10000 16rEFFFF 16r036F 16r203F 16r2040)).
	self
		shouldnt: [
			document :=
				XMLDOMParser parse:
					('<!!DOCTYPE {1} [
						<!!ELEMENT {1} ({2}, {3}, {4})>
						<!!ELEMENT {2} EMPTY>
						<!!ELEMENT {3} EMPTY>
						<!!ELEMENT {4} EMPTY>
						<!!ATTLIST {1} {5} ({3} | {4} | {5}) #IMPLIED>
					]>
					<{1} {5}="{4}">
						<{2}/><{3}/><{4}/>
					</{1}>' format: wideNames)]
		raise: XMLParserException.
	self
		assert: document root name = wideNames first;
		assert: (document root attributeAt: wideNames fifth) = wideNames fourth;
		assert: (document root elementNames) asOrderedCollection = (wideNames copyFrom: 2 to: 4).! !

!XMLEncodingTest methodsFor: 'private' stamp: 'monty 11/18/2014 21:29'!
toUTF16: aString littleEndian: aBoolean
	^ String streamContents: [:stream |
		aString do: [:each |
			aBoolean
				ifTrue: [
					stream
						nextPut: (each asciiValue bitAnd: 16r00FF) asCharacter;
						nextPut: ((each asciiValue bitAnd: 16rFF00) bitShift: -8) asCharacter]
				ifFalse: [
					stream
						nextPut: ((each asciiValue bitAnd: 16rFF00) bitShift: -8) asCharacter;
						nextPut: (each asciiValue bitAnd: 16r00FF) asCharacter]]]! !

!XMLEncodingTest methodsFor: 'private' stamp: 'monty 11/19/2014 05:04'!
toUTF32: aString littleEndian: aBoolean
	^ String streamContents: [:stream |
		aString do: [:each |
			aBoolean
				ifTrue: [
					stream
						nextPut: (each asciiValue bitAnd: 16r000000FF) asCharacter;
						nextPut: ((each asciiValue bitAnd: 16r0000FF00) bitShift: -8) asCharacter;
						nextPut: ((each asciiValue bitAnd: 16r00FF0000) bitShift: -16) asCharacter;
						nextPut: ((each asciiValue bitAnd: 16rFF000000) bitShift: -24) asCharacter]
				ifFalse: [
					stream
						nextPut: ((each asciiValue bitAnd: 16rFF000000) bitShift: -24) asCharacter;
						nextPut: ((each asciiValue bitAnd: 16r00FF0000) bitShift: -16) asCharacter;
						nextPut: ((each asciiValue bitAnd: 16r0000FF00) bitShift: -8) asCharacter;
						nextPut: (each asciiValue bitAnd: 16r000000FF) asCharacter]]]! !

!XMLEncodingTest methodsFor: 'private' stamp: 'monty 11/12/2014 21:35'!
utf16BigEndianBOM
	^ XMLUTF16BigEndianStreamDecoder byteOrderMark! !

!XMLEncodingTest methodsFor: 'private' stamp: 'monty 11/12/2014 21:34'!
utf16LittleEndianBOM
	^ XMLUTF16LittleEndianStreamDecoder byteOrderMark! !

!XMLEncodingTest methodsFor: 'private' stamp: 'monty 11/19/2014 05:51'!
utf32BigEndianBOM
	^ XMLUTF32BigEndianStreamDecoder byteOrderMark! !

!XMLEncodingTest methodsFor: 'private' stamp: 'monty 11/19/2014 05:51'!
utf32LittleEndianBOM
	^ XMLUTF32LittleEndianStreamDecoder byteOrderMark! !

!XMLEncodingTest methodsFor: 'private' stamp: 'monty 11/12/2014 21:35'!
utf8BOM
	^ XMLUTF8StreamDecoder byteOrderMark! !

!XMLEncodingTest methodsFor: 'private' stamp: 'monty 2/2/2015 03:58'!
wideStringFrom: aCollection
	^ String withAll: (aCollection collect: [:each | each asCharacter])! !

TestCase subclass: #XMLExternalEntityTest
	instanceVariableNames: ''
	classVariableNames: 'IsSkipping'
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLExternalEntityTest commentStamp: 'monty 10/14/2014 00:42' prior: 0!
These tests use HTTP and the file system and are skipped by default. This enables them:

self isSkipping: false.!

XMLExternalEntityTest subclass: #XMLExternalEntityLimitsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLExternalEntityLimitsTest methodsFor: 'tests' stamp: 'monty 1/27/2015 23:06'!
testDefaultLimits
	| resolver |

	resolver := (SAXHandler on: '') externalEntityResolver.
	self
		assert: resolver externalSubsetReadLimit = DTDExternalEntityLimits defaultExternalSubsetReadLimit;
		assert: resolver maxExternalEntities > 0;
		assert: resolver maxExternalEntitySize = DTDExternalEntityLimits defaultMaxExternalEntitySize;
		deny: resolver resolvesLocalFromNonLocal.! !

!XMLExternalEntityLimitsTest methodsFor: 'tests' stamp: 'monty 6/21/2015 03:02'!
testExternalEntitiesLimit
	| entityLimit xml parser externalEntityResolver |

	self isSkipping
		ifTrue: [self skipOrReturnWith: [^ self]].

	entityLimit := 2.
	xml :=
		self doctypeWithDeclarationsForEntityURIs:
			(self musicXMLExternalEntityURLs copyFrom: 1 to: entityLimit).
	(parser := SAXHandler on: xml)
		resolvesExternalEntities: true.
	(externalEntityResolver := parser externalEntityResolver)
		maxExternalEntities: entityLimit;
		clearEntityCache.
	self
		shouldnt: [parser parseDocument]
		raise: XMLLimitException.
	self assert: externalEntityResolver totalResolvedEntities = entityLimit.

	"reusing the parser shouldn't trigger the limit"
	parser on: xml.
	externalEntityResolver := parser externalEntityResolver.
	self
		assert: parser resolvesExternalEntities;
		assert: externalEntityResolver maxExternalEntities = entityLimit;
		assert: externalEntityResolver totalResolvedEntities = 0.
	externalEntityResolver clearEntityCache.
	self
		shouldnt: [parser parseDocument]
		raise: XMLLimitException.
	self assert: externalEntityResolver totalResolvedEntities = entityLimit.

	((parser := SAXHandler on: xml)
		resolvesExternalEntities: true;
		externalEntityResolver)
			clearEntityCache;
			maxExternalEntities: entityLimit - 1.
	self
		should: [parser parseDocument]
		raise: XMLLimitException.! !

!XMLExternalEntityLimitsTest methodsFor: 'tests' stamp: 'monty 4/26/2015 14:40'!
testExternalEntitySizeLimit
	| parser url xml size |

	self isSkipping
		ifTrue: [self skipOrReturnWith: [^ self]].

	url := self musicXMLExternalEntityURLs first asXMLURI.
	xml := self doctypeWithDeclarationsForEntityURIs: (Array with: url asString).
	size := url get contents size.
	((parser := SAXHandler on: xml)
		resolvesExternalEntities: true;
		externalEntityResolver)
			clearEntityCache;
			maxExternalEntitySize: size.
	self
		shouldnt: [parser parseDocument]
		raise: XMLLimitException.

	((parser := SAXHandler on: xml)
		resolvesExternalEntities: true;
		externalEntityResolver)
			clearEntityCache;
			maxExternalEntitySize: size - 1.
	self
		should: [parser parseDocument]
		raise: XMLLimitException.! !

!XMLExternalEntityLimitsTest methodsFor: 'tests' stamp: 'monty 4/4/2015 06:02'!
testExternalSubsetReadLimit
	| xml externalSubset fileName parser |

	self isSkipping
		ifTrue: [self skipOrReturnWith: [^ self]].

	fileName := 'externalSubset.dtd'.
	externalSubset := '<?xml encoding="UTF-8"?><!!ELEMENT test EMPTY>'.
	self fileNamed: fileName write: externalSubset.
	xml := '<!!DOCTYPE test SYSTEM "', fileName, '"><test/>'.
	self
		shouldnt: [
			(parser := SAXHandler on: xml)
				externalEntityResolver externalSubsetReadLimit: externalSubset size.
			parser
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLLimitException.
	self
		should: [
			(parser := SAXHandler on: xml)
				externalEntityResolver externalSubsetReadLimit: externalSubset size - 1.
			parser
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLLimitException.
	self deleteFileNamed: fileName.! !

!XMLExternalEntityLimitsTest methodsFor: 'tests' stamp: 'monty 4/4/2015 06:02'!
testOnURLUpToLimit
	| parser size |

	self isSkipping
		ifTrue: [self skipOrReturnWith: [^ self]].

	size := (self feedURL asXMLURI get) contents size.
	self
		shouldnt: [
			parser :=
				SAXHandler
					onURL: self feedURL
					upToLimit: size]
		raise: XMLLimitException.
	self assert: parser documentReadLimit = size.

	self
		should: [
			(SAXHandler
				onURL: self feedURL
				upToLimit: size - 1)
				parseDocument]
		raise: XMLLimitException.! !

!XMLExternalEntityLimitsTest methodsFor: 'tests' stamp: 'monty 5/25/2015 02:39'!
testRemoveLimits
	|  readLimit entityLimit entitySizeLimit parser resolver |

	readLimit := 100.
	entityLimit := 10.
	entitySizeLimit := 100.
	parser := SAXHandler on: ''.
	(resolver := parser externalEntityResolver)
		externalSubsetReadLimit: readLimit;
		maxExternalEntities: entityLimit;
		maxExternalEntitySize: entitySizeLimit;
		resolvesLocalFromNonLocal: true.
	self
		assert: resolver externalSubsetReadLimit = readLimit;
		assert: resolver maxExternalEntities = entityLimit;
		assert: resolver maxExternalEntitySize = entitySizeLimit;
		assert: resolver resolvesLocalFromNonLocal.

	parser removeLimits.
	self
		assert: resolver externalSubsetReadLimit isNil;
		assert: resolver maxExternalEntities isNil;
		assert: resolver maxExternalEntitySize isNil;
		assert: resolver resolvesLocalFromNonLocal.! !

!XMLExternalEntityLimitsTest methodsFor: 'tests' stamp: 'monty 1/24/2014 17:33'!
testResolvingLocalFromNonLocal
	| parser |

	self
		should: [
			(parser :=
				SAXHandler
					on: '<!!DOCTYPE root SYSTEM "file://local/uri">'
					documentURI: 'http://www.example.com')
				externalEntityResolver resolvesLocalFromNonLocal: false.
			parser
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLLimitException.! !

!XMLExternalEntityTest class methodsFor: 'testing' stamp: 'monty 2/11/2014 02:25'!
isSkipping
	"HTTP/file tests are skipped by default"
	^ IsSkipping ifNil: [IsSkipping := true]! !

!XMLExternalEntityTest class methodsFor: 'testing' stamp: 'monty 11/24/2014 21:08'!
isSkipping: aBoolean
	"HTTP/file tests are skipped by default.

	self isSkipping: false.
	self isSkipping: true.
	"
	IsSkipping := aBoolean! !

!XMLExternalEntityTest methodsFor: 'files' stamp: 'monty 1/21/2014 23:36'!
deleteFileNamed: aFileName
	(XMLFileHandle path: aFileName) delete! !

!XMLExternalEntityTest methodsFor: 'source' stamp: 'monty 4/26/2015 23:59'!
docBookArticleSource
	^ '<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE article PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN" "http://docbook.org/xml/4.5/docbookx.dtd">
<article>
	<articleinfo>
		<title>About Pharo</title>
		<author>
			<honorific>Dr.</honorific>
			<firstname>Stephane</firstname>
			<surname>Ducasse</surname>
		</author>
	</articleinfo>
	<section>
		<title>Mission</title>
		<para>Pharo''s goal is to deliver a clean, innovative, free open-source environment. Here is the to be revised Pharo vision document.</para>
		<para>By providing a stable and small core system, excellent developing tools, and maintained releases, Pharo is an attractive platform to build and deploy mission critical applications.</para>
		<para>Pharo fosters a healthy ecosystem of both private and commercial contributors who advance and maintain the core system and its external packages.</para>
	</section>
	<section>
		<title>Pharo features</title>
		<para>A dynamic, pure object-oriented programming language in the tradition of Smalltalk</para>
		<para>An IDE (integrated development environment)</para>
		<para>A huge library and set of external packages</para>
	</section>
	<section>
		<title>Pharo and Business</title>
		<para>The goal of Pharo is to sustain and grow business.</para>
		<para>Pharo is supported by the industrial Pharo consortium.</para>
		<para>Pharo has also an association of users: Pharo association</para>
    </section>
</article>'! !

!XMLExternalEntityTest methodsFor: 'source' stamp: 'monty 4/26/2015 14:52'!
docBookExampleSource
	^ '<!!DOCTYPE example
	PUBLIC "-//OASIS//DTD DocBook XML V4.1.2//EN"
	"http://www.oasis-open.org/docbook/xml/4.1.2/docbookx.dtd">
	<example>
		<title>An Example</title>
		<programlisting>
		XMLDocument root:
			((XMLElement named: ''test'')
				addNode: ''An example'' asXMLString;
				yourself)
		</programlisting>
	</example>'! !

!XMLExternalEntityTest methodsFor: 'source' stamp: 'monty 3/22/2015 03:31'!
doctypeWithDeclarationsForEntityURIs: aURICollection
	^  String streamContents: [:stream |
		stream nextPutAll: '<!!DOCTYPE test ['.
		aURICollection withIndexDo: [:each :i |
			stream nextPutAll: '<!!ENTITY entity', i printString, ' SYSTEM "', each, '">'].
		stream nextPutAll: ']>']! !

!XMLExternalEntityTest methodsFor: 'urls' stamp: 'monty 9/29/2014 12:33'!
feedURL
	^ 'http://pharo.org/news/atom.xml'! !

!XMLExternalEntityTest methodsFor: 'files' stamp: 'monty 12/23/2014 21:24'!
fileNamed: aFileName write: aString
	(XMLFileHandle path: aFileName) writeStream
		nextPutAll: aString;
		close.! !

!XMLExternalEntityTest methodsFor: 'accessing' stamp: 'monty 2/11/2014 00:55'!
isSkipping
	^ self class isSkipping! !

!XMLExternalEntityTest methodsFor: 'source' stamp: 'monty 4/26/2015 23:59'!
musicXMLDocument
	^ '<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!!DOCTYPE score-partwise PUBLIC
    "-//Recordare//DTD MusicXML 3.0 Partwise//EN"
    "http://www.musicxml.org/dtds/partwise.dtd">
<score-partwise version="3.0">
  <part-list>
    <score-part id="P1">
      <part-name>Music</part-name>
    </score-part>
  </part-list>
  <part id="P1">
    <measure number="1">
      <attributes>
        <divisions>1</divisions>
        <key>
          <fifths>0</fifths>
        </key>
        <time>
          <beats>4</beats>
          <beat-type>4</beat-type>
        </time>
        <clef>
          <sign>G</sign>
          <line>2</line>
        </clef>
      </attributes>
      <note>
        <pitch>
          <step>C</step>
          <octave>4</octave>
        </pitch>
        <duration>4</duration>
        <type>whole</type>
      </note>
    </measure>
  </part>
</score-partwise>
'.! !

!XMLExternalEntityTest methodsFor: 'urls' stamp: 'monty 4/26/2015 14:40'!
musicXMLExternalEntityURLs
	^  #('http://www.musicxml.org/dtds/note.mod'
		'http://www.musicxml.org/dtds/isolat1.ent'
		'http://www.musicxml.org/dtds/isolat2.ent'
		'http://www.musicxml.org/dtds/layout.mod'
		'http://www.musicxml.org/dtds/identity.mod'
		'http://www.musicxml.org/dtds/attributes.mod'
		'http://www.musicxml.org/dtds/partwise.dtd'
		'http://www.musicxml.org/dtds/barline.mod'
		'http://www.musicxml.org/dtds/direction.mod'
		'http://www.musicxml.org/dtds/score.mod'
		'http://www.musicxml.org/dtds/link.mod'
		'http://www.musicxml.org/dtds/common.mod')! !

!XMLExternalEntityTest methodsFor: 'private' stamp: 'monty 4/4/2015 06:03'!
skipOrReturnWith: aBlock
	"skip is not portable to squeak"
	(self respondsTo: #skip)
		ifTrue: [self skip]
		ifFalse: [aBlock value]! !

!XMLExternalEntityTest methodsFor: 'tests' stamp: 'monty 4/4/2015 06:01'!
testOnFileNamed
	| parser fileName |

	self isSkipping
		ifTrue: [self skipOrReturnWith: [^ self]].

	fileName := 'testOnFileNamed.xml'.
	self fileNamed: fileName write: ''.
	self
		shouldnt: [parser := SAXHandler onFileNamed: fileName]
		raise: XMLFileException.
	self
		assert: parser documentURI = fileName;
		assert: parser documentURI asXMLURI isLocalURI.

	self deleteFileNamed: fileName.! !

!XMLExternalEntityTest methodsFor: 'tests' stamp: 'monty 4/4/2015 06:01'!
testOnURL
	| parser |

	self isSkipping
		ifTrue: [self skipOrReturnWith: [^ self]].

	self
		shouldnt: [parser := SAXHandler onURL: self feedURL]
		raise: XMLHTTPException.
	self
		assert: parser documentURI = self feedURL;
		deny: parser documentURI asXMLURI isLocalURI.! !

!XMLExternalEntityTest methodsFor: 'tests' stamp: 'monty 4/23/2015 18:17'!
testParsingDocBookArticle
	"This uses HTTP so is skipped by default"

	self isSkipping
		ifTrue: [self skipOrReturnWith: [^ self]].

	self
		shouldnt: [
			(SAXHandler on: self docBookArticleSource)
				resolvesExternalEntities: true;
				removeLimits;
				parseDocument]
		raise: XMLParserException.! !

!XMLExternalEntityTest methodsFor: 'tests' stamp: 'monty 4/26/2015 14:52'!
testParsingDocBookExample
	"This uses HTTP so is skipped by default"

	self isSkipping
		ifTrue: [self skipOrReturnWith: [^ self]].

	self
		shouldnt: [
			(SAXHandler on: self docBookExampleSource)
				resolvesExternalEntities: true;
				removeLimits;
				parseDocument]
		raise: XMLParserException.! !

!XMLExternalEntityTest methodsFor: 'tests' stamp: 'monty 4/26/2015 14:41'!
testParsingExternalEntities
	"This test uses HTTP so is skipped by default."
	| entityCache entityCacheCopy |

	self isSkipping
		ifTrue: [self skipOrReturnWith: [^ self]].

	DTDCachingExternalEntityResolver clearEntityCache.
	entityCache := DTDCachingExternalEntityResolver entityCache.
	self musicXMLExternalEntityURLs do: [:each |
		self deny: (entityCache includesKey: each asXMLURI)].

	SAXHandler
		parse: self musicXMLDocument
		usingNamespaces: true
		validation: true
		externalEntities: true.
	self musicXMLExternalEntityURLs do: [:each |
		self assert: (entityCache at: each asXMLURI ifAbsent: ['']) notEmpty].

	"check for re-requesting"
	entityCacheCopy := entityCache copy.
	SAXHandler
		parse: self musicXMLDocument
		usingNamespaces: true
		validation: true
		externalEntities: true.
	self musicXMLExternalEntityURLs do: [:each |
		self assert: (entityCache at: each asXMLURI) == (entityCacheCopy at: each asXMLURI)].! !

!XMLExternalEntityTest methodsFor: 'tests' stamp: 'monty 4/26/2015 14:41'!
testParsingFile
	"This test creates/deletes a file so is skipped by default"
	| fileName doc |

	self isSkipping
		ifTrue: [self skipOrReturnWith: [^ self]].

	fileName := 'testParsingFile.xml'.
	self
		should: [XMLDOMParser parseFileNamed: fileName]
		raise: XMLFileException.
	self
		fileNamed: fileName
		write: self musicXMLDocument.
	self
		shouldnt: [doc := XMLDOMParser parseFileNamed: fileName]
		raise: XMLFileException.
	self assert: (doc root isNamed: 'score-partwise').

	self deleteFileNamed: fileName.! !

!XMLExternalEntityTest methodsFor: 'tests' stamp: 'monty 4/4/2015 06:02'!
testParsingURL
	"This uses HTTP so is skipped by default"
	| doc |

	self isSkipping
		ifTrue: [self skipOrReturnWith: [^ self]].

	self
		shouldnt: [doc := XMLDOMParser parseURL: self feedURL]
		raise: XMLHTTPException.
	self assert: (doc root isNamed: 'feed').! !

TestCase subclass: #XMLIntegerReaderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLIntegerReaderTest methodsFor: 'private' stamp: 'monty 10/24/2014 20:31'!
maxBase
	^ XMLIntegerReader maxBase! !

!XMLIntegerReaderTest methodsFor: 'tests' stamp: 'monty 10/27/2014 13:32'!
testBaseMarker
	2 to: self maxBase do: [:base | | stream defaultBase |
		defaultBase := (base - 1) max: 2.
		stream := ((base printStringBase: base) copyWithFirst: $#) readStream.
		self
			assert:
				(XMLIntegerReader
					readFrom: stream
					withBase: base
					startingWithAny: '@#$'
					orBase: defaultBase) = base;
			assert: stream atEnd.

		stream := (base printStringBase: defaultBase) readStream.
		self
			assert:
				(XMLIntegerReader
					readFrom: stream
					withBase: base
					startingWithAny: '@#$'
					orBase: defaultBase) = base;
			assert: stream atEnd].! !

!XMLIntegerReaderTest methodsFor: 'tests' stamp: 'monty 10/26/2014 10:24'!
testBases
	2 to: self maxBase do: [:base | | stream |
		(0 to: base), (base + 1 to: base * 10 by: base) do: [:i |
			stream := (i printStringBase: base) readStream.
			self
				assert: (XMLIntegerReader readFrom: stream withBase: base) = i;
				assert: stream atEnd]].
	self
		should: [XMLIntegerReader readFrom: '1' readStream withBase: 1]
		raise: Error.
	self
		should: [XMLIntegerReader readFrom: '1' readStream withBase: self maxBase + 1]
		raise: Error.! !

!XMLIntegerReaderTest methodsFor: 'tests' stamp: 'monty 10/24/2014 20:31'!
testMaxValue
	| maxValue |

	maxValue := XMLIntegerReader maxIntegerValue.
	2 to: self maxBase do: [:base |
		self assert:
			(XMLIntegerReader
				readFrom: (maxValue printStringBase: base) readStream
				withBase: base) = maxValue.
		1 to: base do: [:i |
			self  assert:
				(XMLIntegerReader
					readFrom: ((maxValue + i) printStringBase: base) readStream
					withBase: base) = maxValue]].! !

!XMLIntegerReaderTest methodsFor: 'tests' stamp: 'monty 10/26/2014 10:42'!
testNonDigit

	2 to: self maxBase do: [:base | | baseCharacter stream |
		baseCharacter :=
			base >= 10
				ifTrue: [Character value: $A asciiValue + (base - 10)]
				ifFalse: [Character value: $0 asciiValue + base].
		stream := ((base printStringBase: base) copyWith: baseCharacter) readStream.
		self
			assert: (XMLIntegerReader readFrom: stream withBase: base) = base;
			deny: stream atEnd;
			assert: stream next = baseCharacter.

		baseCharacter := Character value: $0 asciiValue - 1.
		stream := baseCharacter asString readStream.
		self
			assert: (XMLIntegerReader readFrom: stream withBase: base) isNil;
			deny: stream atEnd;
			assert: stream next = baseCharacter].! !

!XMLIntegerReaderTest methodsFor: 'tests' stamp: 'monty 10/27/2014 08:50'!
testPositioning
	| reader string |

	string := 'test'.
	reader := XMLIntegerReader on: string readStream.
	string do: [:each |
		self
			deny: reader atEnd;
			assert: reader peek = each;
			assert: reader next = each].
	self assert: reader atEnd.! !

!XMLIntegerReaderTest methodsFor: 'tests' stamp: 'monty 10/24/2014 20:40'!
testReadLimit
	2 to: self maxBase do: [:base | | stream |
		"101 regardless of base"
		stream := (base * base + 1 printStringBase: base) readStream.
		self
			assert: (XMLIntegerReader readFrom: stream withBase: base upTo: 2) = base;
			deny: stream atEnd;
			assert: stream next == $1]! !

TestCase subclass: #XMLKeyValueCacheTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLKeyValueCacheTest methodsFor: 'accessing' stamp: 'monty 11/15/2014 20:42'!
cacheClass
	^ XMLKeyValueCache! !

!XMLKeyValueCacheTest methodsFor: 'accessing' stamp: 'monty 11/15/2014 21:19'!
keysAndValuesDo: aBlock
	1 to: self maxSize do: [:i |
		aBlock
			value: ('key', i asString)
			value: ('value', i asString)]! !

!XMLKeyValueCacheTest methodsFor: 'accessing' stamp: 'monty 11/15/2014 20:57'!
maxSize
	^ 20! !

!XMLKeyValueCacheTest methodsFor: 'instance creation' stamp: 'monty 11/15/2014 20:58'!
newCache
	^ self cacheClass new! !

!XMLKeyValueCacheTest methodsFor: 'instance creation' stamp: 'monty 11/15/2014 21:18'!
newCacheWithEntries
	| cache |

	cache := self cacheClass maxSize: self maxSize.
	self keysAndValuesDo: [:key :value |
		cache
			at: key
			put: value].
	^ cache.! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 11/15/2014 21:35'!
testAtIfAbsent
	| cache |

	cache := self newCacheWithEntries.
	self keysAndValuesDo: [:key :value |
		self assert: (cache at: key ifAbsent: ['absent']) = value].
	self assert: (cache at: 'newkey' ifAbsent: ['absent']) = 'absent'.! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 11/15/2014 21:19'!
testAtIfAbsentPut
	| cache |

	cache := self newCacheWithEntries.
	self keysAndValuesDo: [:key :value |
		cache at: key ifAbsentPut: ['newkey'].
		self
			assert: (cache at: key) = value;
			assert: cache size = self maxSize].
	self
		assert: (cache at: 'newkey' ifAbsentPut: ['newvalue']) = 'newvalue';
		assert: (cache at: 'newkey') = 'newvalue';
		assert: cache size = 1.! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 11/15/2014 21:38'!
testAtPut
	| cache i |

	cache := self cacheClass maxSize: self maxSize.
	i := 0.
	self keysAndValuesDo: [:key :value |
		self
			assert: (cache at: key put: value) = value;
			assert: (cache at: key) = value.
		i := i + 1.
		self assert: cache size = i].
	self
		assert: (cache at: 'newkey' put: 'newvalue') = 'newvalue';
		assert: (cache at: 'newkey') = 'newvalue';
		assert: cache size = 1.! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 11/15/2014 21:03'!
testClear
	| cache |

	cache := self newCacheWithEntries.
	self deny: cache isEmpty.
	cache clear.
	self assert: cache isEmpty.! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 11/15/2014 20:56'!
testDefaultMaxSize
	self assert: self newCache maxSize = self cacheClass defaultMaxSize! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 11/16/2014 00:02'!
testIncludesKey
	| cache |

	cache := self newCacheWithEntries.
	self keysAndValuesDo: [:key :value | self assert: (cache includesKey: key)].
	self deny: (cache includesKey: 'newkey').! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 11/15/2014 20:53'!
testIsEmpty
	self
		assert: self newCache isEmpty;
		deny: self newCacheWithEntries isEmpty! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 11/15/2014 20:57'!
testMaxSize
	| cache |

	cache := self newCacheWithEntries.
	self assert: cache size = self maxSize.
	cache maxSize: self maxSize + 1.
	self assert: cache size = self maxSize.
	cache maxSize: 0.
	self assert: cache size = 0.! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 11/15/2014 20:57'!
testSize
	self
		assert: self newCache size = 0;
		assert: self newCacheWithEntries size = self maxSize! !

TestCase subclass: #XMLNamespaceScopeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLNamespaceScopeTest methodsFor: 'accessing' stamp: 'monty 12/29/2014 17:54'!
namespaces
	^ OrderPreservingStringDictionary new
		at: 'prefix1' put: 'ns1';
		at: 'prefix2' put: 'ns2';
		at: '' put: 'defaultNS';
		yourself! !

!XMLNamespaceScopeTest methodsFor: 'instance creation' stamp: 'monty 12/28/2014 23:18'!
newNamespaceScope
	^ XMLNamespaceScope new! !

!XMLNamespaceScopeTest methodsFor: 'instance creation' stamp: 'monty 12/28/2014 23:24'!
newNamespaceScopeWithNamespaces
	| scope |

	scope := self newNamespaceScope.
	self namespaces keysAndValuesDo: [:prefix :uri |
		scope
			mapPrefix: prefix
			to: uri].
	^ scope.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 4/21/2015 13:27'!
testCopy
	| scope oldPrefixMappings |

	scope := self newNamespaceScopeWithNamespaces.
	oldPrefixMappings := scope prefixMappings.
	self assert: scope copy prefixMappings == oldPrefixMappings.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 4/21/2015 13:41'!
testDefaultNamespace
	| namespaceScope oldPrefixMappings |

	namespaceScope := self newNamespaceScope.
	self assert: namespaceScope defaultNamespace isEmpty.

	oldPrefixMappings := namespaceScope prefixMappings.
	namespaceScope defaultNamespace: 'test'.
	self
		assert: namespaceScope defaultNamespace = 'test';
		assert: (namespaceScope prefixMappings at: '') = 'test';
		deny: namespaceScope prefixMappings = oldPrefixMappings.

	namespaceScope unmapPrefix: ''.
	self assert: namespaceScope defaultNamespace isEmpty.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 12/28/2014 23:31'!
testEquals
	self
		assert: self newNamespaceScope = self newNamespaceScope;
		assert: self newNamespaceScopeWithNamespaces = self newNamespaceScopeWithNamespaces;
		deny: self newNamespaceScope = self newNamespaceScopeWithNamespaces;
		deny: self newNamespaceScopeWithNamespaces = self newNamespaceScope! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 4/21/2015 12:49'!
testHasDefaultNamespace
	| namespaceScope |

	namespaceScope := self newNamespaceScope.
	self deny: namespaceScope hasDefaultNamespace.

	namespaceScope defaultNamespace: 'test'.
	self assert: namespaceScope hasDefaultNamespace.

	namespaceScope defaultNamespace: ''.
	self assert: namespaceScope hasDefaultNamespace.

	namespaceScope unmapPrefix: ''.
	self deny: namespaceScope hasDefaultNamespace.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 4/21/2015 11:36'!
testHasNamespaces
	| namespaceScope |

	namespaceScope := self newNamespaceScope.
	self deny: namespaceScope hasNamespaces.

	namespaceScope mapPrefixesAndURIs: self namespaces.
	self assert: namespaceScope hasNamespaces.
	self namespaces keysDo: [:each |
		self assert: namespaceScope hasNamespaces.
		namespaceScope unmapPrefix: each].
	self deny: namespaceScope hasNamespaces.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 4/21/2015 11:46'!
testIncludesPrefix
	| namespaceScope |

	namespaceScope := self newNamespaceScope.
	self
		deny: (namespaceScope includesPrefix: 'xml');
		deny: (namespaceScope includesPrefix: 'xmlns').

	"cannot map xmlns prefix, but can map xml"
	namespaceScope mapPrefix: 'xml' to: XMLNamespaceScope xmlNamespaceURI.
	self assert: (namespaceScope includesPrefix: 'xml').

	self namespaces keysAndValuesDo: [:prefix :uri |
		self deny: (namespaceScope includesPrefix: prefix).
		namespaceScope mapPrefix: prefix to: uri.
		self assert: (namespaceScope includesPrefix: prefix)].! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 4/21/2015 11:46'!
testIncludesPrefixMappedTo
	| namespaceScope |

	namespaceScope := self newNamespaceScope.
	self
		deny: (namespaceScope includesPrefix: 'xml' mappedTo: XMLNamespaceScope xmlNamespaceURI);
		deny: (namespaceScope includesPrefix: 'xmlns' mappedTo: XMLNamespaceScope xmlnsNamespaceURI).

	"cannot map xmlns prefix, but can map xml"
	namespaceScope mapPrefix: 'xml' to: XMLNamespaceScope xmlNamespaceURI.
	self assert: (namespaceScope includesPrefix: 'xml' mappedTo: XMLNamespaceScope xmlNamespaceURI).

	self namespaces keysAndValuesDo: [:prefix :uri |
		self deny: (namespaceScope includesPrefix: prefix mappedTo: uri).
		namespaceScope mapPrefix: prefix to: uri.
		self assert: (namespaceScope includesPrefix: prefix mappedTo: uri)].! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 12/28/2014 23:57'!
testInheritMappingsFrom
	| outerScope innerScope |

	outerScope := self newNamespaceScopeWithNamespaces.
	innerScope := self newNamespaceScope.
	innerScope inheritMappingsFrom: outerScope.
	self assert: innerScope prefixMappings == outerScope prefixMappings.

	innerScope := self newNamespaceScopeWithNamespaces.
	innerScope inheritMappingsFrom: outerScope.
	self
		assert: innerScope prefixMappings = outerScope prefixMappings;
		deny: innerScope prefixMappings == outerScope prefixMappings.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 4/21/2015 13:36'!
testMapPrefixTo
	| scope oldPrefixMappings |

	scope := self newNamespaceScope.
	self namespaces keysAndValuesDo: [:prefix :uri |
		oldPrefixMappings := scope prefixMappings.
		scope
			mapPrefix: prefix
			to: uri.
		"ensure prefixMappings is copied when adding"
		self
			assert: (scope prefixMappings at: prefix) = uri;
			deny: scope prefixMappings = oldPrefixMappings;
			deny: scope prefixMappings == oldPrefixMappings.

		oldPrefixMappings := scope prefixMappings.
		scope
			mapPrefix: prefix
			to: uri.
		"ensure prefixMappings is copied, even if it is unchanged"
		self
			assert: (scope prefixMappings at: prefix) = uri;
			assert: scope prefixMappings = oldPrefixMappings;
			deny: scope prefixMappings == oldPrefixMappings].
	self assert: scope prefixMappings associations asArray = self namespaces associations asArray.

	self namespaces keysAndValuesDo: [:prefix :uri |
		scope
			mapPrefix: prefix
			to: 'newNS'.
		self
			assert: (scope prefixMappings at: prefix) = 'newNS';
			deny: scope prefixMappings = oldPrefixMappings;
			deny: scope prefixMappings == oldPrefixMappings].! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 4/21/2015 12:13'!
testMapPrefixesAndURIs
	| outerScope innerScope namespaces |

	namespaces := self namespaces.
	(outerScope := self newNamespaceScope) mapPrefixesAndURIs: namespaces.
	self
		assert: outerScope prefixMappings = namespaces;
		deny: outerScope prefixMappings == namespaces.

	"copying shares dictionary until modified"
	innerScope := outerScope copy.
	self
		assert: innerScope prefixMappings = outerScope prefixMappings;
		assert: innerScope prefixMappings == outerScope prefixMappings.

	"modifying creates new dictionary"
	innerScope mapPrefixesAndURIs: namespaces.
	self
		assert: innerScope prefixMappings = outerScope prefixMappings;
		deny: innerScope prefixMappings == outerScope prefixMappings.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 4/21/2015 12:15'!
testPrefixMappingAt
	| namespaceScope |

	namespaceScope := self newNamespaceScope.
	self
		assert: (namespaceScope prefixMappingAt: 'xml') isEmpty;
		assert: (namespaceScope prefixMappingAt: 'xmlns') isEmpty.

	"cannot map xmlns prefix, but can map xml"
	namespaceScope mapPrefix: 'xml' to: XMLNamespaceScope xmlNamespaceURI.
	self assert: (namespaceScope prefixMappingAt: 'xml') = XMLNamespaceScope xmlNamespaceURI.

	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert: (namespaceScope prefixMappingAt: prefix) isEmpty.
		namespaceScope mapPrefix: prefix to: uri.
		self assert: (namespaceScope prefixMappingAt: prefix) = uri].! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 4/21/2015 12:17'!
testPrefixMappingAtIfAbsent
	| namespaceScope |

	namespaceScope := self newNamespaceScope.
	self
		assert: (namespaceScope prefixMappingAt: 'xml' ifAbsent: [#absent]) = #absent;
		assert: (namespaceScope prefixMappingAt: 'xmlns'ifAbsent: [#absent]) = #absent.

	"cannot map xmlns prefix, but can map xml"
	namespaceScope mapPrefix: 'xml' to: XMLNamespaceScope xmlNamespaceURI.
	self assert:
		(namespaceScope
			prefixMappingAt: 'xml'
			ifAbsent: [#absent]) = XMLNamespaceScope xmlNamespaceURI.

	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert:
			(namespaceScope
				prefixMappingAt: prefix
				ifAbsent: [#absent]) = #absent.
		namespaceScope mapPrefix: prefix to: uri.
		self assert:
			(namespaceScope
				prefixMappingAt: prefix
				ifAbsent: [#absent]) = uri].! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 4/21/2015 11:49'!
testPrefixesAndURIsDo
	| associations |

	associations := OrderedCollection new.
	self newNamespaceScope prefixesAndURIsDo: [:prefix :uri |
		associations addLast: prefix -> uri].
	self assert: associations isEmpty.

	self newNamespaceScopeWithNamespaces prefixesAndURIsDo: [:prefix :uri |
		associations addLast: prefix -> uri].
	self assert: associations asArray = self namespaces associations asArray.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 4/21/2015 12:29'!
testPrefixesOfNamespaceURI
	| namespaceScope |

	namespaceScope := self newNamespaceScope.
	self assert:
		(namespaceScope prefixesOfNamespaceURI: XMLNamespaceScope xmlNamespaceURI) =
			(Set with: 'xml').
	self assert:
		(namespaceScope prefixesOfNamespaceURI: XMLNamespaceScope xmlnsNamespaceURI) =
			(Set with: 'xmlns').

	"cannot map xmlns prefix, but can map xml"
	namespaceScope mapPrefix: 'xml' to: XMLNamespaceScope xmlNamespaceURI.
	self assert:
		(namespaceScope prefixesOfNamespaceURI: XMLNamespaceScope xmlNamespaceURI) =
			(Set with: 'xml').

	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert: (namespaceScope prefixesOfNamespaceURI: uri) isEmpty.

		namespaceScope mapPrefix: prefix to: uri.
		self assert: (namespaceScope prefixesOfNamespaceURI: uri) = (Set with: prefix).

		namespaceScope mapPrefix: 'newPrefix' to: uri.
		self assert:
			(namespaceScope prefixesOfNamespaceURI: uri) =
				(Set with: prefix with: 'newPrefix')].! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 4/21/2015 11:48'!
testResolvePrefix
	| namespaceScope |

	namespaceScope := self newNamespaceScope.
	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert: (namespaceScope resolvePrefix: prefix) isEmpty.
		namespaceScope mapPrefix: prefix to: uri.
		self assert: (namespaceScope resolvePrefix: prefix) = uri].

	self
		assert: (namespaceScope resolvePrefix: 'xml') = XMLNamespaceScope xmlNamespaceURI;
		assert: (namespaceScope resolvePrefix: 'xmlns') = XMLNamespaceScope xmlnsNamespaceURI.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 4/12/2015 11:52'!
testResolvePrefixIfUnresolvable
	| namespaceScope |

	namespaceScope := self newNamespaceScope.
	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert:
			(namespaceScope
				resolvePrefix: prefix
				ifUnresolvable: [#unresolvable]) = #unresolvable.
		namespaceScope mapPrefix: prefix to: uri.
		self assert:
			(namespaceScope
				resolvePrefix: prefix
				ifUnresolvable: [#unresolvable]) = uri].

	self assert:
		(namespaceScope
			resolvePrefix: 'xml'
			ifUnresolvable: [#unresolvable]) = XMLNamespaceScope xmlNamespaceURI.
	self  assert:
		(namespaceScope
			resolvePrefix: 'xmlns'
			ifUnresolvable: [#unresolvable]) = XMLNamespaceScope xmlnsNamespaceURI.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 12/28/2014 23:30'!
testSize
	self
		assert: self newNamespaceScope size = 0;
		assert: self newNamespaceScopeWithNamespaces size = self namespaces size! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 4/21/2015 13:35'!
testUnmapPrefix
	| scope oldPrefixMappings |

	scope := self newNamespaceScopeWithNamespaces.
	self namespaces keysAndValuesDo: [:prefix :uri |
		oldPrefixMappings := scope prefixMappings.
		scope unmapPrefix: prefix.
		"ensure prefixMappings is copied when removing"
		self
			deny: (scope prefixMappings includesKey: prefix);
			deny: scope prefixMappings = oldPrefixMappings;
			deny: scope prefixMappings == oldPrefixMappings.

		self
			should: [scope unmapPrefix: prefix]
			raise: XMLNamespaceException].
	self assert: scope prefixMappings isEmpty.! !

TestCase subclass: #XMLNodeFactoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Factories'!

!XMLNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 15:59'!
cdataClass
	^ XMLCData! !

!XMLNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 15:59'!
commentClass
	^ XMLComment! !

!XMLNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 16:00'!
documentClass
	^ XMLDocument! !

!XMLNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 16:01'!
elementClass
	^ XMLElement! !

!XMLNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 15:56'!
factoryClass
	^ XMLNodeFactory! !

!XMLNodeFactoryTest methodsFor: 'instance creation' stamp: 'monty 11/1/2014 15:56'!
newFactory
	^ self factoryClass new! !

!XMLNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 16:02'!
piClass
	^ XMLPI! !

!XMLNodeFactoryTest methodsFor: 'source XML' stamp: 'monty 11/1/2014 21:32'!
sampleUserXML
	^
	XMLWriter new
		enablePrettyPrinting;
		writeWith: [:writer |
			writer pi
				target: 'xml-stylesheet';
				data: 'type="text/css" href="sample.css"'.
			writer comment: 'sample'.
			writer tag
				name: 'user:user';
				xmlnsAt: 'user' put: 'urn:user';
				with: [
					writer
						tag: 'user:username' with: 'jsmith';
						tag: 'user:real-name' with: 'John Smith';
						tag: 'user:date-registered' with: [writer cdata: DateAndTime now printString];
						tag: 'user:date-last-active' with: [writer cdata: DateAndTime now printString];
						tag: 'table-name' with: 'users';
						tag: 'row-id' with: '1000';
						tag: 'serializationFormat' with: 'XML']];
		contents! !

!XMLNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 15:59'!
stringClass
	^ XMLString! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 4/17/2015 10:49'!
testAsPluggableNodeFactory
	| factory pluggableFactory |

	factory := self factoryClass new.
	pluggableFactory := factory asPluggableNodeFactory.
	self
		assert: (pluggableFactory isKindOf: XMLPluggableNodeFactory);
		deny: pluggableFactory == factory.! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 11/22/2014 23:02'!
testNewCData
	| cdata |

	cdata := self newFactory newCData: 'test'.
	self
		assert: cdata class == self cdataClass;
		assert: cdata string = 'test'.! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 11/22/2014 23:02'!
testNewComment
	| comment |

	comment := self newFactory newComment: 'test'.
	self
		assert: comment class == self commentClass;
		assert: comment string = 'test'.! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 11/22/2014 23:03'!
testNewDocument
	| newDocument |

	newDocument := self newFactory newDocument.
	self assert: newDocument class == self documentClass.! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 11/22/2014 23:05'!
testNewElement
	| element |

	element := self newFactory newElement.
	self assert: element class == self elementClass.! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 11/22/2014 23:05'!
testNewElementNamed
	| element |

	element := self newFactory newElementNamed: 'test'.
	self
		assert: element class == self elementClass;
		assert: element name = 'test'.! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 11/22/2014 23:07'!
testNewElementNamedNamespaceURI
	| element |

	element := self newFactory newElementNamed: 'prefix:test' namespaceURI: 'prefixNS'.
	self
		assert: element class == self elementClass;
		assert: element name = 'prefix:test';
		assert: element namespaceURI = 'prefixNS'.! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 11/22/2014 23:06'!
testNewPI
	self assert: self newFactory newPI class == self piClass! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 11/22/2014 23:06'!
testNewString
	| string |

	string := self newFactory newString: 'test'.
	self
		assert: string class == self stringClass;
		assert: string string = 'test'.! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 11/4/2014 20:23'!
testParsingSample
	| document factory |

	factory := self newFactory.
	document :=
		(XMLDOMParser on: self sampleUserXML)
			nodeFactory: factory;
			preservesCDataNodes: true;
			preservesCommentNodes: true;
			parseDocument.
	self
		assert: document class == self documentClass;
		assert: document nodeFactory == factory.

	document allElementsDo: [:each |
		self
			assert: each class == self elementClass;
			assert: each nodeFactory == factory].

	document allNodesDo: [:each |
		each isStringNode
			ifTrue: [
				self assert:
					each class == 
						(each isCData
							ifTrue: [self cdataClass]
							ifFalse: [self stringClass])].
		each isComment
			ifTrue: [self assert: each class == self commentClass].
		each isPI
			ifTrue: [self assert: each class == self piClass]].! !

XMLNodeFactoryTest subclass: #XMLPluggableNodeFactoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Factories'!

XMLPluggableNodeFactoryTest subclass: #XMLPluggableElementFactoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Factories'!

!XMLPluggableElementFactoryTest commentStamp: '<historical>' prior: 0!
This class tests the pluggable element factory. To do this it creates a number of dummy subclasses of XMLElement in its #setUp message that should be removed from the system by its #tearDown message. Since these classes only exist during testing, special accessor messages are used to reference them. These accessors are also generated automatically, whenever you send the class #createDummyElementAccessors. The names for the classes and accessors are taken from the class-side #dummyElementNames message and some supporting messages that specify a prefix and suffix (so the created classes don't collide with other, possibly pre-existing classes in the sytem).

Browse the class side for more information.!

!XMLPluggableElementFactoryTest class methodsFor: 'running' stamp: 'monty 11/1/2014 16:35'!
createDummyClasses
	super createDummyClasses.

	self createDummyElementClasses.! !

!XMLPluggableElementFactoryTest class methodsFor: 'running' stamp: 'monty 11/1/2014 16:30'!
createDummyElementClasses
	self dummyElementClassNames do: [:each |
		self
			createDummySubclassOf: XMLElement
			named: each]! !

!XMLPluggableElementFactoryTest class methodsFor: 'accessing' stamp: 'monty 11/1/2014 16:45'!
dummyElementClassNames
	^ self dummyElementNames collect: [:each |
		(self dummyClassPrefix,
			each,
			'Element') asSymbol]! !

!XMLPluggableElementFactoryTest class methodsFor: 'accessing' stamp: 'monty 11/2/2014 09:38'!
dummyElementNames
	^ #('User' 'Username' 'RealName' 'Date' 'Table' 'SerializationFormat' 'Wrong')! !

!XMLPluggableElementFactoryTest class methodsFor: 'running' stamp: 'monty 11/1/2014 16:44'!
removeDummyClasses
	super removeDummyClasses.

	self removeDummyElementClasses.! !

!XMLPluggableElementFactoryTest class methodsFor: 'running' stamp: 'monty 11/1/2014 16:44'!
removeDummyElementClasses
	self dummyElementClassNames do: [:each |
		self removeDummySubclassNamed: each]! !

!XMLPluggableElementFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:37'!
dateElementClass
	^ XMLFDateElement! !

!XMLPluggableElementFactoryTest methodsFor: 'accessing' stamp: 'monty 11/2/2014 09:38'!
defaultElementClass
	^ self elementClass! !

!XMLPluggableElementFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 15:58'!
factoryClass
	^ XMLPluggableElementFactory! !

!XMLPluggableElementFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:38'!
realNameElementClass
	^ XMLFRealNameElement! !

!XMLPluggableElementFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:38'!
serializationFormatElementClass
	^ XMLFSerializationFormatElement! !

!XMLPluggableElementFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:39'!
tableElementClass
	^ XMLFTableElement! !

!XMLPluggableElementFactoryTest methodsFor: 'tests' stamp: 'monty 7/15/2015 09:26'!
testCopy
	| factory copy |

	factory := self newFactory.
	factory handleElement: 'user' withClass: XMLFUserElement.
	copy := factory copy.
	self
		deny: copy == factory;
		deny: copy elementClasses == factory elementClasses;
		assert: copy elementClasses = factory elementClasses.

	copy handleElement: 'user' withClass: XMLElement.
	self deny: copy elementClasses = factory elementClasses.! !

!XMLPluggableElementFactoryTest methodsFor: 'tests' stamp: 'JAA 3/24/2011 18:25'!
testElementClassAccessor
	| document |

	document :=
		(XMLDOMParser on: self sampleUserXML)
			nodeFactory: XMLPluggableElementFactory new;
			parseDocument.
	self assert: (document allElementsDetect: [:each | (each isMemberOf: XMLElement) not]) isNil.

	document :=
		(XMLDOMParser on: self sampleUserXML)
			nodeFactory: (XMLPluggableElementFactory new elementClass: self defaultElementClass);
			parseDocument.
	self assert: (document allElementsDetect: [:each | (each isMemberOf: self defaultElementClass) not]) isNil.! !

!XMLPluggableElementFactoryTest methodsFor: 'tests' stamp: 'monty 11/1/2014 22:27'!
testElementClassNameMatching
	| document |

	document :=
		(XMLDOMParser on: self sampleUserXML)
			nodeFactory:
				(self newFactory
					handleElementsMatchingClass: self userElementClass;
					handleElementsMatchingClasses:
						(Array
							with: self realNameElementClass
							with: self serializationFormatElementClass));
			parseDocument.

	self
		assert: ((document root) isMemberOf: self userElementClass);
		assert: ((document root elementAt: 'real-name') isMemberOf: self realNameElementClass);
		assert:
			((document root elementAt: 'serializationFormat')
				isMemberOf: self serializationFormatElementClass).! !

!XMLPluggableElementFactoryTest methodsFor: 'tests' stamp: 'monty 11/1/2014 22:28'!
testElementNameAndNamespaceMatching
	| factory document root |

	(factory := self newFactory)
		elementClass: self defaultElementClass;
		handleElement: 'user:user' namespaceURI: 'urn:user' withClass: self userElementClass;
		handleElement: 'user:user' withClass: self wrongElementClass;
		handleElement: 'user' namespaceURI: 'urn:user' withClass: self wrongElementClass;
		handleElement: 'user' withClass: self wrongElementClass;
		handleElement: 'user:username' withClass: self usernameElementClass;
		handleElement: 'username' namespaceURI: 'urn:user' withClass: self wrongElementClass;
		handleElement: 'username' withClass: self wrongElementClass;
		handleElement: 'real-name' namespaceURI: 'urn:user' withClass: self realNameElementClass;
		handleElement: 'real-name' withClass: self wrongElementClass;
		handleElement: 'date-registered' withClass: self dateElementClass;
		handleElement: 'user:date-last-active' namespaceURI: 'urn:notuser' withClass: self wrongElementClass;
		handleElement: 'notuser:date-last-active' namespaceURI: 'urn:user' withClass: self wrongElementClass;
		handleElement: 'date-last-active' namespaceURI: 'urn:notuser' withClass: self wrongElementClass;
		handleElement: 'notuser:date-last-active' withClass: self wrongElementClass.

	document :=
		(XMLDOMParser on: self sampleUserXML)
			nodeFactory: factory;
			parseDocument.
	self
		assert: ((root := document root) isMemberOf: self userElementClass);
		assert: ((root elementAt: 'username') isMemberOf: self usernameElementClass);
		assert: ((root elementAt: 'real-name') isMemberOf: self realNameElementClass);
		assert: ((root elementAt: 'date-registered') isMemberOf: self dateElementClass);
		assert:
			((root elements copyAfter: (root elementAt: 'date-registered'))
				allSatisfy: [:each | each isMemberOf: self defaultElementClass]).! !

!XMLPluggableElementFactoryTest methodsFor: 'tests' stamp: 'monty 11/1/2014 22:28'!
testElementsNameAndNamespaceMatching
	| factory document root |

	factory := self newFactory.
	factory
		handleElements: #('date-registered' 'date-last-active')
		namespaceURI: 'urn:user'
		withClass: self dateElementClass.
	factory
		handleElements: #('date-registered' 'date-last-active')
		withClass: self wrongElementClass.
	factory
		handleElements: #('table-name' 'not-table-name')
		withClass: self tableElementClass.

	document :=
		(XMLDOMParser on: self sampleUserXML)
			nodeFactory: factory;
			parseDocument.
	root := document root.
	self
		assert: ((root elementAt: 'date-registered') isMemberOf: self dateElementClass);
		assert: ((root elementAt: 'date-last-active') isMemberOf: self dateElementClass);
		assert: ((root elementAt: 'table-name') isMemberOf: self tableElementClass).! !

!XMLPluggableElementFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:38'!
userElementClass
	^ XMLFUserElement! !

!XMLPluggableElementFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:37'!
usernameElementClass
	^ XMLFUsernameElement! !

!XMLPluggableElementFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:37'!
wrongElementClass
	^ XMLFWrongElement! !

!XMLPluggableNodeFactoryTest class methodsFor: 'running' stamp: 'monty 11/1/2014 16:34'!
createDummyClasses
	self nodeClasses
		with: self dummyClassNames
		do: [:nodeClass :dummyName |
			self
				createDummySubclassOf: nodeClass
				named: dummyName]! !

!XMLPluggableNodeFactoryTest class methodsFor: 'running' stamp: 'monty 11/1/2014 22:22'!
createDummySubclassOf: aNodeClass named: aName
	(aNodeClass
		subclass: aName asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self category)
		comment: 'A dummy subclass of ', aNodeClass name asString! !

!XMLPluggableNodeFactoryTest class methodsFor: 'accessing' stamp: 'monty 11/1/2014 21:43'!
dummyClassNames
	^ self nodeClasses collect: [:each |
		(self dummyClassPrefix,
			(each name asString allButFirst: 3)) asSymbol]! !

!XMLPluggableNodeFactoryTest class methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:39'!
dummyClassPrefix
	^ 'XMLF'! !

!XMLPluggableNodeFactoryTest class methodsFor: 'accessing' stamp: 'monty 11/1/2014 16:26'!
nodeClasses
	^ #(XMLDocument XMLElement XMLString XMLCData XMLComment XMLPI)
		collect: [:each | Smalltalk at: each]! !

!XMLPluggableNodeFactoryTest class methodsFor: 'running' stamp: 'monty 11/1/2014 16:33'!
removeDummyClasses
	self dummyClassNames do: [:each |
		self removeDummySubclassNamed: each]! !

!XMLPluggableNodeFactoryTest class methodsFor: 'running' stamp: 'monty 11/1/2014 16:32'!
removeDummySubclassNamed: aName
	(Smalltalk at: aName asSymbol) removeFromSystem! !

!XMLPluggableNodeFactoryTest class methodsFor: 'testing' stamp: 'monty 11/24/2014 07:39'!
shouldInheritSelectors
	^ true! !

!XMLPluggableNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:36'!
cdataClass
	^ XMLFCData! !

!XMLPluggableNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:36'!
commentClass
	^ XMLFComment! !

!XMLPluggableNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:37'!
documentClass
	^ XMLFDocument! !

!XMLPluggableNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:37'!
elementClass
	^ XMLFElement! !

!XMLPluggableNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 16:51'!
factoryClass
	^ XMLPluggableNodeFactory! !

!XMLPluggableNodeFactoryTest methodsFor: 'instance creation' stamp: 'monty 11/1/2014 21:44'!
newFactory
	^ self factoryClass new
		documentClass: self documentClass;
		elementClass: self elementClass;
		stringClass: self stringClass;
		cdataClass: self cdataClass;
		commentClass: self commentClass;
		piClass: self piClass! !

!XMLPluggableNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:38'!
piClass
	^ XMLFPI! !

!XMLPluggableNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:38'!
stringClass
	^ XMLFString! !

!XMLPluggableNodeFactoryTest methodsFor: 'tests' stamp: 'monty 4/17/2015 10:49'!
testAsPluggableNodeFactory
	| factory pluggableFactory |

	factory := self factoryClass new.
	pluggableFactory := factory asPluggableNodeFactory.
	self
		assert: (pluggableFactory isKindOf: XMLPluggableNodeFactory);
		assert: pluggableFactory == factory.! !

TestCase subclass: #XMLNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLNodeTest commentStamp: '<historical>' prior: 0!
This is a base class for node tests.!

XMLNodeTest subclass: #XMLAttributeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLAttributeTest methodsFor: 'accessing' stamp: 'monty 11/23/2014 00:03'!
escapedString
	^ '&lt;test name=&quot;&amp;name;&quot;>''&amp;value;''&lt;/test>'! !

!XMLAttributeTest methodsFor: 'accessing' stamp: 'monty 11/2/2014 11:17'!
nodeClass
	^ XMLAttribute! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 12/6/2014 14:24'!
testCanonicallyEquals
	super testCanonicallyEquals.
	self assert:
		((self nodeClass name: 'one' value: 'two') canonicallyEquals:
			(self nodeClass name: 'one' value: 'two')).
	self deny: ((self nodeClass name: 'one' value: 'two') canonicallyEquals: self nodeClass new).! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 11/22/2014 20:14'!
testCopy
	| node copy |

	(node := self nodeClass new)
		element: XMLElement new.
	copy := node copy.
	self
		deny: copy == node;
		assert: copy element isNil.! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:06'!
testElement
	| node element |

	node := self nodeClass new.
	element := XMLElement new.
	node element: element.
	self assert: node element == element.! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 12/30/2014 02:39'!
testExpandedName
	| element attribute |

	element := XMLElement new.
	attribute := self nodeClass name: 'one' value: 'two'.
	element attributeNodes add: attribute.
	self assert: (attribute expandedName = 'one').

	element defaultNamespace: 'defaultNS'.
	self assert: (attribute expandedName = 'one').

	element declarePrefix: 'prefix' uri: 'prefixNS'.
	attribute name: 'prefix:two'.
	self assert: (attribute expandedName = 'Q{prefixNS}two').! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 12/23/2014 16:18'!
testHasLanguage
	| attribute |

	attribute := self nodeClass new.
	attribute name: 'xml:lang'.
	self
		deny: (attribute hasLanguage: 'en-us');
		deny: (attribute hasLanguage: 'EN-US');
		deny: (attribute hasLanguage: 'En');
		deny: (attribute hasLanguage: 'de-de');
		deny: (attribute hasLanguage: 'DE-DE');
		deny: (attribute hasLanguage: 'De').

	attribute value: 'En-Us'.
	self
		assert: (attribute hasLanguage: 'en-us');
		assert: (attribute hasLanguage: 'EN-US');
		assert: (attribute hasLanguage: 'En');
		deny: (attribute hasLanguage: 'de-de');
		deny: (attribute hasLanguage: 'DE-DE');
		deny: (attribute hasLanguage: 'De').! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 2/13/2015 22:25'!
testHasNamespaceURI
	| element attribute |

	attribute := self nodeClass name: 'test' value: ''.
	self deny: attribute hasNamespaceURI.

	element := XMLElement name: 'test' namespaceURI: 'defaultNS'.
	element attributeNodes add: attribute.
	self deny: attribute hasNamespaceURI.

	element
		declarePrefix: 'prefix'
		uri: 'prefixNS'.
	attribute name: 'prefix:test'.
	self assert: attribute hasNamespaceURI.

	attribute name: 'test'.
	self deny: attribute hasNamespaceURI.! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 11/23/2014 20:28'!
testHasPrefix
	| attribute |

	attribute := self nodeClass new.
	self deny: attribute hasPrefix.

	attribute name: 'one'.
	self deny: attribute hasPrefix.

	attribute name: 'prefix:two'.
	self assert: attribute hasPrefix.

	attribute name: 'three'.
	self deny: attribute hasPrefix.! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 1/29/2015 00:31'!
testIsAttribute
	self assert: self nodeClass new isAttribute! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 12/23/2014 21:04'!
testIsInLanguage
	| element |

	super testIsInLanguage.
	element := self newElementWithAttributes.	
	element attributeNodesDo: [:each |
		self
			deny: (each isInLanguage: 'en');
			deny: (each isInLanguage: 'EN');
			deny: (each isInLanguage: 'En');
			deny: (each isInLanguage: 'en-us');
			deny: (each isInLanguage: 'EN-US');
			deny: (each isInLanguage: 'En-Us')].

	element attributeAt: 'xml:lang' put: 'En'.
	element attributeNodesDo: [:each |
		self
			assert: (each isInLanguage: 'en');
			assert: (each isInLanguage: 'EN');
			assert: (each isInLanguage: 'En');
			deny: (each isInLanguage: 'en-us');
			deny: (each isInLanguage: 'EN-US');
			deny: (each isInLanguage: 'En-Us')].! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 11/23/2014 05:01'!
testIsNamed
	| attribute |

	(attribute := self nodeClass new) name: 'one'.
	self
		assert: (attribute isNamed: 'one');
		deny: (attribute isNamed: 'two').
	attribute name: 'one:two'.
	self
		assert: (attribute isNamed: 'one:two');
		assert: (attribute isNamed: 'two');
		deny: (attribute isNamed: 'one').! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 11/23/2014 05:06'!
testIsNamedAny
	| attribute |

	(attribute := self nodeClass new) name: 'one'.
	self
		assert: (attribute isNamedAny: #('two' 'one' 'three'));
		deny: (attribute isNamedAny: #('two' 'three')).
	attribute name: 'one:two'.
	self
		assert: (attribute isNamedAny: #('one' 'one:two' 'three'));
		assert: (attribute isNamedAny: #('one' 'two' 'three'));
		deny: (attribute isNamedAny: #('one' 'three')).! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 11/23/2014 20:21'!
testLocalName
	| attribute |

	attribute := self nodeClass new.
	self assert: attribute name isEmpty.

	attribute name: 'one'.
	self assert: attribute localName = 'one'.

	attribute name: 'two'.
	self assert: attribute localName = 'two'.

	attribute name: 'prefix:three'.
	self assert: attribute localName = 'three'.

	attribute name: 'four'.
	self assert: attribute localName = 'four'.! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 11/23/2014 20:23'!
testName
	| attribute |

	attribute := self nodeClass new.
	self assert: attribute name isEmpty.

	attribute name: 'one'.
	self assert: attribute name = 'one'.

	attribute name: 'prefix:two'.
	self assert: attribute name = 'prefix:two'.! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 11/23/2014 04:55'!
testNameValue
	| attribute |

	attribute := self nodeClass name: 'one' value: 'two'.
	self
		assert: attribute name = 'one';
		assert: attribute value = 'two'! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 11/23/2014 20:33'!
testNamespaceURI
	| element attribute|

	element := XMLElement new.
	attribute := self nodeClass new.
	element attributeNodes add: attribute.
	self assert: attribute namespaceURI isEmpty.

	element defaultNamespace: 'defaultNS'.
	self assert: attribute namespaceURI isEmpty.

	element declarePrefix: 'prefix' uri: 'prefixNS'.
	attribute name: 'prefix:test'.
	self assert: attribute namespaceURI = 'prefixNS'.
	
	attribute name: 'test'.
	self assert: attribute namespaceURI isEmpty.! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 11/23/2014 20:27'!
testPrefix
	| attribute |

	attribute := self nodeClass new.
	self assert: attribute prefix isEmpty.

	attribute name: 'one'.
	self assert: attribute prefix isEmpty.

	attribute name: 'prefix:two'.
	self assert: attribute prefix = 'prefix'.

	attribute name: 'three'.
	self assert: attribute prefix isEmpty.! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 12/3/2014 01:10'!
testSortKey
	self assert: (self nodeClass new name: 'test') sortKey = 'test'! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 11/23/2014 20:16'!
testValue
	self
		assert: self nodeClass new value isEmpty;
		assert: (self nodeClass new value: 'test') value = 'test'! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 11/23/2014 05:17'!
testWriteXMLOn
	self
		assert: (self nodeClass name: 'name' value: '') printString = 'name=""';
		assert: (self nodeClass name: 'name' value: 'value') printString = 'name="value"';
		assert:
			(self nodeClass
				name: 'name'
				value: self markupString) printString = ('name="', self escapedString, '"')! !

XMLNodeTest subclass: #XMLCommentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLCommentTest methodsFor: 'accessing' stamp: 'monty 11/2/2014 11:17'!
nodeClass
	^ XMLComment! !

!XMLCommentTest methodsFor: 'tests' stamp: 'monty 12/6/2014 14:27'!
testCanonicallyEquals
	super testCanonicallyEquals.
	self
		assert: ((self nodeClass string: 'test') canonicallyEquals: (self nodeClass string: 'test'));
		deny: ((self nodeClass string: 'test') canonicallyEquals: self nodeClass new).! !

!XMLCommentTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:47'!
testIsComment
	self assert: self nodeClass new isComment! !

!XMLCommentTest methodsFor: 'tests' stamp: 'monty 12/3/2014 01:09'!
testSortKey
	self assert: (self nodeClass string: 'test') sortKey = 'test'! !

!XMLCommentTest methodsFor: 'tests' stamp: 'monty 11/22/2014 23:25'!
testString
	| comment |

	comment := self nodeClass new.
	self assert: comment string isEmpty.
	comment string: self markupString.
	self assert: comment string = self markupString.

	self assert: (self nodeClass string: self markupString) string = self markupString.! !

!XMLCommentTest methodsFor: 'tests' stamp: 'monty 11/22/2014 19:27'!
testWriteXMLOn
	self
		assert: self nodeClass new printString = '<!!---->';
		assert: (self nodeClass string: self markupString) printString = ('<!!--', self markupString, '-->')! !

XMLNodeTest subclass: #XMLDeclarationNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLDeclarationNodeTest commentStamp: 'monty 11/23/2014 18:43' prior: 0!
Abstract, do not run.!

XMLDeclarationNodeTest subclass: #XMLAttributeDeclarationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLAttributeDeclarationTest class methodsFor: 'testing' stamp: 'monty 11/23/2014 19:21'!
isAbstract
	^ false! !

!XMLAttributeDeclarationTest methodsFor: 'accessing' stamp: 'monty 11/23/2014 19:22'!
nodeClass
	^ XMLAttributeDeclaration! !

!XMLAttributeDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 19:24'!
testAttribute
	self
		assert: self nodeClass new attribute isEmpty;
		assert: (self nodeClass new attribute: 'test') attribute = 'test'! !

!XMLAttributeDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 19:34'!
testDefaultPragma
	self
		assert: self nodeClass new defaultPragma isEmpty;
		assert: (self nodeClass new defaultPragma: 'REQUIRED') defaultPragma = 'REQUIRED'! !

!XMLAttributeDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 19:24'!
testDefaultValue
	self
		assert: self nodeClass new defaultValue isEmpty;
		assert: (self nodeClass new defaultValue: 'test') defaultValue = 'test'! !

!XMLAttributeDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 19:24'!
testElement
	self
		assert: self nodeClass new element isEmpty;
		assert: (self nodeClass new element: 'test') element = 'test'! !

!XMLAttributeDeclarationTest methodsFor: 'tests' stamp: 'monty 11/24/2014 06:50'!
testElementAttributeTypeDefaultPragmaDefaultValue
	| declaration |

	declaration :=
		self nodeClass
			element: 'one'
			attribute: 'two'
			type: 'CDATA'
			defaultPragma: '#IMPLIED'
			defaultValue: 'default'.
	self
		assert: declaration element = 'one';
		assert: declaration attribute = 'two';
		assert: declaration type = 'CDATA';
		assert: declaration defaultPragma = '#IMPLIED';
		assert: declaration defaultValue = 'default'.! !

!XMLAttributeDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 19:34'!
testType
	self
		assert: self nodeClass new type isEmpty;
		assert: (self nodeClass new type: 'CDATA') type = 'CDATA'! !

!XMLAttributeDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 19:33'!
testWriteXMLOn
	self assert:
		(self nodeClass
			element: 'one'
			attribute: 'two'
			type: 'CDATA'
			defaultPragma: ''
			defaultValue: 'three') printString = '<!!ATTLIST one two CDATA "three">'.
	self assert:
		(self nodeClass
			element: 'one'
			attribute: 'two'
			type: 'ENTITY'
			defaultPragma: 'FIXED'
			defaultValue: 'three') printString = '<!!ATTLIST one two ENTITY #FIXED "three">'.
	self assert:
		(self nodeClass
			element: 'one'
			attribute: 'two'
			type: '(three|four)'
			defaultPragma: '#IMPLIED'
			defaultValue: 'four') printString = '<!!ATTLIST one two (three|four) #IMPLIED "four">'.! !

!XMLDeclarationNodeTest class methodsFor: 'testing' stamp: 'monty 11/23/2014 18:14'!
isAbstract
	^ true! !

!XMLDeclarationNodeTest methodsFor: 'accessing' stamp: 'monty 11/23/2014 18:11'!
nodeClass
	^ XMLDeclarationNode! !

!XMLDeclarationNodeTest methodsFor: 'tests' stamp: 'monty 11/23/2014 18:11'!
testIsDeclaration
	self assert: self nodeClass new isDeclaration! !

XMLDeclarationNodeTest subclass: #XMLElementDeclarationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLElementDeclarationTest class methodsFor: 'testing' stamp: 'monty 11/23/2014 18:27'!
isAbstract
	^ false! !

!XMLElementDeclarationTest methodsFor: 'accessing' stamp: 'monty 11/23/2014 18:25'!
nodeClass
	^ XMLElementDeclaration! !

!XMLElementDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 18:26'!
testContentModel
	self
		assert: self nodeClass new contentModel isEmpty;
		assert: (self nodeClass new contentModel: '(one|two)') contentModel = '(one|two)'! !

!XMLElementDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 18:25'!
testElement
	self
		assert: self nodeClass new element isEmpty;
		assert: (self nodeClass new element: 'test') element = 'test'! !

!XMLElementDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 18:28'!
testElementContentModel
	| declaration |

	declaration :=
		self nodeClass
			element: 'one'
			contentModel: '(two|three)'.
	self
		assert: declaration element = 'one';
		assert: declaration contentModel = '(two|three)'! !

!XMLElementDeclarationTest methodsFor: 'assertions' stamp: 'monty 11/23/2014 18:31'!
testWriteXMLOn
	self assert:
		(self nodeClass
			element: 'one'
			contentModel: '(two | three)') printString = '<!!ELEMENT one (two | three)>'.
	self assert:
		(self nodeClass
			element: 'one'
			contentModel: 'EMPTY') printString = '<!!ELEMENT one EMPTY>'.! !

XMLDeclarationNodeTest subclass: #XMLEntityDeclarationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLEntityDeclarationTest commentStamp: 'monty 11/23/2014 18:46' prior: 0!
Abstract, do not run.!

!XMLEntityDeclarationTest class methodsFor: 'testing' stamp: 'monty 11/23/2014 18:47'!
isAbstract
	^ true! !

!XMLEntityDeclarationTest methodsFor: 'accessing' stamp: 'monty 11/23/2014 18:46'!
nodeClass
	^ XMLEntityDeclaration! !

!XMLEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 19:02'!
testIsParameter
	self deny: self nodeClass new isParameter! !

!XMLEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 18:49'!
testName
	self
		assert: self nodeClass new name isEmpty;
		assert: (self nodeClass new name: 'test') name = 'test'! !

!XMLEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 18:59'!
testNamePublicIDSystemID
	| declaration |

	declaration := self nodeClass name: 'one' publicID: 'two' systemID: 'three'.
	self
		assert: declaration name = 'one';
		assert: declaration publicID = 'two';
		assert: declaration systemID = 'three'.! !

!XMLEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 18:58'!
testNameReplacement
	| declaration |

	declaration := self nodeClass name: 'one' replacement: 'two'.
	self
		assert: declaration name = 'one';
		assert: declaration replacement = 'two'.! !

!XMLEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 18:50'!
testPublicID
	self
		assert: self nodeClass new publicID isEmpty;
		assert: (self nodeClass new publicID: 'test') publicID = 'test'! !

!XMLEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 18:49'!
testReplacement
	self
		assert: self nodeClass new replacement isEmpty;
		assert: (self nodeClass new replacement: 'test') replacement = 'test'! !

!XMLEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 18:50'!
testSystemID
	self
		assert: self nodeClass new systemID isEmpty;
		assert: (self nodeClass new systemID: 'test') systemID = 'test'! !

XMLEntityDeclarationTest subclass: #XMLGeneralEntityDeclarationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLGeneralEntityDeclarationTest class methodsFor: 'testing' stamp: 'monty 11/23/2014 18:47'!
isAbstract
	^ false! !

!XMLGeneralEntityDeclarationTest methodsFor: 'accessing' stamp: 'monty 11/23/2014 18:59'!
nodeClass
	^ XMLGeneralEntityDeclaration! !

!XMLGeneralEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 19:03'!
testNamePublicIDSystemIDNdata
	| declaration |

	declaration := self nodeClass name: 'one' publicID: 'two' systemID: 'three' ndata: 'four'.
	self
		assert: declaration name = 'one';
		assert: declaration publicID = 'two';
		assert: declaration systemID = 'three';
		assert: declaration ndata = 'four'.! !

!XMLGeneralEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 18:53'!
testNdata
	self
		assert: self nodeClass new ndata isEmpty;
		assert: (self nodeClass new ndata: 'test') ndata = 'test'! !

!XMLGeneralEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 19:07'!
testWriteXMLOn
	self assert:
		(self nodeClass name: 'one' replacement: 'two') printString =
			'<!!ENTITY one "two">'.
	self assert:
		(self nodeClass name: 'one' publicID: 'two' systemID: 'three') printString =
			'<!!ENTITY one PUBLIC "two" "three">'.
	self assert:
		(self nodeClass name: 'one' publicID: '' systemID: 'three') printString =
			'<!!ENTITY one SYSTEM "three">'.
	self assert:
		(self nodeClass name: 'one' publicID: 'two' systemID: 'three' ndata: 'four') printString =
			'<!!ENTITY one PUBLIC "two" "three" NDATA four>'.! !

XMLEntityDeclarationTest subclass: #XMLParameterEntityDeclarationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLParameterEntityDeclarationTest class methodsFor: 'testing' stamp: 'monty 11/23/2014 19:18'!
isAbstract
	^ false! !

!XMLParameterEntityDeclarationTest methodsFor: 'accessing' stamp: 'monty 11/23/2014 19:01'!
nodeClass
	^ XMLParameterEntityDeclaration! !

!XMLParameterEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 19:01'!
testIsParameter
	self assert: self nodeClass new isParameter! !

!XMLParameterEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 19:07'!
testWriteXMLOn
	self assert:
		(self nodeClass name: 'one' replacement: 'two') printString =
			'<!!ENTITY % one "two">'.
	self assert:
		(self nodeClass name: 'one' publicID: 'two' systemID: 'three') printString =
			'<!!ENTITY % one PUBLIC "two" "three">'.
	self assert:
		(self nodeClass name: 'one' publicID: '' systemID: 'three') printString =
			'<!!ENTITY % one SYSTEM "three">'.! !

XMLDeclarationNodeTest subclass: #XMLNotationDeclarationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLNotationDeclarationTest class methodsFor: 'testing' stamp: 'monty 11/23/2014 19:12'!
isAbstract
	^ false! !

!XMLNotationDeclarationTest methodsFor: 'accessing' stamp: 'monty 11/23/2014 19:15'!
nodeClass
	^ XMLNotationDeclaration! !

!XMLNotationDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 19:12'!
testName
	self
		assert: self nodeClass new name isEmpty;
		assert: (self nodeClass new name: 'test') name = 'test'! !

!XMLNotationDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 19:18'!
testNamePublicIDSystemID
	| declaration |

	declaration := self nodeClass name: 'one' publicID: 'two' systemID: 'three'.
	self
		assert: declaration name = 'one';
		assert: declaration publicID = 'two';
		assert: declaration systemID = 'three'.! !

!XMLNotationDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 19:12'!
testPublicID
	self
		assert: self nodeClass new publicID isEmpty;
		assert: (self nodeClass new publicID: 'test') publicID = 'test'! !

!XMLNotationDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 19:12'!
testSystemID
	self
		assert: self nodeClass new systemID isEmpty;
		assert: (self nodeClass new systemID: 'test') systemID = 'test'! !

!XMLNotationDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 19:20'!
testWriteXMLOn
	self assert:
		(self nodeClass name: 'one' publicID: 'two' systemID: 'three') printString =
			'<!!NOTATION one PUBLIC "two" "three">'.
	self assert:
		(self nodeClass name: 'one' publicID: '' systemID: 'two') printString =
			'<!!NOTATION one SYSTEM "two">'.
	self assert:
		(self nodeClass name: 'one' publicID: 'two' systemID: '') printString =
			'<!!NOTATION one PUBLIC "two">'.! !

!XMLNodeTest class methodsFor: 'testing' stamp: 'monty 11/2/2014 10:56'!
shouldInheritSelectors
	^ true! !

!XMLNodeTest methodsFor: 'assertions' stamp: 'monty 11/7/2014 14:19'!
assertList: aList collects: aSecondList
	self
		assert: aList = aSecondList;
		assert: aList class == self collectListClass.! !

!XMLNodeTest methodsFor: 'assertions' stamp: 'monty 3/9/2015 19:06'!
assertList: aList selects: aSecondList
	self
		assert: aList = aSecondList;
		assert: aList class == self selectListClass.! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 11/7/2014 14:19'!
collectListClass
	^ XMLOrderedList! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 12/1/2014 09:31'!
escapedString
	^ '&lt;test name="&amp;name;"&gt;''&amp;value;''&lt;/test&gt;'! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 11/7/2014 13:56'!
markupString
	^ '<test name="&name;">''&value;''</test>'! !

!XMLNodeTest methodsFor: 'instance creation' stamp: 'monty 11/24/2014 18:37'!
newElementWithAttributes
	| element |

	element :=
		XMLElement
			name: 'test'
			namespaces: (Array with: '' -> 'defaultNS' with: 'prefix' -> 'testNS').
	element attributeNodes
		add: (XMLAttribute name: 'one' value: 'two');
		add: (XMLAttribute name: 'three' value: 'four');
		add: (XMLAttribute name: 'prefix:three' value: 'five');
		add: (XMLAttribute name: 'prefix:six' value: 'seven').
	^ element.! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 11/2/2014 10:59'!
nodeClass
	^ XMLNode! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 3/9/2015 19:06'!
selectListClass
	^ XMLNodeList! !

!XMLNodeTest methodsFor: 'assertions' stamp: 'JAAyer 10/28/2010 21:25'!
should: aBlock enumerate: aCollection
	| enumerated |

	enumerated := OrderedCollection new.
	aBlock value: [:each | enumerated add: each].
	self assert: enumerated = aCollection asOrderedCollection.! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/24/2014 18:19'!
testAddContent
	self should: [self nodeClass new addContent: 'test'] raise: Error! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:14'!
testAncestorElements
	self assert: self nodeClass new ancestorElements isEmpty! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:16'!
testAncestorElementsDo
	| node |

	node := self nodeClass new.
	self should: [:block |  node ancestorElementsDo: block] enumerate: #().! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:13'!
testAncestorNodes
	self assert: self nodeClass new ancestorNodes isEmpty! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:16'!
testAncestorNodesDo
	| node |

	node := self nodeClass new.
	self should: [:block |  node ancestorNodesDo: block] enumerate: #().! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/23/2014 20:54'!
testCanHaveChildren
	self deny: self nodeClass new canHaveChildren! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 12/6/2014 14:16'!
testCanonicallyEquals
	self assert: (self nodeClass new canonicallyEquals: self nodeClass new)! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/24/2014 05:05'!
testConfiguration
	self assert: self nodeClass new configuration isNil! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:07'!
testContentString
	self assert: self nodeClass new contentString isEmpty! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/22/2014 20:15'!
testCopy
	| node copy |

	(node := self nodeClass new)
		parent: self nodeClass new.
	copy := node copy.
	self
		deny: copy == node;
		deny: copy hasParent. ! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/24/2014 00:12'!
testDocument
	self assert: self nodeClass new document isNil! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:08'!
testHasChildren
	self deny: self nodeClass new hasChildren! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:12'!
testHasParent
	| node |

	node := self nodeClass new.
	self deny: node hasParent.

	node parent: self nodeClass new.
	self assert: node hasParent.! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 1/29/2015 00:31'!
testIsAttribute
	self deny: self nodeClass new isAttribute! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:40'!
testIsCData
	self deny: self nodeClass new isCData! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:40'!
testIsComment
	self deny: self nodeClass new isComment! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:40'!
testIsContentNode
	self deny: self nodeClass new isContentNode! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:39'!
testIsDeclaration
	self deny: self nodeClass new isDeclaration! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:39'!
testIsDocument
	self deny: self nodeClass new isDocument! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:35'!
testIsElement
	self deny: self nodeClass new isElement! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:41'!
testIsElementNamed
	self deny: (self nodeClass new isElementNamed: '')! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:35'!
testIsElementNamedAny
	self deny: (self nodeClass new isElementNamedAny: #())! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 12/23/2014 16:23'!
testIsInLanguage
	self deny: (self nodeClass new isInLanguage: 'test')! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:38'!
testIsPI
	self deny: self nodeClass new isPI! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/20/2014 02:49'!
testIsStringNode
	self
		deny: self nodeClass new isStringNode;
		deny: (self nodeClass new isStringNode: '').! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/19/2014 20:58'!
testNextNode
	self assert: self nodeClass new nextNode isNil! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:11'!
testParent
	| node parent |

	node := self nodeClass new.
	self assert: node parent isNil.

	parent := self nodeClass new.
	node parent: parent.
	self assert: node parent == parent.! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/19/2014 20:58'!
testPreviousNode
	self assert: self nodeClass new previousNode isNil! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 11/19/2014 23:47'!
testRawContentString
	self assert: self nodeClass new rawContentString isEmpty! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 12/2/2014 22:58'!
testSortKey
	self assert: self nodeClass new sortKey = self nodeClass name asString! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 4/6/2015 06:41'!
testValidate
	self
		shouldnt: [self nodeClass new validate]
		raise: XMLValidationException! !

XMLNodeTest subclass: #XMLNodeWithChildrenTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLNodeWithChildrenTest commentStamp: 'monty 11/4/2014 19:05' prior: 0!
Abstract, do not run.!

XMLNodeWithChildrenTest subclass: #XMLDoctypeDeclarationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLDoctypeDeclarationTest class methodsFor: 'testing' stamp: 'monty 11/2/2014 11:06'!
isAbstract
	^ false! !

!XMLDoctypeDeclarationTest methodsFor: 'instance creation' stamp: 'monty 11/22/2014 20:38'!
newNodeWithNodes
	^ self nodeClass new
		addNode: (XMLComment string: 'before');
		addNode: (XMLGeneralEntityDeclaration name: 'one' replacement: 'two');
		addNode: (XMLParameterEntityDeclaration name: 'three' publicID: 'four' systemID: 'four');
		addNode: (XMLElementDeclaration element: 'five' contentModel: '(six|sevent|eight)');
		addNode:
			(XMLAttributeDeclaration
				element: 'five'
				attribute: 'nine'
				type: 'CDATA'
				defaultPragma: '#IMPLIED'
				defaultValue: 'ten');
		addNode:
			(XMLNotationDeclaration
				name: 'eleven'
				publicID: 'twelve'
				systemID: 'twelve');
		addNode: (XMLPI target: 'thirteen' data: 'fourteen');
		addNode: (XMLComment string: 'after');
		yourself! !

!XMLDoctypeDeclarationTest methodsFor: 'accessing' stamp: 'monty 11/2/2014 11:02'!
nodeClass
	^ XMLDoctypeDeclaration! !

!XMLDoctypeDeclarationTest methodsFor: 'accessing' stamp: 'monty 3/9/2015 19:06'!
selectListClass
	^ XMLInternalSubsetList! !

!XMLDoctypeDeclarationTest methodsFor: 'tests' stamp: 'monty 11/22/2014 20:40'!
testAllNodes
	| nodeWithNodes allNodes |

	nodeWithNodes := self newNodeWithNodes.
	allNodes := nodeWithNodes allNodes.
	self
		assert: allNodes size = 9;
		assert: allNodes first == nodeWithNodes;
		assert: allNodes second isComment;
		assert: allNodes second string = 'before';
		assert: allNodes third class == XMLGeneralEntityDeclaration;
		assert: allNodes fourth class == XMLParameterEntityDeclaration;
		assert: allNodes fifth class == XMLElementDeclaration;
		assert: allNodes sixth class == XMLAttributeDeclaration;
		assert: allNodes seventh class == XMLNotationDeclaration;
		assert: allNodes eighth isPI;
		assert: allNodes ninth isComment;
		assert: allNodes ninth string = 'after'.! !

!XMLDoctypeDeclarationTest methodsFor: 'tests' stamp: 'monty 12/6/2014 16:56'!
testCanonicallyEquals
	self
		assert: (self nodeClass new canonicallyEquals: self nodeClass new);
		assert: (self newNodeWithNodes canonicallyEquals: self newNodeWithNodes);
		assert: (self newNodeWithNodes canonicallyEquals: self nodeClass new)! !

!XMLDoctypeDeclarationTest methodsFor: 'tests' stamp: 'monty 11/22/2014 19:36'!
testNodes
	self assert: (self nodeClass new nodes isKindOf: XMLInternalSubsetList)! !

!XMLDoctypeDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 18:32'!
testPublicID
	self
		assert: self nodeClass new publicID isEmpty;
		assert: (self nodeClass new publicID: 'test') publicID = 'test'! !

!XMLDoctypeDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 18:32'!
testRoot
	self
		assert: self nodeClass new root isEmpty;
		assert: (self nodeClass new root: 'test') root = 'test'! !

!XMLDoctypeDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 18:34'!
testRootPublicIDSystemID
	| doctype |

	doctype := self nodeClass root: 'one' publicID: 'two' systemID: 'three'.
	self
		assert: doctype root = 'one';
		assert: doctype publicID = 'two';
		assert: doctype systemID = 'three'! !

!XMLDoctypeDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 18:32'!
testSystemID
	self
		assert: self nodeClass new systemID isEmpty;
		assert: (self nodeClass new systemID: 'test') systemID = 'test'! !

!XMLDoctypeDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 18:44'!
testWriteXMLOn
	| doctype elementDeclaration |

	doctype := self nodeClass new.
	self assert: doctype printString = '<!!DOCTYPE >'.
	doctype root: 'one'.
	self assert: doctype printString = '<!!DOCTYPE one>'.
	doctype publicID: 'two'.
	self assert: doctype printString = '<!!DOCTYPE one PUBLIC "two">'.
	doctype systemID: 'three'.
	self assert: doctype printString = '<!!DOCTYPE one PUBLIC "two" "three">'.

	elementDeclaration := XMLElementDeclaration element: 'four' contentModel: '(five|six)'.
	doctype addNode: elementDeclaration.
	self assert:
		doctype printString =
			('<!!DOCTYPE one PUBLIC "two" "three" [', elementDeclaration printString, ']>').

	self assert:
		(self nodeClass root: 'one' publicID: '' systemID: 'two') printString =
			'<!!DOCTYPE one SYSTEM "two">'.! !

!XMLNodeWithChildrenTest class methodsFor: 'testing' stamp: 'monty 11/2/2014 11:01'!
isAbstract
	^ true! !

!XMLNodeWithChildrenTest methodsFor: 'accessing' stamp: 'monty 6/21/2015 02:20'!
copiedClasses
	"an object that isKindOf: any of these should be copied if it's
	reachable from a copied node directly or through another copied object"

	^ #(OrderedCollection Dictionary
		XMLNode XMLNamespaceScope XMLOrderedList
		XMLConfiguration XMLNodeFactory)! !

!XMLNodeWithChildrenTest methodsFor: 'instance creation' stamp: 'monty 11/7/2014 14:49'!
newNodeWithNodes
	^ self nodeClass new
		addNode: (XMLComment string: 'one');
		addNode: (XMLPI target: 'two' data: 'three');
		addNode: (XMLComment string: 'four');
		addNode: (XMLPI target: 'five' data: 'six');
		yourself! !

!XMLNodeWithChildrenTest methodsFor: 'accessing' stamp: 'monty 11/4/2014 19:03'!
nodeClass
	^ XMLNodeWithChildren! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/19/2014 20:37'!
testAddNode
	| node nodeWithNodes added |

	node := self nodeClass new.
	nodeWithNodes := self newNodeWithNodes.
	added := OrderedCollection new.
	10 timesRepeat: [
		added add: self nodeClass new.
		self
			assert: (node addNode: added last) == added last;
			assert: (node lastNode) == added last.
		self
			should: [nodeWithNodes addNode: added last]
			raise: XMLDOMException].
	node nodes asOrderedCollection = added.
! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/19/2014 07:19'!
testAddNodeAfter
	| nodeWithNodes added |

	nodeWithNodes := self newNodeWithNodes.
	added := OrderedCollection new.
	nodeWithNodes nodes copy do: [:each |
		added
			add: each;
			add: self nodeClass new.
		self
			assert: (nodeWithNodes addNode: added last after: each) == added last;
			assert: (nodeWithNodes nodeAfter: each) == added last.
		self
			should: [nodeWithNodes addNode: each after: each]
			raise: XMLDOMException].
	nodeWithNodes nodes asOrderedCollection = added.
! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/19/2014 07:33'!
testAddNodeBefore
	| nodeWithNodes added |

	nodeWithNodes := self newNodeWithNodes.
	added := OrderedCollection new.
	nodeWithNodes nodes copy do: [:each | | node |
		added
			add: (node := self nodeClass new);
			add: each.
		self
			assert: (nodeWithNodes addNode: node before: each) == node;
			assert: (nodeWithNodes nodeBefore: each) == node.
		self
			should: [nodeWithNodes addNode: each before: each]
			raise: XMLDOMException].
	nodeWithNodes nodes asOrderedCollection = added.
! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/19/2014 20:37'!
testAddNodeFirst
	| node nodeWithNodes added |

	node := self nodeClass new.
	nodeWithNodes := self newNodeWithNodes.
	added := OrderedCollection new.
	10 timesRepeat: [
		added addFirst: self nodeClass new.
		self
			assert: (node addNodeFirst: added first) == added first;
			assert: (node firstNode) == added first.
		self
			should: [nodeWithNodes addNodeFirst: added first]
			raise: XMLDOMException].
	node nodes asOrderedCollection = added.
! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/19/2014 20:43'!
testAddNodes
	| node nodeWithNodes added |

	node := self nodeClass new.
	nodeWithNodes := self newNodeWithNodes.
	added := OrderedCollection new.
	1 to: 10 do: [:i | | nodes |
		nodes := (1 to: i) collect: [:each | self nodeClass new].
		added addAll: nodes.

		self assert: (node addNodes: nodes) == nodes.
		nodes do: [:each |
			self assert: (node includesNode: each).
			self
				should: [nodeWithNodes addNode: each]
				raise: XMLDOMException]].

	node nodes asOrderedCollection = added.
! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/7/2014 14:50'!
testAllNodes
	| nodeWithNodes allNodes |

	nodeWithNodes := self newNodeWithNodes.
	allNodes := nodeWithNodes allNodes.
	self
		assert: allNodes size = 5;
		assert: allNodes first == nodeWithNodes;
		assert: allNodes second isComment;
		assert: allNodes second string = 'one';
		assert: allNodes third isPI;
		assert: allNodes third target = 'two';
		assert: allNodes third data = 'three';
		assert: allNodes fourth isComment;
		assert: allNodes fourth string = 'four';
		assert: allNodes fifth isPI;
		assert: allNodes fifth target = 'five';
		assert: allNodes fifth data = 'six'.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/23/2014 20:57'!
testAllNodesCollect
	| nodeWithNodes allNodes |

	nodeWithNodes := self newNodeWithNodes.
	allNodes := nodeWithNodes allNodes.
	self
		assertList: (nodeWithNodes allNodesCollect: [:each | each identityHash])
		collects: (allNodes collect: [:each | each identityHash]).

	allNodes do: [:node |
		node canHaveChildren
			ifTrue: [
				self
					assertList: (node allNodesCollect: [:each | each identityHash])
					collects: (node allNodes collect: [:each | each identityHash])]].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/22/2014 20:41'!
testAllNodesDetect
	| nodeWithNodes allNodes detectedNode |

	nodeWithNodes := self newNodeWithNodes.
	allNodes := nodeWithNodes allNodes.
	detectedNode := nodeWithNodes allNodesDetect: [:each | each isPI].
	self
		assert: detectedNode notNil;
		assert: detectedNode isPI;
		assert: detectedNode == (allNodes detect: [:each | each isPI]);
		assert: (nodeWithNodes allNodesDetect: [:each | each isElementNamed: 'absent']) isNil.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/22/2014 20:42'!
testAllNodesDetectIfNone
	| nodeWithNodes allNodes detectedNode |

	nodeWithNodes := self newNodeWithNodes.
	allNodes := nodeWithNodes allNodes.
	detectedNode :=
		nodeWithNodes
			allNodesDetect: [:each | each isPI]
			ifNone: [#absent].
	self
		deny: detectedNode = #absent;
		assert: detectedNode isPI;
		assert: detectedNode == (allNodes detect: [:each | each isPI] ifNone: [#absent]);
		assert:
			(nodeWithNodes
				allNodesDetect: [:each | each isElementNamed: 'absent']
				ifNone: [#absent]) = #absent.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/23/2014 20:56'!
testAllNodesDo
	| nodeWithNodes allNodes |

	nodeWithNodes := self newNodeWithNodes.
	allNodes := nodeWithNodes allNodes.
	self
		should: [:block | nodeWithNodes allNodesDo: block]
		enumerate: allNodes.

	allNodes do: [:node |
		node canHaveChildren
			ifTrue: [
				self
					should: [:block | node allNodesDo: block]
					enumerate: node allNodes]].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/23/2014 20:57'!
testAllNodesSelect
	| nodeWithNodes allNodes |

	nodeWithNodes := self newNodeWithNodes.
	allNodes := nodeWithNodes allNodes.
	self
		assertList: (nodeWithNodes allNodesSelect: [:each | each isComment])
		selects: (allNodes select: [:each | each isComment]).

	allNodes do: [:node |
		node canHaveChildren
			ifTrue: [
				self
					assertList: (node allNodesSelect: [:each | each isComment])
					selects: (node allNodes select: [:each | each isComment])]].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 3/8/2015 13:48'!
testAncestorNodes
	| nodeWithNodes ancestorStack |

	super testAncestorNodes.

	nodeWithNodes := self newNodeWithNodes.
	ancestorStack := OrderedCollection new.
	nodeWithNodes allNodesDo: [:each |
		[ancestorStack isEmpty
			or: [ancestorStack last == each parent]]
			whileFalse: [ancestorStack removeLast].
		self assert:
			each ancestorNodes asOrderedCollection =
				ancestorStack reversed.
		ancestorStack addLast: each].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 3/8/2015 13:48'!
testAncestorNodesDo
	| nodeWithNodes |

	super testAncestorNodesDo.

	nodeWithNodes := self newNodeWithNodes.
	nodeWithNodes allNodesDo: [:each |
		self
			should: [:block | each ancestorNodesDo: block]
			enumerate: each ancestorNodes].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/23/2014 20:54'!
testCanHaveChildren
	self assert: self nodeClass new canHaveChildren! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 12/6/2014 14:23'!
testCanonicallyEquals
	super testCanonicallyEquals.
	self
		assert: (self newNodeWithNodes canonicallyEquals: self newNodeWithNodes);
		deny: (self newNodeWithNodes canonicallyEquals: self nodeClass new).! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 6/21/2015 03:06'!
testCopy
	"this traverses the object graph of each node and compares it with
	its copy to make sure nodes and the inst vars that should be copied
	are copied. See #copiedClasses"
	| nodeWithNodes nodeWithNodesCopy unvisitedPairs visitedPairs copiedClasses |

	super testCopy.

	nodeWithNodes := self newNodeWithNodes.
	"initialize the configuration (if it can have one)"
	nodeWithNodes configuration
		ifNotNil: [:config | config nodeFactory: XMLPluggableNodeFactory new].

	nodeWithNodesCopy := nodeWithNodes copy.
	self
		assert: nodeWithNodes printString = nodeWithNodesCopy printString;
		assert: nodeWithNodes allNodes size = nodeWithNodesCopy allNodes size.

	unvisitedPairs := Set new.
	nodeWithNodes allNodes
		with: nodeWithNodesCopy allNodes
		do: [:node :nodeCopy | unvisitedPairs add: node -> nodeCopy].

	visitedPairs := Set new.
	copiedClasses := self copiedClasses collect: [:each | Smalltalk at: each].
	[unvisitedPairs isEmpty]
		whileFalse: [ | pair originalObject copyObject |
			pair := unvisitedPairs remove: unvisitedPairs anyOne.
			originalObject := pair key.
			copyObject := pair value.

			self deny: originalObject == copyObject.
			visitedPairs add: pair.
			1
				to: (originalObject class instSize min: copyObject class instSize)
				do: [:i | | newPair |
					newPair := (originalObject instVarAt: i) -> (copyObject instVarAt: i).
					((visitedPairs includes: newPair)
						or: [copiedClasses noneSatisfy: [:each | newPair key isKindOf: each]])
						ifFalse: [unvisitedPairs add: newPair]]].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/23/2014 20:56'!
testDescendentNodes
	| nodeWithNodes descendentNodes |

	nodeWithNodes := self newNodeWithNodes.
	descendentNodes := nodeWithNodes descendentNodes.
	self
		assertList: descendentNodes
		selects: nodeWithNodes allNodes allButFirst.

	descendentNodes do: [:node |
		node canHaveChildren
			ifTrue: [
				self
					assertList: node descendentNodes
					selects: node allNodes allButFirst]].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/23/2014 20:57'!
testDescendentNodesCollect
	| nodeWithNodes descendentNodes |

	nodeWithNodes := self newNodeWithNodes.
	descendentNodes := nodeWithNodes descendentNodes.
	self
		assertList: (nodeWithNodes descendentNodesCollect: [:each | each identityHash])
		collects: (descendentNodes collect: [:each | each identityHash]).

	descendentNodes do: [:node |
		node canHaveChildren
			ifTrue: [
				self
					assertList: (node descendentNodesCollect: [:each | each identityHash])
					collects: (node descendentNodes collect: [:each | each identityHash])]].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/22/2014 20:42'!
testDescendentNodesDetect
	| nodeWithNodes descendentNodes detectedNode |

	nodeWithNodes := self newNodeWithNodes.
	descendentNodes := nodeWithNodes descendentNodes.
	detectedNode := nodeWithNodes descendentNodesDetect: [:each | each isPI].
	self
		assert: detectedNode notNil;
		assert: detectedNode isPI;
		assert: detectedNode == (descendentNodes detect: [:each | each isPI]);
		assert: (nodeWithNodes descendentNodesDetect: [:each | each isElementNamed: 'absent']) isNil.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/22/2014 20:42'!
testDescendentNodesDetectIfNone
	| nodeWithNodes descendentNodes detectedNode |

	nodeWithNodes := self newNodeWithNodes.
	descendentNodes := nodeWithNodes descendentNodes.
	detectedNode :=
		nodeWithNodes
			descendentNodesDetect: [:each | each isPI]
			ifNone: [#absent].
	self
		deny: detectedNode = #absent;
		assert: detectedNode isPI;
		assert: detectedNode == (descendentNodes detect: [:each | each isPI] ifNone: [#absent]);
		assert:
			(nodeWithNodes
				descendentNodesDetect: [:each | each isElementNamed: 'absent']
				ifNone: [#absent]) = #absent.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/23/2014 20:56'!
testDescendentNodesDo
	| nodeWithNodes descendentNodes |

	nodeWithNodes := self newNodeWithNodes.
	descendentNodes := nodeWithNodes descendentNodes.
	self
		should: [:block | nodeWithNodes descendentNodesDo: block]
		enumerate: descendentNodes.

	descendentNodes do: [:node |
		node canHaveChildren
			ifTrue: [
				self
					should: [:block | node descendentNodesDo: block]
					enumerate: node descendentNodes]].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/23/2014 20:57'!
testDescendentNodesSelect
	| nodeWithNodes descendentNodes |

	nodeWithNodes := self newNodeWithNodes.
	descendentNodes := nodeWithNodes descendentNodes.
	self
		assertList: (nodeWithNodes descendentNodesSelect: [:each | each isComment])
		selects: (descendentNodes select: [:each | each isComment]).

	descendentNodes do: [:node |
		node canHaveChildren
			ifTrue: [
				self
					assertList: (node descendentNodesSelect: [:each | each isComment])
					selects: (node descendentNodes select: [:each | each isComment])]].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/24/2014 00:16'!
testDocument
	| nodeWithNodes document |

	nodeWithNodes := self newNodeWithNodes.
	document := nodeWithNodes document.
	nodeWithNodes allNodesDo: [:each |
		self assert: each document == document].

	document
		ifNotNil: [ | root |
			root := document root.
			document removeNodes.
			root allNodesDo: [:each |
				self assert: each document isNil]].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/19/2014 06:58'!
testFirstNode
	| nodeWithNodes |

	nodeWithNodes := self newNodeWithNodes.
	nodeWithNodes nodes copy do: [:each |
		self  assert: nodeWithNodes firstNode == each.
		nodeWithNodes removeNode: each].
	self assert: nodeWithNodes firstNode isNil.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:09'!
testHasChildren
	super testHasChildren.

	self assert: self newNodeWithNodes hasChildren.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:50'!
testIncludesNode
	| nodeWithNodes |

	nodeWithNodes := self newNodeWithNodes.
	nodeWithNodes nodes do: [:each |
		self assert: (nodeWithNodes includesNode: each)].
	self deny: (nodeWithNodes includesNode: self nodeClass new).! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/19/2014 06:55'!
testLastNode
	| nodeWithNodes |

	nodeWithNodes := self newNodeWithNodes.
	nodeWithNodes nodes reversed do: [:each |
		self  assert: nodeWithNodes lastNode == each.
		nodeWithNodes removeNode: each].

	self assert: nodeWithNodes lastNode isNil.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/24/2014 18:44'!
testNextNode
	| nodeWithNodes nextNode |

	super testNextNode.
	nodeWithNodes := self newNodeWithNodes.
	nextNode := nil.
	nodeWithNodes nodes reverseDo: [:each |
		self assert: each nextNode == nextNode.
		nextNode := each].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/24/2014 18:43'!
testNodeAfter
	| nodeWithNodes nodeAfter |

	nodeWithNodes := self newNodeWithNodes.
	nodeAfter := nil.
	nodeWithNodes nodes reverseDo: [:each |
		self assert: (nodeWithNodes nodeAfter: each) == nodeAfter.
		nodeAfter := each].
	self assert: (nodeWithNodes nodeAfter: self nodeClass new) isNil.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/19/2014 08:42'!
testNodeAt
	| nodeWithNodes |

	nodeWithNodes := self newNodeWithNodes.
	self assert: (nodeWithNodes nodeAt: 0) isNil.
	1 to: nodeWithNodes nodes size do: [:i |
		self assert: (nodeWithNodes nodeAt: i) == (nodeWithNodes nodes at: i)].
	self assert: (nodeWithNodes nodeAt: nodeWithNodes nodes size + 1) isNil.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/19/2014 08:41'!
testNodeAtIfAbsent
	| nodeWithNodes |

	nodeWithNodes := self newNodeWithNodes.
	self assert: (nodeWithNodes nodeAt: 0 ifAbsent: [#absent]) = #absent.
	1 to: nodeWithNodes nodes size do: [:i |
		self assert:
			(nodeWithNodes
				nodeAt: i
				ifAbsent: [#absent]) == (nodeWithNodes nodes at: i)].
	self assert:
		(nodeWithNodes
			nodeAt: nodeWithNodes nodes size + 1
			ifAbsent: [#absent]) = #absent.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 12/16/2014 11:21'!
testNodeAtPut
	| nodeWithNodes newNodeClass newNode |

	nodeWithNodes := self newNodeWithNodes.
	newNodeClass := nodeWithNodes firstNode class.
	self
		should: [nodeWithNodes nodeAt: 0 put: newNodeClass new]
		raise: Error.
	1 to: nodeWithNodes nodes size do: [:i |
		newNode := newNodeClass new.
		self
			assert: (nodeWithNodes nodeAt: i put: newNode) == newNode;
			assert: (nodeWithNodes nodeAt: i) == newNode].

	newNode := newNodeClass new.
	self assert:
		(nodeWithNodes
			nodeAt: nodeWithNodes nodes size + 1
			put: newNode) == newNode.
	self assert: (nodeWithNodes nodeAt: nodeWithNodes nodes size) == newNode.
	self
		should: [
			nodeWithNodes
				nodeAt: nodeWithNodes nodes size + 2
				put: newNodeClass new]
		raise: Error.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/24/2014 18:43'!
testNodeBefore
	| nodeWithNodes nodeBefore |

	nodeWithNodes := self newNodeWithNodes.
	nodeBefore := nil.
	nodeWithNodes nodes do: [:each |
		self assert: (nodeWithNodes nodeBefore: each) == nodeBefore.
		nodeBefore := each].
	self assert: (nodeWithNodes nodeBefore: self nodeClass new) isNil.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/24/2014 22:14'!
testNodeListCopying
	| nodeWithNodes nodeListCopy |

	nodeWithNodes := self newNodeWithNodes.
	nodeListCopy := nodeWithNodes nodes copy.
	self
		assert: nodeListCopy = nodeWithNodes nodes;
		deny: nodeListCopy == nodeWithNodes nodes;
		assert: nodeWithNodes nodes observer == nodeWithNodes;
		assert: nodeListCopy observer isNil.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/22/2014 19:36'!
testNodes
	self assert: (self nodeClass new nodes isKindOf: XMLNodeList)! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/23/2014 21:04'!
testNodesCollect
	| node |

	node := self newNodeWithNodes.
	self
		assertList: (node nodesCollect: [:each | each identityHash])
		collects: (node nodes collect: [:each | each identityHash]).! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/23/2014 21:07'!
testNodesDetect
	| node detectedNode |

	node := self newNodeWithNodes.
	detectedNode := node nodesDetect: [:each | each isComment].
	self
		assert: detectedNode notNil;
		assert: detectedNode == (node nodes detect: [:each | each isComment]);
		assert: (node nodesDetect: [:each | each isElementNamed: 'absent']) isNil.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/24/2014 08:05'!
testNodesDetectIfNone
	| node detectedNode |

	node := self newNodeWithNodes.
	detectedNode :=
		node
			nodesDetect: [:each | each isComment]
			ifNone: [#absent].
	self deny: detectedNode = #absent.
	self assert:
		detectedNode ==
			(node nodes detect: [:each | each isComment] ifNone: [#absent]).
	self assert:
		(node
			nodesDetect: [:each | each isElementNamed: 'absent']
			ifNone: [#absent]) = #absent.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:50'!
testNodesDo
	| node |

	node := self nodeClass new.
	self should: [:block | node nodesDo: block] enumerate: #().

	node := self newNodeWithNodes.
	self should: [:block | node nodesDo: block] enumerate: node nodes.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/23/2014 21:04'!
testNodesSelect
	| node |

	node := self newNodeWithNodes.
	self
		assertList: (node nodesSelect: [:each | each hasChildren])
		selects: (node nodes select: [:each | each hasChildren]).! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/24/2014 18:44'!
testPreviousNode
	| nodeWithNodes previousNode |

	super testPreviousNode.
	nodeWithNodes := self newNodeWithNodes.
	previousNode := nil.
	nodeWithNodes nodes do: [:each |
		self assert: each previousNode == previousNode.
		previousNode := each].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/19/2014 20:28'!
testRemoveNode
	| nodeWithNodes |

	nodeWithNodes := self newNodeWithNodes.
	nodeWithNodes nodes copy do: [:each |
		self
			assert: (nodeWithNodes includesNode: each);
			assert: (nodeWithNodes removeNode: each) == each;
			deny: (nodeWithNodes includesNode: each)].
	self deny: nodeWithNodes hasChildren.
	self
		should: [nodeWithNodes removeNode: self nodeClass new]
		raise: Error.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/19/2014 20:54'!
testRemoveNodeIfAbsent
	| nodeWithNodes |

	nodeWithNodes := self newNodeWithNodes.
	nodeWithNodes nodes copy do: [:each |
		self
			assert: (nodeWithNodes includesNode: each);
			assert: (nodeWithNodes removeNode: each ifAbsent: [#absent]) == each;
			deny: (nodeWithNodes includesNode: each)].
	self deny: nodeWithNodes hasChildren.
	self assert:
		(nodeWithNodes
			removeNode: self nodeClass new
			ifAbsent: [#absent]) == #absent.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/19/2014 20:20'!
testRemoveNodes
	| nodeWithNodes |

	nodeWithNodes := self newNodeWithNodes.
	self
		assert: nodeWithNodes hasChildren;
		assert: nodeWithNodes removeNodes == nodeWithNodes;
		deny: nodeWithNodes hasChildren.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/19/2014 20:53'!
testRemoveNodesAll
	| nodeWithNodes |

	nodeWithNodes := self newNodeWithNodes.
	1 to: nodeWithNodes nodes size do: [:i | | removed |
		removed := (nodeWithNodes nodes copyFrom: 1 to: i).
		self
			assert: (removed allSatisfy: [:each | nodeWithNodes includesNode: each]);
			assert: (nodeWithNodes removeNodes: removed) == removed;
			deny: (removed anySatisfy: [:each | nodeWithNodes includesNode: each]).
		nodeWithNodes := self newNodeWithNodes].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 2/2/2015 03:55'!
testReplaceNodeWith
	| nodeWithNodes replacements nodes firstIndex secondIndex |

	nodeWithNodes := self newNodeWithNodes.
	replacements := OrderedCollection new.
	nodeWithNodes nodes copy do: [:each |
		self assert:
			(nodeWithNodes
				replaceNode: each
				with: (replacements add: self nodeClass new)) == replacements last].
	self assert: nodeWithNodes nodes asOrderedCollection = replacements.

	nodeWithNodes := self newNodeWithNodes.
	nodes := nodeWithNodes nodes copy.
	nodes do: [:each |
		self assert:
			(nodeWithNodes
				replaceNode: each
				with: each) == each].
	self assert: nodeWithNodes nodes = nodes.

	firstIndex := 1.
	secondIndex := nodes size.
	[firstIndex < secondIndex]
		whileTrue: [
			nodeWithNodes
				replaceNode: (nodes at: firstIndex)
				with: (nodes at: secondIndex).
			firstIndex := firstIndex + 1.
			secondIndex := secondIndex - 1].
	self assert: nodeWithNodes nodes = nodes reversed.

	self
		should: [
			nodeWithNodes
				replaceNode: nodes anyOne copy
				with: self nodeClass new]
		raise: Error.! !

XMLNodeWithChildrenTest subclass: #XMLNodeWithElementsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLNodeWithElementsTest commentStamp: 'monty 11/4/2014 19:05' prior: 0!
Abstract, do not run.!

XMLNodeWithElementsTest subclass: #XMLDocumentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLDocumentTest class methodsFor: 'testing' stamp: 'monty 11/2/2014 11:08'!
isAbstract
	^ false! !

!XMLDocumentTest methodsFor: 'instance creation' stamp: 'monty 11/22/2014 20:49'!
newNodeWithElements
	^ super newNodeWithElements
		doctypeDeclaration: XMLDoctypeDeclaration new;
		yourself! !

!XMLDocumentTest methodsFor: 'accessing' stamp: 'monty 11/2/2014 11:08'!
nodeClass
	^ XMLDocument! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 4/11/2015 01:00'!
testDoctypeDeclaration
	| document doctypeDeclaration |

	document := self nodeClass new.
	self assert: document doctypeDeclaration isNil.
	doctypeDeclaration := XMLDoctypeDeclaration new.
	self
		assert: (document doctypeDeclaration: doctypeDeclaration) == document;
		assert: document doctypeDeclaration == doctypeDeclaration;
		assert: doctypeDeclaration parent == document.
	self
		should: [self nodeClass new doctypeDeclaration: document doctypeDeclaration]
		raise: XMLDOMException.

	document doctypeDeclaration: nil.
	self
		assert: document doctypeDeclaration isNil;
		assert: doctypeDeclaration parent isNil.! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 3/8/2015 10:18'!
testDoctypeDefinition
	| document doctypeDefinition |

	document := self nodeClass new.
	self assert: document doctypeDefinition isNil.
	doctypeDefinition := DTDDoctypeDefinition new.
	self
		assert: (document doctypeDefinition: doctypeDefinition) == document;
		assert: document doctypeDefinition == doctypeDefinition.! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 11/24/2014 00:17'!
testDocument
	| document |

	super testDocument.

	document := self nodeClass new.
	self assert: document document == document.

	document := self newNodeWithElements.
	self assert: document document == document.! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 3/24/2015 18:37'!
testEncoding
	self
		assert: self nodeClass new encoding isEmpty;
		assert: ((self nodeClass new encoding: 'UTF-8') encoding) = 'UTF-8'.! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 5/9/2015 03:12'!
testHasDoctypeDeclaration
	| document |

	document := self nodeClass new.
	self deny: document hasDoctypeDeclaration.
	document doctypeDeclaration: XMLDoctypeDeclaration new.	
	self assert: document hasDoctypeDeclaration.
	document doctypeDeclaration: nil.
	self deny: document hasDoctypeDeclaration.! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 5/9/2015 03:14'!
testHasDoctypeDefinition
	| document |

	document := self nodeClass new.
	self deny: document hasDoctypeDefinition.
	document doctypeDefinition: DTDDoctypeDefinition new.
	self assert: document hasDoctypeDefinition.
	document doctypeDefinition: nil.
	self deny: document hasDoctypeDefinition.! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:45'!
testIsDocument
	self assert: self nodeClass new isDocument! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 11/22/2014 23:18'!
testIsStandalone
	self
		deny: self nodeClass new isStandalone;
		assert: (self nodeClass new isStandalone: true) isStandalone! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 3/24/2015 18:40'!
testRoot
	| nodeWithElements firstNode newRoot |

	self assert: self nodeClass new root isNil.

	nodeWithElements := self newNodeWithElements.
	firstNode := XMLComment string: 'first'.
	nodeWithElements addNodeFirst: firstNode.
	self assert: (nodeWithElements root isElementNamed: 'root').

	newRoot := XMLElement named: 'new-root'.
	nodeWithElements root: newRoot.
	self
		assert: nodeWithElements firstNode == firstNode;
		assert: nodeWithElements root == newRoot.

	nodeWithElements removeNodes.
	self assert: nodeWithElements root isNil.

	newRoot := XMLElement named: 'root'.
	self assert: (self nodeClass root: newRoot) root == newRoot.! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 4/7/2015 00:06'!
testValidate
	| xml document |

	super testValidate.

	xml := '
		<!!DOCTYPE one [
			<!!ELEMENT one (two+)>
			<!!ATTLIST one idref IDREF #REQUIRED>
			<!!ELEMENT two (#PCDATA)*>
			<!!ATTLIST two id ID #REQUIRED>]>
		<one idref="a">
			<two id="a">three</two><two id="b"><!!--comment--></two>
		</one>'.

	document :=
		(XMLDOMParser on: xml)
			preservesCommentNodes: true;
			parseDocument.
	self
		shouldnt: [document validate]
		raise: XMLValidationException.
	self assert:
		(document canonicallyEquals: 
			((XMLDOMParser on: xml)
				preservesCommentNodes: true;
				parseDocument)).

	document
		allElementsNamed: 'two'
		do: [:each | each attributeAt: 'id' put: 'a'].
	self
		should: [document validate]
		raise: XMLValidationException.

	document := XMLDOMParser parse: xml.
	document root name: 'zero'.
	self
		should: [document validate]
		raise: XMLValidationException.

	document := XMLDOMParser parse: xml.
	document root attributeAt: 'idref' put: 'undeclared'.
	self
		should: [document validate]
		raise: XMLValidationException.

	document := XMLDOMParser parse: xml.
	document root addElementNamed: 'three'.
	self
		should: [document validate]
		raise: XMLValidationException.

	(document := XMLDOMParser parse: xml) doctypeDefinition: nil.
	document root
		name: 'zero';
		attributeAt: 'idref' put: 'undeclared';
		addElementNamed: 'three';
		allElementsNamed: 'two' do: [:each | each attributeAt: 'id' put: 'same'].
	self
		shouldnt: [document validate]
		raise: XMLValidationException.! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 4/7/2015 00:10'!
testValidateNoSubset
	| xml document |

	xml := '<!!DOCTYPE one>
		<one idref="a">
			<two id="a">three</two><two id="b"><!!--comment--></two>
		</one>'.

	document :=
		(XMLDOMParser on: xml)
			preservesCommentNodes: true;
			parseDocument.
	self
		shouldnt: [document validate]
		raise: XMLValidationException.
	self assert:
		(document canonicallyEquals: 
			((XMLDOMParser on: xml)
				preservesCommentNodes: true;
				parseDocument)).

	document root name: 'five'.
	self
		should: [document validate]
		raise: XMLValidationException.

	document doctypeDefinition: nil.
	self
		shouldnt: [document validate]
		raise: XMLValidationException.! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 11/22/2014 23:19'!
testVersion
	self
		assert: self nodeClass new version isNil;
		assert: (self nodeClass new version: 1.0) version = 1.0! !

XMLNodeWithElementsTest subclass: #XMLElementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLElementTest class methodsFor: 'testing' stamp: 'monty 11/2/2014 11:09'!
isAbstract
	^ false! !

!XMLElementTest methodsFor: 'assertions' stamp: 'monty 11/23/2014 04:37'!
assertElement: anElement hasAttributes: anAssociationCollection
	| attributeNodes |

	self assert: anElement attributeNodes size = anAssociationCollection size.
	attributeNodes := anElement attributeNodes copy.
	anAssociationCollection associationsDo: [:each | | attributeNode |
		attributeNode := attributeNodes removeFirst.
		self
			assert: attributeNode name = each key;
			assert: attributeNode value = each value.]! !

!XMLElementTest methodsFor: 'accessing' stamp: 'monty 11/23/2014 04:26'!
attributes
	^ self newElementWithAttributes attributeNodes asDictionary! !

!XMLElementTest methodsFor: 'accessing' stamp: 'monty 11/24/2014 00:32'!
namespaces
	^ OrderPreservingDictionary with: 'prefix' -> 'prefixNS' with: '' -> 'defaultNS'! !

!XMLElementTest methodsFor: 'accessing' stamp: 'monty 11/2/2014 11:09'!
nodeClass
	^ XMLElement! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 00:23'!
testAttributeAssociations
	| element |

	element := self newElementWithAttributes.
	self
		assertList: element attributeAssociations
		collects: (element attributeNodes collect: [:each | each name -> each value]).! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 00:13'!
testAttributeAt
	| element |

	element := self newElementWithAttributes.
	element attributeNodes do: [:each |
		self assert: (element attributeAt: each name) == each value].
	self assert: (element attributeAt: 'absent') isEmpty.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 00:20'!
testAttributeAtIfAbsent
	| element |

	element := self newElementWithAttributes.
	element attributeNodes do: [:each |
		self assert:
			(element
				attributeAt: each name
				ifAbsent: [#absent]) == each value].
	self assert: (element attributeAt: 'absent' ifAbsent: [#absent]) = #absent.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 00:21'!
testAttributeAtIfAbsentPut
	| element |

	element := self newElementWithAttributes.
	element attributeNodes do: [:each |
		self assert:
			(element
				attributeAt: each name
				ifAbsentPut: ['newValue']) == each value].
	self
		assert: (element attributeAt: 'newName' ifAbsentPut: ['newValue']) = 'newValue';
		assert: (element attributeAt: 'newName') = 'newValue'.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 00:13'!
testAttributeAtPut
	| element |

	element := self newElementWithAttributes.
	element attributeNodes do: [:each | | newValue |
		newValue := 'new', each value.
		self
			assert: (element attributeAt: each name put: newValue) = newValue;
			assert: (element attributeAt: each name) = newValue].
	self
		assert: (element attributeAt: 'newName' put: 'newValue') = 'newValue';
		assert: (element attributeAt: 'newName') = 'newValue'.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/24/2014 22:15'!
testAttributeListCopying
	| element attributeListCopy |

	element := self newElementWithAttributes.
	attributeListCopy := element attributeNodes copy.
	self
		assert: attributeListCopy = element attributeNodes;
		deny: attributeListCopy == element attributeNodes;
		assert: attributeListCopy attributesByName = element attributeNodes attributesByName;
		deny: attributeListCopy attributesByName == element attributeNodes attributesByName;
		assert: element attributeNodes observer == element;
		assert: attributeListCopy observer isNil.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 00:13'!
testAttributeNames
	| element |

	element := self newElementWithAttributes.
	self
		assertList: element attributeNames
		collects: (element attributeNodes collect: [:each | each name])! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 00:13'!
testAttributeNamesAndValuesDo
	| element pairs |

	pairs := OrderedCollection new.
	XMLElement new attributeNamesAndValuesDo: [:attributeName :attributeValue|
		pairs add: attributeName -> attributeValue].
	self assert: pairs isEmpty.

	element := self newElementWithAttributes.
	element attributeNamesAndValuesDo: [:attributeName :attributeValue|
		pairs add: attributeName -> attributeValue].
	self assert:
		pairs =
			((element attributeNodes collect: [:each |
				each name -> each value]) asOrderedCollection).! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 00:13'!
testAttributeNamesDo
	| element |

	element := XMLElement new.
	self
		should: [:block | element attributeNamesDo: block]
		enumerate: #().

	element := self newElementWithAttributes.
	self
		should: [:block | element attributeNamesDo: block]
		enumerate: element attributeNames.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 3/22/2015 03:42'!
testAttributeNodeAt
	| element |

	element := self newElementWithAttributes.
	element attributeNodes do: [:each |
		self assert: (element attributeNodeAt: each name) == each].
	self assert: (element attributeNodeAt: 'absent') isNil.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 00:19'!
testAttributeNodeAtIfAbsent
	| element  |

	element := self newElementWithAttributes.
	element attributeNodes do: [:each |
		self assert:
			(element
				attributeNodeAt: each name
				ifAbsent: [#absent]) == each].
	self assert: (element attributeNodeAt: 'absent' ifAbsent: [#absent]) = #absent.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 3/22/2015 03:42'!
testAttributeNodeAtNamespaceURI
	| element |

	element := self newElementWithAttributes.
	self assert:
		(element attributeNodeAt: 'prefix:three' namespaceURI: 'absent') isNil.
	self assert:
		(element attributeNodeAt: 'prefix:three' namespaceURI: 'testNS') ==
			(element attributeNodes third).! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 3/22/2015 03:42'!
testAttributeNodeAtNamespaceURIIfAbsent
	| element |

	element := self newElementWithAttributes.
	self assert:
		(element
			attributeNodeAt: 'prefix:three'
			namespaceURI: 'absent'
			ifAbsent: [#absent]) = #absent.
	self assert:
		(element
			attributeNodeAt: 'prefix:three'
			namespaceURI: 'testNS'
			ifAbsent: [#absent]) ==
				(element attributeNodes third).! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 00:16'!
testAttributeNodes
	| element nodes |

	element := self newElementWithAttributes.
	nodes := element attributeNodes.
	self
		assert: (nodes isKindOf: XMLAttributeList);
		assert: nodes size = 4;
		assert: (nodes collect: [:each | each name]) asArray = #('one' 'three' 'prefix:three' 'prefix:six');
		assert: (nodes collect: [:each | each value]) asArray = #('two' 'four' 'five' 'seven').! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/26/2014 19:24'!
testAttributeNodesDo
	| element |

	element := self nodeClass new.
	self should: [:block | element attributeNodesDo: block] enumerate: #().

	element := self newElementWithAttributes.
	self
		should: [:block | element attributeNodesDo: block]
		enumerate: element attributeNodes.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 08:06'!
testAttributeRenaming
	| elementWithAttributes attributeNodes attributeNode oldSize oldNames oldName |

	elementWithAttributes := self newElementWithAttributes.
	attributeNodes := elementWithAttributes attributeNodes.

	attributeNode := attributeNodes first.
	oldSize := attributeNodes size.
	oldNames := elementWithAttributes attributeNames.
	oldName := attributeNode name.
	attributeNode name: 'newName'.
	self
		assert: attributeNodes size = oldSize;
		assert: attributeNodes first == attributeNode;
		assert: elementWithAttributes attributeNames = (oldNames allButFirst copyWithFirst: 'newName');
		deny: (elementWithAttributes includesAttribute: oldName);
		assert: (elementWithAttributes attributeNodeAt: 'newName') == attributeNode.

	oldNames := elementWithAttributes attributeNames.
	oldName := attributeNode name.
	attributeNode name: oldNames last.
	self
		assert: attributeNodes size = (oldSize - 1);
		assert: attributeNodes first == attributeNode;
		assert:
			elementWithAttributes attributeNames =
				((oldNames copyFrom: 2 to: oldNames size - 1) copyWithFirst: oldNames last);
		deny: (elementWithAttributes includesAttribute: oldName);
		assert: (elementWithAttributes attributeNodeAt: attributeNode name) == attributeNode.

	self should: [attributeNode name: 'undeclared:newName'] raise: XMLNamespaceException.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 1/6/2015 20:07'!
testAttributeSorting
	| element |

	element :=
		XMLElement
			name: 'sorted'
			attributes: (Array with: 'c' -> '3' with: 'b' -> '2' with: 'a' -> '1').
	self assert:
		(element attributeNodes sorted
			collect: [:each | each name]) asArray = #('a' 'b' 'c').
	self assert:
		((element attributeNodes sorted: [:a :b | a name <= b name])
			collect: [:each | each name]) asArray = #('a' 'b' 'c').
	"sorted/sorted: should sort copies"
	self assert: element attributeNames asArray = #('c' 'b' 'a').

	element attributeNodes sort.
	self assert: element attributeNames asArray = #('a' 'b' 'c').
	element attributeNodes sort: [:a :b | a name > b name].
	self assert: element attributeNames asArray = #('c' 'b' 'a').! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 00:25'!
testAttributes
	| element attributeDictionary |

	element := self newElementWithAttributes.
	attributeDictionary := element attributes.
	self
		assert: attributeDictionary isDictionary;
		assert: attributeDictionary size = element attributeNodes size.
	self assert:
		(element attributeNodes allSatisfy: [:each |
			(attributeDictionary at: each name) = each value]).! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 10/12/2014 01:06'!
testCanonicalPrinting
	| element |

	element :=
		XMLElement
			name: 'test'
			namespaces: (Array with: 'b' -> 'ns2' with: 'a' -> 'ns1' with: '' -> 'default')
			attributes: (Array with: 'c' -> '3' with: 'b' -> '2' with: 'a' -> '1').

	self assert:
		element printString =
			'<test xmlns:b="ns2" xmlns:a="ns1" xmlns="default" c="3" b="2" a="1" />'.
	self assert:
		element canonicallyPrinted =
			'<test xmlns="default" xmlns:a="ns1" xmlns:b="ns2" a="1" b="2" c="3"></test>'.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/24/2014 06:34'!
testDeclareNamespaces
	| element |

	element := self nodeClass new.
	element declareNamespaces: self namespaces.
	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert: (element isDeclaredPrefix: prefix uri: uri)].

	element := self nodeClass new.
	element declareNamespaces: self namespaces associations.
	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert: (element isDeclaredPrefix: prefix uri: uri)]! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/24/2014 06:59'!
testDeclarePrefixURI
	| element elementsWithDeclaredPrefix |

	(element := self newNodeWithElements)
		declarePrefix: 'newPrefix' uri: 'prefixNS';
		allElementsDo: [:each | self assert: (each isDeclaredPrefix: 'newPrefix' uri: 'prefixNS')];
		declarePrefix: 'newPrefix' uri: 'newPrefixNS';
		allElementsDo: [:each | self assert: (each isDeclaredPrefix: 'newPrefix' uri: 'newPrefixNS')].

	elementsWithDeclaredPrefix :=
		element allElementsSelect: [:each | each prefix = 'prefix'].
	element
		declarePrefix: 'prefix' uri: 'newPrefixNS';
		allElementsDo: [:each |
			(elementsWithDeclaredPrefix includes: each)
				ifTrue: [
					self
						assert: (each isDeclaredPrefix: 'prefix');
						deny: (each isDeclaredPrefix: 'prefix' uri: 'newPrefixNS')]
				ifFalse: [self assert: (each isDeclaredPrefix: 'prefix' uri: 'newPrefixNS')]].

	self
		should: [element declarePrefix: 'nonDefault' uri: '']
		raise: XMLNamespaceException.
	self
		should: [element declarePrefix: 'xmlns' uri: XMLNamespaceScope xmlnsNamespaceURI]
		raise: XMLNamespaceException.
	self
		should: [element declarePrefix: 'xml' uri: 'newNS']
		raise: XMLNamespaceException.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/24/2014 07:00'!
testDeclaresDefaultNamespace
	| element |

	element := self newNodeWithElements.
	self deny: element declaresDefaultNamespace.

	element defaultNamespace: 'defaultNS'.
	self assert: element declaresDefaultNamespace.
	element elementsDo: [:each |
		self deny: each declaresDefaultNamespace].

	element elementsDo: [:each |
		each defaultNamespace: 'newDefaultNS'.
		self assert: each declaresDefaultNamespace].

	self assert: element declaresDefaultNamespace.	
	element undeclarePrefix: ''.
	self deny: element declaresDefaultNamespace.
	element elementsDo: [:each |
		self assert: each declaresDefaultNamespace].! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/24/2014 07:00'!
testDeclaresPrefixURI
	| element |

	element := self newNodeWithElements.
	self deny: element declaresDefaultNamespace.

	element declarePrefix: 'prefix' uri: 'prefixNS'.
	self assert: (element declaresPrefix: 'prefix' uri: 'prefixNS').
	element elementsDo: [:each |
		self deny: (each declaresPrefix: 'prefix' uri: 'prefixNS')].

	element elementsDo: [:each |
		each declarePrefix: 'prefix' uri: 'newPrefixNS'.
		self assert: (each declaresPrefix: 'prefix' uri: 'newPrefixNS')].

	self assert: (element declaresPrefix: 'prefix' uri: 'prefixNS').
	element undeclarePrefix: 'prefix'.
	self deny: (element declaresPrefix: 'prefix' uri: 'prefixNS').
	element elementsDo: [:each |
		self assert: (each declaresPrefix: 'prefix' uri: 'newPrefixNS')].! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/24/2014 07:00'!
testDefaultNamespace
	| element elementsWithDefaultNamespace |

	element := self newNodeWithElements.
	elementsWithDefaultNamespace :=
		element allElementsSelect: [:each |
			each defaultNamespace notEmpty].

	element
		defaultNamespace: 'newDefaultNS';
		allElementsDo: [:each |
			(elementsWithDefaultNamespace includes: each)
				ifTrue: [self deny: (each defaultNamespace = 'newDefaultNS')]
				ifFalse: [self assert: (each defaultNamespace = 'newDefaultNS')]].

	element
		defaultNamespace: '';
		allElementsDo: [:each |
			(elementsWithDefaultNamespace includes: each)
				ifTrue: [self assert: each defaultNamespace notEmpty]
				ifFalse: [self assert: each defaultNamespace isEmpty]].! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/1/2014 21:02'!
testElementSorting
	| element |

	(element := XMLElement name: 'sorted')
		addElementNamed: 'c';
		addElementNamed: 'b';
		addElementNamed: 'a'.

	self assert: (element nodes sorted collect: [:each | each name]) asArray = #('a' 'b' 'c').
	self assert:
		((element nodes sorted: [:a :b | a name <= b name])
			collect: [:each | each name]) asArray = #('a' 'b' 'c').

	self assert: (element nodesCollect: [:each | each name]) asArray = #('c' 'b' 'a').
	element nodes sort.
	self assert: (element nodesCollect: [:each | each name]) asArray = #('a' 'b' 'c').
	element nodes sort: [:a :b | a name > b name].
	self assert: (element nodesCollect: [:each | each name]) asArray = #('c' 'b' 'a').! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 12/30/2014 02:40'!
testExpandedName
	| element |

	element := self nodeClass named: 'test'.
	self assert: (element expandedName = 'test').

	element defaultNamespace: 'defaultNS'.
	self assert: (element expandedName = 'Q{defaultNS}test').

	element name: 'prefix:test' namespaceURI: 'prefixNS'.
	self assert: (element expandedName = 'Q{prefixNS}test').

	element
		defaultNamespace: '';
		name: 'test'.
	self assert: (element expandedName = 'test').! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 00:27'!
testHasAttributes
	self
		deny: self nodeClass new hasAttributes;
		assert: self newElementWithAttributes hasAttributes;
		deny: self newElementWithAttributes removeAttributes hasAttributes! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 3/22/2015 03:42'!
testHasNamespaceURI
	| element |

	element := self nodeClass named: 'test'.
	self deny: element hasNamespaceURI.

	element defaultNamespace: 'defaultNS'.
	self assert: element hasNamespaceURI.

	element defaultNamespace: ''.
	self deny: element hasNamespaceURI.

	element name: 'prefix:test' namespaceURI: 'prefixNS'.
	self assert: element hasNamespaceURI.

	element name: 'test'.
	self deny: element hasNamespaceURI.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 02:06'!
testHasNamespaces
	| element |

	element := self nodeClass new.
	self deny: element hasNamespaces.

	element defaultNamespace: 'defaultNS'.
	self assert: element hasNamespaces.

	element undeclarePrefix: ''.
	self deny: element hasNamespaces.

	element declarePrefix: 'prefix' uri: 'prefixNS'.
	self assert: element hasNamespaces.

	element undeclarePrefix: 'prefix'.
	self deny: element hasNamespaces.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 01:45'!
testHasPrefix
	| element |

	element := self nodeClass new.
	self deny: element hasPrefix.

	element name: 'one'.
	self deny: element hasPrefix.

	element declarePrefix: 'prefix' uri: 'prefixNS'.
	element name: 'prefix:two'.
	self assert: element hasPrefix.

	element name: 'three'.
	self deny: element hasPrefix.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 00:31'!
testIncludesAttribute
	| element |

	element := self newElementWithAttributes.
	element attributeNames do: [:each |
		self assert: (element includesAttribute: each).
		element removeAttribute: each.
		self deny: (element includesAttribute: each)].! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/24/2014 08:11'!
testIsDeclaredPrefix
	| element elementsWithDeclaredPrefix |

	element := self newNodeWithElements.
	elementsWithDeclaredPrefix :=
		element allElementsSelect: [:each | each isDeclaredPrefix: 'prefix'].
	self assert: elementsWithDeclaredPrefix size = 2.

	element allElementsDo: [:each |
		(elementsWithDeclaredPrefix includes: each )
			ifFalse: [self deny: (each isDeclaredPrefix: 'prefix')]].

	element declarePrefix: 'prefix' uri: 'newPrefixNS'.
	element allElementsDo: [:each | self assert: (each isDeclaredPrefix: 'prefix')].

	element undeclarePrefix: 'prefix'.
	element allElementsDo: [:each |
		(elementsWithDeclaredPrefix includes: each )
			ifTrue: [self assert: (each isDeclaredPrefix: 'prefix')]
			ifFalse: [self deny: (each isDeclaredPrefix: 'prefix')]].! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 3/22/2015 03:43'!
testIsDeclaredPrefixURI
	| element elementsWithDeclaredPrefix oldNamespace |

	element := self newNodeWithElements.
	elementsWithDeclaredPrefix :=
		element allElementsSelect: [:each | each isDeclaredPrefix: 'prefix'].
	oldNamespace := elementsWithDeclaredPrefix anyOne resolvePrefix: 'prefix'.
	self assert: elementsWithDeclaredPrefix size = 2.

	element allElementsDo: [:each |
		self deny: (each isDeclaredPrefix: 'prefix' uri: 'newPrefixNS')].

	element declarePrefix: 'prefix' uri: 'newPrefixNS'.
	element allElementsDo: [:each |
		(elementsWithDeclaredPrefix includes: each )
			ifTrue: [self assert: (each isDeclaredPrefix: 'prefix' uri: oldNamespace)]
			ifFalse: [self assert: (each isDeclaredPrefix: 'prefix' uri: 'newPrefixNS')]].

	element undeclarePrefix: 'prefix'.
	element allElementsDo: [:each |
		(elementsWithDeclaredPrefix includes: each )
			ifTrue: [self assert: (each isDeclaredPrefix: 'prefix' uri: oldNamespace)]
			ifFalse: [self deny: (each isDeclaredPrefix: 'prefix')]].! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:41'!
testIsElement
	self assert: self nodeClass new isElement! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 05:24'!
testIsElementNamed
	| element |

	element := self nodeClass named: 'one'.
	self
		assert: (element isElementNamed: 'one');
		deny: (element isElementNamed: 'two').
	element name: 'one:two' namespaceURI: 'testNS'.
	self
		assert: (element isElementNamed: 'one:two');
		assert: (element isElementNamed: 'two');
		deny: (element isElementNamed: 'one').! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 05:23'!
testIsElementNamedAny
	| element |

	element := self nodeClass named: 'one'.
	self
		assert: (element isElementNamedAny: #('two' 'one' 'three'));
		deny: (element isElementNamedAny: #('two' 'three')).
	element name: 'one:two' namespaceURI: 'testNS'.
	self
		assert: (element isElementNamedAny: #('one' 'one:two' 'three'));
		assert: (element isElementNamedAny: #('one' 'two' 'three'));
		deny: (element isElementNamedAny: #('one' 'three')).! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 12/23/2014 16:19'!
testIsInLanguage
	| nodeWithElements |

	super testIsInLanguage.
	nodeWithElements := self newNodeWithElements.
	nodeWithElements allNodesDo: [:each |
		self
			deny: (each isInLanguage: 'en-us');
			deny: (each isInLanguage: 'EN-US');
			deny: (each isInLanguage: 'En');
			deny: (each isInLanguage: 'de-de');
			deny: (each isInLanguage: 'DE-DE');
			deny: (each isInLanguage: 'De')].

	nodeWithElements attributeAt: 'xml:lang' put: 'En-Us'.
	nodeWithElements allNodesDo: [:each |
		self
			assert: (each isInLanguage: 'en-us');
			assert: (each isInLanguage: 'EN-US');
			assert: (each isInLanguage: 'En');
			deny: (each isInLanguage: 'de-de');
			deny: (each isInLanguage: 'DE-DE');
			deny: (each isInLanguage: 'De')].! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 05:00'!
testIsNamed
	| element |

	element := self nodeClass named: 'one'.
	self
		assert: (element isNamed: 'one');
		deny: (element isNamed: 'two').
	element name: 'one:two' namespaceURI: 'testNS'.
	self
		assert: (element isNamed: 'one:two');
		assert: (element isNamed: 'two');
		deny: (element isNamed: 'one').! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 05:02'!
testIsNamedAny
	| element |

	element := self nodeClass named: 'one'.
	self
		assert: (element isNamedAny: #('two' 'one' 'three'));
		deny: (element isNamedAny: #('two' 'three')).
	element name: 'one:two' namespaceURI: 'testNS'.
	self
		assert: (element isNamedAny: #('one' 'one:two' 'three'));
		assert: (element isNamedAny: #('one' 'two' 'three'));
		deny: (element isNamedAny: #('one' 'three')).! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/24/2014 08:09'!
testIsRoot
	| element |

	element := self newNodeWithElements.
	self assert: element allElements first isRoot.
	element descendentElementsDo: [:each |
		self deny: each isRoot].
	(element removeNodes: element elements copy) do: [:each |
		self assert: each isRoot].! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 20:20'!
testLocalName
	| element |

	element := self nodeClass new.
	self assert: element name isEmpty.

	element name: 'one'.
	self assert: element localName = 'one'.

	element name: 'two'.
	self assert: element localName = 'two'.

	element declarePrefix: 'prefix' uri: 'prefixNS'.
	element name: 'prefix:three'.
	self assert: element localName = 'three'.

	element name: 'four'.
	self assert: element localName = 'four'.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 04:18'!
testName
	| element |

	self
		assert: (self nodeClass name: 'one') name = 'one';
		should: [self nodeClass name: 'unmapped:two'] raise: XMLNamespaceException.
	
	element := self nodeClass new.
	self assert: element name isEmpty.

	element name: 'one'.
	self assert: element name = 'one'.

	element name: 'two'.
	self assert: element name = 'two'.
	self should: [element name: 'unmapped:two'] raise: XMLNamespaceException.

	element usesNamespaces: false.
	self shouldnt: [element name: 'unmapped:three'] raise: XMLNamespaceException.
	self assert: element name = 'unmapped:three'.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 04:28'!
testNameAttributes
	| attributes unprefixedAttributes element |

	attributes := self attributes.
	unprefixedAttributes := self unprefixedAttributes.
	element := self nodeClass name: 'one' attributes: unprefixedAttributes.
	self
		assert: element name = 'one';
		assertElement: element hasAttributes: unprefixedAttributes.

	element := self nodeClass name: 'two' attributes: unprefixedAttributes associations.
	self
		assert: element name = 'two';
		assertElement: element hasAttributes: unprefixedAttributes.

	self
		should: [self nodeClass name: 'undeclared:three' attributes: unprefixedAttributes]
		raise: XMLNamespaceException.
	self
		should: [self nodeClass name: 'four' attributes: attributes]
		raise: XMLNamespaceException.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 01:13'!
testNameNamespaceURI
	| element |

	element := self nodeClass new.
	element name: 'one' namespaceURI: 'defaultNS'.
	self
		assert: element name = 'one';
		assert: element namespaceURI = 'defaultNS'.

	element := self nodeClass name: 'prefix:two' namespaceURI: 'prefixNS'.
	self
		assert: element name = 'prefix:two';
		assert: element namespaceURI = 'prefixNS'.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 04:41'!
testNameNamespaceURIAttributes
	| attributes unprefixedAttributes element |

	attributes := self attributes.
	unprefixedAttributes := self unprefixedAttributes.
	element :=
		self nodeClass
			name: 'prefix:one'
			namespaceURI: 'prefixNS'
			attributes: attributes.
	self
		assert: element name = 'prefix:one';
		assert: element namespaceURI = 'prefixNS';
		assertElement: element hasAttributes: attributes.

	element :=
		self nodeClass
			name: 'two'
			namespaceURI: 'prefixNS'
			attributes: unprefixedAttributes.
	self
		assert: element name = 'two';
		assert: element namespaceURI = 'prefixNS';
		assertElement: element hasAttributes: unprefixedAttributes.

	self
		should: [self nodeClass name: 'three' namespaceURI: '' attributes: attributes]
		raise: XMLNamespaceException.
	self
		should: [self nodeClass name: 'four' namespaceURI: 'prefixNS' attributes: attributes]
		raise: XMLNamespaceException.
	self
		should: [self nodeClass name: 'prefix:five' namespaceURI: '' attributes: unprefixedAttributes]
		raise: XMLNamespaceException.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/24/2014 00:33'!
testNameNamespaces
	| element |
	
	element := self nodeClass name: 'one' namespaces: self namespaces.
	self assert: element namespaceURI = 'defaultNS'.
	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert: (element isDeclaredPrefix: prefix uri: uri)].

	element := self nodeClass name: 'two' namespaces: self namespaces associations.
	self assert: element namespaceURI = 'defaultNS'.
	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert: (element isDeclaredPrefix: prefix uri: uri)].

	self
		should: [
			self nodeClass
				name: 'undeclared:three'
				namespaces: self namespaces]
		raise: XMLNamespaceException.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/24/2014 00:33'!
testNameNamespacesAttributes
	| element |

	element :=
		self nodeClass
			name: 'one'
			namespaces: self namespaces
			attributes: self attributes.
	self
		assert: element namespaceURI = 'defaultNS';
		assertElement: element hasAttributes: self attributes.
	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert: (element isDeclaredPrefix: prefix uri: uri)].

	element :=
		self nodeClass
			name: 'two'
			namespaces: self namespaces associations
			attributes: self attributes associations.
	self
		assert: element namespaceURI = 'defaultNS';
		assertElement: element hasAttributes: self attributes.
	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert: (element isDeclaredPrefix: prefix uri: uri)].

	self
		should: [
			self nodeClass
				name: 'undeclared:three'
				namespaces: self namespaces
				attributes: self attributes]
		raise: XMLNamespaceException.
	self
		should: [
			self nodeClass
				name: 'four'
				namespaces: #()
				attributes: self attributes]
		raise: XMLNamespaceException.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 04:15'!
testNamed
	self
		assert: (self nodeClass named: 'test') name = 'test';
		should: [self nodeClass named: 'undeclared:test'] raise: XMLNamespaceException! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 20:32'!
testNamespaceURI
	| element |

	element := self nodeClass new.
	self assert: element namespaceURI isEmpty.

	element defaultNamespace: 'defaultNS'.
	self assert: element namespaceURI = 'defaultNS'.

	element name: 'prefix:test' namespaceURI: 'prefixNS'.
	self assert: element namespaceURI = 'prefixNS'.
	
	element
		defaultNamespace: '';
		name: 'test'.
	self assert: element namespaceURI isEmpty.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/24/2014 18:40'!
testNextElement 
	| root nextElement |

	root := self newNodeWithElements firstElement.
	nextElement := nil.
	root elements reverseDo: [:each |
		self assert: each nextElement == nextElement.
		nextElement := each].! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 01:46'!
testPrefix
	| element |

	element := self nodeClass new.
	self assert: element prefix isEmpty.

	element name: 'one'.
	self assert: element prefix isEmpty.

	element declarePrefix: 'prefix' uri: 'prefixNS'.
	element name: 'prefix:two'.
	self assert: element prefix = 'prefix'.

	element name: 'three'.
	self assert: element prefix isEmpty.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/24/2014 18:40'!
testPreviousElement 
	| root previousElement |

	root := self newNodeWithElements firstElement.
	previousElement := nil.
	root elements do: [:each |
		self assert: each previousElement == previousElement.
		previousElement := each].! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/1/2014 21:02'!
testPrintingDefaultNamespaces
	| element |

	element :=
		XMLElement
			name: 'element'
			namespaceURI: 'default'.
	element addNode:
		((XMLElement
			name: 'element'
			namespaceURI: '')
			addElementNamed: 'empty';
			yourself).

	self assert:
		element printString =
			('<element xmlns="default">',
			'<element xmlns=""><empty /></element>',
			'</element>').! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 10/25/2014 21:33'!
testPrintingNonRootNamespaces
	| element |

	element :=
		XMLElement
			name: 'element'.
	element addNode:
		(XMLElement
			name: 'used:empty'
			namespaces: (Array with: '' -> 'defaultNS' with: 'used' -> 'usedNS')).

	self assert:
		element printString =
			('<element>',
			'<used:empty xmlns="defaultNS" xmlns:used="usedNS" />',
			'</element>').! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/1/2014 21:02'!
testPrintingRootNamespaces
	| element |

	element :=
		XMLElement
			name: 'used:element'
			namespaces: (Array with: '' -> 'defaultNS' with: 'used' -> 'usedNS').
	element addElementNamed: 'empty'.

	self assert:
		element printString =
			('<used:element xmlns="defaultNS" xmlns:used="usedNS">',
			'<empty />',
			'</used:element>').! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 00:52'!
testRemoveAttribute
	| element |

	element := self newElementWithAttributes.
	element attributeNodes copy do: [:each |
		self
			assert: (element removeAttribute: each name) = each value;
			should: [element removeAttribute: each name] raise: Error;
			deny: (element includesAttribute: each name)].
	self assert: element attributeNodes isEmpty.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/24/2014 22:05'!
testRemoveAttributeIfAbsent
	| element |

	element := self newElementWithAttributes.
	element attributeNodes copy do: [:each |
		self
			assert: (element removeAttribute: each name ifAbsent: [#absent]) = each value;
			assert: (element removeAttribute: each name ifAbsent: [#absent]) = #absent;
			deny: (element includesAttribute: each name)].
	self assert: element attributeNodes isEmpty.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 00:58'!
testRemoveAttributeNode
	| element |

	element := self newElementWithAttributes.
	element attributeNodes copy do: [:each |
		self
			assert: (element removeAttributeNode: each) == each ;
			should: [element removeAttribute: each] raise: Error;
			deny: (element attributeNodes includes: each)].
	self assert: element attributeNodes isEmpty.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 00:58'!
testRemoveAttributeNodeIfAbsent
	| element |

	element := self newElementWithAttributes.
	element attributeNodes copy do: [:each |
		self
			assert: (element removeAttributeNode: each ifAbsent: [#absent]) == each ;
			assert: (element removeAttributeNode: each ifAbsent: [#absent]) = #absent;
			deny: (element attributeNodes includes: each)].
	self assert: element attributeNodes isEmpty.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 00:40'!
testRemoveAttributes
	| element |

	element := self newElementWithAttributes.
	self
		assert: element removeAttributes == element;
		assert: element attributeNodes isEmpty;
		deny: element hasAttributes.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/24/2014 00:35'!
testResolvePrefix
	| element |

	(element := self nodeClass new)
		declareNamespaces: self namespaces.
	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert: (element resolvePrefix: prefix) = uri].
	self
		assert: (element resolvePrefix: 'xml') = XMLNamespaceScope xmlNamespaceURI;
		assert: (element resolvePrefix: 'xmlns') = XMLNamespaceScope xmlnsNamespaceURI;
		assert: (element resolvePrefix: 'undeclared') isEmpty.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 12/2/2014 22:59'!
testSortKey
	self assert: (self nodeClass named: 'test') sortKey = 'test'! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/24/2014 07:08'!
testUndeclareDefaultNamespace
	| element elementsWithDefaultNamespace |

	element := self newNodeWithElements.
	elementsWithDefaultNamespace :=
		element allElementsSelect: [:each | each defaultNamespace notEmpty].

	element
		defaultNamespace: 'defaultNS';
		undeclareDefaultNamespace;
		allElementsDo: [:each |
			(elementsWithDefaultNamespace includes: each)
				ifTrue: [self assert: each defaultNamespace notEmpty]
				ifFalse: [self assert: each defaultNamespace isEmpty]].! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 01:49'!
testUndeclarePrefix
	| element |

	element :=
		XMLElement
			name: 'outer'
			namespaces: (Array with: '' -> 'defaultNS' with: 'unused' -> 'unusedNS' with: 'used' -> 'usedNS').
	element addElementNamed: 'used:inner'.

	self
		shouldnt: [element undeclarePrefix: '']
		raise: XMLNamespaceException.
	self
		shouldnt: [element undeclarePrefix: 'unused']
		raise: XMLNamespaceException.
	element allElementsDo: [:each |
		self
			deny: (each isDeclaredPrefix: '');
			deny: (each isDeclaredPrefix: 'unused')].
	self
		should: [element undeclarePrefix: 'used']
		raise: XMLNamespaceException.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 10/12/2014 01:13'!
testUndeclaringAttributePrefixes
	| element |

	element :=
		XMLElement
			name: 'element'
			namespaces: (Array with: '' -> 'defaultNS' with: 'unused' -> 'unusedNS' with: 'used' -> 'usedNS')
			attributes: (Array with: 'name' -> 'value' with: 'used:name' -> 'value').

	self
		shouldnt: [element undeclarePrefix: '']
		raise: XMLNamespaceException.
	self
		shouldnt: [element undeclarePrefix: 'unused']
		raise: XMLNamespaceException.
	self
		should: [element undeclarePrefix: 'used']
		raise: XMLNamespaceException.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/24/2014 08:50'!
testWriteXMLOn
	| element attributes |

	element := XMLElement named: 'element'.
	attributes := OrderPreservingDictionary with: 'b'->'two' with: 'a'->'one'.
	self
		assert: element printString = '<element />';
		assert: (element contentString: 'test') printString = '<element>test</element>';
		assert: (element setAttributes: attributes) printString = '<element b="two" a="one">test</element>'! !

!XMLElementTest methodsFor: 'accessing' stamp: 'monty 11/24/2014 08:30'!
unprefixedAttributes
	^ OrderPreservingStringDictionary newFrom:
		(self attributes associations collect: [:each |
			each key localNameAfterPrefix -> each value])! !

!XMLNodeWithElementsTest class methodsFor: 'testing' stamp: 'monty 11/2/2014 11:13'!
isAbstract
	^ true! !

!XMLNodeWithElementsTest methodsFor: 'instance creation' stamp: 'monty 4/1/2015 19:09'!
newNodeWithElements
	^ self nodeClass new
		addNode: (XMLComment string: 'before');
		addNode:
			((XMLElement name: 'root')
				addNode: (XMLComment string: 'before');
				addNode:
					((XMLElement named: 'one')
						attributeAt: 'one' put: '1';
						addNode: (XMLString string: 'testing one');
						addNode: (XMLElement named: 'two');
						addNode: (XMLPI target: 'target' data: 'data');
						yourself);
				addNode: (XMLString string: 'testing two');
				addNode:
					((XMLElement name: 'three' namespaceURI: 'testNS')
						addNode: (XMLElement name: 'four');
						addNode: (XMLCData string: 'testing three');
						yourself);
				addNode:
					((XMLElement name: 'prefix:four' namespaceURI: 'testNS')
						attributeAt: 'four' put: '4';
						addNode: (XMLElement name: 'prefix:five' namespaceURI: 'testNS');
						yourself);
				addNode: (XMLElement name: 'four');
				yourself);
		addNode: (XMLComment string: 'after');
		yourself.! !

!XMLNodeWithElementsTest methodsFor: 'instance creation' stamp: 'monty 11/7/2014 14:18'!
newNodeWithNodes
	^ self newNodeWithElements! !

!XMLNodeWithElementsTest methodsFor: 'accessing' stamp: 'monty 11/4/2014 19:02'!
nodeClass
	^ XMLNodeWithElements! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 00:04'!
testAddContent
	| node |

	node := self nodeClass new.
	node addContent: 'one'.
	self
		assert: node nodes size = 1;
		assert: (node firstNode isStringNode: 'one').
	node addContent: 'two' asXMLString.
	self
		assert: node nodes size = 1;
		assert: (node firstNode isStringNode: 'onetwo').

	node addNode: (XMLElement named: 'three').
	self
		assert: node nodes size = 2;
		assert: (node firstNode isStringNode: 'onetwo');
		assert: (node nodes second isElementNamed: 'three').

	node
		addContent: (XMLCData string: 'four');
		addContent: (XMLString string: 'five').
	self
		assert: node nodes size = 4;
		assert: (node firstNode isStringNode: 'onetwo');
		assert: (node nodes second isElementNamed: 'three');
		assert: (node nodes third isCData and: [node nodes third string = 'four']);
		assert: (node nodes fourth isStringNode: 'five').! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/7/2014 15:41'!
testAddElementNamed
	| node element |

	node := self nodeClass new.
	(element := node addElementNamed: 'test')
		addElementNamed: 'first';
		declarePrefix: 'prefix' uri: 'ns';
		addElementNamed: 'prefix:second'.
	self assert: element elementNames asArray = #('first' 'prefix:second').
	self
		should: [element addElementNamed: 'undeclared:fourth']
		raise: XMLNamespaceException.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/7/2014 15:45'!
testAddElementNamedNamespaceURI
	| node element |

	node := self nodeClass new.
	(element := node addElementNamed: 'test' namespaceURI: 'defaultNS')
		addElementNamed: 'prefix:first' namespaceURI: 'firstNS';
		addElementNamed: 'second' namespaceURI: 'secondNS'.
	self
		assert: element namespaceURI = 'defaultNS';
		assert: element nodes first name = 'prefix:first';
		assert: element nodes first namespaceURI = 'firstNS';
		assert: element nodes second name = 'second';
		assert: element nodes second namespaceURI = 'secondNS'.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 22:06'!
testAllElements
	| nodeWithElements allElements |

	nodeWithElements := self newNodeWithElements.
	allElements := nodeWithElements allElements.
	nodeWithElements isElement
		ifTrue: [
			self assert: allElements first == nodeWithElements.
			allElements removeFirst].
	self assert:
		(allElements collect: [:each | each name]) asArray =
			#('root' 'one' 'two' 'three' 'four' 'prefix:four' 'prefix:five' 'four').
	self
		assertList: allElements first allElements selects: (allElements copyFrom: 1 to: 8);
		assertList: allElements second allElements selects: (allElements copyFrom: 2 to: 3);
		assertList: allElements third allElements selects: (allElements copyFrom: 3 to: 3);
		assertList: allElements fourth allElements selects: (allElements copyFrom: 4 to: 5);
		assertList: allElements fifth allElements selects: (allElements copyFrom: 5 to: 5);
		assertList: allElements sixth allElements selects: (allElements copyFrom: 6 to: 7);
		assertList: allElements seventh allElements selects: (allElements copyFrom: 7 to: 7);
		assertList: allElements eighth allElements selects: (allElements copyFrom: 8 to: 8).! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/7/2014 14:07'!
testAllElementsCollect
	| nodeWithElements allElements |

	nodeWithElements := self newNodeWithElements.
	allElements := nodeWithElements allElements.
	self
		assertList: (nodeWithElements allElementsCollect: [:each | each identityHash])
		collects: (allElements collect: [:each | each identityHash]).

	allElements do: [:node |
		self
			assertList: (node allElementsCollect: [:each | each identityHash])
			collects: (node allElements collect: [:each | each identityHash])].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/7/2014 14:37'!
testAllElementsDetect
	| nodeWithElements allElements detectedElement |

	nodeWithElements := self newNodeWithElements.
	allElements := nodeWithElements allElements.
	detectedElement := nodeWithElements allElementsDetect: [:each | each isNamed: 'prefix:four'].
	self
		assert: detectedElement notNil;
		assert: (detectedElement isNamed: 'prefix:four');
		assert: detectedElement == (allElements detect: [:each | each isNamed: 'prefix:four']);
		assert: (nodeWithElements allElementsDetect: [:each | each isNamed: 'absent']) isNil.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/7/2014 14:46'!
testAllElementsDetectIfNone
	| nodeWithElements allElements detectedElement |

	nodeWithElements := self newNodeWithElements.
	allElements := nodeWithElements allElements.
	detectedElement :=
		nodeWithElements
			allElementsDetect: [:each | each isNamed: 'prefix:four']
			ifNone: [#absent].
	self
		deny: detectedElement = #absent;
		assert: (detectedElement isNamed: 'prefix:four').
	self assert:	
		detectedElement ==
			(allElements
				detect: [:each | each isNamed: 'prefix:four']
				ifNone: [#absent]).
	self assert:
		(nodeWithElements
			allElementsDetect: [:each | each isNamed: 'absent']
			ifNone: [#absent]) = #absent.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/7/2014 14:07'!
testAllElementsDo
	| nodeWithElements allElements |

	nodeWithElements := self newNodeWithElements.
	allElements := nodeWithElements allElements.
	self
		should: [:block | nodeWithElements allElementsDo: block]
		enumerate: allElements.

	allElements do: [:element |
		self
			should: [:block | element allElementsDo: block]
			enumerate: element allElements].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 21:22'!
testAllElementsNamed
	| nodeWithElements allElements namedElements |

	nodeWithElements := self newNodeWithElements.
	self assert: (nodeWithElements allElementsNamed: 'absent') isEmpty.

	allElements := nodeWithElements allElements.
	namedElements := nodeWithElements allElementsNamed: 'four'. 
	self
		assert: namedElements size = 3;
		assertList: namedElements selects: (allElements select: [:each | each isNamed: 'four']).! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 21:25'!
testAllElementsNamedDo
	| nodeWithElements allElements namedElements |

	nodeWithElements := self newNodeWithElements.
	self
		should: [:block | nodeWithElements allElementsNamed: 'absent' do: block]
		enumerate: #().

	allElements := nodeWithElements allElements.
	namedElements := nodeWithElements allElementsNamed: 'four'. 
	self
		should: [:block | nodeWithElements allElementsNamed: 'four' do: block]
		enumerate: namedElements.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 21:22'!
testAllElementsNamedNamespaceURI
	| nodeWithElements allElements namedElements |

	nodeWithElements := self newNodeWithElements.
	self assert: (nodeWithElements allElementsNamed: 'four' namespaceURI: 'absent') isEmpty.

	allElements := nodeWithElements allElements.
	namedElements := nodeWithElements allElementsNamed: 'four' namespaceURI: 'testNS'. 
	self
		assert: namedElements size = 2;
		assertList: namedElements
		selects:
			(allElements select: [:each |
				(each isNamed: 'four')
					and: [each namespaceURI = 'testNS']]).! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/7/2014 14:07'!
testAllElementsSelect
	| nodeWithElements allElements |

	nodeWithElements := self newNodeWithElements.
	allElements := nodeWithElements allElements.
	self
		assertList: (nodeWithElements allElementsSelect: [:each | each hasChildren])
		selects: (allElements select: [:each | each hasChildren]).

	allElements do: [:node |
		self
			assertList: (node allElementsSelect: [:each | each hasChildren])
			selects: (node allElements select: [:each | each hasChildren])].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/19/2014 22:14'!
testAllNodes
	| nodeWithElements allNodes |

	nodeWithElements := self newNodeWithElements.
	allNodes := nodeWithElements allNodes.
	self
		assert: allNodes size = 16;
		assert: (allNodes at: 1) == nodeWithElements;
		assert: (allNodes at: 2) isComment;
		assert: ((allNodes at: 3) isElementNamed: 'root');
		assert: (allNodes at: 4) isComment;
		assert: ((allNodes at: 5) isElementNamed: 'one');
		assert: ((allNodes at: 6) isStringNode: 'testing one');
		assert: ((allNodes at: 7) isElementNamed: 'two');
		assert: (allNodes at: 8) isPI;
		assert: ((allNodes at: 9) isStringNode: 'testing two');
		assert: ((allNodes at: 10) isElementNamed: 'three');
		assert: ((allNodes at: 11) isElementNamed: 'four');
		assert: ((allNodes at: 12) isStringNode: 'testing three');
		assert: ((allNodes at: 13) isElementNamed: 'prefix:four');
		assert: ((allNodes at: 14) isElementNamed: 'prefix:five');
		assert: ((allNodes at: 15) isElementNamed: 'four');
		assert: (allNodes at: 16) isComment.
	self
		assertList: (allNodes at: 3) allNodes selects: (allNodes copyFrom: 3 to: 15);
		assertList: (allNodes at: 5) allNodes selects: (allNodes copyFrom: 5 to: 8);
		assertList: (allNodes at: 7) allNodes selects: (allNodes copyFrom: 7 to: 7);
		assertList: (allNodes at: 10) allNodes selects: (allNodes copyFrom: 10 to: 12);
		assertList: (allNodes at: 11) allNodes selects: (allNodes copyFrom: 11 to: 11);
		assertList: (allNodes at: 13) allNodes selects: (allNodes copyFrom: 13 to: 14);
		assertList: (allNodes at: 14) allNodes selects: (allNodes copyFrom: 14 to: 14);
		assertList: (allNodes at: 15) allNodes selects: (allNodes copyFrom: 15 to: 15).! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 3/8/2015 17:07'!
testAncestorElements
	| nodeWithElements ancestorStack |

	super testAncestorElements.

	nodeWithElements := self newNodeWithElements.
	ancestorStack := OrderedCollection new.
	nodeWithElements allNodesDo: [:each |
		[ancestorStack isEmpty
			or: [ancestorStack last == each parent]]
			whileFalse: [ancestorStack removeLast].
		self assert:
			each ancestorElements asOrderedCollection =
				ancestorStack reversed.
		each isElement
			ifTrue: [ancestorStack addLast: each]].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 3/8/2015 17:07'!
testAncestorElementsDo
	| nodeWithElements |

	super testAncestorElementsDo.

	nodeWithElements := self newNodeWithElements.
	nodeWithElements allNodesDo: [:each |
		self
			should: [:block | each ancestorElementsDo: block]
			enumerate: each ancestorElements].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 05:08'!
testConfiguration
	| nodeWithElements configuration newConfiguration |

	nodeWithElements := self newNodeWithElements.
	configuration := nodeWithElements configuration.
	self assert: configuration class == XMLDOMConfiguration.
	nodeWithElements allElementsDo: [:element |
		self assert: element configuration == configuration.
		element attributeNodes do: [:each |
			self assert: each configuration == configuration]].

	newConfiguration := XMLDOMConfiguration new.
	nodeWithElements configuration: newConfiguration.
	self assert: nodeWithElements configuration == newConfiguration.
	nodeWithElements allElementsDo: [:element |
		self assert: element configuration == newConfiguration.
		element attributeNodes do: [:each |
			self assert: each configuration == newConfiguration]].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 05:43'!
testContentNodes
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self
		assertList: nodeWithElements contentNodes
		selects: (nodeWithElements nodes select: [:each | each isContentNode]).
	nodeWithElements allElementsDo: [:element |
		self
			assertList: element contentNodes
			selects: (element nodes select: [:each | each isContentNode])].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 05:44'!
testContentNodesDo
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self
		should: [:block | nodeWithElements contentNodesDo: block]
		enumerate: nodeWithElements contentNodes.
	nodeWithElements allElementsDo: [:each |
		self
			should: [:block | each contentNodesDo: block]
			enumerate: each contentNodes].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 2/2/2015 16:35'!
testContentString
	self
		assert: self newNodeWithElements contentString = 'testing one testing two testing three';
		assert: (self newNodeWithElements contentString: 'new') contentString = 'new'! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 2/2/2015 16:35'!
testContentStringAt
	| root |

	root := self newNodeWithElements firstElement.
	root elementsDo: [:each |
		self assert: (root contentStringAt: each name) = each contentString].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 22:06'!
testDescendentElements
	| nodeWithElements descendentElements |

	nodeWithElements := self newNodeWithElements.
	descendentElements := nodeWithElements descendentElements.
	self assert:
		(descendentElements collect: [:each | each name]) asArray =
			#('root' 'one' 'two' 'three' 'four' 'prefix:four' 'prefix:five' 'four').
	self
		assertList: descendentElements first descendentElements selects: (descendentElements copyFrom: 2 to: 8);
		assertList: descendentElements second descendentElements selects: (descendentElements copyFrom: 3 to: 3);
		assertList: descendentElements third descendentElements selects: descendentElements copyEmpty;
		assertList: descendentElements fourth descendentElements selects: (descendentElements copyFrom: 5 to: 5);
		assertList: descendentElements fifth descendentElements selects: descendentElements copyEmpty;
		assertList: descendentElements sixth descendentElements selects: (descendentElements copyFrom: 7 to: 7);
		assertList: descendentElements seventh descendentElements selects: descendentElements copyEmpty;
		assertList: descendentElements eighth descendentElements selects: descendentElements copyEmpty.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/7/2014 14:07'!
testDescendentElementsCollect
	| nodeWithElements descendentElements |

	nodeWithElements := self newNodeWithElements.
	descendentElements := nodeWithElements descendentElements.
	self
		assertList: (nodeWithElements descendentElementsCollect: [:each | each identityHash])
		collects: (descendentElements collect: [:each | each identityHash]).

	descendentElements do: [:node |
		self
			assertList: (node descendentElementsCollect: [:each | each identityHash])
			collects: (node descendentElements collect: [:each | each identityHash])].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/7/2014 14:28'!
testDescendentElementsDetect
	| nodeWithElements descendentElements detectedElement |

	nodeWithElements := self newNodeWithElements.
	descendentElements := nodeWithElements descendentElements.
	detectedElement := nodeWithElements descendentElementsDetect: [:each | each isNamed: 'prefix:four'].
	self
		assert: detectedElement notNil;
		assert: (detectedElement isNamed: 'prefix:four');
		assert: detectedElement == (descendentElements detect: [:each | each isNamed: 'prefix:four']);
		assert: (detectedElement descendentElementsDetect: [:each | each isNamed: 'prefix:four']) isNil.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/7/2014 14:45'!
testDescendentElementsDetectIfNone
	| nodeWithElements descendentElements detectedElement |

	nodeWithElements := self newNodeWithElements.
	descendentElements := nodeWithElements descendentElements.
	detectedElement :=
		nodeWithElements
			descendentElementsDetect: [:each | each isNamed: 'prefix:four']
			ifNone: [#absent].
	self
		deny: detectedElement = #absent;
		assert: (detectedElement isNamed: 'prefix:four').
	self assert:	
		detectedElement ==
			(descendentElements
				detect: [:each | each isNamed: 'prefix:four'] 
				ifNone: [#absent]).
	self assert:
		(detectedElement
			descendentElementsDetect: [:each | each isNamed: 'prefix:four']
			ifNone: [#absent]) = #absent.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/7/2014 14:07'!
testDescendentElementsDo
	| nodeWithElements descendentElements |

	nodeWithElements := self newNodeWithElements.
	descendentElements := nodeWithElements descendentElements.
	self
		should: [:block | nodeWithElements descendentElementsDo: block]
		enumerate: descendentElements.

	descendentElements do: [:element |
		self
			should: [:block | element descendentElementsDo: block]
			enumerate: element descendentElements].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 21:25'!
testDescendentElementsNamed
	| nodeWithElements descendentElements namedElements |

	nodeWithElements := self newNodeWithElements.
	self assert: (nodeWithElements descendentElementsNamed: 'absent') isEmpty.

	descendentElements := nodeWithElements descendentElements.
	namedElements := nodeWithElements descendentElementsNamed: 'four'. 
	self assert: namedElements size = 3.
	self
		assertList: namedElements
		selects: (descendentElements select: [:each | each isNamed: 'four']).

	namedElements do: [:each |
		self assert: (each descendentElementsNamed: 'four') isEmpty]! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 21:24'!
testDescendentElementsNamedDo
	| nodeWithElements descendentElements namedElements |

	nodeWithElements := self newNodeWithElements.
	self
		should: [:block | nodeWithElements descendentElementsNamed: 'absent' do: block]
		enumerate: #().

	descendentElements := nodeWithElements descendentElements.
	namedElements := nodeWithElements descendentElementsNamed: 'four'. 
	self
		should: [:block | nodeWithElements descendentElementsNamed: 'four' do: block]
		enumerate: namedElements.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 21:23'!
testDescendentElementsNamedNamespaceURI
	| nodeWithElements descendentElements namedElements |

	nodeWithElements := self newNodeWithElements.
	self assert:
		(nodeWithElements
			descendentElementsNamed: 'four'
			namespaceURI: 'absent') isEmpty.

	descendentElements := nodeWithElements descendentElements.
	namedElements :=
		nodeWithElements
			descendentElementsNamed: 'four'
			namespaceURI: 'testNS'. 
	self
		assert: namedElements size = 2;
		assertList: namedElements
		selects:
			(descendentElements select: [:each |
				(each isNamed: 'four')
					and: [each namespaceURI = 'testNS']]).! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/7/2014 14:07'!
testDescendentElementsSelect
	| nodeWithElements descendentElements |

	nodeWithElements := self newNodeWithElements.
	descendentElements := nodeWithElements descendentElements.
	self
		assertList: (nodeWithElements descendentElementsSelect: [:each | each hasChildren])
		selects: (descendentElements select: [:each | each hasChildren]).

	descendentElements do: [:node |
		self
			assertList: (node descendentElementsSelect: [:each | each hasChildren])
			selects: (node descendentElements select: [:each | each hasChildren])].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 18:42'!
testElementAfter
	| root elementAfter |

	root := self newNodeWithElements firstElement.
	elementAfter := nil.
	root elements reverseDo: [:each |
		self assert: (root elementAfter: each) == elementAfter.
		elementAfter := each].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 21:34'!
testElementAt
	| root  |

	root := self newNodeWithElements firstElement.
	self assert: (root elementAt: 'absent') isNil.
	root elements do: [:each |
		self assert:
			(root elementAt: each name) ==
				(root elements detect: [:element | element isNamed: each name])].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 21:35'!
testElementAtIfAbsent
	| root  |

	root := self newNodeWithElements firstElement.
	self assert: (root elementAt: 'absent' ifAbsent: [#absent]) = #absent.
	root elements do: [:each |
		self assert:
			(root elementAt: each name ifAbsent: [#absent]) ==
				(root elements detect: [:element | element isNamed: each name])].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/23/2014 03:57'!
testElementAtNamespaceURI
	| root element |

	root := self newNodeWithElements firstElement.
	self assert: (root elementAt: 'four' namespaceURI: 'absent') isNil.

	element := root elementAt: 'four' namespaceURI: 'testNS'.
	self deny: element isNil.
	self assert:
		element ==
			(root elements detect: [:each |
				(each isNamed: 'four') and: [each namespaceURI = 'testNS']]).

	root removeNode: element.
	self deny: (root elementAt: 'four' namespaceURI: 'testNS') == element.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/25/2014 00:04'!
testElementAtNamespaceURIIfAbsent
	| root element |

	root := self newNodeWithElements firstElement.
	self assert:
		(root
			elementAt: 'four'
			namespaceURI: 'absent'
			ifAbsent: [#absent]) = #absent.

	element := root elementAt: 'four' namespaceURI: 'testNS' ifAbsent: [#absent].
	self deny: element = #absent.
	self assert:
		element ==
			(root elements
				detect: [:each |
					(each isNamed: 'four')
						and: [each namespaceURI = 'testNS']]
				ifNone: [#absent]).

	root removeNode: element.
	self assert:
		(root
			elementAt: 'four'
			namespaceURI: 'testNS'
			ifAbsent: [#absent]) = #absent.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 18:41'!
testElementBefore
	| root elementBefore |

	root := self newNodeWithElements firstElement.
	elementBefore := nil.
	root elements do: [:each |
		self assert: (root elementBefore: each) == elementBefore.
		elementBefore := each].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 22:09'!
testElementNames
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self
		assertList: nodeWithElements elementNames
		collects: (nodeWithElements elements collect: [:each | each name]).
	nodeWithElements allElementsDo: [:element |
		self
			assertList: element elementNames
			collects: (element elements collect: [:each | each name])].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 01:42'!
testElementRenamingToNext
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements
		usesNamespaces: false;
		allElementsDo: [:each |
		| parent oldName oldLocalName nextElement |

		((parent := each parent) notNil
			and: [(nextElement := each nextElement) notNil])
			ifTrue: [
				oldName := each name.
				oldLocalName := each localName.
				
				each name: nextElement name.
				each name = oldName
					ifFalse: [
						self
							deny: ((parent elementAt: oldName) == each);
							deny: ((parent elementsAt: oldName) includes: each)].
				each localName = oldLocalName
					ifFalse: [
						self
							deny: ((parent elementAt: oldLocalName) == each);
							deny: ((parent elementsAt: oldLocalName) includes: each)].
				self
					assert: ((parent elementsAt: each name) after: each) == nextElement;
					assert: ((parent elementsAt: each localName) after: each) == nextElement]].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 01:44'!
testElementRenamingToPrevious
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements
		usesNamespaces: false;
		allElementsDo: [:each |
		| parent oldName oldLocalName previousElement |

		((parent := each parent) notNil
			and: [(previousElement := each previousElement) notNil])
			ifTrue: [
				oldName := each name.
				oldLocalName := each localName.
				
				each name: previousElement name.
				each name = oldName
					ifFalse: [
						self
							deny: ((parent elementAt: oldName) == each);
							deny: ((parent elementsAt: oldName) includes: each)].
				each localName = oldLocalName
					ifFalse: [
						self
							deny: ((parent elementAt: oldLocalName) == each);
							deny: ((parent elementsAt: oldLocalName) includes: each)].
				self
					assert: ((parent elementsAt: each name) before: each) == previousElement;
					assert: ((parent elementsAt: each localName) before: each) == previousElement]].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/23/2014 04:05'!
testElements
	| nodeWithElmeents |

	nodeWithElmeents := self newNodeWithElements.
	self
		assertList: nodeWithElmeents elements 
		selects: (nodeWithElmeents nodes select: [:each | each isElement]).
	nodeWithElmeents allElementsDo: [:element |
		self
			assertList: element elements 
			selects: (element nodes select: [:each | each isElement])].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 23:58'!
testElementsAt
	| root namedElements |

	root := self newNodeWithElements firstElement.
	self assert: (root elementsAt: 'absent') isEmpty.

	namedElements := root elementsAt: 'four'.
	self assert: namedElements size = 2.
	self
		assertList: namedElements
		selects: (root elements select: [:each | each isNamed: 'four']).

	(namedElements := namedElements copy) do: [:each |
		root removeNode: each.
		self
			assertList: (root elementsAt: 'four')
			selects: (namedElements copyAfter: each)].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 23:58'!
testElementsAtDo
	| root namedElements |

	root := self newNodeWithElements firstElement.
	self
		should: [:block | root elementsAt: 'absent' do: block]
		enumerate: #().
	namedElements := root elementsAt: 'four'.
	self
		should: [:block | root elementsAt: 'four' do: block]
		enumerate: namedElements.

	(namedElements := namedElements copy) do: [:each |
		root removeNode: each.
		self
			should: [:block | root elementsAt: 'four' do: block]
			enumerate: (namedElements copyAfter: each)].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 23:58'!
testElementsAtNamespaceURI
	| root namedElements |

	root := self newNodeWithElements firstElement.
	self assert: (root elementsAt: 'four' namespaceURI: 'absent') isEmpty.

	namedElements := root elementsAt: 'four' namespaceURI: 'testNS'.
	self assert: namedElements size = 1.
	self
		assertList: namedElements
		selects:
			(root elements select: [:each |
				(each isNamed: 'four') and: [each namespaceURI = 'testNS']]).

	root removeNode: namedElements first.
	self assert: (root elementsAt: 'four' namespaceURI: 'testNS') isEmpty.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 02:30'!
testElementsCollect
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self
		assertList: (nodeWithElements elementsCollect: [:each | each name])
		collects: (nodeWithElements elements collect: [:each | each name]).
	nodeWithElements allElementsDo: [:element |
		self
			assertList: (element elementsCollect: [:each | each name])
			collects: (element elements collect: [:each | each name])].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 05:18'!
testElementsDetect
	| root element |

	root := self newNodeWithElements firstElement.
	element :=
		root elementsDetect: [:each |
			(each isNamed: 'four') and: [each namespaceURI = 'testNS']].
	self deny: element isNil.
	self assert:
		element == 
			(root elements detect: [:each |
				(each isNamed: 'four') and: [each namespaceURI = 'testNS']]).
	self assert:
		(root elementsDetect: [:each |
			(each isNamed: 'four') and: [each namespaceURI = 'absentNS']]) isNil.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 05:20'!
testElementsDetectIfNone
	| root element |

	root := self newNodeWithElements firstElement.
	element :=
		root
			elementsDetect: [:each |
				(each isNamed: 'four') and: [each namespaceURI = 'testNS']]
			ifNone: [#absent].
	self deny: element = #absent.
	self assert:
		element == 
			(root elements
				detect: [:each |
					(each isNamed: 'four') and: [each namespaceURI = 'testNS']]
				ifNone: [#absent]).
	self assert:
		(root
			elementsDetect: [:each |
				(each isNamed: 'four') and: [each namespaceURI = 'absentNS']]
			ifNone: [#absent]) = #absent.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 02:33'!
testElementsDo
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self
		should: [:block | nodeWithElements elementsDo: block]
		enumerate: nodeWithElements elements.

	nodeWithElements allElementsDo: [:each |
		self
			should: [:block | each elementsDo: block]
			enumerate: each elements].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 02:32'!
testElementsSelect
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self
		assertList: (nodeWithElements elementsSelect: [:each | each hasChildren])
		selects: (nodeWithElements elements select: [:each | each hasChildren]).
	nodeWithElements allElementsDo: [:element |
		self
			assertList: (element elementsSelect: [:each | each hasChildren])
			selects: (element elements select: [:each | each hasChildren])].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 21:57'!
testFindElementNamed
	| nodeWithElements allElements foundElement |

	nodeWithElements := self newNodeWithElements.
	allElements := nodeWithElements allElements.
	foundElement := nodeWithElements findElementNamed: 'four'.
	self
		assert: foundElement notNil;
		assert: (foundElement isNamed: 'four');
		assert: foundElement == (allElements detect: [:each | each isNamed: 'four']);
		assert: (foundElement findElementNamed: 'four') == foundElement;
		assert: (nodeWithElements findElementNamed: 'absent') isNil.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 22:02'!
testFindElementNamedNamespaceURI
	| nodeWithElements allElements foundElement |

	nodeWithElements := self newNodeWithElements.
	allElements := nodeWithElements allElements.
	foundElement := nodeWithElements findElementNamed: 'four' namespaceURI: 'testNS'.
	self
		assert: foundElement notNil;
		assert: (foundElement isNamed: 'four').
	self assert:
		foundElement ==
			(allElements detect: [:each |
				(each isNamed: 'four') and: [each namespaceURI = 'testNS']]).
	self
		assert: (foundElement findElementNamed: 'four' namespaceURI: 'testNS') == foundElement;
		assert: (nodeWithElements findElementNamed: 'four' namespaceURI: 'absentNS') isNil.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 09:09'!
testFindElementNamedNamespaceURIWith
	| nodeWithElements allElements foundElement |

	nodeWithElements := self newNodeWithElements.
	allElements := nodeWithElements allElements.
	foundElement :=
		nodeWithElements
			findElementNamed: 'four'
			namespaceURI: 'testNS'
			with: [:each | each hasChildren].
	self
		assert: foundElement notNil;
		assert: (foundElement isNamed: 'prefix:four').
	self assert:
		foundElement ==
			(allElements detect: [:each |
				(each isNamed: 'four')
					and: [(each namespaceURI = 'testNS')
						and: [each hasChildren]]]).
	self assert:
		(foundElement
			findElementNamed: 'four'
			namespaceURI: 'testNS'
			with: [:each | each hasChildren]) == foundElement.
	self assert:
		(nodeWithElements 
			findElementNamed: 'four'
			namespaceURI: 'testNS'
			with: [:each | false]) isNil.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 22:04'!
testFindElementNamedWith
	| nodeWithElements allElements foundElement |

	nodeWithElements := self newNodeWithElements.
	allElements := nodeWithElements allElements.
	foundElement := nodeWithElements findElementNamed: 'four' with: [:each | each hasChildren].
	self
		assert: foundElement notNil;
		assert: (foundElement isNamed: 'four').
	self assert:
		foundElement ==
			(allElements detect: [:each | (each isNamed: 'four') and: [each hasChildren]]).
	self
		assert: (foundElement findElementNamed: 'four' with: [:each | each hasChildren]) == foundElement;
		assert: (nodeWithElements findElementNamed: 'four' with: [:each | false]) isNil.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/19/2014 22:19'!
testFirstElement
	| root |

	root := self newNodeWithElements nodeAt: 2.
	root elements copy do: [:each |
		self  assert: root firstElement == each.
		root removeNode: each].
	self assert: root firstElement isNil.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 05:42'!
testHasContentNodes
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self assert: nodeWithElements hasContentNodes.
	nodeWithElements allElementsDo: [:element |
		self assert: element hasContentNodes = element contentNodes notEmpty].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 00:21'!
testHasElements
	self
		deny: self nodeClass new hasElements;
		assert: self newNodeWithElements hasElements;
		deny: self newNodeWithElements removeNodes hasElements! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 05:41'!
testHasStringNodes
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self deny: nodeWithElements hasStringNodes.
	nodeWithElements allElementsDo: [:element |
		self assert: element hasStringNodes = element stringNodes notEmpty].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/25/2014 00:02'!
testIncludesElement
	| root |
	
	root := self newNodeWithElements firstElement.
	self deny: (root includesElement: 'absent').
	root elements copy do: [:each |
		self assert: (root includesElement: each name).
		root removeNode: each.
		self deny: (root includesElement: each name)].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/7/2014 15:10'!
testInnerXML
	| node element |

	node := self nodeClass new.
	element :=
		node addNode:
			(XMLElement name: 'test' namespaces: (Array with: 'prefix'-> 'ns')).
	element innerXML: '<prefix:inner></prefix:inner>'.
	element firstNode innerXML: 'test<!!--comment-->'.
	self
		assert: element nodes size = 1;
		assert: (element firstNode isNamed: 'prefix:inner');
		assert: (element firstNode contentString = 'test');
		assert: node innerXML = '<test xmlns:prefix="ns"><prefix:inner>test</prefix:inner></test>';
		assert: element innerXML = '<prefix:inner xmlns:prefix="ns">test</prefix:inner>';
		assert: element firstNode innerXML = 'test'.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 5/7/2015 23:10'!
testInnerXMLResetting
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self
		should: [nodeWithElements firstElement innerXML: '<one><two></one></two>']
		raise: XMLWellFormednessException.
	self assert: nodeWithElements printString = self newNodeWithNodes printString.

	self
		should: [nodeWithElements firstElement innerXML: '<one>&invalid;</one>']
		raise: XMLValidationException.
	self assert: nodeWithElements printString = self newNodeWithNodes printString.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:46'!
testIsContentNode
	self assert: self nodeClass new isContentNode! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/19/2014 22:19'!
testLastElement
	| root |

	root := self newNodeWithElements nodeAt: 2.
	root elements reversed do: [:each |
		self  assert: root lastElement == each.
		root removeNode: each].
	self assert: root lastElement isNil.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 23:01'!
testNewCData
	| cdata |

	cdata := self nodeClass new newCData: 'test'.
	self
		assert: cdata isCData;
		assert: cdata string = 'test'.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 23:12'!
testNewComment
	| comment |

	comment := self nodeClass new newComment: 'test'.
	self
		assert: comment isComment;
		assert: comment string = 'test'.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 23:09'!
testNewDocument
	| node document |

	node := self nodeClass new.
	document := node newDocument.
	self
		assert: document isDocument;
		assert: document configuration == node configuration;
		assert: document nodeFactory == node nodeFactory.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 23:09'!
testNewElement
	| node element |

	node := self nodeClass new.
	element := node newElement.
	self
		assert: element isElement;
		assert: element configuration == node configuration;
		assert: element nodeFactory == node nodeFactory.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 23:09'!
testNewElementNamed
	| node element |

	node := self nodeClass new.
	element := node newElementNamed: 'test'.
	self
		assert: element isElement;
		assert: element configuration == node configuration;
		assert: element nodeFactory == node nodeFactory;
		assert: element name = 'test'.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 23:29'!
testNewElementNamedNamespaceURI
	| node element |

	node := self nodeClass new.
	element := node newElementNamed: 'prefix:test' namespaceURI: 'prefixNS'.
	self
		assert: element isElement;
		assert: element configuration == node configuration;
		assert: element nodeFactory == node nodeFactory;
		assert: element name = 'prefix:test';
		assert: element namespaceURI = 'prefixNS'.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 23:11'!
testNewPI
	self assert: self nodeClass new newPI isPI! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 23:06'!
testNewString
	| string |

	string := self nodeClass new newString: 'test'.
	self
		assert: string isStringNode;
		assert: string string = 'test'.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/23/2014 00:44'!
testNodeFactory
	| nodeWithElements newFactory |

	nodeWithElements := self newNodeWithElements.
	newFactory := XMLPluggableNodeFactory new.
	self
		assert: (nodeWithElements nodeFactory isKindOf: XMLNodeFactory);
		assert: (nodeWithElements nodeFactory: newFactory) nodeFactory == newFactory.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 2/3/2015 00:49'!
testPrintedWithoutSelfClosingTags
	| nodeWithElements printString |

	nodeWithElements := self newNodeWithElements.
	printString := nodeWithElements printString.
	self deny: printString = nodeWithElements printedWithoutSelfClosingTags.

	nodeWithElements allElementsDo: [:each |
		each hasChildren
			ifFalse: [
				printString :=
					printString
						copyReplaceAll: '<', each name, ' />'
						with: '<', each name, '></', each name, '>']].
	self assert: printString = nodeWithElements printedWithoutSelfClosingTags.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 2/2/2015 16:35'!
testRawContentString
	self assert: self newNodeWithElements rawContentString = 'testing onetesting twotesting three'! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 05:24'!
testStringNodes
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self
		assertList: nodeWithElements stringNodes
		selects: (nodeWithElements nodes select: [:each | each isStringNode]).
	nodeWithElements allElementsDo: [:element |
		self
			assertList: element stringNodes
			selects: (element nodes select: [:each | each isStringNode])].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 05:23'!
testStringNodesDo
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self
		should: [:block | nodeWithElements stringNodesDo: block]
		enumerate: nodeWithElements stringNodes.
	nodeWithElements allElementsDo: [:each |
		self
			should: [:block | each stringNodesDo: block]
			enumerate: each stringNodes].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 05:26'!
testStrings
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self
		assertList: nodeWithElements strings
		collects: (nodeWithElements stringNodes collect: [:each | each string]).
	nodeWithElements allElementsDo: [:element |
		self
			assertList: element strings
			collects: (element stringNodes collect: [:each | each string]).].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 05:27'!
testStringsDo
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self
		should: [:block | nodeWithElements stringsDo: block]
		enumerate: nodeWithElements strings.
	nodeWithElements allElementsDo: [:each |
		self
			should: [:block | each stringsDo: block]
			enumerate: each strings].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 00:27'!
testUsesNamespaces
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self assert: nodeWithElements usesNamespaces.
	nodeWithElements allElementsDo: [:each |
		self assert: each usesNamespaces].

	nodeWithElements usesNamespaces: false.
	self deny: nodeWithElements usesNamespaces.
	nodeWithElements allElementsDo: [:each |
		self deny: each usesNamespaces.
		self
			shouldnt: [each prefix: 'undeclared']
			raise: XMLNamespaceException].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 4/6/2015 06:54'!
testValidate
	super testValidate.
	self
		shouldnt: [self newNodeWithNodes validate]
		raise: XMLValidationException.! !

XMLNodeTest subclass: #XMLPITest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLPITest methodsFor: 'accessing' stamp: 'monty 11/2/2014 11:18'!
nodeClass
	^ XMLPI! !

!XMLPITest methodsFor: 'tests' stamp: 'monty 12/6/2014 14:23'!
testCanonicallyEquals
	super testCanonicallyEquals.
	self assert:
		((self nodeClass target: 'one' data: 'two')
			canonicallyEquals: (self nodeClass target: 'one' data: 'two')).
	self deny: ((self nodeClass target: 'one' data: 'two') canonicallyEquals: self nodeClass new).! !

!XMLPITest methodsFor: 'tests' stamp: 'monty 11/22/2014 23:24'!
testData
	| pi |

	pi := self nodeClass new.
	self assert: pi data isEmpty.
	pi data: 'test'.
	self assert: pi data = 'test'.! !

!XMLPITest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:46'!
testIsPI
	self assert: self nodeClass new isPI! !

!XMLPITest methodsFor: 'tests' stamp: 'monty 12/3/2014 01:09'!
testSortKey
	self assert: (self nodeClass new target: 'test') sortKey = 'test'! !

!XMLPITest methodsFor: 'tests' stamp: 'monty 11/22/2014 23:24'!
testTarget
	| pi |

	pi := self nodeClass new.
	self assert: pi target isEmpty.
	pi target: 'test'.
	self assert: pi target = 'test'.! !

!XMLPITest methodsFor: 'tests' stamp: 'monty 11/22/2014 19:31'!
testTargetData
	| pi |

	pi := self nodeClass target: 'target' data: 'data'.
	self
		assert: pi target = 'target';
		assert: pi data = 'data'.! !

!XMLPITest methodsFor: 'tests' stamp: 'monty 11/24/2014 07:35'!
testWriteXMLOn
	self
		assert: (self nodeClass target: 'target' data: 'data') printString = '<?target data?>';
		assert: (self nodeClass target: 'target ' data: ' data') printString = '<?target   data?>'.! !

XMLNodeTest subclass: #XMLStringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

XMLStringTest subclass: #XMLCDataTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLCDataTest methodsFor: 'accessing' stamp: 'monty 11/2/2014 11:17'!
nodeClass
	^ XMLCData! !

!XMLCDataTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:44'!
testIsCData
	self assert: self nodeClass new isCData! !

!XMLCDataTest methodsFor: 'tests' stamp: 'monty 11/22/2014 19:37'!
testWriteXMLOn
	self
		assert: self nodeClass new printString = '<!![CDATA[]]>';
		assert: (self nodeClass string: self markupString) printString = ('<!![CDATA[', self markupString, ']]>').! !

!XMLStringTest methodsFor: 'accessing' stamp: 'monty 11/2/2014 11:18'!
nodeClass
	^ XMLString! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/4/2014 17:08'!
testAddContent
	| node |

	node := self nodeClass new.
	node addContent: 'one'.
	self assert: node string = 'one'.

	node addContent: (self nodeClass string: 'two').
	self assert: node string = 'onetwo'.

	node addContent: 'three'.
	self assert: node string = 'onetwothree'.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/4/2014 12:45'!
testAppend
	| node |

	node := self nodeClass new.
	node append: 'one'.
	self assert: node string = 'one'.

	node append: (self nodeClass string: 'two').
	self assert: node string = 'onetwo'.

	node append: 'three'.
	self assert: node string = 'onetwothree'.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/20/2014 00:46'!
testAsString
	self
		assert: self nodeClass new asString isEmpty;
		assert: (self nodeClass string: 'test') asString = 'test'! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/4/2014 14:56'!
testAsXMLEscapedString
	| node |

	node := self nodeClass string: self markupString.
	self	
		assert: node string = self markupString;
		deny: node string = self escapedString;
		assert: node asXMLEscapedString = self escapedString.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/4/2014 17:05'!
testAsXMLString
	| node |

	node := self nodeClass new.
	self assert: node asXMLString == node.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/24/2014 00:39'!
testBeginsWith
	| node |

	node := self nodeClass string: 'test'.
	0 to: node string size - 1 do: [:i | | prefix |
		prefix := node string allButLast: i.
		self
			assert: (node beginsWith: prefix);
			assert: (node beginsWith: (self nodeClass string: prefix));
			deny: (node beginsWith: (prefix copyWith: $.));
			deny: (node beginsWith: (self nodeClass string: (prefix copyWith: $.)))].! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 12/6/2014 14:23'!
testCanonicallyEquals
	super testCanonicallyEquals.
	self
		assert: ((self nodeClass string: 'test') canonicallyEquals: (self nodeClass string: 'test'));
		deny: ((self nodeClass string: 'test') canonicallyEquals: self nodeClass new).! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/20/2014 00:48'!
testContentString
	super testContentString.
	self
		assert: (self nodeClass string: 'test') contentString = 'test';
		assert: ((self nodeClass new) contentString: 'test') contentString = 'test'.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/4/2014 12:12'!
testDeleteFromTo
	| node |

	node := self nodeClass new.
	node deleteFrom: 1 to: 0.
	self assert: node string isEmpty.

	node append: 'onetwothree'.
	node deleteFrom: 0 to: -1.
	node deleteFrom: 12 to: 13.
	self assert: node string = 'onetwothree'.

	node deleteFrom: 4 to: 6.
	self assert: node string = 'onethree'.

	node deleteFrom: 4 to: 8.
	self assert: node string = 'one'.

	node deleteFrom: 1 to: 3.
	self assert: node string isEmpty.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/24/2014 00:41'!
testEndsWith
	| node |

	node := self nodeClass string: 'test'.
	0 to: node string size - 1 do: [:i | | suffix |
		suffix := node string allButFirst: i.
		self
			assert: (node endsWith: suffix);
			assert: (node endsWith: (self nodeClass string: suffix));
			deny: (node endsWith: (suffix copyWithFirst: $.));
			deny: (node endsWith: (self nodeClass string: (suffix copyWithFirst: $.)))].! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/6/2014 20:13'!
testIncludesSubstring
	| node |

	node := self nodeClass new.
	self
		deny: (node includesSubstring: 'one');
		deny: (node includesSubstring: (self nodeClass string: 'one')).
	node prepend: 'one'.
	self
		assert: (node includesSubstring: 'one');
		assert: (node includesSubstring: (self nodeClass string: 'one')).

	self
		deny: (node includesSubstring: 'three');
		deny: (node includesSubstring: (self nodeClass string: 'three')).
	node append: 'three'.
	self
		assert: (node includesSubstring: 'three');
		assert: (node includesSubstring: (self nodeClass string: 'three')).

	self
		deny: (node includesSubstring: 'onetwothree');
		deny: (node includesSubstring: (self nodeClass string: 'onetwothree')).
	node replaceFrom: 4 to: 3 with: 'two'.
	self
		assert: (node includesSubstring: 'onetwothree');
		assert: (node includesSubstring: (self nodeClass string: 'onetwothree')).! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/6/2014 20:15'!
testIndexOfSubstring
	| node |

	node := self nodeClass new.
	self
		assert: (node indexOfSubstring: 'one') isZero;
		assert: (node indexOfSubstring: (self nodeClass string: 'one')) isZero.
	node prepend: 'one'.
	self
		assert: (node indexOfSubstring: 'one') = 1;
		assert: (node indexOfSubstring: (self nodeClass string: 'one')) = 1.

	self
		assert: (node indexOfSubstring: 'two') isZero;
		assert: (node indexOfSubstring: (self nodeClass string: 'two')) isZero.
	node append: 'two'.
	self
		assert: (node indexOfSubstring: 'two') = 4;
		assert: (node indexOfSubstring: (self nodeClass string: 'two')) = 4.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:46'!
testIsContentNode
	self assert: self nodeClass new isContentNode! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/4/2014 12:23'!
testIsEmpty
	self
		assert: self nodeClass new isEmpty;
		deny: (self nodeClass string: ' ') isEmpty! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/6/2014 02:20'!
testIsString
	| node |

	node := self nodeClass new.
	self
		assert: (node isString: '');
		assert: (node isString: self nodeClass new);
		deny: (node isString: 'test');
		deny: (node isString: (self nodeClass string: 'test')).
	node string: 'test'.
	self
		assert: (node isString: 'test');
		assert: (node isString: (self nodeClass string: 'test'));
		deny: (node isString: '');
		deny: (node isString: self nodeClass new).! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/20/2014 02:48'!
testIsStringNode
	| node |

	self assert: self nodeClass new isStringNode.

	node := self nodeClass new.
	self
		assert: (node isStringNode: '');
		assert: (node isStringNode: self nodeClass new);
		deny: (node isStringNode: 'test');
		deny: (node isStringNode: (self nodeClass string: 'test')).
	node string: 'test'.
	self
		assert: (node isStringNode: 'test');
		assert: (node isStringNode: (self nodeClass string: 'test'));
		deny: (node isStringNode: '');
		deny: (node isStringNode: self nodeClass new).! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 4/7/2015 09:29'!
testIsWhitespace
	| node |

	node := self nodeClass new.
	self deny: node isWhitespace.

	node string: Character xmlParserWhitespace.
	self assert: node isWhitespace.

	node append: 'non-space'.
	self deny: node isWhitespace.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/4/2014 20:59'!
testMergeAdjacent
	| element nodes |

	(element := XMLElement new)
		addNode: (self nodeClass string: 'one');
		addNode: (self nodeClass string: 'two');
		addNode: (self nodeClass string: 'three');
		addNode: XMLComment new;
		addNode: (self nodeClass string: 'four');
		addNode: (self nodeClass string: 'five');
		addNode: XMLComment new;
		addNode: (self nodeClass string: 'six').

	element nodes second mergeAdjacent.
	nodes := element nodes.
	self
		assert: nodes size = 6;
		assert: (nodes first isStringNode and: [nodes first string = 'onetwothree']);
		assert: nodes second isComment;
		assert: (nodes third isStringNode and: [nodes third string = 'four']);
		assert: (nodes fourth isStringNode and: [nodes fourth string = 'five']);
		assert: nodes fifth isComment;
		assert: (nodes sixth isStringNode and: [nodes sixth string = 'six']).

	nodes fourth mergeAdjacent.
	nodes fifth mergeAdjacent.
	self
		assert: nodes size = 5;
		assert: (nodes first isStringNode and: [nodes first string = 'onetwothree']);
		assert: nodes second isComment;
		assert: (nodes third isStringNode and: [nodes third string = 'fourfive']);
		assert: nodes fourth isComment;
		assert: (nodes fifth isStringNode and: [nodes fifth string = 'six']).! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/4/2014 12:46'!
testPrepend
	| node |

	node := self nodeClass new.
	node prepend: 'three'.
	self assert: node string = 'three'.

	node prepend: (self nodeClass string: 'two').
	self assert: node string = 'twothree'.

	node prepend: 'one'.
	self assert: node string = 'onetwothree'.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/4/2014 12:46'!
testReplaceAllWith
	| node |

	(node := self nodeClass new) replaceAll: 'old' with: 'new'.
	self assert: node string isEmpty.

	node string: 'one old two old three old'.
	node replaceAll: 'old' with: (self nodeClass string: 'new').
	self assert: node string = 'one new two new three new'.

	node replaceAll: 'new' with: ''.
	self assert: node string = 'one  two  three '.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 1/16/2015 08:46'!
testReplaceFromToWith
	| node |

	(node := self nodeClass new) replaceFrom: -1 to: -3 with: 'one'.
	self assert: node string = 'one'.

	node replaceFrom: 1 to: 0 with: 'zero'.
	self assert: node string = 'zeroone'.

	node replaceFrom: 9 to: 7 with: (self nodeClass string: 'fourthree').
	self assert: node string = 'zeroonefourthree'.

	node replaceFrom: 8 to: 11 with: ' two '.
	self assert: node string = 'zeroone two three'.

	node replaceFrom: 0 to: 4 with: ''.
	self assert: node string = 'one two three'.

	node replaceFrom: 14 to: 13 with: (self nodeClass string: ' four').
	self assert: node string = 'one two three four'.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/4/2014 00:44'!
testSize
	self
		assert: self nodeClass new size = 0;
		assert: (self nodeClass string: 'test') size = 4! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 12/2/2014 22:59'!
testSortKey
	self assert: (self nodeClass string: 'test') sortKey = 'test'! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/4/2014 17:16'!
testSplitAt
	| node newNode element |

	node := self nodeClass string: 'onetwo'.
	newNode := node splitAt: 0.
	self
		deny: node == newNode;
		assert: node string isEmpty;
		assert: newNode string = 'onetwo'.

	node := self nodeClass string: 'onetwo'.
	newNode := node splitAt: 7.
	self
		deny: node == newNode;
		assert: node string = 'onetwo';
		assert: newNode string isEmpty.

	(element := XMLElement new) addNode: node.
	newNode := node splitAt: 4.
	self
		deny: node == newNode;
		assert: node string = 'one';
		assert: newNode string = 'two';
		assert: (element nodeAfter: node) == newNode.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/4/2014 17:13'!
testString
	| node |

	node := self nodeClass new.
	self assert: node string isEmpty.

	node string: self markupString.
	self assert: node string = self markupString.

	node string: ''.
	self assert: node string isEmpty.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/22/2014 19:29'!
testWriteXMLOn
	self
		assert: self nodeClass new printString isEmpty;
		assert: (self nodeClass string: self markupString) printString = self escapedString.! !

TestCase subclass: #XMLOrderedListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

XMLOrderedListTest subclass: #XMLObservableListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

XMLObservableListTest subclass: #XMLAttributeListTest
	instanceVariableNames: 'attributes newAttribute absentAttribute changedAttributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 11:09'!
absentElement
	^ absentAttribute
		ifNil: [absentAttribute := XMLAttribute name: 'absentName' value: 'absentValue']! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 11:06'!
afterAddingToNotifications
	^ #(addedAttribute:)! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 11:06'!
afterRemovingFromNotifications
	^ #(removedAttribute:)! !

!XMLAttributeListTest methodsFor: 'testing' stamp: 'monty 1/18/2015 11:26'!
allowsDuplicates
	^ false! !

!XMLAttributeListTest methodsFor: 'assertions' stamp: 'monty 1/17/2015 14:57'!
assertList: aList copiedFrom: aSecondList equals: aThirdList
	super
		assertList: aList
		copiedFrom: aSecondList
		equals: aThirdList.
	self
		assert: aList attributesByName size = aList size;
		assert: aList attributesByName = aThirdList attributesByName;
		deny: aList attributesByName == aSecondList attributesByName.! !

!XMLAttributeListTest methodsFor: 'assertions' stamp: 'monty 1/17/2015 14:57'!
assertList: aList isCopyOf: aSecondList
	super assertList: aList isCopyOf: aSecondList.
	self
		assert: aList attributesByName size = aList size;
		assert: aList attributesByName = aSecondList attributesByName;
		deny: aList attributesByName == aSecondList attributesByName.! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 11:06'!
beforeAddingToNotifications
	^ #(addingAttribute:)! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 11:24'!
changeElement: anAttribute
	^ (changedAttributes ifNil: [changedAttributes := IdentityDictionary new])
		at: anAttribute
		ifAbsentPut: [
			XMLAttribute
				name: 'new', anAttribute name
				value: 'new', anAttribute value]! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 11:07'!
listClass
	^ XMLAttributeList! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 1/18/2015 18:09'!
listElements
	attributes ifNil: [
		attributes :=
			super listElements collect: [:each |
				XMLAttribute name: each value: each]].
	^ attributes copy.! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 11:10'!
newElement
	^ newAttribute
		ifNil: [newAttribute := XMLAttribute name: 'newName' value: 'newValue']! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 11:12'!
observerClass
	^ XMLRecordingAttributeListObserver! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 11:25'!
reverseSortBlock
	^ [:a :b | a sortKey > b sortKey]! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 11:25'!
sortBlock
	^ [:a :b | a sortKey <= b sortKey]! !

XMLObservableListTest subclass: #XMLNodeListTest
	instanceVariableNames: 'nodes newNode absentNode changedNodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

XMLNodeListTest subclass: #XMLCachingNodeListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLCachingNodeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 11:48'!
listClass
	^ XMLCachingNodeList! !

!XMLCachingNodeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 11:50'!
listCopyClass
	^ XMLNodeList! !

!XMLCachingNodeListTest methodsFor: 'tests' stamp: 'monty 2/8/2015 23:08'!
testSort
	| list cachedElements |

	super testSort.

	list := self listWithElements.
	cachedElements := list elements.
	list sort: self reverseSortBlock.
	self assert: list elements = (cachedElements sort: self reverseSortBlock).! !

!XMLCachingNodeListTest methodsFor: 'tests' stamp: 'monty 2/2/2015 00:01'!
testSwapWith
	| list cachedElements start end |

	super testSwapWith.

	list := self listWithElements.
	cachedElements := list elements.
	start := 1.
	end := list size.
	[start < end]
		 whileTrue: [
			list swap: start with: end.
			start := start + 1.
			end := end - 1].
	self assert: list elements = cachedElements reversed.! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 10:26'!
absentElement
	^ absentNode ifNil: [absentNode := 'absentElement' asXMLString]! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 09:52'!
afterAddingToNotifications
	^ #(addedNode: addedElement:)! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 09:53'!
afterRemovingFromNotifications
	^ #(removedNode: removedElement:)! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 09:54'!
beforeAddingToNotifications
	^ #(addingNode:)! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 10:28'!
changeElement: anElement
	^ (changedNodes ifNil: [changedNodes := IdentityDictionary new])
		at: anElement
		ifAbsentPut: [anElement copy]! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 09:54'!
listClass
	^ XMLNodeList! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 10:03'!
listElements
	nodes ifNil: [
		nodes := OrderedCollection new.
		super listElements withIndexDo: [:each :i |
			i even
				ifTrue: [nodes addLast: (XMLElement named: each)]
				ifFalse: [nodes addLast: each asXMLString]].
		nodes := nodes asArray].
	^ nodes copy.! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 10:08'!
newElement
	^ newNode ifNil: [newNode := 'newElement' asXMLString]! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 09:53'!
observerClass
	^ XMLRecordingNodeListObserver! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 10:35'!
reverseSortBlock
	^ [:a :b | a sortKey > b sortKey]! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 10:35'!
sortBlock
	^ [:a :b | a sortKey <= b sortKey]! !

!XMLObservableListTest class methodsFor: 'testing' stamp: 'JAA 3/26/2011 19:00'!
shouldInheritSelectors
	^ true! !

!XMLObservableListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 09:45'!
afterAddingToNotifications
	^ #(added:to:)! !

!XMLObservableListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 09:45'!
afterRemovingFromNotifications
	^ #(removed:from:)! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 1/17/2015 11:20'!
assertList: aList copiedFrom: aSecondList equals: aThirdList
	super
		assertList: aList
		copiedFrom: aSecondList
		equals: aThirdList.
	self denyList: aList sharesObserverWith: aSecondList.! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 1/17/2015 11:20'!
assertList: aList isCopyOf: aSecondList
	super assertList: aList isCopyOf: aSecondList.
	self denyList: aList sharesObserverWith: aSecondList.! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 1/21/2015 11:58'!
assertList: aList receivedNotificationOfAdding: anElement
	self
		assertList: aList
		receivedNotificationOfBeforeAdding: anElement;
		assertList: aList
		receivedNotificationOfAfterAdding: anElement! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 1/21/2015 11:57'!
assertList: aList receivedNotificationOfAfterAdding: anElement
	self
		assertNotification: aList observer nextNotification
		forElement: anElement
		andList: aList
		hasType: self afterAddingToNotifications! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 1/21/2015 11:57'!
assertList: aList receivedNotificationOfBeforeAdding: anElement
	self
		assertNotification: aList observer nextNotification
		forElement: anElement
		andList: aList
		hasType: self beforeAddingToNotifications! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 1/18/2015 08:19'!
assertList: aList receivedNotificationOfRemoving: anElement
	self
		assertNotification: aList observer nextNotification
		forElement: anElement
		andList: aList
		hasType: self afterRemovingFromNotifications! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 1/21/2015 12:02'!
assertList: aList receivedNotificationOfReplacing: anOldElement with: aNewElement
	self
		assertList: aList
		receivedNotificationOfBeforeAdding: aNewElement.
	self
		assertList: aList
		receivedNotificationOfRemoving: anOldElement.
	self
		assertList: aList
		receivedNotificationOfAfterAdding: aNewElement.! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 1/18/2015 18:40'!
assertNotification: aNotification forElement: anElement andList: aList hasType: aSelectorColleciton
	self assert: (aSelectorColleciton includes: aNotification selector).
	self assert:
		aNotification arguments =
			((Array with: anElement with: aList)
				copyFrom: 1
				to: (aNotification selector asString occurrencesOf: $:)).! !

!XMLObservableListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 09:42'!
beforeAddingToNotifications
	^ #(adding:to:)! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 1/17/2015 11:19'!
denyList: aList sharesObserverWith: aSecondList
	self deny:
		(aList observer notNil
			and: [aSecondList observer notNil
				and: [aList observer == aSecondList observer]])! !

!XMLObservableListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 10:41'!
emptyList
	| list |

	list := super emptyList.
	self observerOnList: list.
	^ list.! !

!XMLObservableListTest methodsFor: 'accessing' stamp: 'JAA 3/26/2011 19:01'!
listClass
	^ XMLObservableList! !

!XMLObservableListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 10:41'!
listWithElements
	| list |

	list := super listWithElements.
	self observerOnList: list.
	^ list.! !

!XMLObservableListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 10:42'!
listWithSingleElement
	| list |

	list := super listWithSingleElement.
	self observerOnList: list.
	^ list.! !

!XMLObservableListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 09:52'!
observerClass
	^ XMLRecordingListObserver! !

!XMLObservableListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 09:53'!
observerOnList: aList
	| observer |

	observer := self observerClass new.
	aList observer: observer.
	^ observer.! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 1/18/2015 07:23'!
should: aBlock add: anElement toAndNotify: aList
	self
		should: aBlock
		addAll: (Array with: anElement)
		toAndNotify: aList! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 1/18/2015 15:50'!
should: aBlock addAll: anElementCollection toAndNotify: aList
	aList observer clearNotifications.
	aBlock value.
	anElementCollection do: [:each |
		self assert: (aList includes: each).
		self 
			assertList: aList
			receivedNotificationOfAdding: each].! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 1/18/2015 07:23'!
should: aBlock remove: anElement fromAndNotify: aList
	self
		should: aBlock
		removeAll: (Array with: anElement)
		fromAndNotify: aList! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 1/18/2015 15:50'!
should: aBlock removeAll: anElementCollection fromAndNotify: aList
	aList observer clearNotifications.
	aBlock value.
	anElementCollection do: [:each |
		self deny: (aList includes: each).
		self
			assertList: aList
			receivedNotificationOfRemoving: each].! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 07:38'!
testAdd
	| list |

	super testAdd.

	list := self emptyList.
	self listElements do: [:each |
		self
			should: [list add: each]
			add: each
			toAndNotify: list].! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 07:38'!
testAddAfter
	| list |

	super testAddAfter.

	list := self listWithSingleElement.
	self listElements allButFirst reverseDo: [:each |
		self
			should: [list add: each after: self singleElement]
			add: each
			toAndNotify: list].! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 07:38'!
testAddAfterIndex
	| list |

	super testAddAfterIndex.

	list := self listWithSingleElement.
	self listElements allButFirst reverseDo: [:each |
		self
			should: [list add: each afterIndex: 1]
			add: each
			toAndNotify: list].! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 07:38'!
testAddAll
	| list |

	super testAddAll.

	list := self emptyList.
	self
		should: [list addAll: self listElements]
		addAll: self listElements
		toAndNotify: list.
	self
		should: [list addAll: self changedListElements]
		addAll: self changedListElements
		toAndNotify: list.! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 07:38'!
testAddAllFirst
	| list |

	super testAddAllFirst.

	list := self emptyList.
	self
		should: [list addAllFirst: self listElements]
		addAll: self listElements reversed
		toAndNotify: list.
	self
		should: [list addAllFirst: self changedListElements]
		addAll: self changedListElements reversed
		toAndNotify: list.! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 07:38'!
testAddAllLast
	| list |

	super testAddAllLast.

	list := self emptyList.
	self
		should: [list addAllLast: self listElements]
		addAll: self listElements
		toAndNotify: list.
	self
		should: [list addAllLast: self changedListElements]
		addAll: self changedListElements
		toAndNotify: list.! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 07:38'!
testAddBefore
	| list last |

	super testAddBefore.

	last := self listElements last.
	(list := self emptyList) add: last.
	"allButLastDo: is not portable"
	self listElements allButLast do: [:each |
		self
			should: [list add: each before: last]
			add: each
			toAndNotify: list].! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 07:42'!
testAddBeforeIndex
	| list |

	super testAddBeforeIndex.

	(list := self emptyList) add: self listElements last.
	self listElements allButLast withIndexDo: [:each :i |
		self
			should: [list add: each beforeIndex: i]
			add: each
			toAndNotify: list].! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 07:44'!
testAddFirst
	| list |

	super testAddFirst.

	list := self emptyList.
	self listElements reverseDo: [:each |
		self
			should: [list addFirst: each]
			add: each
			toAndNotify: list].! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 07:45'!
testAddLast
	| list |

	super testAddLast.

	list := self emptyList.
	self listElements do: [:each |
		self
			should: [list addLast: each]
			add: each
			toAndNotify: list].! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 1/21/2015 12:01'!
testAtPut
	| list |

	super testAtPut.

	list := self listWithElements.
	1 to: list size do: [:i | | old new |
		old := list at: i.
		new := self changedListElements at: i.
		list at: i put: new.
		self
			assertList: list
			receivedNotificationOfReplacing: old
			with: new].
	self
		should: [list at: list size + 2 put: self newElement]
		raise: Error.
	self
		assertList: list
		receivedNotificationOfBeforeAdding: self newElement.
	self deny: list observer hasNotifications.! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 1/17/2015 11:52'!
testOfSize
	self
		should: [self listClass ofSize: 10]
		raise: Error! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 07:37'!
testRemoveAll
	| list |

	super testRemoveAll.

	list := self listWithElements.
	self
		should: [list removeAll]
		removeAll: self listElements reversed
		fromAndNotify: list.! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 08:00'!
testRemoveAt
	super testRemoveAt.

	self listElements withIndexDo: [:each :i | | list |
		list := self listWithElements.
		self
			should: [list removeAt: i]
			remove: each
			fromAndNotify: list.
		self
			should: [list removeAt: 0] raise: Error;
			should: [list removeAt: list size + 1] raise: Error;
			deny: list observer hasNotifications].! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 07:52'!
testRemoveFirst
	| list |

	super testRemoveFirst.

	list := self listWithElements.
	self listElements do: [:each |
		self
			should: [list removeFirst]
			remove: each
			fromAndNotify: list].
	self
		should: [list removeFirst] raise: Error;
		deny: list observer hasNotifications.! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 08:07'!
testRemoveFirstFew
	| list |

	super testRemoveFirstFew.

	1 to: self listElements size do: [:i |
		list := self listWithElements.
		self
			should: [list removeFirst: i]
			removeAll: (self listElementsFirst: i)
			fromAndNotify: list].
	list := self emptyList.
	self
		should: [list removeFirst: list size + 1] raise: Error;
		deny: list observer hasNotifications.! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 08:09'!
testRemoveIfAbsent
	| list |

	super testRemoveIfAbsent.

	list := self listWithElements.
	self
		should: [list remove: self singleElement ifAbsent: [nil]]
		remove: self singleElement
		fromAndNotify: list.
	self
		assert: (list remove: self singleElement ifAbsent: [nil]) isNil;
		deny: list observer hasNotifications.! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 08:08'!
testRemoveLast
	| list |

	super testRemoveLast.

	list := self listWithElements.
	self listElements reverseDo: [:each |
		self
			should: [list removeLast]
			remove: each
			fromAndNotify: list].
	self
		should: [list removeFirst] raise: Error;
		deny: list observer hasNotifications.! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 08:08'!
testRemoveLastFew
	| list |
	
	super testRemoveLastFew.

	1 to: self listElements size do: [:i |
		list := self listWithElements.
		self
			should: [list removeLast: i]
			removeAll: (self listElementsLast: i) reversed
			fromAndNotify: list].
	list := self emptyList.
	self
		should: [list removeFirst: list size + 1] raise: Error;
		deny: list observer hasNotifications.! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 1/21/2015 12:00'!
testReplaceFromToWith
	super testReplaceFromToWith.

	1 to: self listElements size do: [:start |
		start to: self listElements size do: [:stop | | list old new |
			list := self listWithElements.
			old := self listElements copyFrom: start to: stop.
			new := self changedListElements copyFrom: 1 to: stop - start + 1.
			list
				replaceFrom: start
				to: stop
				with: self changedListElements.
			old with: new do: [:oldElement :newElement |
				self
					assertList: list
					receivedNotificationOfReplacing: oldElement
					with: newElement].
			self deny: list observer hasNotifications]].! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 1/21/2015 12:03'!
testReplaceFromToWithStartingAt
	super testReplaceFromToWithStartingAt.

	1 to: self listElements size do: [:start |
		start to: self listElements size do: [:stop | | list old new |
			list := self listWithElements.
			old := self listElements copyFrom: start to: stop.
			new := self changedListElements copyFrom: start to: stop.
			list
				replaceFrom: start
				to: stop
				with: self changedListElements
				startingAt: start.
			old with: new do: [:oldElement :newElement |
				self
					assertList: list
					receivedNotificationOfReplacing: oldElement
					with: newElement].
			self deny: list observer hasNotifications]].! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 07:23'!
testReset
	| list |

	super testReset.
	list := self listWithElements.
	self
		should: [list reset]
		removeAll: self listElements
		fromAndNotify: list.! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'JAA 3/24/2011 20:15'!
absentElement
	^ 'absent'! !

!XMLOrderedListTest methodsFor: 'testing' stamp: 'monty 1/18/2015 11:26'!
allowsDuplicates
	^ true! !

!XMLOrderedListTest methodsFor: 'assertions' stamp: 'monty 10/28/2014 19:09'!
assertList: aList collectedFrom: aSecondList equals: aThirdList
	self
		assert: aList = aThirdList;
		assert: aList class = aSecondList species;
		deny: aList == aSecondList;
		deny: aList collection == aSecondList collection! !

!XMLOrderedListTest methodsFor: 'assertions' stamp: 'monty 4/12/2015 11:29'!
assertList: aList copiedFrom: aSecondList equals: aThirdList
	self
		assert: aList = aThirdList;
		assert: aList class == self listCopyClass;
		assert: aList collection class == aSecondList collection class;
		deny: aList == aSecondList;
		deny: aList collection == aSecondList collection! !

!XMLOrderedListTest methodsFor: 'assertions' stamp: 'monty 4/11/2015 07:39'!
assertList: aFirstList equals: aSecondList
	self
		assert: aFirstList = aFirstList;
		assert: aSecondList = aSecondList;
		assert: aFirstList = aSecondList;
		assert: aSecondList = aFirstList! !

!XMLOrderedListTest methodsFor: 'assertions' stamp: 'monty 4/12/2015 11:29'!
assertList: aList isCopyOf: aSecondList
	self
		assert: aList = aSecondList;
		assert: aList class == self listCopyClass;
		assert: aList collection class == aSecondList collection class;
		assert: aList collection = aSecondList collection;
		deny: aList == aSecondList;
		deny: aList collection == aSecondList collection! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 09:25'!
changeElement: anObject
	^ anObject asUppercase! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 09:26'!
changedListElements
	^ self listElements collect: [:each | self changeElement: each]! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 09:31'!
changedSingleElement
	^ self changeElement: self singleElement! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'JAA 3/24/2011 20:46'!
defaultValue
	^ nil! !

!XMLOrderedListTest methodsFor: 'assertions' stamp: 'monty 4/11/2015 07:39'!
denyList: aFirstList equals: aSecondList
	self
		deny: aFirstList = aSecondList;
		deny: aSecondList = aFirstList! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'JAA 3/24/2011 20:19'!
emptyList
	^ self listClass new! !

!XMLOrderedListTest methodsFor: 'testing' stamp: 'monty 12/14/2014 13:59'!
hasCapacity
	"for portability"
	^ self listClass collectionClass includesSelector: #capacity! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'JAA 3/24/2011 20:15'!
listClass
	^ XMLOrderedList! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 11:47'!
listCopyClass
	^ self listClass! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 10/23/2014 08:14'!
listElements
	^ #('one' 'two' 'three' 'four' 'five' 'six' 'seven' 'eight' 'nine') copy! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 1/16/2015 08:49'!
listElementsFirst: anInteger
	"first: is not portable"
	^ self listElements
		copyFrom: 1
		to: ((anInteger max: 0) min: self listElements size)! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 08:54'!
listElementsLast: anInteger
	"last: is not portable"
	anInteger > 0
		ifFalse: [^ #()].
	^ self listElements
		copyFrom: (((self listElements size - anInteger) + 1) max: 1)
		to: self listElements size.! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'JAA 3/26/2011 18:15'!
listSpecies
	^ XMLOrderedList! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'JAA 3/24/2011 20:24'!
listWithElements
	^ self listClass new
		addAll: self listElements;
		yourself! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'JAA 3/24/2011 20:26'!
listWithSingleElement
	^ self listClass new
		add: self singleElement;
		yourself! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 10/22/2014 17:01'!
newElement
	^ 'newElement'! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 10:34'!
reverseSortBlock
	^ [:a :b | a > b]! !

!XMLOrderedListTest methodsFor: 'assertions' stamp: 'JAA 3/26/2011 17:37'!
should: aBlock enumerate: aCollection
	| enumerated |

	enumerated := OrderedCollection new.
	aBlock value: [:each | enumerated add: each].
	self assert: enumerated = aCollection asOrderedCollection.! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'JAA 3/24/2011 20:15'!
singleElement
	^ self listElements first! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 10:34'!
sortBlock
	^ [:a :b | a <= b]! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 19:19'!
testAdd
	| list |

	list := self emptyList.
	self
		deny: list = self listWithElements;
		assert: (self listElements allSatisfy: [:each | (list add: each) == each]);
		assert: (list = self listWithElements).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 19:26'!
testAddAfter
	| list |

	list := self listWithSingleElement.
	self
		assert:
			(self listElements allButFirst reversed
				allSatisfy: [:each | (list add: each after: self singleElement) = each]);
		assert: list = self listWithElements;
		should: [list add: self newElement after: self absentElement] raise: Error.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 19:27'!
testAddAfterIndex
	| list |

	list := self listWithSingleElement.
	self
		assert:
			(self listElements allButFirst reversed
				allSatisfy: [:each | (list add: each afterIndex: 1) = each]);
		assert: list = self listWithElements;
		should: [list add: self newElement afterIndex: self listElements size + 1] raise: Error;
		should: [list add: self newElement afterIndex: -1] raise: Error.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/17/2015 09:35'!
testAddAll
	| list |

	list := self emptyList.
	self
		deny: list = self listWithElements;
		assert: (list addAll: self listElements) = self listElements;
		assert: list = self listWithElements;
		assert: (list addAll: self changedListElements) = self changedListElements;
		assert: list = (self listClass newFrom: (self listElements, self changedListElements)).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/17/2015 09:35'!
testAddAllFirst
	| list |

	list := self emptyList.
	self
		assert: (list addAllFirst: self listElements) = self listElements;
		assert: list = self listWithElements;
		assert: (list addAllFirst: self changedListElements) = self changedListElements;
		assert: list = (self listClass newFrom: self changedListElements, self listElements).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/17/2015 09:35'!
testAddAllLast
	| list |

	list := self emptyList.
	self
		assert: (list addAllLast: self listElements) = self listElements;
		assert: list = self listWithElements;
		assert: (list addAllLast: self changedListElements) = self changedListElements;
		assert: list = (self listClass newFrom: self listElements, self changedListElements).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 07:36'!
testAddBefore
	| list last |

	last := self listElements last.
	(list := self emptyList) add: last.
	self
		assert:
			(self listElements allButLast
				allSatisfy: [:each | (list add: each before: last) = each]);
		assert: list = self listWithElements;
		should: [list add: self newElement before: self absentElement] raise: Error.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 07:42'!
testAddBeforeIndex
	| list |

	(list := self emptyList) add: self listElements last.
	self listElements allButLast withIndexDo: [:each :i |
		self assert: (list add: each beforeIndex: i) = each].
	self
		assert: list = self listWithElements;
		should: [list add: self newElement beforeIndex: self listElements size + 2] raise: Error;
		should: [list add: self newElement beforeIndex: 0] raise: Error.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 17:17'!
testAddFirst
	| list |

	list := self emptyList.
	self
		assert: (self listElements reversed allSatisfy: [:each | (list addFirst: each) = each]);
		assert: list = self listWithElements.

	self assert: (self listElements allSatisfy: [:each | (list addFirst: each) = each]).
	self assert:
		list =
			(self listClass newFrom: 
				(self allowsDuplicates
					ifTrue: [self listElements reversed, self listElements]
					ifFalse: [self listElements reversed])).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 17:17'!
testAddLast
	| list |

	list := self emptyList.
	self
		assert: (self listElements allSatisfy: [:each | (list addLast: each) = each]);
		assert: list = self listWithElements.

	self assert: (self listElements allSatisfy: [:each | (list addLast: each) = each]).
	self assert:
		list =
			(self listClass newFrom: 
				(self allowsDuplicates
					ifTrue: [self listElements, self listElements]
					ifFalse: [self listElements])).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 07:01'!
testAfter
	| list |

	list := self listWithElements.
	self assert:
		(self listElements allSatisfy: [:each |
			(list after: each) = (self listElements after: each ifAbsent: [self defaultValue])]).
	self assert: (list after: self absentElement) = self defaultValue.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 07:02'!
testAfterIfAbsent
	| list |

	list := self listWithElements.
	self assert:
		(self listElements allSatisfy: [:each |
			(list after: each ifAbsent: [self newElement]) =
				(self listElements after: each ifAbsent: [self newElement])]).
	self assert: (list after: self absentElement ifAbsent: [self newElement]) = self newElement.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 18:07'!
testAllButFirst
	| list |

	self assert: self emptyList allButFirst = self emptyList.

	list := self listWithElements.
	self
		assertList: list allButFirst
		copiedFrom: list
		equals: (self listClass newFrom: self listElements allButFirst).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 05:19'!
testAllButFirstDo
	self
		should: [:block | self emptyList allButFirstDo: block]
		enumerate: #().
	self
		should: [:block | self listWithElements allButFirstDo: block]
		enumerate: self listElements allButFirst.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 18:06'!
testAllButFirstFew
	| list |

	list := self listWithElements.
	1 to: list size do: [:i |
		self
			assertList: (list allButFirst: i)
			copiedFrom: list
			equals: (self listClass newFrom: (self listElements allButFirst: i)).
		self
			assertList: (list allButFirst: i + list size)
			copiedFrom: list
			equals: self emptyList.
		self
			assertList: (list allButFirst: i * -1)
			copiedFrom: list
			equals: list.
		self assert: (self emptyList allButFirst: i) = self emptyList].
	self
		assertList: (list allButFirst: 0)
		copiedFrom: list
		equals: list.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 18:08'!
testAllButLast
	| list |

	self assert: self emptyList allButLast = self emptyList.

	list := self listWithElements.
	self
		assertList: list allButLast
		copiedFrom: list
		equals: (self listClass newFrom: self listElements allButLast).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 05:19'!
testAllButLastDo
	self
		should: [:block | self emptyList allButLastDo: block]
		enumerate: #().
	self
		should: [:block | self listWithElements allButLastDo: block]
		enumerate: self listElements allButLast.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 18:08'!
testAllButLastFew
	| list |

	list := self listWithElements.
	1 to: list size do: [:i |
		self
			assertList: (list allButLast: i)
			copiedFrom: list
			equals: (self listClass newFrom: (self listElements allButLast: i)).
		self
			assertList: (list allButLast: i + list size)
			copiedFrom: list
			equals: self emptyList.
		self
			assertList: (list allButLast: i * -1)
			copiedFrom: list
			equals: list.
		self assert: (self emptyList allButLast: i) = self emptyList].
	self
		assertList: (list allButLast: 0)
		copiedFrom: list
		equals: list.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 04:52'!
testAnyOne
	self
		assert: self emptyList anyOne = self defaultValue;
		assert: self listWithElements anyOne = self listElements first.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'JAA 3/24/2011 20:48'!
testAsArray
	self
		assert: self emptyList asArray = #();
		assert: self listWithElements asArray = self listElements asArray! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 16:38'!
testAsOrderedCollection
	| list |

	list := self listWithElements.
	self
		assert: self emptyList asOrderedCollection = OrderedCollection new;
		assert: list asOrderedCollection = self listElements asOrderedCollection;
		deny: list asOrderedCollection == list collection.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'JAA 3/25/2011 00:47'!
testAt
	| list |

	list := self listWithElements.
	self
		assert: ((1 to: list size) allSatisfy: [:i | (list at: i) = (self listElements at: i)]);
		assert: (list at: 0) = self defaultValue;
		assert: (list at: list size + 1) = self defaultValue.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 19:32'!
testAtIfAbsent
	| list |

	list := self listWithElements.
	self
		assert: ((1 to: list size) allSatisfy: [:i | (list at: i ifAbsent: [self newElement]) = (self listElements at: i)]);
		assert: (list at: 0 ifAbsent: [self newElement]) = self newElement;
		assert: (list at: list size + 1 ifAbsent: [self newElement]) = self newElement.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 06:56'!
testAtLast
	| list |

	list := self listWithElements.
	1 to: list size do: [:i | self assert: (list atLast: i) = (self listElements atLast: i)].
	self
		assert: (list atLast: 0) = self defaultValue;
		assert: (list atLast: list size + 1) = self defaultValue.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 06:57'!
testAtLastIfAbsent
	| list |

	list := self listWithElements.
	1 to: list size do: [:i |
		self assert: (list atLast: i ifAbsent: [self newElement]) = (self listElements atLast: i)].
	self
		assert: (list atLast: 0 ifAbsent: [self newElement]) = self newElement;
		assert: (list atLast: list size + 1 ifAbsent: [self newElement]) = self newElement.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/21/2015 14:30'!
testAtPut
	| list |

	list := self listWithElements.
	1 to: list size do: [:i | | replacement |
		replacement := list at: i.
		self
			assert: (list at: i put: replacement) == replacement;
			assert: (list at: i) == replacement].
	self assert: list = self listWithElements.

	self assert: (list at: list size + 1 put: self newElement) = self newElement.
	self assert:
		list =
			(self listClass newFrom: (self listElements copyWith: self newElement)).

	list := self listWithElements.
	1 to: list size do: [:i | | replacement |
		replacement := self changedListElements at: i.
		self
			assert: (list at: i put: replacement) == replacement;
			assert: (list at: i) == replacement].
	self assert: list = (self listClass newFrom: self changedListElements).

	list := self listWithElements.
	self listElements do: [:each |
		self assert: (list at: list size + 1 put: each) == each].
	self assert:
		list =
			(self allowsDuplicates
				ifTrue: [self listClass newFrom: self listElements, self listElements]
				ifFalse: [self listWithElements]).
	self
		should: [list at: 0 put: self newElement]
		raise: Error.
	self
		should: [list at: list size + 2 put: self newElement]
		raise: Error.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 07:03'!
testBefore
	| list |

	list := self listWithElements.
	self assert:
		(self listElements allSatisfy: [:each |
			(list before: each) = (self listElements before: each ifAbsent: [self defaultValue])]).
	self assert: (list before: self absentElement) = self defaultValue.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 07:03'!
testBeforeIfAbsent
	| list |

	list := self listWithElements.
	self assert:
		(self listElements allSatisfy: [:each |
			(list before: each ifAbsent: [self newElement]) =
				(self listElements before: each ifAbsent: [self newElement])]).
	self assert: (list before: self absentElement ifAbsent: [self newElement]) = self newElement.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 16:41'!
testBeginsWith
	| list |

	self deny: (self emptyList beginsWith: self listElements).
	list := self listWithElements.
	1 to: list size do: [:i |
		self
			assert: (list beginsWith: (self listElements copyFrom: 1 to: i));
			deny: (list beginsWith: ((self listElements copyFrom: 1 to: i) copyWith: self absentElement));
			deny: (list beginsWith: ((self listElements copyFrom: 1 to: i) copyWithFirst: self absentElement))].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 12/14/2014 13:56'!
testCapacity
	self hasCapacity
		ifTrue: [
			self
				assert: self emptyList capacity >= 0;
				assert: self listWithSingleElement capacity >= 1;
				assert: self listWithElements capacity >= self listElements size]! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/17/2015 09:26'!
testCollect
	| list |

	list := self listWithElements.
	self
		assertList: (list collect: [:each | self changeElement: each])
		collectedFrom: list
		equals: (self listSpecies newFrom: self changedListElements).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 18:48'!
testCollectThenSelect
	| list |

	list := self listWithElements.
	self
		assertList:
			(list
				collect: [:each | self changeElement: each]
				thenSelect: [:each | each ~= self changedSingleElement])
		collectedFrom: list
		equals:
			(self listSpecies newFrom:
				(self changedListElements copyWithout: self changedSingleElement)).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/24/2014 04:38'!
testConcatenation
	| list |

	list := self emptyList.
	self
		assertList: (list, self emptyList) copiedFrom: list equals: self emptyList;
		assertList: (list, self listWithElements) copiedFrom: list equals: self listWithElements.

	list := self listWithElements.
	self assertList: (list, self emptyList) copiedFrom: list equals: self listWithElements.
	self
		assertList: (list, self listWithElements)
		copiedFrom: list
		equals: (self listClass newFrom: (self listElements, self listElements)).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'JAA 3/25/2011 15:38'!
testCopy
	| list |

	list := self emptyList.
	self assertList: list copy isCopyOf: list.

	list := self listWithSingleElement.
	self assertList: list copy isCopyOf: list.

	list := self listWithElements.
	self assertList: list copy isCopyOf: list.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/24/2014 04:33'!
testCopyAfter
	| list |

	list := self listWithElements.
	list do: [:each |
		self
			assertList: (list copyAfter: each)
			copiedFrom: list
			equals: (self listClass newFrom: (self listElements copyAfter: each)).
		self assert: (self emptyList copyAfter: each) = self emptyList].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/24/2014 04:33'!
testCopyAfterLast
	| list |

	list := self listWithElements.
	list do: [:each |
		self
			assertList: (list copyAfterLast: each)
			copiedFrom: list
			equals: (self listClass newFrom: (self listElements copyAfterLast: each)).
		self assert: (self emptyList copyAfterLast: each) = self emptyList].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 9/28/2014 23:33'!
testCopyEmpty
	| list |

	list := self emptyList.
	self assertList: list copyEmpty copiedFrom: list equals: self emptyList.

	list := self listWithSingleElement.
	self assertList: list copyEmpty copiedFrom: list equals: self emptyList.

	list := self listWithElements.
	self assertList: list copyEmpty copiedFrom: list equals: self emptyList.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/26/2014 12:06'!
testCopyFromTo
	| list emptyList |

	list := self listWithElements.
	emptyList  := self emptyList.
	-1 to: list size + 1 do: [:start |
		start to: list size + 1 do: [:stop |
			self
				assertList: (list copyFrom: start to: stop)
				copiedFrom: list
				equals: (self listWithElements copyFrom: (start max: 1) to: (stop min: list size)).
			self
				assertList: (list copyFrom: start to: start - 1)
				copiedFrom: list
				equals: self emptyList.
			self
				assertList: (list copyFrom: start to: start - 2)
				copiedFrom: list
				equals: self emptyList.
			self
				assertList: (emptyList copyFrom: start to: stop)
				copiedFrom: list
				equals: self emptyList]].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/17/2015 09:29'!
testCopyReplaceAllWith
	| list |

	list := self listClass newFrom: self listElements, self listElements.
	1 to: self listElements size do: [:i | | replacedElements |
		replacedElements := self listElementsLast: i.
		self
			assertList:
				(list
					copyReplaceAll: replacedElements
					with: (replacedElements collect: [:each | self changeElement: each]))
			copiedFrom: list
			equals: 
				(self listClass newFrom:
					((self listElements, self listElements) 
						copyReplaceAll: replacedElements
						with: (replacedElements collect: [:each | self changeElement: each]))).
		self
			assertList:
				(list
					copyReplaceAll: (Array with: self absentElement)
					with: (Array with: self newElement))
			copiedFrom: list
			equals: list.	
		self
			assertList: (list copyReplaceAll: #() with: (Array with: self newElement))
			copiedFrom: list
			equals: list.
		self
			assertList: (list copyReplaceAll: (self listElements copyWith: self absentElement) with: #())
			copiedFrom: list
			equals: list].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/17/2015 09:29'!
testCopyReplaceFromToWith
	| list emptyList |

	list := self listWithElements.
	emptyList := self emptyList.
	-1 to: list size + 1 do: [:start |
		start to: list size + 1 do: [:stop |
			self
				assertList: (list copyReplaceFrom: start to: stop with: self changedListElements)
				copiedFrom: list
				equals:
					(self listClass newFrom:
						(self listElementsFirst: start - 1),
						(self changedListElements),
						(self listElementsLast: list size - stop)).
			self
				assertList: (emptyList copyReplaceFrom: start to: stop with: self listElements)
				copiedFrom: emptyList
				equals: self listWithElements]].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/25/2014 10:54'!
testCopyUpTo
	| list |

	list := self listWithElements.
	list do: [:each |
		self
			assertList: (list copyUpTo: each)
			copiedFrom: list
			equals: (self listClass newFrom: (self listElements copyUpTo: each))].
	self
		assertList: (list copyUpTo: self absentElement)
		copiedFrom: list
		equals: self listWithElements.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 11:29'!
testCopyUpToLast
	| list |

	list := self listClass newFrom: self listElements, self listElements.
	list do: [:each |
		self
			assertList: (list copyUpToLast: each)
			copiedFrom: list
			equals:
				(self listClass newFrom:
					(self allowsDuplicates
						ifTrue: [self listElements, self listElements copyUpToLast: each]
						ifFalse: [self listElements copyUpToLast: each]))].
	self
		assertList: (list copyUpToLast: self absentElement)
		copiedFrom: list
		equals:
			(self listClass newFrom:
				(self allowsDuplicates
					ifTrue: [self listElements, self listElements]
					ifFalse: [self listElements])).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 07:14'!
testCopyWith
	| list |

	list := self emptyList.
	self
		assertList: (list copyWith: self singleElement)
		copiedFrom: list
		equals: self listWithSingleElement.

	list := self listWithElements.
	self
		assertList: (list copyWith: self newElement)
		copiedFrom: list
		equals: (self listClass newFrom: (self listElements copyWith: self newElement)).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/24/2014 14:47'!
testCopyWithFirst
	| list |

	list := self emptyList.
	self
		assertList: (list copyWithFirst: self singleElement)
		copiedFrom: list
		equals: self listWithSingleElement.

	list := self listWithElements.
	self
		assertList: (list copyWithFirst: self newElement)
		copiedFrom: list
		equals:
			(self listClass newFrom:
				(self listElements copyWithFirst: self newElement)).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/16/2015 14:11'!
testCopyWithout
	| list |

	list := self emptyList.
	self
		assertList: (list copyWithout: self singleElement)
		copiedFrom: list
		equals: self emptyList.

	list := self listWithElements.
	self
		assertList: (list copyWithout: self singleElement)
		copiedFrom: list
		equals: (self listClass newFrom: (self listElements copyWithout: self singleElement)).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/16/2015 14:14'!
testCopyWithoutAll
	| list |

	list := self emptyList.
	self
		assertList: (list copyWithoutAll: self listElements)
		copiedFrom: list
		equals: self emptyList.

	list := self listWithElements.
	self
		assertList: (list copyWithoutAll: (Array with: self absentElement))
		copiedFrom: list
		equals: self listWithElements.
	self
		assertList: (list copyWithoutAll: self listElements)
		copiedFrom: list
		equals: self emptyList.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'JAA 3/25/2011 16:02'!
testDefaultValue
	self assert: self emptyList defaultValue = self defaultValue! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 11/7/2014 00:25'!
testDetect
	| list |

	list := self listWithElements.
	self listElements do: [:element |
		self assert: (list detect: [:each | each = element]) = element].
	self assert: (list detect: [:each | each = self absentElement]) = self defaultValue.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 11/7/2014 00:25'!
testDetectIfNone
	| list |

	list := self listWithElements.
	self listElements do: [:element |
		self assert:
			(list
				detect: [:each | each = element]
				ifNone: [self newElement]) = element].
	self assert:
		(list
			detect: [:each | each = self absentElement]
			ifNone: [self newElement]) = self newElement.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'JAA 3/26/2011 17:32'!
testDo
	self
		should: [:block | self emptyList do: block] enumerate: #();
		should: [:block | self listWithElements do: block] enumerate: self listElements! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 12/14/2014 07:09'!
testDoWithIndex
	| list enumerated |

	list := self listWithElements.
	enumerated := OrderedCollection new.
	list withIndexDo: [:each :i | enumerated addLast: each -> i].
	self assert:
		enumerated =
			(self listElements withIndexCollect: [:each : i | each -> i ])
				asOrderedCollection.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 12/14/2014 06:52'!
testEighth
	self
		assert: self emptyList eighth = self defaultValue;
		assert: self listWithElements eighth = (self listElements at: 8).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 16:43'!
testEndsWith
	| list |

	self deny: (self emptyList endsWith: self listElements).
	list := self listWithElements.
	1 to: list size do: [:i |
		self
			assert: (list endsWith: (self listElements copyFrom: i to: list size));
			deny: (list endsWith: ((self listElements copyFrom: i to: list size) copyWith: self absentElement));
			deny: (list endsWith: ((self listElements copyFrom: i to: list size) copyWithFirst: self absentElement))].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 4/11/2015 07:40'!
testEquals
	self
		assertList: self emptyList equals: self emptyList;
		assertList: self listWithSingleElement equals: self listWithSingleElement;
		assertList: self listWithElements equals: self listWithElements;
		denyList: self emptyList equals: self listWithSingleElement;
		denyList: self emptyList equals: self listWithElements;
		denyList: self listWithSingleElement equals: self listWithElements! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 4/19/2015 15:21'!
testEqualsInternalCollections
	| emptyArrayList emptyOCList arrayListWithSingleElement ocListWithSingleElement arrayListWithElements ocListWithElements |

	emptyArrayList := self listClass collection: #().
	emptyOCList := self listClass collection: OrderedCollection new.
	arrayListWithSingleElement := self listClass collection: (Array with: self singleElement).
	ocListWithSingleElement := self listClass collection: (OrderedCollection with: self singleElement).
	"use withAll: for portability to GS"
	arrayListWithElements := self listClass collection: (Array withAll: self listElements).
	ocListWithElements := self listClass collection: (OrderedCollection withAll: self listElements).

	self
		assertList: emptyArrayList equals: emptyOCList;
		assertList: arrayListWithSingleElement equals: ocListWithSingleElement;
		assertList: arrayListWithElements equals: ocListWithElements;
		denyList: emptyArrayList equals: ocListWithSingleElement;
		denyList: emptyArrayList equals: ocListWithElements;
		denyList: arrayListWithSingleElement equals: emptyOCList;
		denyList: arrayListWithSingleElement equals: ocListWithElements;
		denyList: arrayListWithElements equals: emptyOCList;
		denyList: arrayListWithElements equals: ocListWithSingleElement.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 4/11/2015 07:44'!
testEqualsSpecies
	| emptySpeciesList speciesListWithSingleElement speciesListWithElements |

	emptySpeciesList := self listSpecies new.
	speciesListWithSingleElement := self listSpecies with: self singleElement.
	speciesListWithElements := self listSpecies newFrom: self listElements.
	self
		assertList: self emptyList equals: emptySpeciesList;
		assertList: self listWithSingleElement equals: speciesListWithSingleElement;
		assertList: self listWithElements equals: speciesListWithElements;
		denyList: self emptyList equals: speciesListWithSingleElement;
		denyList: self emptyList equals: speciesListWithElements;
		denyList: self listWithSingleElement equals: emptySpeciesList;
		denyList: self listWithSingleElement equals: speciesListWithElements;
		denyList: self listWithElements equals: emptySpeciesList;
		denyList: self listWithElements equals: speciesListWithSingleElement.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 12/14/2014 06:52'!
testFifth
	self
		assert: self emptyList fifth = self defaultValue;
		assert: self listWithElements fifth = (self listElements at: 5).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 12/14/2014 06:51'!
testFirst
	self
		assert: self emptyList first = self defaultValue;
		assert: self listWithElements first = (self listElements at: 1).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 11/24/2014 08:34'!
testFirstFew
	| list |

	list := self listWithElements.
	1 to: list size do: [:i |
		self
			assertList: (list first: i)
			copiedFrom: list
			equals: (self listClass newFrom: (self listElementsFirst: i)).
		self
			assertList: (list first: list size + i)
			copiedFrom: list
			equals: self listWithElements.
		self
			assertList: (list first: (i * -1))
			copiedFrom: list
			equals: self emptyList].
	self
		assertList: (list first: 0)
		copiedFrom: list
		equals: self emptyList.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 12/14/2014 06:51'!
testFourth
	self
		assert: self emptyList fourth = self defaultValue;
		assert: self listWithElements fourth = (self listElements at: 4).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 05:27'!
testIdentityIndexOf
	| list |

	list := self listWithElements.
	1 to: list size do: [:i |
		self
			assert: (list identityIndexOf: (list at: i)) = i;
			assert: (list identityIndexOf: (list at: i) copy) isZero].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 05:33'!
testIdentityIndexOfIfAbsent
	| list |

	list := self listWithElements.
	1 to: list size do: [:i |
		self
			assert: (list identityIndexOf: (list at: i) ifAbsent: [-1]) = i;
			assert: (list identityIndexOf: (list at: i) copy ifAbsent: [-1]) = -1].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/17/2015 10:22'!
testIndexOf
	| list |

	list := self listWithElements.
	1 to: list size do: [:i |
		self
			assert: (list indexOf: (list at: i)) = i;
			assert: (list indexOf: (self listElements at: i)) = i].
	self assert: (list indexOf: self absentElement) isZero.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/17/2015 10:23'!
testIndexOfIfAbsent
	| list |

	list := self listWithElements.
	1 to: list size do: [:i |
		self
			assert: (list indexOf: (list at: i) ifAbsent: [-1]) = i;
			assert: (list indexOf: (self listElements at: i) ifAbsent: [-1]) = i].
	self assert: (list indexOf: self absentElement ifAbsent: [-1]) = -1.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 05:44'!
testIndexOfStartingAt
	| list |

	list := self listWithElements.
	1 to: list size do: [:i |
		self
			assert: (list indexOf: (list at: i) startingAt: i) = i;
			assert: (list indexOf: (list at: i) startingAt: i + 1) isZero].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 05:46'!
testIndexOfStartingAtIfAbsent
	| list |

	list := self listWithElements.
	1 to: list size do: [:i |
		self
			assert: (list indexOf: (list at: i) startingAt: i ifAbsent: [-1]) = i;
			assert: (list indexOf: (list at: i) startingAt: i + 1 ifAbsent: [-1]) = -1].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 08:00'!
testLast
	self
		assert: self emptyList last = self defaultValue;
		assert: self listWithElements last = self listElements last.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 11/24/2014 08:35'!
testLastFew
	| list |

	list := self listWithElements.
	1 to: list size do: [:i |
		self
			assertList: (list last: i)
			copiedFrom: list
			equals: (self listClass newFrom: (self listElementsLast: i)).
		self
			assertList: (list last: list size + i)
			copiedFrom: list
			equals: self listWithElements.
		self
			assertList: (list last: (i * -1))
			copiedFrom: list
			equals: self emptyList].
	self
		assertList: (list last: 0)
		copiedFrom: list
		equals: self emptyList.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 11:31'!
testLastIndexOf
	| list |

	list := self listClass newFrom: self listElements, self listElements.
	list do: [:each |
		self assert:
			(list lastIndexOf: each) =
				(self allowsDuplicates
					ifTrue: [self listElements, self listElements lastIndexOf: each]
					ifFalse: [self listElements lastIndexOf: each])].
	self assert: (list lastIndexOf: self newElement) isZero.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 11:32'!
testLastIndexOfIfAbsent
	| list |

	list := self listClass newFrom: self listElements, self listElements.
	list do: [:each |
		self assert:
			(list lastIndexOf: each ifAbsent: [-1]) =
				(self allowsDuplicates
					ifTrue: [self listElements, self listElements lastIndexOf: each]
					ifFalse: [self listElements lastIndexOf: each])].
	self assert: (list lastIndexOf: self newElement ifAbsent: [-1])  = -1.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 12/14/2014 13:58'!
testNew
	| list |

	list := self listClass new: 20.
	self assert: list = self emptyList.
	self hasCapacity
		ifTrue: [self assert: list capacity >= 20].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'JAA 3/26/2011 18:21'!
testNewFrom
	self assert: (self listClass newFrom: self listElements) = self listWithElements! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 11:26'!
testNewWithAll
	| list |

	list := self listClass new: 10 withAll: self singleElement.
	self allowsDuplicates
		ifTrue: [self assert: list size = 10]
		ifFalse: [self assert: list size = 1].
	self assert: (list allSatisfy: [:each | each = self singleElement]).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 12/14/2014 06:49'!
testNinth
	self
		assert: self emptyList ninth = self defaultValue;
		assert: self listWithElements ninth = (self listElements at: 9).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'JAA 3/26/2011 18:32'!
testOfSize
	self assert: (self listClass ofSize: 10) size = 10! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/28/2014 15:54'!
testPairsDo
	| pairs |

	0 to: self listElements size do: [:i |
		pairs := OrderedCollection new.
		(self listClass newFrom: (self listElements allButLast: i))
			pairsDo: [:a :b | pairs addLast: a -> b].
		
		(self listElements allButLast: i) pairsDo: [:a :b |
			self assert: pairs removeFirst = (a -> b)].
		self assert: pairs isEmpty].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 16:53'!
testReadStream
	| list stream elements |

	list := self listWithElements.
	stream := list readStream.
	self assert: (stream isKindOf: ReadStream).

	elements := self listElements asOrderedCollection.
	[stream atEnd]
		whileFalse: [self assert: stream next = elements removeFirst].
	self assert: elements isEmpty.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/24/2014 14:45'!
testReject
	| list |

	list := self listWithElements.
	self
		assertList: (list reject: [:each | each = self singleElement])
		copiedFrom: list
		equals:
			(self listClass newFrom:
				(self listWithElements copyWithout: self singleElement)).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/17/2015 09:36'!
testRejectThenCollect
	| list |

	list := self listWithElements.
	self
		assertList:
			(list
				reject: [:each | each = self singleElement]
				thenCollect: [:each | self changeElement: each])
		collectedFrom: list
		equals:
			(self listSpecies newFrom:
				(self changedListElements copyWithout: self changedSingleElement)).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/12/2014 21:16'!
testRemoveAll
	| list |

	list := self listWithElements.
	self
		assert: (list removeAll) == list;
		assert: list isEmpty.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 07:51'!
testRemoveAt
	self listElements withIndexDo: [:each :i | | list |
		list := self listWithElements.
		self
			assert: (list removeAt: i) = each;
			assert: (list = (self listClass newFrom: (self listElements copyWithout: each)))].
	self
		should: [self listWithElements removeAt: 0] raise: Error;
		should: [self listWithElements removeAt: self listElements size + 1] raise: Error.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 17:30'!
testRemoveFirst
	| list |

	list := self listWithElements.
	self listElements do: [:each | 
	self
		assert: list removeFirst = each;
		assert: list = (self listClass newFrom: (self listElements copyAfter: each))].
	self should: [list removeFirst] raise: Error.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 07:57'!
testRemoveFirstFew
	1 to: self listElements size do: [:i | | list removedElements |
		list := self listWithElements.
		removedElements := list removeFirst: i.
		self
			assert: removedElements asArray = (self listElementsFirst: i);
			assert: list = (self listClass newFrom: (self listElements allButFirst: i));
			assert: (list removeFirst: 0) isEmpty;
			should: [self emptyList removeFirst: i] raise: Error].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'JAA 3/26/2011 17:40'!
testRemoveIfAbsent
	| list |

	list := self listWithElements.
	self
		assert: (list remove: self singleElement ifAbsent: [nil]) = self singleElement;
		deny: (list includes: self singleElement);
		assert: (list remove: self absentElement ifAbsent: [nil]) isNil.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 17:30'!
testRemoveLast
	| list |

	list := self listWithElements.
	self listElements reverseDo: [:each |
		self
			assert: list removeLast = each;
			assert: list = (self listClass newFrom: (self listElements copyUpTo: each))].
	self should: [list removeLast] raise: Error.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 11/24/2014 08:37'!
testRemoveLastFew
	| list removedElements |

	1 to: self listElements size do: [:i |
		list := self listWithElements.
		removedElements := list removeLast: i.
		self
			assert: removedElements asArray = (self listElementsLast: i) asArray;
			assert: list = (self listClass newFrom: (self listElements allButLast: i));
			assert: (list removeLast: 0) isEmpty;
			should: [self emptyList removeLast: i] raise: Error].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/17/2015 11:28'!
testReplaceFromToWith
	| list |

	1 to: self listElements size do: [:start |
		start to: self listElements size do: [:stop |
			list := self listWithElements.
			self assert:
				(list
					replaceFrom: start
					to: stop
					with: (self changedListElements allButFirst: start - 1)) == list.

			1 to: start - 1 do: [:i | self assert: (list at: i) = (self listElements at: i)].
			start to: stop do: [:i | self assert: (list at: i) = (self changedListElements at: i)].
			stop + 1 to: list size do: [:i | self assert: (list at: i) = (self listElements at: i)].

			start > 1
				ifTrue: [
					self
						should: [
							self emptyList
								replaceFrom: start
								to: stop
								with: self listElements]
						raise: Error]
				ifFalse: [
					self assert:
						(self emptyList
							replaceFrom: start
							to: stop
							with: self listElements) =
								(self listClass newFrom:
									(self listElementsFirst: (stop - start) + 1))]]].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/18/2015 08:10'!
testReplaceFromToWithStartingAt
	1 to: self listElements size do: [:start |
		start to: self listElements size do: [:stop | | list |
			list := self listWithElements.
			self assert:
				(list
					replaceFrom: start
					to: stop
					with: self changedListElements
					startingAt: start) == list.

			1 to: start - 1 do: [:i | self assert: (list at: i) = (self listElements at: i)].
			start to: stop do: [:i | self assert: (list at: i) = (self changedListElements at: i)].
			stop + 1 to: list size do: [:i | self assert: (list at: i) = (self listElements at: i)].

			start > 1
				ifTrue: [
					self
						should: [
							self emptyList
								replaceFrom: start
								to: stop
								with: self listElements
								startingAt: start]
						raise: Error]
				ifFalse: [
					self assert:
						(self emptyList
							replaceFrom: start
							to: stop
							with: self listElements
							startingAt: start) =
								(self listClass newFrom:
									(self listElementsFirst: (stop - start) + 1))]]].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 12/14/2014 13:58'!
testReset
	| list oldCapacity |

	list := self listWithElements.
	self hasCapacity
		ifTrue: [oldCapacity := list capacity].
	list reset.
	self assert: list isEmpty.
	oldCapacity
		ifNotNil: [self assert: list capacity >= oldCapacity].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 10:47'!
testReverse
	| list |

	list := self listWithElements.
	self
		assertList: list reverse
		copiedFrom: list
		equals: (self listClass newFrom: self listElements reverse).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'JAA 3/26/2011 18:08'!
testReverseDo
	self
		should: [:block | self emptyList reverseDo: block] enumerate: #();
		should: [:block | self listWithElements reverseDo: block] enumerate: self listElements reversed.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/23/2014 10:47'!
testReversed
	| list |

	list := self listWithElements.
	self
		assertList: list reversed
		copiedFrom: list
		equals: (self listClass newFrom: self listElements reversed).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 12/14/2014 06:51'!
testSecond
	self
		assert: self emptyList second = self defaultValue;
		assert: self listWithElements second = (self listElements at: 2).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/24/2014 14:39'!
testSelect
	| list |

	list := self listWithElements.
	self
		assertList: (list select: [:each | each ~= self singleElement])
		copiedFrom: list
		equals:
			(self listClass newFrom:
				(self listWithElements copyWithout: self singleElement)).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/17/2015 09:31'!
testSelectThenCollect
	| list |

	list := self listWithElements.
	self
		assertList:
			(list
				select: [:each | each ~= self singleElement]
				thenCollect: [:each | self changeElement: each])
		collectedFrom: list
		equals:
			(self listSpecies newFrom:
				(self changedListElements copyWithout: self changedSingleElement)).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 12/14/2014 06:51'!
testSeventh
	self
		assert: self emptyList seventh = self defaultValue;
		assert: self listWithElements seventh = (self listElements at: 7).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 12/14/2014 06:51'!
testSixth
	self
		assert: self emptyList sixth = self defaultValue;
		assert: self listWithElements sixth = (self listElements at: 6).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'JAA 3/26/2011 18:13'!
testSize
	self
		assert: self emptyList size isZero;
		assert: self listWithSingleElement size = 1;
		assert: self listWithElements size = self listElements size! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/17/2015 10:34'!
testSort
	| list |

	list := self listWithElements.
	self
		assert: list sort == list;
		assert: list = (self listClass newFrom: (self listElements copy sort: self sortBlock));
		assert: (list sort: self reverseSortBlock) == list;
		assert: list = (self listClass newFrom: (self listElements copy sort: self reverseSortBlock)).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 1/17/2015 10:35'!
testSorted
	| list |

	list := self listWithElements.
	self
		assertList: list sorted
		copiedFrom: list
		equals: (self listClass newFrom: (self listElements copy sorted: self sortBlock)).
	self
		assertList: (list sorted: self reverseSortBlock)
		copiedFrom: list
		equals: (self listClass newFrom: (self listElements copy sorted: self reverseSortBlock)).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/19/2014 06:27'!
testSpecies
	self
		assert: self emptyList species = self listSpecies! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 2/2/2015 02:20'!
testSwapWith
	| list start end |

	list := self listWithElements.

	start := 1.
	end := list size.
	[start < end]
		whileTrue: [
			list swap: start with: end.
			start := start + 1.
			end := end - 1].
	self assert: list = (self listClass newFrom: self listElements reversed).

	start := 1.
	end := list size.
	[start < end]
		whileTrue: [
			list swap: end with: start.
			start := start + 1.
			end := end - 1].
	self assert: list = self listWithElements.

	1 to: list size do: [:i | list swap: i with: i].
	self assert: list = self listWithElements.

	self
		should: [list swap: 0 with: 1]
		raise: Error.
	self
		should: [list swap: list size + 1 with: list size]
		raise: Error.
	self assert: list = self listWithElements.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 12/14/2014 06:51'!
testThird
	self
		assert: self emptyList third = self defaultValue;
		assert: self listWithElements third = (self listElements at: 3).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 12/14/2014 07:10'!
testWithCollect
	| list |

	list := self listWithElements.
	self
		assertList: (list with: (1 to: list size + 1) collect: [:each :i | each -> i])
		collectedFrom: list
		equals:
			(self listSpecies newFrom:
				(self listElements withIndexCollect: [:each :i | each -> i])).
	self
		assertList: (list with: (1 to: list size - 1) collect: [:each :i | each -> i])
		collectedFrom: list
		equals:
			(self listSpecies newFrom:
				(self listElements allButLast
					withIndexCollect: [:each :i | each -> i])).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 12/14/2014 07:10'!
testWithDo
	| list enumerated |

	list := self listWithElements.
	enumerated := OrderedCollection new.
	list with: (1 to: list size + 1) do: [:each :i | enumerated addLast: each -> i].
	self assert:
		enumerated =
			(self listElements withIndexCollect: [:each : i | each -> i ])
				asOrderedCollection.

	enumerated removeAll.
	list with: (1 to: list size - 1) do: [:each :i | enumerated addLast: each -> i].
	self assert:
		enumerated =
			(self listElements allButLast
				withIndexCollect: [:each : i | each -> i ])
					asOrderedCollection.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 12/14/2014 07:11'!
testWithIndexCollect
	| list |

	list := self listWithElements.
	self
		assertList: (list withIndexCollect: [:each :i | each -> i])
		collectedFrom: list
		equals:
			(self listSpecies newFrom:
				(self listElements withIndexCollect: [:each :i | each -> i])).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 12/14/2014 07:11'!
testWithIndexDo
	| enumerated |

	enumerated := OrderedCollection new.
	self listWithElements withIndexDo: [:each :i | enumerated addLast: each -> i].
	self assert:
		enumerated =
			(self listElements withIndexCollect: [:each : i | each -> i ]) asOrderedCollection.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/24/2014 14:40'!
testWriteStream
	| list stream |

	list := self emptyList.
	stream := list writeStream.
	self assert: (stream isKindOf: WriteStream).

	self listElements do: [:each | stream nextPut: each].
	self assert:
		(stream contents) asOrderedCollection =
			self listElements asOrderedCollection.! !

TestCase subclass: #XMLParserLimitsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLParserLimitsTest methodsFor: 'source' stamp: 'monty 1/19/2014 04:10'!
recursiveEntitiesNamed: aName depth: aLimit isParameter: aBoolean
	| xml |

	xml := String new writeStream.
	1 to: aLimit do: [:i |
		xml
			cr;
			nextPutAll: '<!!ENTITY '.
		aBoolean
			ifTrue: [xml nextPutAll: '% '].
		xml
			nextPutAll: aName, i printString;
			nextPutAll: ' "'.
			(i = aLimit)
				ifTrue: [xml nextPutAll: '<!!--last-->']
				ifFalse: [
					aBoolean
						ifTrue: [xml nextPutAll: '&#37;']
						ifFalse: [xml nextPut: $&].
					xml
						nextPutAll: aName, (i + 1) printString;
						nextPut: $;].
		xml nextPutAll: '">'].
	^ xml contents.! !

!XMLParserLimitsTest methodsFor: 'tests' stamp: 'monty 1/27/2015 22:49'!
testDefaultLimits
	| parser |

	parser := SAXHandler on: ''.
	self
		assert: parser documentReadLimit = XMLParserLimits defaultDocumentReadLimit;
		assert: parser maxEntityReplacementDepth > 0.! !

!XMLParserLimitsTest methodsFor: 'tests' stamp: 'monty 11/16/2014 00:24'!
testDocumentReadLimit
	| xml replacement |

	replacement := 'entity replacement'.
	xml := '<!!DOCTYPE test [<!!ENTITY entity "', replacement, '">]><test>&entity;</test>'.
	self
		shouldnt: [
			(SAXHandler on: xml)
				documentReadLimit: xml size + replacement size;
				parseDocument]
		raise: XMLLimitException.
	self
		should: [
			(SAXHandler on: xml)
				documentReadLimit: xml size + replacement size - 1;
				parseDocument]
		raise: XMLLimitException.
	self
		shouldnt: [
			(SAXHandler on: xml)
				documentReadLimit: nil;
				parseDocument]
		raise: XMLLimitException.! !

!XMLParserLimitsTest methodsFor: 'tests' stamp: 'monty 1/19/2014 03:54'!
testRecursiveGeneralEntityReplacement
	| limit xml |

	limit := 3.
	xml :=
		self
			xmlWithRecursiveEntitiesNamed: 'entity'
			depth: limit
			isParameter: false.
	self
		shouldnt: [
			(SAXHandler on: xml)
				maxEntityReplacementDepth: limit;
				parseDocument]
		raise: XMLLimitException.! !

!XMLParserLimitsTest methodsFor: 'tests' stamp: 'monty 1/19/2014 22:50'!
testRecursiveGeneralEntityReplacementPastLimit
	| limit xml |

	limit := 3.
	xml :=
		self
			xmlWithRecursiveEntitiesNamed: 'entity'
			depth: limit + 1
			isParameter: false.
	self
		should: [
			(SAXHandler on: xml)
				maxEntityReplacementDepth: limit;
				parseDocument]
		raise: XMLLimitException.
	self
		shouldnt: [
			(SAXHandler on: xml)
				maxEntityReplacementDepth: nil;
				parseDocument]
		raise: XMLLimitException.! !

!XMLParserLimitsTest methodsFor: 'tests' stamp: 'monty 1/19/2014 03:56'!
testRecursiveParameterEntityReplacement
	| limit xml |

	limit := 3.
	xml :=
		self
			xmlWithRecursiveEntitiesNamed: 'entity'
			depth: limit
			isParameter: true.
	self
		shouldnt: [
			(SAXHandler on: xml)
				maxEntityReplacementDepth: limit;
				parseDocument]
		raise: XMLLimitException.! !

!XMLParserLimitsTest methodsFor: 'tests' stamp: 'monty 1/19/2014 22:49'!
testRecursiveParameterEntityReplacementPastLimit
	| limit xml |

	limit := 3.
	xml :=
		self
			xmlWithRecursiveEntitiesNamed: 'entity'
			depth: limit + 1
			isParameter: true.
	self
		should: [
			(SAXHandler on: xml)
				maxEntityReplacementDepth: limit;
				parseDocument]
		raise: XMLLimitException.
	self
		shouldnt: [
			(SAXHandler on: xml)
				maxEntityReplacementDepth: nil;
				parseDocument]
		raise: XMLLimitException.! !

!XMLParserLimitsTest methodsFor: 'tests' stamp: 'monty 1/27/2015 23:08'!
testRemoveLimits
	| parser readLimit depthLimit |

	readLimit := 100.
	depthLimit := 5.
	(parser := SAXHandler on: '')
		documentReadLimit: readLimit;
		maxEntityReplacementDepth: depthLimit.
	self
		assert: parser documentReadLimit = readLimit;
		assert: parser maxEntityReplacementDepth = depthLimit.

	parser removeLimits.
	self
		assert: parser documentReadLimit isNil;
		assert: parser maxEntityReplacementDepth isNil.! !

!XMLParserLimitsTest methodsFor: 'tests' stamp: 'monty 2/10/2014 02:43'!
testTokenizerMaxPushBack
	| tokenizer |

	tokenizer :=
		XMLWellFormedParserTokenizer
			driver: nil
			on: '' readStream.
	self
		shouldnt: [
			tokenizer streamReader maxNestedStreams
				timesRepeat: [tokenizer streamReader pushBack: 'test']]
		raise: XMLLimitException.
	self
		should: [tokenizer streamReader pushBack: 'test']
		raise: XMLLimitException.! !

!XMLParserLimitsTest methodsFor: 'source' stamp: 'monty 1/19/2014 04:10'!
xmlWithRecursiveEntitiesNamed: aName depth: aLimit isParameter: aBoolean
	| xml |

	(xml := String new writeStream)
		nextPutAll: '<!!DOCTYPE test ['.
	xml nextPutAll:
		(self
			recursiveEntitiesNamed: aName
			depth: aLimit
			isParameter: aBoolean).
	aBoolean
		ifTrue: [xml nextPutAll: '%', aName, '1;]>']
		ifFalse: [xml nextPutAll: ']><test>&', aName, '1;</test>'].

	^ xml contents.! !

TestCase subclass: #XMLParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

XMLParserTest subclass: #SAXHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!SAXHandlerTest methodsFor: 'accessing' stamp: 'monty 4/12/2015 09:28'!
prefixedXMLAttributes
	^ OrderPreservingDictionary with: 'name' -> 'value'! !

!SAXHandlerTest methodsFor: 'accessing' stamp: 'monty 4/12/2015 09:28'!
prefixedXMLAttributesNamespacesDisabled
	^ OrderPreservingStringDictionary
		with: 'xmlns:prefix' -> 'prefixNS'
		with: 'xmlns' -> 'defaultNS'
		with: 'name' -> 'value'! !

!SAXHandlerTest methodsFor: 'source' stamp: 'monty 1/31/2014 21:05'!
prefixedXMLSource
	^ '<prefix:test xmlns:prefix="prefixNS" xmlns="defaultNS" name="value">test</prefix:test>'! !

!SAXHandlerTest methodsFor: 'accessing' stamp: 'monty 10/24/2014 07:06'!
prefixedXMLSourceSelectors
	^ #(startDocument
		startPrefixMapping:uri: startPrefixMapping:uri:
		startElement:prefix:uri:localName:attributes:
		characters:
		endElement:prefix:uri:localName:
		endPrefixMapping: endPrefixMapping:
		endDocument)! !

!SAXHandlerTest methodsFor: 'accessing' stamp: 'monty 10/24/2014 07:16'!
prefixedXMLSourceSelectorsNamespacesDisabled
	^ self prefixedXMLSourceSelectors reject: [:each |
		#(startPrefixMapping:uri: endPrefixMapping:) includes: each].
! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 4/12/2015 09:34'!
testSAXEndElementForwarding
	| messageRecorder message |

	messageRecorder :=
		(SAXElementEventRecordingHandler on: self prefixedXMLSource)
			parseDocument;
			messageRecorder.

	message :=
		messageRecorder
			nextMessage;
			nextMessage.
	self
		assert: message selector == #endElement:;
		assert: message arguments = #('prefix:test').! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 4/12/2015 10:11'!
testSAXEndElementForwardingNamespacesDisabled
	| messageRecorder message |

	messageRecorder :=
		(SAXElementEventRecordingHandler on: self prefixedXMLSource)
			usesNamespaces: false;
			parseDocument;
			messageRecorder.

	message :=
		messageRecorder
			nextMessage;
			nextMessage.
	self
		assert: message selector == #endElement:;
		assert: message arguments = #('prefix:test').! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 4/12/2015 09:42'!
testSAXEndElementPrefixURIForwarding
	| messageRecorder message |

	messageRecorder :=
		(SAXElementPrefixURIEventRecordingHandler on: self prefixedXMLSource)
			parseDocument;
			messageRecorder.

	message :=
		messageRecorder
			nextMessage;
			nextMessage.
	self
		assert: message selector == #endElement:prefix:uri:;
		assert: message arguments = #('prefix:test' 'prefix' 'prefixNS').! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 4/12/2015 09:42'!
testSAXEndElementPrefixURIForwardingNamespacesDisabled
	| messageRecorder message |

	messageRecorder :=
		(SAXElementPrefixURIEventRecordingHandler on: self prefixedXMLSource)
			usesNamespaces: false;
			parseDocument;
			messageRecorder.

	message :=
		messageRecorder
			nextMessage;
			nextMessage.
	self
		assert: message selector == #endElement:prefix:uri:;
		assert: message arguments = #('prefix:test' 'prefix' '').! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 4/12/2015 10:09'!
testSAXEndElementPrefixURILocalName
	| messageRecorder message |

	messageRecorder :=
		(SAXElementPrefixURILocalNameEventRecordingHandler on: self prefixedXMLSource)
			parseDocument;
			messageRecorder.

	message :=
		messageRecorder
			nextMessage;
			nextMessage.
	self
		assert: message selector == #endElement:prefix:uri:localName:;
		assert: message arguments = #('prefix:test' 'prefix' 'prefixNS' 'test').! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 4/12/2015 10:10'!
testSAXEndElementPrefixURILocalNameNamespacesDisabled
	| messageRecorder message |

	messageRecorder :=
		(SAXElementPrefixURILocalNameEventRecordingHandler on: self prefixedXMLSource)
			usesNamespaces: false;
			parseDocument;
			messageRecorder.

	message :=
		messageRecorder
			nextMessage;
			nextMessage.
	self
		assert: message selector == #endElement:prefix:uri:localName:;
		assert: message arguments = #('prefix:test' 'prefix' '' 'test').! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 11/26/2014 06:28'!
testSAXEntityHandlers
	| xml parser messages |

	xml := '<!!DOCTYPE root [
		<!!ENTITY % firstDeclaration "<!!ENTITY first &#39; &second; &#39;>">
		%firstDeclaration;
		<!!ENTITY second " replacement ">]>
	<root name="&second;">&first;</root>'.
	(parser :=SAXHandlerProxy on: xml) parseDocument.
	self assert:
		(parser wasSentSelectors: 
			#(startDocument
				startDTD:publicID:systemID:
				parameterEntityDeclaration:replacement:
				generalEntityDeclaration:replacement: generalEntityDeclaration:replacement:
				endDTD
				startElement:prefix:uri:localName:attributes:
				startEntity: startEntity: endEntity: endEntity: characters:
				endElement:prefix:uri:localName:
				endDocument)).
	messages := parser allSentMessagesNamed: #startEntity:.
	self
		assert: messages first arguments = #('first');
		assert: messages second arguments = #('second').
	messages := parser allSentMessagesNamed: #endEntity:.
	self
		assert: messages first arguments = #('second');
		assert: messages second arguments = #('first').! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 4/5/2015 01:45'!
testSAXIgnorableWhitespace
	| xml parser |

	xml := '
	<one>
		<two>
			test
		</two>
	</one>
	'.
	(parser := SAXHandlerProxy on: xml) parseDocument.
	self assert:
		(parser wasSentSelectors: 
			#(startDocument
				startElement:prefix:uri:localName:attributes:
				ignorableWhitespace:
				startElement:prefix:uri:localName:attributes: characters: endElement:prefix:uri:localName:
				ignorableWhitespace:
				endElement:prefix:uri:localName:
				ignorableWhitespace:
				endDocument)).
	(parser allSentMessagesNamed: #ignorableWhitespace:) do: [:each |
		self assert:
			((each arguments first) notEmpty
				and: [each arguments first allSatisfy: [:char | char xmlParserIsSeparator]])].! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 4/5/2015 01:45'!
testSAXParsingInterrupt
	| uniqueSelectors parser |

	uniqueSelectors := OrderedCollection new.
	self prefixedXMLSourceSelectors do: [:each |
		(uniqueSelectors includes: each)
			ifFalse: [uniqueSelectors addLast: each]].
	uniqueSelectors do: [:each |
		(parser := SAXHandlerPluggableProxy on: self prefixedXMLSource)
			handle: each with: [:message | parser interruptParsing];
			parseDocument.
		self assert:
			(parser wasSentSelectors:
				((self prefixedXMLSourceSelectors copyUpTo: each) copyWith: each))].! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 11/26/2014 06:29'!
testSAXPrefixMappingHandlers
	| parser messages |

	(parser := SAXHandlerProxy on: self prefixedXMLSource) parseDocument.
	self assert: (parser wasSentSelectors: self prefixedXMLSourceSelectors).

	messages := parser allSentMessagesNamed: #startPrefixMapping:uri:.
	self
		assert: messages first arguments = #('prefix' 'prefixNS');
		assert: messages second arguments = #('' 'defaultNS').

	messages := parser allSentMessagesNamed: #endPrefixMapping:.
	self
		assert: messages first arguments = #('prefix');
		assert: messages second arguments = #('').! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 4/13/2015 02:35'!
testSAXSkippedEntityUndeclared
	| xml parser |

	xml := '<root>&undeclared;</root>'.
	(parser := SAXHandlerProxy on: xml)
		isValidating: false;
		parseDocument.
	self assert:
		(parser wasSentSelectors: 
			#(startDocument
				startElement:prefix:uri:localName:attributes:
				skippedEntity:
				endElement:prefix:uri:localName:
				endDocument)).
	self assert: (parser argumentsSentWith: #skippedEntity:) = #('undeclared').! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 4/13/2015 02:36'!
testSAXSkippedEntityUndeclaredPreserved
	| xml parser |

	xml := '<root>&undeclared;</root>'.
	(parser := SAXHandlerProxy on: xml)
		isValidating: false;
		preservesUndeclaredEntityReferences: true;
		parseDocument.
	self assert:
		(parser wasSentSelectors:
			#(startDocument
				startElement:prefix:uri:localName:attributes:
				skippedEntity:
				characters:
				endElement:prefix:uri:localName:
				endDocument)).
	self
		assert: (parser argumentsSentWith: #skippedEntity:) = #('undeclared');
		assert: (parser argumentsSentWith: #characters:) = #('&undeclared;').! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 4/13/2015 02:37'!
testSAXSkippedEntityUnreplaced
	| xml parser |

	xml := '<!!DOCTYPE root [<!!ENTITY declared "replacement">]><root>&declared;</root>'.
	(parser := SAXHandlerProxy on: xml)
		isValidating: true;
		replacesContentEntityReferences: false;
		parseDocument.
	self assert:
		(parser wasSentSelectors:
			#(startDocument
				startDTD:publicID:systemID:
				generalEntityDeclaration:replacement:
				endDTD
				startElement:prefix:uri:localName:attributes:
				skippedEntity:
				characters:
				endElement:prefix:uri:localName:
				endDocument)).
	self
		assert: (parser argumentsSentWith: #skippedEntity:) = #('declared');
		assert: (parser argumentsSentWith: #characters:) = #('&declared;').! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 4/12/2015 09:31'!
testSAXStartElementForwarding
	| messageRecorder message arguments |

	messageRecorder :=
		(SAXElementEventRecordingHandler on: self prefixedXMLSource)
			parseDocument;
			messageRecorder.

	message := messageRecorder nextMessage.
	self assert: message selector == #startElement:attributes:.

	arguments := message arguments.
	self
		assert: arguments first = 'prefix:test';
		assert: arguments second = self prefixedXMLAttributes.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 4/12/2015 09:32'!
testSAXStartElementForwardingNamespacesDisabled
	| messageRecorder message arguments |

	messageRecorder :=
		(SAXElementEventRecordingHandler on: self prefixedXMLSource)
			usesNamespaces: false;
			parseDocument;
			messageRecorder.
	
	message := messageRecorder nextMessage.
	self assert: message selector == #startElement:attributes:.

	arguments := message arguments.
	self
		assert: arguments first = 'prefix:test';
		assert: arguments second = self prefixedXMLAttributesNamespacesDisabled.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 4/12/2015 09:40'!
testSAXStartElementPrefixURIForwarding
	| messageRecorder message arguments |

	messageRecorder :=
		(SAXElementPrefixURIEventRecordingHandler on: self prefixedXMLSource)
			parseDocument;
			messageRecorder.

	message := messageRecorder nextMessage.
	self assert: message selector == #startElement:prefix:uri:attributes:.

	arguments := message arguments.
	self
		assert: arguments first = 'prefix:test';
		assert: arguments second = 'prefix';
		assert: arguments third = 'prefixNS';
		assert: arguments fourth = self prefixedXMLAttributes.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 4/12/2015 09:41'!
testSAXStartElementPrefixURIForwardingNamespacesDisabled
	| messageRecorder message arguments |

	messageRecorder :=
		(SAXElementPrefixURIEventRecordingHandler on: self prefixedXMLSource)
			usesNamespaces: false;
			parseDocument;
			messageRecorder.

	message := messageRecorder nextMessage.
	self assert: message selector == #startElement:prefix:uri:attributes:.

	arguments := message arguments.
	self
		assert: arguments first = 'prefix:test';
		assert: arguments second = 'prefix';
		assert: arguments third isEmpty;
		assert: arguments fourth = self prefixedXMLAttributesNamespacesDisabled.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 4/12/2015 10:04'!
testSAXStartElementPrefixURILocalName
	| messageRecorder message arguments |

	messageRecorder :=
		(SAXElementPrefixURILocalNameEventRecordingHandler on: self prefixedXMLSource)
			parseDocument;
			messageRecorder.

	message := messageRecorder nextMessage.
	self assert: message selector == #startElement:prefix:uri:localName:attributes:.

	arguments := message arguments.
	self
		assert: arguments first = 'prefix:test';
		assert: arguments second = 'prefix';
		assert: arguments third = 'prefixNS';
		assert: arguments fourth = 'test';
		assert: arguments fifth = self prefixedXMLAttributes.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 4/12/2015 10:07'!
testSAXStartElementPrefixURILocalNameNamespacesDisabled
	| messageRecorder message arguments |

	messageRecorder :=
		(SAXElementPrefixURILocalNameEventRecordingHandler on: self prefixedXMLSource)
			usesNamespaces: false;
			parseDocument;
			messageRecorder.

	message := messageRecorder nextMessage.
	self assert: message selector == #startElement:prefix:uri:localName:attributes:.

	arguments := message arguments.
	self
		assert: arguments first = 'prefix:test';
		assert: arguments second = 'prefix';
		assert: arguments third = '';
		assert: arguments fourth = 'test';
		assert: arguments fifth = self prefixedXMLAttributesNamespacesDisabled.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 11/26/2014 06:29'!
testSAXXMLDeclaration
	| parser selectors arguments |

	(parser := SAXHandlerProxy on: '<?xml version="1.0" encoding="UTF-8"?>')
		parseDocument.
	selectors := #(startDocument xmlVersion:encoding:standalone: endDocument).
	self assert: (parser wasSentSelectors: selectors).

	arguments := parser argumentsSentWith: #xmlVersion:encoding:standalone:.
	self
		assert: arguments first = 1.0;
		assert: arguments second = 'UTF-8';
		deny: arguments third.

	(parser :=
		SAXHandlerProxy on:
			'<?xml version="1.1" encoding="utf-8" standalone="yes"?>')
		parseDocument.
	self assert: (parser wasSentSelectors: selectors).

	arguments := (parser argumentsSentWith: #xmlVersion:encoding:standalone:).
	self
		assert: arguments first = 1.1;
		assert: arguments second = 'utf-8';
		assert: arguments third.! !

XMLParserTest subclass: #XMLDOMParserTest
	instanceVariableNames: 'addressBookNamespacePrefixedXML addressBookNamespacedXML'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLDOMParserTest class methodsFor: 'source' stamp: 'monty 10/24/2014 11:32'!
addressBookNamespacePrefixedXML
	"
	self addressBookNamespacePrefixedXML
	"
	| xmlWithPrefixes |

	xmlWithPrefixes := self addressBookNamespacedXML.
	#('<addressbook' '</addressbook' '<person' '</person' 'family-name=' 'first-name=')
		with: #('<book:addressbook' '</book:addressbook' '<ps:person' '</ps:person' 'ps:family-name=' 'ps:first-name=')
		do: [:source :replacement |
			xmlWithPrefixes := xmlWithPrefixes copyReplaceAll: source with: replacement].
	^ xmlWithPrefixes.! !

!XMLDOMParserTest class methodsFor: 'source' stamp: 'monty 10/24/2014 11:30'!
addressBookNamespacedXML
	"
	self addressBookNamespacedXML
	"
	^ '<addressbook xmlns="defaultNS" xmlns:book="bookNS" xmlns:ps="personNS">',
		(self addressBookXML copyAfter:  $>)! !

!XMLDOMParserTest methodsFor: 'source' stamp: 'monty 3/22/2015 03:27'!
addressBookNamespacePrefixedXML
	^ addressBookNamespacePrefixedXML
		ifNil: [addressBookNamespacePrefixedXML := self class addressBookNamespacePrefixedXML]! !

!XMLDOMParserTest methodsFor: 'source' stamp: 'monty 3/22/2015 03:28'!
addressBookNamespacedXML
	^ addressBookNamespacedXML
		ifNil: [addressBookNamespacedXML := self class addressBookNamespacedXML]! !

!XMLDOMParserTest methodsFor: 'source' stamp: 'monty 4/6/2015 06:32'!
internalSubsetWithDeclarations
	^ '<!!DOCTYPE root PUBLIC "pubid" "external.dtd" [
			<!!ELEMENT root ( #PCDATA | one | two)* >
			<!!ATTLIST root
						name CDATA #IMPLIED
						number ( one | two | three ) "three">
			<!!ENTITY general "replacement">
			<!!ENTITY externalGeneral PUBLIC "pubid2" "external1.dtd">
			<!!ENTITY % parameter "replacement">
			<!!ENTITY % externalParameter SYSTEM "external2.dtd">
			<!!NOTATION notation SYSTEM "note.doc">
		]>'! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/25/2014 04:46'!
testAllElementsNamespaceURIs
	| document people |

	document := XMLDOMParser parse: self addressBookNamespacedXML.

	people :=
		document
			allElementsNamed: 'person'
			namespaceURI: 'defaultNS'.
	self
		assert: people size = 4;
		assert:
			(document
				allElementsNamed: 'person'
				namespaceURI: 'undeclaredNS') isEmpty.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 10/24/2014 12:06'!
testAttributeNamespaces
	| document  people |

	document := XMLDOMParser parse: self addressBookNamespacePrefixedXML.
	people := document allElementsNamed: 'person' namespaceURI: 'personNS'.
	self assert: people notEmpty.
	
	people do: [:each |
		self
			assert: each hasAttributes;
			deny: each attributeNames isEmpty;
			assert:
				(each attributeNames allSatisfy: [:name |
					(each attributeNodeAt: name namespaceURI: 'defaultNS') isNil]);
			assert: (each attributeNodeAt: 'ps:family-name' namespaceURI: 'personNS') notNil;
			assert: (each attributeNodeAt: 'ps:first-name' namespaceURI: 'personNS') notNil].! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 10/24/2014 12:06'!
testAttributeNamespacesDisabled
	| document  people |

	document :=
		XMLDOMParser
			parse: self addressBookNamespacePrefixedXML
			usingNamespaces: false.
	people := document allElementsNamed: 'person'.
	self assert: people notEmpty.
	people do: [:each |
		self
			assert: each hasAttributes;
			deny: each attributeNames isEmpty;
			assert: (each attributeNodeAt: 'ps:family-name' namespaceURI: 'personNS') isNil;
			assert: (each attributeNodeAt: 'ps:first-name' namespaceURI: 'personNS') isNil].! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/25/2014 04:46'!
testAttributesExcludingDeclarations
	| document   |

	document := XMLDOMParser parse: self addressBookNamespacedXML.
	self deny: document root hasAttributes.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/25/2014 04:46'!
testAttributesIncludingDeclarations
	| document  root |

	document :=
		XMLDOMParser
			parse: self addressBookNamespacedXML
			usingNamespaces: false.
	root := document root.
	self
		assert: root hasAttributes;
		assert: (root attributeAt: 'xmlns') = 'defaultNS';
		assert: (root attributeAt: 'xmlns:book') = 'bookNS';
		assert: (root attributeAt: 'xmlns:ps') = 'personNS'.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 2/11/2014 00:22'!
testCDATASection
	| document element unescaped escaped xml |

	unescaped := 'this is CDATA test content 1 < 2 & 5 > 3'.
	escaped := 'this is CDATA test content 1 &lt; 2 &amp; 5 &gt; 3'.
	xml := 
		'<?xml version="1.0" encoding="UTF-8"?>
		<test-data>test<!![CDATA[', unescaped, ']]>test</test-data>'.
	document := XMLDOMParser parse: xml.
	element := document findElementNamed: 'test-data'.
	self
		assert: element nodes size = 1;
		assert: element firstNode isStringNode;
		assert: element firstNode printString = ('test', escaped, 'test').

	document :=
		(XMLDOMParser on: xml)
			preservesCDataNodes: true;
			parseDocument.
	element := document findElementNamed: 'test-data'.
	self
		assert: element nodes size = 3;
		assert: element nodes second isCData;
		assert: element nodes second printString = ('<!![CDATA[', unescaped, ']]>');
		assert: element strings asArray = (Array with: 'test' with: unescaped with: 'test').! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 10/24/2014 12:07'!
testChangingNamespaces
	| document people person |

	document := XMLDOMParser parse: self addressBookNamespacedXML.

	people := document allElementsNamed: 'person' namespaceURI: 'defaultNS'.
	(person := people third) prefix: 'ps'.
	self assert: person == (document findElementNamed: 'person' namespaceURI: 'personNS').
	self assert:
		(people copyWithout: person) =
			((document findElementNamed: 'addressbook') nodesSelect: [:each |
				each isElement and: [each namespaceURI = 'defaultNS']]).! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 12/21/2013 06:10'!
testCollectingParsedNodes
	| document firstPerson allNames |
	"self debug: #testParsing"

	document := XMLDOMParser parse: self addressBookXML.
	firstPerson := document findElementNamed: 'person'.

	allNames := #('person' 'contact-info' 'address' 'job-info' 'manager').
	self
		assert: (firstPerson allElementsCollect: [:each | each name]) asArray = allNames;
		assert: (firstPerson allElements collect: [:each | each name]) asArray = allNames;
		assert: (firstPerson nodesCollect: [:each | each name]) asArray = allNames allButFirst;
		assert: (firstPerson nodes collect: [:each | each name]) asArray = allNames allButFirst.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 3/12/2015 18:19'!
testDeclaringXMLNamespace
	| xmlNamespace elements |

	xmlNamespace :=XMLNamespaceScope xmlNamespaceURI.
	self deny:
		((XMLDOMParser parse: self addressBookNamespacedXML) root
			declaresPrefix: 'xml'
			uri: xmlNamespace).

	elements :=
		(XMLDOMParser parse:
			'<one><two xmlns:xml="', xmlNamespace, '"/><xml:three/></one>') allElements.
	self
		deny: (elements first declaresPrefix: 'xml' uri: xmlNamespace);
		assert: (elements second declaresPrefix: 'xml' uri: xmlNamespace);
		deny: (elements third declaresPrefix: 'xml' uri: xmlNamespace).! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/30/2014 21:42'!
testDisabledNamespacesAttributes
	| document |

	document :=
		XMLDOMParser
			parse: '<root xmlns:prefix="prefixNS" xmlns="defaultNS" name="value"/>'
			usingNamespaces: false.
	self
		assert: document root attributeNames asArray = #('xmlns:prefix' 'xmlns' 'name');
		assert: (document root attributeAt: 'xmlns:prefix') = 'prefixNS';
		assert: (document root attributeAt: 'xmlns') = 'defaultNS';
		assert: (document root attributeAt: 'name') = 'value'.! !

!XMLDOMParserTest methodsFor: 'tests - internal subset' stamp: 'monty 12/22/2013 06:22'!
testDoctypeDeclaration
	| doctype |

	doctype :=
		(XMLDOMParser
			parse: self internalSubsetWithDeclarations
			usingNamespaces: true
			validation: true
			externalEntities: false) doctypeDeclaration.
	self
		assert: doctype root = 'root';
		assert: doctype publicID = 'pubid';
		assert: doctype systemID = 'external.dtd';
		assert: doctype nodes notEmpty;
		assert: (doctype nodes allSatisfy: [:each | each isDeclaration]).! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 11/7/2014 14:53'!
testDocument
	| document root |

	document := XMLDOMParser parse: self addressBookXML.
	document allNodesDo: [:each | self assert: each document == document].

	root := document root.
	root innerXML: self addressBookXML.
	document allNodesDo: [:each | self assert: each document == document].

	document removeNode: root.
	root allNodesDo: [:each | self assert: each document isNil].! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 4/11/2015 01:06'!
testDocumentInternalSubset
	| document doctypeDeclaration |

	document := XMLDOMParser parse: self internalSubsetWithDeclarations.
	doctypeDeclaration := document doctypeDeclaration.
	doctypeDeclaration allNodesDo: [:each |
		self assert: each document == document].

	document doctypeDeclaration: nil.
	doctypeDeclaration allNodesDo: [:each |
		self assert: each document isNil].! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 10/29/2014 10:04'!
testElementNames
	| document root  persons |

	document := XMLDOMParser parse: self addressBookXML.
	root := document root.

	persons := 	root allNodesSelect: [:each |
			each isElement
				and: [(each isNamedAny: #('notperson' 'person'))
					and: [(each isNamed: 'person')
						and: [(each name = 'person') and: [each localName = 'person']]]]].
	self assert: persons size = 4.

	root allElementsNamed: 'person' do: [:p |
		self assert: (persons includes: p).
		persons remove: p].
	self assert: persons isEmpty.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/25/2014 04:44'!
testElementPrefixes
	| document  persons |

	document := XMLDOMParser parse: self addressBookNamespacePrefixedXML.
	persons := 	document allElementsSelect: [:each |
		(each isNamedAny: #('notperson' 'ps:person'))
			and: [(each isNamedAny: #('notperson' 'person'))
				and: [(each isNamed: 'person')
					and: [(each isNamed: 'ps:person')
						and: [(each name = 'ps:person') and: [each localName = 'person']]]]]].
	self assert: persons size = 4.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/25/2014 04:44'!
testElementPrefixesNamespacesDisabled
	| document  persons |

	document :=
		XMLDOMParser
			parse: self addressBookNamespacePrefixedXML
			usingNamespaces: false.
	persons := 	document allElementsSelect: [:each |
		(each isNamedAny: #('notperson' 'ps:person'))
			and: [(each isNamedAny: #('notperson' 'person'))
				and: [(each isNamed: 'person')
					and: [(each isNamed: 'ps:person')
						and: [(each name = 'ps:person') and: [each localName = 'person']]]]]].
	self assert: persons size = 4.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/25/2014 04:46'!
testFindElementNamespaceURI
	| document people |

	document := XMLDOMParser parse: self addressBookNamespacedXML.

	people := document allElementsNamed: 'person' namespaceURI: 'defaultNS'.
	self assert:
		(document
			findElementNamed: 'person'
			namespaceURI: 'defaultNS'
			with: [:each | (each attributeAt: 'employee-number') = 'A7987']) == people last.
	self assert:
		(document
			findElementNamed: 'person'
			namespaceURI: 'defaultNS'
			with: [:each | (each attributeAt: 'family-name') = 'Brown']) == people second.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/3/2015 01:09'!
testIgnorableWhitespacePreservation
	| xml document elements |

	xml :=
		'<one>
			<two>
					<three>
					test
					</three>
			</two>
		</one>'.
	document :=
		(XMLDOMParser on: xml)
			preservesIgnorableWhitespace: true;
			parseDocument.
	elements := document allElements.
	self
		assert: document allNodes size = 9;
		assert: elements size = 3.
	"avoid allButLastDo: for portability"
	elements allButLast do: [:each |
		self
			assert: each nodes size = 3;
			assert: (each firstNode isStringNode and: [each firstNode isWhitespace]);
			assert: (each lastNode isStringNode and: [each lastNode isWhitespace])].
	self
		assert: elements last nodes size = 1;
		assert: elements last firstNode isStringNode;
		deny: elements last firstNode isWhitespace.

	document :=
		(XMLDOMParser on: xml)
			preservesIgnorableWhitespace: false;
			parseDocument.
	elements := document allElements.
	self
		assert: document allNodes size = 5;
		assert: elements size = 3.
	elements do: [:each |
		self
			assert: each nodes size = 1;
			deny: (each firstNode isStringNode and: [each firstNode isWhitespace])].! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 12/13/2014 19:32'!
testInnerXML
	| document |

	document := XMLDOMParser parse: self addressBookXML.
	document allElementsNamed: 'person' do: [:person | | contactInfo address1 address2 |
		#('address' 'job-info' 'manager') do: [:each |
			self assert: (person elementAt: each) innerXML isEmpty].

		contactInfo := person elementAt: 'contact-info'.
		address1 := (person attributeAt: 'first-name'), '@example.com'.
		address2 := (person attributeAt: 'first-name'), '@users.example.com'.
		self
			assert: (contactInfo innerXML: '<email></email><email2/>') innerXML = '<email /><email2 />';
			assert: contactInfo elements size = 2;
			assert: (contactInfo elements first isNamed: 'email');
			assert: (contactInfo elements second isNamed: 'email2');
			assert: (contactInfo firstElement innerXML: address1, '<!!--ignored-->') innerXML = address1;
			assert: (contactInfo elements second innerXML: '<!![CDATA[', address2, ']]>') innerXML = address2.
		self assert:
			contactInfo innerXML = 
				('<email>', address1, '</email><email2>', address2, '</email2>')].! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 5/9/2015 23:34'!
testInnerXMLDocument
	| document |

	document := XMLDOMParser parse: self addressBookXMLWithDTD.
	self
		assert: ((document innerXML: '<new-root/>') root isNamed: 'new-root');
		assert: document innerXML = '<new-root />';
		assert: ((document root innerXML: 'test') contentString = 'test');
		assert: document root innerXML = 'test'.
	
	document := XMLDOMParser parse: self addressBookXMLWithDTD.
	self assert:
		(document innerXML: document innerXML) printString =
			(XMLDOMParser parse: self addressBookXMLWithDTD) printString.
	self
		should: [document innerXML: self addressBookXMLWithDTD]
		raise: XMLWellFormednessException.

	document := XMLDOMParser parse: '<root/>'.
	self
		should: [document innerXML: '<root1/><root2/>']
		raise: XMLWellFormednessException.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 5/10/2015 06:33'!
testInnerXMLEntities
	| document |

	document :=
		XMLDOMParser parse:
			'<!!DOCTYPE test [
					<!!ENTITY one "one">
					<!!ENTITY two "two">
				]>
			<test name="&one;">&one;</test>'.
	self
		assert: (document root attributeAt: 'name') = 'one';
		assert: document root contentString = 'one'.

	document innerXML: '<test name="&two;">&two;</test>'.
	self
		assert: (document root attributeAt: 'name') = 'two';
		assert: document root contentString = 'two'.

	self
		should: [document innerXML: '<test name="&three;"></test>']
		raise: XMLValidationException.
	self
		should: [document innerXML: '<test name="">&four;</test>']
		raise: XMLValidationException.! !

!XMLDOMParserTest methodsFor: 'tests - internal subset' stamp: 'monty 12/8/2014 11:05'!
testInternalAttributeDeclarations
	| doctype firstAttribute secondAttribute |

	doctype :=
		(XMLDOMParser
			parse: self internalSubsetWithDeclarations
			usingNamespaces: true
			validation: true
			externalEntities: false) doctypeDeclaration.

	firstAttribute := doctype nodes second.
	self
		assert: firstAttribute element = 'root';
		assert: firstAttribute attribute = 'name';
		assert: firstAttribute type = 'CDATA';
		assert: firstAttribute defaultPragma = 'IMPLIED';
		assert: firstAttribute defaultValue isEmpty.

	secondAttribute := doctype nodes third.
	self
		assert: secondAttribute element = 'root';
		assert: secondAttribute attribute = 'number';
		assert: secondAttribute type = '(one|two|three)';
		assert: secondAttribute defaultPragma isEmpty;
		assert: secondAttribute defaultValue = 'three'.! !

!XMLDOMParserTest methodsFor: 'tests - internal subset' stamp: 'monty 12/22/2013 06:22'!
testInternalElementDeclaration
	| doctype elementDeclaration |

	doctype :=
		(XMLDOMParser
			parse: self internalSubsetWithDeclarations
			usingNamespaces: true
			validation: true
			externalEntities: false) doctypeDeclaration.
	elementDeclaration := doctype nodes first.
	self
		assert: elementDeclaration element = 'root';
		assert: elementDeclaration contentModel = '(#PCDATA|one|two)*'.! !

!XMLDOMParserTest methodsFor: 'tests - internal subset' stamp: 'monty 12/21/2013 06:10'!
testInternalGeneralEntityDeclarations
	| doctype firstEntity secondEntity |

	doctype :=
		(XMLDOMParser
			parse: self internalSubsetWithDeclarations
			usingNamespaces: true
			validation: true
			externalEntities: false) doctypeDeclaration.

	firstEntity := doctype nodes fourth.
	self
		deny: firstEntity isParameter;
		assert: firstEntity name = 'general';
		assert: firstEntity replacement = 'replacement';
		assert: firstEntity publicID isEmpty;
		assert: firstEntity systemID isEmpty;
		assert: firstEntity ndata isEmpty.

	secondEntity := doctype nodes fifth.
	self
		deny: secondEntity isParameter;
		assert: secondEntity name = 'externalGeneral';
		assert: secondEntity replacement isEmpty;
		assert: secondEntity publicID = 'pubid2';
		assert: secondEntity systemID = 'external1.dtd';
		assert: secondEntity ndata isEmpty.! !

!XMLDOMParserTest methodsFor: 'tests - internal subset' stamp: 'monty 12/21/2013 06:09'!
testInternalNotationDeclarations
	| doctype notation |

	doctype :=
		(XMLDOMParser
			parse: self internalSubsetWithDeclarations
			usingNamespaces: true
			validation: true
			externalEntities: false) doctypeDeclaration.

	notation := doctype nodes eighth.
	self
		assert: notation name = 'notation';
		assert: notation publicID isEmpty;
		assert: notation systemID = 'note.doc'.! !

!XMLDOMParserTest methodsFor: 'tests - internal subset' stamp: 'monty 12/21/2013 06:09'!
testInternalParameterEntityDeclarations
	| doctype firstEntity secondEntity |

	doctype :=
		(XMLDOMParser
			parse: self internalSubsetWithDeclarations
			usingNamespaces: true
			validation: true
			externalEntities: false) doctypeDeclaration.

	firstEntity := doctype nodes sixth.
	self
		assert: firstEntity isParameter;
		assert: firstEntity name = 'parameter';
		assert: firstEntity replacement = 'replacement';
		assert: firstEntity publicID isEmpty;
		assert: firstEntity systemID isEmpty.

	secondEntity := doctype nodes seventh.
	self
		assert: secondEntity isParameter;
		assert: secondEntity name = 'externalParameter';
		assert: secondEntity replacement isEmpty;
		assert: secondEntity publicID isEmpty;
		assert: secondEntity systemID = 'external2.dtd'.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/25/2014 04:44'!
testNamespaces
	| document  |

	document := XMLDOMParser parse: self addressBookNamespacePrefixedXML.
	document allElementsDo: [:each |
		(each == document root or: [each isNamed: 'person'])
			ifTrue: [
				self assert: each hasPrefix.
				each == document root
					ifTrue: [
						self
							assert: each prefix = 'book';
							assert: each namespaceURI = 'bookNS']
					ifFalse: [
						self
							assert: each prefix = 'ps';
							assert: each namespaceURI = 'personNS']]
			ifFalse: [
				self
					assert: each namespaceURI = 'defaultNS';
					deny: each hasPrefix;
					assert: each prefix isEmpty]].! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 12/28/2014 23:42'!
testNamespacesCopyOnWrite
	| xml elements |

	xml := 
		'<one xmlns:prefix1="ns" xmlns="defualt">
			<two xmlns:prefix2="ns2"><three /></two>
			<four><five xmlns:prefix1="ns3" xmlns="defualt2" /></four>
		</one>'.
	elements := (XMLDOMParser parse: xml) allElements.
	self assert:
		(IdentitySet withAll:
			(elements collect: [:each |
				each namespaceScope prefixMappings])) size = 3.

	elements := (XMLDOMParser parse: xml usingNamespaces: false) allElements.
	self assert:
		(IdentitySet withAll:
			(elements collect: [:each |
				each namespaceScope prefixMappings])) size = elements size.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/25/2014 04:46'!
testNamespacesDeclaring
	| document |

	document := XMLDOMParser parse: self addressBookNamespacedXML.
	document allElementsDo: [:each |
		self assert: each hasNamespaces.
		each == document root
			ifTrue: [
				self
					assert: each declaresDefaultNamespace;
					assert: (each declaresPrefix: 'ps' uri: 'personNS')]
			ifFalse: [ 
				self
					deny: each declaresDefaultNamespace;
					deny: (each declaresPrefix: 'ps' uri: 'personNS')].
		self
			deny: (each declaresPrefix: 'undeclared' uri: 'undeclaredNS');
			deny: (each isDeclaredPrefix: 'undeclared');
			deny: (each isDeclaredPrefix: 'undeclared' uri: 'undeclaredNS');
			assert: (each isDeclaredPrefix: 'ps');
			assert: (each isDeclaredPrefix: 'ps' uri: 'personNS')].! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/25/2014 04:46'!
testNamespacesDeclaringDisabled
	| document |

	document := XMLDOMParser parse: self addressBookNamespacedXML usingNamespaces: false.
	document allElementsDo: [:each |
		self
			deny: each hasNamespaces;
			deny: each declaresDefaultNamespace;
			deny: (each declaresPrefix: 'ps' uri: 'personNS');
			deny: (each isDeclaredPrefix: 'ps');
			deny: (each isDeclaredPrefix: 'ps' uri: 'personNS')].! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/25/2014 04:44'!
testNamespacesDisabled
	| document |

	document :=
		XMLDOMParser
			parse: self addressBookNamespacePrefixedXML
			usingNamespaces: false.
	document allElementsDo: [:each |
		self assert: each namespaceURI isEmpty.
		(each == document root or: [each isNamed: 'person'])
			ifTrue: [
				self
					assert: each hasPrefix;
					assert:
						each prefix =
							((each == document root) ifTrue: ['book'] ifFalse: ['ps'])]
			ifFalse: [
				self
					deny: each hasPrefix;
					assert: each prefix isEmpty]].! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/25/2014 04:46'!
testNamespacesResolving
	| document |

	document := XMLDOMParser parse: self addressBookNamespacedXML.
	document allElementsDo: [:each |
		self
			assert: each defaultNamespace = 'defaultNS';
			assert: (each resolvePrefix: '') = 'defaultNS';
			assert: (each resolvePrefix: 'book') = 'bookNS';
			assert: (each resolvePrefix: 'ps') = 'personNS';
			assert:
				each namespaceURI =
					(each hasPrefix
						ifTrue: [each resolvePrefix: each prefix]
						ifFalse: [each defaultNamespace])]! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/25/2014 04:46'!
testNamespacesResolvingDisabled
	| document |

	document :=
		XMLDOMParser
			parse: self addressBookNamespacedXML
			usingNamespaces: false.
	document allElementsDo: [:each |
		self
			assert: each defaultNamespace isEmpty;
			assert: (each resolvePrefix: '') isEmpty;
			assert: (each resolvePrefix: 'book') isEmpty;
			assert: (each resolvePrefix: 'ps') isEmpty;
			assert:
				each namespaceURI =
					(each hasPrefix
						ifTrue: [each resolvePrefix: each prefix]
						ifFalse: [each defaultNamespace])]! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 12/21/2013 06:21'!
testNodeDetecting
	| document people |

	document := XMLDOMParser parse: self addressBookXML.
	people := document root elementsAt: 'person'.
	self assert:
		((document findElementNamed: 'addressbook') nodesDetect: [:each |
			each isElement and: [(each attributeAt: 'family-name') = 'Brown']]) == people second.
	self assert:
		((document findElementNamed: 'addressbook')
			nodesDetect: [:each | each isElement and: [(each attributeAt: 'unknown') = 'Brown']]
			ifNone: ['not found']) = 'not found'.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 12/12/2013 01:06'!
testNodeListClass
	| document parser listClass |

	listClass := XMLCachingNodeList.
	document :=
		(parser := XMLDOMParser on: self addressBookXML)
			nodeListClass: listClass;
			parseDocument.

	self
		assert: parser nodeListClass == listClass;
		assert: document nodes class == listClass;
		assert: (document allElements allSatisfy: [:each | each nodes class == listClass]).! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 10/13/2014 01:37'!
testOverridingDefaultNamespace
	| document |

	document := XMLDOMParser parse: '<outer xmlns="default"><inner xmlns=""/></outer>'.
	self
		assert: document root namespaceURI = 'default';
		assert: document root defaultNamespace = 'default';
		assert: document root firstNode namespaceURI isEmpty;
		assert: document root firstNode defaultNamespace isEmpty.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 11/26/2014 21:28'!
testParseDocumentUntil
	| i document |

	self
		shouldnt: [
			i := 0.
			document :=
				(XMLDOMParser on: '<root><one>two<#malformed')
					parseDocumentUntil: [(i := i + 1) > 4]]
		raise: XMLWellFormednessException.
	self
		assert: document allNodes size = 4;
		assert: (document findElementNamed: 'one') nodes size = 1;
		assert: (document findElementNamed: 'one') contentString = 'two'.
	self
		should: [
			i := 0.
			(XMLDOMParser on: '<root><one>two<#malformed')
				parseDocumentUntil: [(i := i + 1) > 5]]
		raise: XMLWellFormednessException.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 10/14/2014 23:11'!
testParseDocumentWhile
	| i document |

	self
		shouldnt: [
			i := 0.
			document :=
				(XMLDOMParser on: '<root><one>two<#malformed')
					parseDocumentWhile: [(i := i + 1) <= 4]]
		raise: XMLWellFormednessException.
	self
		assert: document allNodes size = 4;
		assert: (document findElementNamed: 'one') nodes size = 1;
		assert: (document findElementNamed: 'one') contentString = 'two'.
	self
		should: [
			i := 0.
			(XMLDOMParser on: '<root><one>two<#malformed')
				parseDocumentWhile: [(i := i + 1) <= 5]]
		raise: XMLWellFormednessException.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 10/29/2014 13:54'!
testParsedElementNames
	| document |

	document := XMLDOMParser parse: self addressBookNamespacePrefixedXML.
	self assert:
		document elementNames =
			(document elements collect: [:each | each name ]).

	document allElementsDo: [:element |
		self assert:
			element elementNames =
				(element elements collect: [:each | each name])].! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 12/12/2013 00:41'!
testParsingAttributes
	| document firstPerson  |

	document := XMLDOMParser parse: self addressBookXML.
	firstPerson := document findElementNamed: 'person'.
	self
		assert: (firstPerson attributeAt: 'employee-number') = 'A0000';
		assert: (firstPerson attributeAt: 'family-name') = 'Gates';
		assert: (firstPerson attributeAt: 'first-name') = 'Bob';
		assert:
			firstPerson attributeNames asArray =
				#('employee-number' 'family-name' 'first-name');
		assert: firstPerson attributeAssociations asArray =
			{('employee-number'->'A0000'). ('family-name'->'Gates'). ('first-name'->'Bob').}.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 12/12/2013 00:42'!
testParsingRoot
	| document root  |

	document := XMLDOMParser parse: self addressBookXML.
	self assert: (document isKindOf: XMLDocument).
	root := document root.
	self assert: (root class == XMLElement).

	self assert:
		(root allNodesDetect: [:each |
			each isElement
				and: [each isNamedAny: #('AddressBook' 'addressbook')]]) == root.
	self assert: (root findElementNamed: 'addressbook') == root.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 3/22/2015 17:36'!
testPreservingCommentNodes
	| document comment|

	document := XMLDOMParser parse: self addressBookXML.
	self deny: (document findElementNamed: 'contact-info') hasChildren.

	document :=
		(XMLDOMParser on: self addressBookXML)
			preservesCommentNodes: true;
			parseDocument.
	comment := (document findElementNamed: 'contact-info') firstNode.
	self
		assert: comment notNil;
		assert: comment string = 'Confidential'.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/6/2015 05:00'!
testUnreplacedEntityRererencePrinting
	| xml |

	xml :=
		'<one two="&quot;&three;&quot;">',
		'&lt;four five=&#34;&amp;six;&#34;/&gt;',
		'</one>'.
	self assert:
		((XMLDOMParser on: xml)
			isValidating: false;
			replacesContentEntityReferences: false;
			parseDocument) printString = xml.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 11/12/2014 23:43'!
testXMLDeclaration
	| document |

	document := XMLDOMParser parse: '<?xml version="1.0" encoding="UTF-8"?>'.
	self
		assert: document version = 1.0;
		assert: document encoding = 'UTF-8';
		deny: document isStandalone.

	document := XMLDOMParser parse: '<?xml version="1.1" encoding="utf-8" standalone="yes"?>'.
	self
		assert: document version = 1.1;
		assert: document encoding = 'utf-8';
		assert: document isStandalone.! !

!XMLParserTest class methodsFor: 'source' stamp: 'monty 1/12/2014 23:36'!
addressBookXML
	^'<addressbook>
  <person employee-number="A0000" family-name="Gates" first-name="Bob">
    <contact-info><!!--Confidential--></contact-info>
    <address city="Los Angeles" number="1239" state="CA" street="Pine Rd."/>
    <job-info employee-type="Full-Time" is-manager="no" job-description="Manager"/>
    <manager employee-number="A0000"/>
  </person>
  <person employee-number="A7000" family-name="Brown"
    first-name="Robert" middle-initial="L.">
    <contact-info>
      <email address="robb@iro.ibm.com"/>
      <home-phone number="03-3987873"/>
    </contact-info>
    <address city="New York" number="344" state="NY" street="118 St."/>
    <job-info employee-type="Full-Time" is-manager="yes" job-description="Group Leader"/>
    <manager employee-number="A0000"/>
  </person>
  <person employee-number="A7890" family-name="DePaiva"
    first-name="Kassie" middle-initial="W.">
    <contact-info><!!-- Kassie''s agent phone: 03-987654 --></contact-info>
    <address city="Los Angeles" number="1234" state="CA" street="Pine Rd."/>
    <job-info employee-type="Full-Time" is-manager="no" job-description="Actor"/>
    <manager employee-number="A0000"/>
    <misc-info>One of the most talented actresses on Daytime. Kassie
      plays the devious and beautiful Blair Cramer on ABC&apos;s
      &quot;One Life To Live.&quot;</misc-info>
  </person>
  <person employee-number="A7987" family-name="Smith" first-name="Joe">
    <contact-info>
      <email address="joes@iro.ibm.com"/>
      <mobile-phone number="888-7657765"/>
      <home-phone number="03-8767898"/>
      <home-phone number="03-8767871"/>
    </contact-info>
    <address city="New York" number="12789" state="NY" street="W. 15th Ave."/>
    <job-info employee-type="Part-Time" is-manager="no" job-description="Hacker"/>
    <manager employee-number="A7000"/>
  </person>
</addressbook>
'! !

!XMLParserTest class methodsFor: 'source' stamp: 'monty 1/12/2014 23:36'!
addressBookXMLWithDTD
	^'<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE addressbook SYSTEM "addressbook.dtd">
<?xml-stylesheet type="text/xsl" href="demo.xsl"?>
<addressbook>
  <person employee-number="A0000" family-name="Gates" first-name="Bob">
    <contact-info><!!--Confidential--></contact-info>
    <address city="Los Angeles" number="1239" state="CA" street="Pine Rd."/>
    <job-info employee-type="Full-Time" is-manager="no" job-description="Manager"/>
    <manager employee-number="A0000"/>
  </person>
  <person employee-number="A7000" family-name="Brown"
    first-name="Robert" middle-initial="L.">
    <contact-info>
      <email address="robb@iro.ibm.com"/>
      <home-phone number="03-3987873"/>
    </contact-info>
    <address city="New York" number="344" state="NY" street="118 St."/>
    <job-info employee-type="Full-Time" is-manager="yes" job-description="Group Leader"/>
    <manager employee-number="A0000"/>
  </person>
  <person employee-number="A7890" family-name="DePaiva"
    first-name="Kassie" middle-initial="W.">
    <contact-info><!!-- Kassie''s agent phone: 03-987654 --></contact-info>
    <address city="Los Angeles" number="1234" state="CA" street="Pine Rd."/>
    <job-info employee-type="Full-Time" is-manager="no" job-description="Actor"/>
    <manager employee-number="A0000"/>
    <misc-info>One of the most talented actresses on Daytime. Kassie
      plays the devious and beautiful Blair Cramer on ABC&apos;s
      &quot;One Life To Live.&quot;</misc-info>
  </person>
  <person employee-number="A7987" family-name="Smith" first-name="Joe">
    <contact-info>
      <email address="joes@iro.ibm.com"/>
      <mobile-phone number="888-7657765"/>
      <home-phone number="03-8767898"/>
      <home-phone number="03-8767871"/>
    </contact-info>
    <address city="New York" number="12789" state="NY" street="W. 15th Ave."/>
    <job-info employee-type="Part-Time" is-manager="no" job-description="Hacker"/>
    <manager employee-number="A7000"/>
  </person>
</addressbook>
'! !

!XMLParserTest methodsFor: 'source' stamp: 'monty 1/12/2014 23:36'!
addressBookXML
	^ self class addressBookXML! !

!XMLParserTest methodsFor: 'source' stamp: 'monty 1/12/2014 23:37'!
addressBookXMLWithDTD
	^ self class addressBookXMLWithDTD! !

!XMLParserTest methodsFor: 'benchmark' stamp: 'JAA 3/24/2011 18:26'!
benchmark1
	"
	XMLParserTest new benchmark1
	600 timesRepeat => 2131 (Alexandre Bergel 3/29/2010 09:09)
	"
	Smalltalk garbageCollect.
	^ [4000 timesRepeat: [SAXHandler parse: self addressBookXML]] timeToRun! !

!XMLParserTest methodsFor: 'benchmark' stamp: 'JAA 3/24/2011 18:26'!
benchmark2
	"
	XMLParserTest new benchmark2
	"
	Smalltalk garbageCollect.
	^ [4000 timesRepeat: [XMLDOMParser parse: self addressBookXML]] timeToRun! !

!XMLParserTest methodsFor: 'benchmark' stamp: 'monty 2/6/2014 19:17'!
benchmark3
	"
	XMLParserTest new benchmark3
	"
	Smalltalk garbageCollect.
	^ [4000 timesRepeat: [XMLDOMParser parse: self addressBookXMLWithDTD]] timeToRun! !

!XMLParserTest methodsFor: 'benchmark' stamp: 'monty 11/16/2013 07:34'!
benchmark4
	| doc |
	"
	XMLParserTest new benchmark4
	"
	doc := XMLDOMParser
		parse: self addressBookXML readStream
		usingNamespaces: false.
	^ [500000 timesRepeat: [
		doc root firstElement
			elementAt: 'contact-info';
			elementAt: 'address';
			elementAt: 'job-info';
			elementAt: 'manager']] timeToRun.! !

!XMLParserTest methodsFor: 'source' stamp: 'monty 12/19/2013 02:04'!
elementDeclarationsNamed: aNameCollection
	| stream |

	stream := String new writeStream.
	aNameCollection do: [:each |
		stream
			nextPutAll: '<!!ELEMENT ';
			nextPutAll: each;
			nextPutAll: ' EMPTY>';
			cr].
	^ stream contents.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/4/2015 07:02'!
testAttributeDeclarationWhitespace
	#('<!!DOCTYPE test [<!!ATTLISTtest name (value) #FIXED "value">]>'
		'<!!DOCTYPE test [<!!ATTLIST test name(value) #FIXED "value">]>'
		'<!!DOCTYPE test [<!!ATTLIST test name (value)#FIXED "value">]>'
		'<!!DOCTYPE test [<!!ATTLIST test name (value) #FIXED"value">]>'
		'<!!DOCTYPE test [<!!ATTLIST test name (value) #FIXED "value"name2
			(value) #FIXED "value">]>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException].
	#('<!!DOCTYPE test [<!!ATTLIST   test   name  ( value )  #FIXED  "value">]>'
		'<!!DOCTYPE test [
			<!!ATTLIST test
				name (value) #FIXED "value"
				name2 (value) #FIXED "value">]>'
		'<!!DOCTYPE test [<!!ATTLIST   test   >]>')
		do: [:each |
			self
				shouldnt: [SAXHandler parse: each]
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/19/2014 17:11'!
testAttributeDefaultDeclaration
	| dtd document |

	dtd := '
		<!!DOCTYPE root [
		<!!ELEMENT root EMPTY>
		<!!ATTLIST root one CDATA #IMPLIED
						two CDATA #REQUIRED
						three CDATA #FIXED "fixedDefault"
						three CDATA #FIXED "redundant"
						four CDATA "default" >]>'.
	document := XMLDOMParser parse: dtd, '<root two=''required'' />'.
	self
		assert: (document root attributeAt: 'two') = 'required';
		deny: (document root includesAttribute: 'one');
		assert: (document root attributeAt: 'three') = 'fixedDefault';
		assert: (document root attributeAt: 'four') = 'default'.
	self
		should: [SAXHandler parse: dtd, '<root />'] raise: XMLValidationException;
		should: [SAXHandler parse: dtd, '<root three="nonDefault"/>'] raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 1/3/2015 02:58'!
testAttributeEntityDeclaration
	| dtd |

	dtd := '<!!DOCTYPE root [
		<!!NOTATION first SYSTEM "first.txt">
		<!!NOTATION second SYSTEM "second.txt">
		<!!ENTITY firstEntity SYSTEM "first.txt" NDATA first>
		<!!ENTITY secondEntity SYSTEM "second.txt" NDATA second>
		<!!ELEMENT root EMPTY>
		<!!ATTLIST root
			unparsedEntity ENTITY #IMPLIED
			unparsedEntities ENTITIES #IMPLIED>]>'.
	self
		shouldnt: [
			SAXHandler parse:
				dtd, '<root unparsedEntity="firstEntity"  unparsedEntities="firstEntity  secondEntity"/> ']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root unparsedEntity="thirdEntity"/>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root unparsedEntity="secondEntity thirdEntity"/>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/18/2013 19:18'!
testAttributeEnumerationDeclaration
	| dtd |

	dtd := '<!!DOCTYPE root [
		<!!NOTATION txtFile PUBLIC "//file.txt//">
		<!!NOTATION confFile PUBLIC "//file.conf//">
		<!!ELEMENT root EMPTY>
		<!!ATTLIST root
			number ( one | two | three) #IMPLIED
			note NOTATION (txtFile | confFile ) #IMPLIED>]>'.
	self
		shouldnt: [SAXHandler parse: dtd, '<root number="two" note="txtFile"/>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root number="four"/>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root note="htmlFile" />']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/18/2013 19:19'!
testAttributeIDDeclaration
	| dtd |

	dtd := '<!!DOCTYPE root [
		<!!ELEMENT root (unique|unique2)+>
		<!!ELEMENT unique EMPTY>
		<!!ELEMENT unique2 EMPTY>
		<!!ATTLIST unique id ID #REQUIRED>
		<!!ATTLIST unique2 id ID #REQUIRED>]>'.
	self
		shouldnt: [
			SAXHandler parse:
				dtd, '<root><unique id=" one "/><unique id="two"/><unique2 id="three"/></root> ']
		raise:XMLValidationException.
	self
		should: [
			SAXHandler parse:
				dtd, '<root><unique id="one"/><unique id=" one "/></root> ']
		raise: XMLValidationException.
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE root [
					<!!ATTLIST unique
						id ID #REQUIRED
						id2 ID #REQUIRED>]>
					<root/>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/18/2013 19:54'!
testAttributeIDRefDeclaration
	| dtd |

	dtd := '<!!DOCTYPE root [
		<!!ELEMENT root (unique|ref|refs)+>
		<!!ELEMENT unique EMPTY>
		<!!ELEMENT ref EMPTY>
		<!!ELEMENT refs EMPTY>
		<!!ATTLIST unique id ID #REQUIRED>
		<!!ATTLIST ref idref IDREF #REQUIRED>
		<!!ATTLIST refs idrefs IDREFS #REQUIRED>]>'.
	XMLDOMParser parse:
		dtd, '<root>
		<unique id=" one "/><unique id=" two "/>
		<ref idref="one"/><refs idrefs="  one  two"/>
		</root> '.
	self
		should: [
			XMLDOMParser parse:
				dtd, '<root><unique id="one"/><ref idref="two"/></root> ']
		raise: XMLValidationException.
	self
		should: [
			XMLDOMParser parse:
				dtd, '<root><unique id="one"/><refs idrefs="one two"/></root> ']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/29/2013 00:58'!
testAttributeNmtokenDeclaration
	| dtd |

	dtd := '<!!DOCTYPE root [
		<!!ELEMENT root ANY>
		<!!ATTLIST root name NMTOKEN #IMPLIED>
		<!!ATTLIST root names NMTOKENS #IMPLIED>]>'.
	self
		shouldnt: [SAXHandler parse: dtd, '<root name=" one " names="  one  two three "/> ']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root name="#" names="one two"/>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root name="one" names="# #" />']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/19/2013 05:55'!
testAttributeValueNormalization
	| separators unnormalized normalized document |

	separators :=
		String
			with: Character space
			with: Character tab
			with: Character lf.
	unnormalized := separators, 'nonspace', separators.
	normalized := '   nonspace   '.
	document :=
		(XMLDOMParser parse:
			'<root name="', unnormalized,'">', unnormalized, '</root>').
	self
		assert: (document root attributeAt: 'name') = normalized;
		assert: (document root contentString) = unnormalized.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/22/2015 15:11'!
testAttributeValueWithAngleBrackets
	self
		should: [SAXHandler parse: '<test name="<test name=''value''/>"/>']
		raise: XMLWellFormednessException.
	self
		shouldnt: [SAXHandler parse: '<test name="&lt;test name=''value''/>"/>']
		raise: XMLWellFormednessException.
	self
		shouldnt: [SAXHandler parse: '<test name=''&lt;test name="value"/>''/>']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/12/2015 10:20'!
testComments
	self
		shouldnt: [SAXHandler parse: '<test><!!-- <comment/> - - --></test>']
		raise: XMLWellFormednessException.
	"can't contain --"
	self
		should: [SAXHandler parse: '<test><!!-- <comment/> -- --></test>']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/23/2015 18:46'!
testConditionalSectionInInternalSubset
	#('<!![INCLUDE[ <!!-- comment --> ]]>'
		'<!![IGNORE[ <!!-- comment --> ]]>'
		'<!!ENTITY % include "INCLUDE"> <!![%include;[ <!!-- comment --> ]]>'
		'<!!ENTITY % ignore "IGNORE"> <!![%ignore;[ <!!-- comment --> ]]>'
		) do: [:each |
			self
				should: [SAXHandler parse:'<!!DOCTYPE test [', each, ']>']
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 5/3/2015 16:47'!
testConditionalSectionLabelReplacementIgnore
	#('<!!ENTITY % label "{1}">
		<!![%label;[ <malformed-xml/> ]]>'
		'<!!ENTITY % label "{1}">
		<!![ %label; [ <malformed-xml/> ]]>'
		) do: [:each |
		self
			should: [
				(SAXHandler on: (each format: (Array with: 'INCLUDE')))
					parser
						context: XMLExternalSubsetContext new;
						parseDocument]
			raise: XMLWellFormednessException.
		self
			shouldnt: [
				(SAXHandler on: (each format: (Array with: 'IGNORE')))
					parser
						context: XMLExternalSubsetContext new;
						parseDocument]
			raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 5/3/2015 16:47'!
testConditionalSectionLabelReplacementInclude
	#('<!!ENTITY % label "{1}">
		<!![%label;[
			<!!ENTITY % comment "<!!--comment-->">
		]]> %comment;'
		'<!!ENTITY % label "{1}">
		<!![ %label; [
			<!!ENTITY % comment "<!!--comment-->">
		]]> %comment;'
	) do: [:each |
		self
			shouldnt: [
				(SAXHandler on: (each format: (Array with: 'INCLUDE')))
					parser
						context: XMLExternalSubsetContext new;
						parseDocument]
			raise: XMLValidationException.
		self
			should: [
				(SAXHandler on: (each format: (Array with: 'IGNORE')))
					parser
						context: XMLExternalSubsetContext new;
						parseDocument]
			raise: XMLValidationException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 5/3/2015 16:47'!
testConditionalSectionMixedIncludeIgnore
	| xml |

	xml := '
		<!![INCLUDE[
			<!![IGNORE[ %comment; ]]>
			<!!ENTITY % comment "<!!--comment]]>-->">
			<!![INCLUDE[
				<!![IGNORE[ %commentTwo; ]]>
				<!!ENTITY % commentTwo "<!!--comment]]>-->">
				%commentTwo;
			]]>
			%comment;
			%commentTwo;
		]]>
		%comment;
		%commentTwo;'.
	self
		shouldnt: [
			(SAXHandler on: xml) parser
				context: XMLExternalSubsetContext new;
				parseDocument]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 5/3/2015 16:47'!
testConditionalSectionNestedIgnores
	| xml |

	xml := '
		<!![ IGNORE [
			<!!--ignored terminator {1} -->
			<!![ INCLUDE [
				<!!ENTITY % comment "<!!--ignored terminator {1} -->">
				%comment;
			]]>
			%comment;
		]]>'.
	self
		shouldnt: [
			(SAXHandler on: (xml format: (Array with: ']]')))
				parser
					context: XMLExternalSubsetContext new;
					parseDocument]
		raise: XMLWellFormednessException.
	self
		should: [
			(SAXHandler on: (xml format: (Array with: ']]>')))
				parser
					context: XMLExternalSubsetContext new;
					parseDocument]
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 5/3/2015 16:47'!
testConditionalSectionNestedIncludes
	| xml |

	xml := '
		<!![ INCLUDE [
			<!!--ignored terminator ]]> -->
			<!![ INCLUDE [
				<!!ENTITY % comment "<!!--ignored terminator ]]> -->">
				%comment;
			]]>
			%comment;
		]]>
		%comment;'.
	self
		shouldnt: [
			(SAXHandler on: xml) parser
				context: XMLExternalSubsetContext new;
				parseDocument]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 5/3/2015 16:47'!
testConditionalSectionUnterminatedIignores
	#('<!![IGNORE['
		'<!![IGNORE[<!!--comment-->'
		'<!![IGNORE[<!!--comment--><!![IGNORE['
		'<!![IGNORE[<!!--comment--><!![IGNORE[ ]]>'
	) do: [:each |
		self
			should: [
				(SAXHandler on: each) parser
					context: XMLExternalSubsetContext new;
					parseDocument]
			raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 5/3/2015 16:47'!
testConditionalSectionUnterminatedIncludes
	#('<!![INCLUDE['
		'<!![INCLUDE[<!!--comment-->'
		'<!![INCLUDE[<!!--comment--><!![INCLUDE['
		'<!![INCLUDE[<!!--comment--><!![INCLUDE[ ]]>'
	) do: [:each |
		self
			should: [
				(SAXHandler on: each) parser
					context: XMLExternalSubsetContext new;
					parseDocument]
			raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 10/9/2014 00:55'!
testDeclaringNamespaces
	self
		shouldnt: [SAXHandler parse: '<prefix:root prefix:name="test" xmlns:prefix="NS"/>']
		raise: XMLNamespaceException.
	self
		shouldnt: [SAXHandler parse: '<root xmlns="defaultNS"/>']
		raise: XMLNamespaceException.
	self
		shouldnt: [SAXHandler parse: '<root xmlns=""/>' usingNamespaces: true]
		raise: XMLNamespaceException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 10/9/2014 20:40'!
testDeclaringNamespacesBadPrefixes
	self
		should: [SAXHandler parse: '<root xmlns:invalid:prefix="invalidNS"/>']
		raise: XMLNamespaceException.
	self
		should: [SAXHandler parse: '<root xmlns::invalidprefix="invalidNS"/>']
		raise: XMLNamespaceException.
	self
		should: [SAXHandler parse: '<root xmlns:invalidprefix:="invalidNS"/>']
		raise: XMLNamespaceException.
	self
		should: [SAXHandler parse: '<:invalidname />']
		raise: XMLNamespaceException.
	self
		should: [SAXHandler parse: '<invalidname: />']
		raise: XMLNamespaceException.
	self
		should: [SAXHandler parse: '<root :invalidname="test" />']
		raise: XMLNamespaceException.
	self
		should: [SAXHandler parse: '<root invalidname:="test" />']
		raise: XMLNamespaceException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 10/9/2014 00:58'!
testDeclaringNamespacesBadURIs
	self
		should: [SAXHandler parse: '<root xmlns:empty=""/>' usingNamespaces: true]
		raise: XMLNamespaceException.

	"Cannot change xmlns or xml prefixes"
	self
		should: [SAXHandler parse: '<root xmlns:xmlns="newNS"/>' usingNamespaces: true]
		raise: XMLNamespaceException.
	self
		should: [SAXHandler parse: '<root xmlns:xml="newNS" />' usingNamespaces: true]
		raise: XMLNamespaceException.

	"Redundant xml prefix mapping is ok, but xmlns is not"
	self
		shouldnt: [
			SAXHandler
				parse: '<root xmlns:xml="', XMLNamespaceScope xmlNamespaceURI, '"/>'
				usingNamespaces: true]
		raise: XMLNamespaceException.
	self
		should: [
			SAXHandler
				parse: '<root xmlns:xmlns="', XMLNamespaceScope xmlnsNamespaceURI, '"/>'
				usingNamespaces: true]
		raise: XMLNamespaceException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/7/2015 05:17'!
testDefaultDocumentURI
	| cwd documentURI |

	documentURI := (SAXHandler on: '' documentURI: 'test/test.xml') documentURI.
	self assert: documentURI = 'test/test.xml'.

	cwd := XMLFileHandle currentWorkingDirectory.
	documentURI := (SAXHandler on: '') documentURI.
	self
		assert: documentURI size > (cwd size + 1);
		assert: (documentURI copyUpToLast: $/) = cwd.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/6/2015 05:22'!
testDoctypeDeclarationInContent
	self
		should: [SAXHandler parse: '<test><!!DOCTYPE test></test>']
		raise: XMLWellFormednessException.
	self
		shouldnt: [SAXHandler parse: '<!!DOCTYPE test><test></test>']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/6/2015 05:24'!
testDoctypeDeclarationRoot
	| xmlWithInvalidRoot xmlWithValidRoot |

	xmlWithInvalidRoot := '<!!DOCTYPE root><invalidRoot/>'.
	xmlWithValidRoot := '<!!DOCTYPE root><root/>'.
	self
		should: [SAXHandler parse: xmlWithInvalidRoot]
		raise: XMLValidationException.
	self
		shouldnt: [
			SAXHandler
				parse: xmlWithInvalidRoot
				usingNamespaces: false
				validation: false]
		raise: XMLValidationException.
	self
		shouldnt: [SAXHandler parse: xmlWithValidRoot]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/6/2015 05:24'!
testDoctypeDeclarationWhitespace
	#('<!!DOCTYPEtest>'
		'<!!DOCTYPE test PUBLIC"publicid">'
		'<!!DOCTYPE test PUBLIC "publicid""systemid">'
		'<!!DOCTYPE test SYSTEM"systemid">')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException].
	#('<!!DOCTYPE test PUBLIC "publicid" "systemid"	 >'
		'<!!DOCTYPE test SYSTEM "systemid"	>')
		do: [:each |
			self
				shouldnt: [SAXHandler parse: each]
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/2/2014 18:27'!
testElementAnyDeclarations
	self
		shouldnt: [
			SAXHandler parse: 
				'<!!DOCTYPE one [
					<!!ELEMENT one ANY>
					<!!ELEMENT two ANY>]>
				<one>one<two><!![CDATA[two]]><two/></two>three</one>']
		raise: XMLValidationException.
	self
		shouldnt: [
			SAXHandler parse: 
				'<!!DOCTYPE root [
					<!!ELEMENT root ANY>
					<!!ELEMENT two ANY>]>
				<root><two></two></root>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/27/2013 07:10'!
testElementContentModelsBranching
	| dtd |

	dtd := '<!!DOCTYPE root [',
		(self elementDeclarationsNamed: #('one' 'two' 'three' 'four' 'five')),
		'<!!ELEMENT root ((one|two),(three|four|five))>]>'.

	self
		shouldnt: [
			SAXHandler
				parse: dtd, '<root><one/><three/></root>';
				parse: dtd, '<root><one/><four/></root>';
				parse: dtd, '<root><one/><five/></root>';
				parse: dtd, '<root><two/><three/></root>';
				parse: dtd, '<root><two/><four/></root>';
				parse: dtd, '<root><two/><five/></root>']
		raise: XMLValidationException.

	self
		should: [SAXHandler parse: dtd, '<root><one/><two/><three/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><one/><three/><four/><five/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><one/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><four/></root>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 10/22/2014 09:58'!
testElementContentModelsManyBranches
	| dtd names |

	names := (1 to: 50) collect: [:each | 'element', each printString].
	dtd := String streamContents: [:stream |
		stream
			nextPutAll: '<!!DOCTYPE root [';
			nextPutAll: (self elementDeclarationsNamed: names);
			nextPutAll: '<!!ELEMENT root ('.
		names
			do: [:each | stream nextPutAll: each]
			separatedBy: [stream nextPut: $|].
		stream nextPutAll: ')>]>'].

	names do: [:each |
		self
			shouldnt: [SAXHandler parse: dtd, '<root><', each, '/></root>']
			raise: XMLValidationException].
	self
		should: [
			SAXHandler parse:
				dtd, '<root><element', (names size + 1) printString, '/></root>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/27/2013 16:12'!
testElementContentModelsOptional
	| dtd |

	dtd := '<!!DOCTYPE root [',
		(self elementDeclarationsNamed: #('one' 'two' 'three' 'four' 'five')),
		'<!!ELEMENT root (one?,two,three?,(four?, five)?)>]>'.

	self
		shouldnt: [
			SAXHandler
				parse: dtd, '<root><one/><two/><three/><four/><five/></root>';
				parse: dtd, '<root><two/><three/></root>';
				parse: dtd, '<root><one/><two/><three/><five/></root>';
				parse: dtd, '<root><two/></root>';
				parse: dtd, '<root><one/><two/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><one/><three/><four/><five/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><one/><two/><three/><four/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><one/><two/><three/><five/><four/></root>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/28/2013 02:01'!
testElementContentModelsOptionalBranching
	| dtd |

	dtd := '<!!DOCTYPE root [',
		(self elementDeclarationsNamed: #('one' 'two' 'three' 'four' 'five' 'six')),
		'<!!ELEMENT root (((one,two)|(three,four)),five?)>]>'.

	self
		shouldnt: [
			SAXHandler
				parse: dtd, '<root><one/><two/><five/></root>';
				parse: dtd, '<root><three/><four/><five/></root>';
				parse: dtd, '<root><one/><two/></root>';
				parse: dtd, '<root><three/><four/></root>']
		raise: XMLValidationException.

	self
		should: [SAXHandler parse: dtd, '<root><three/><five/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><one/><five/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><five/></root>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/28/2013 01:36'!
testElementContentModelsOptionalEmpty
	| dtd |

	dtd := '<!!DOCTYPE root [',
		(self elementDeclarationsNamed: #('one' 'two' 'three')),
		'<!!ELEMENT root (one?,two)?>]>'.

	self
		shouldnt: [
			SAXHandler
				parse: dtd, '<root><one/><two/></root>';
				parse: dtd, '<root><two/></root>';
				parse: dtd, '<root></root>']
		raise: XMLValidationException.

	self
		should: [SAXHandler parse: dtd, '<root><one/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><three/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><one/><one/></root>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/27/2013 08:40'!
testElementContentModelsPlus
	| dtd |

	dtd := '<!!DOCTYPE root [',
		(self elementDeclarationsNamed: #('one' 'two' 'three' 'four' 'five')),
		'<!!ELEMENT root ((one?,two)+,three,four+,five)>]>'.

	self
		shouldnt: [
			SAXHandler
				parse: dtd, '<root><one/><two/><three/><four/><five/></root>';
				parse: dtd, '<root><two/><one/><two/><two/><three/><four/><five/></root>';
				parse: dtd, '<root><two/><three/><four/><four/><five/></root>';
				parse: dtd, '<root><two/><three/><four/><five/></root>']
		raise: XMLValidationException.

	self
		should: [SAXHandler parse: dtd, '<root><three/><four/><five/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><one/><two/><four/><four/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><one/><two/><three/><five/></root>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/27/2013 16:08'!
testElementContentModelsStar
	| dtd |

	dtd := '<!!DOCTYPE root [',
		(self elementDeclarationsNamed: #('one' 'two' 'three' 'four' 'five')),
		'<!!ELEMENT root ((one?,two)*,(three)*,four,five*)>]>'.

	self
		shouldnt: [
			SAXHandler
				parse: dtd, '<root><one/><two/><three/><four/><five/></root>';
				parse: dtd, '<root><two/><one/><two/><three/><four/><five/></root>';
				parse: dtd, '<root><three/><three/><four/><five/></root>';
				parse: dtd, '<root><four/><five/><five/></root>';
				parse: dtd, '<root><four/></root>']
		raise: XMLValidationException.

	self
		should: [SAXHandler parse: dtd, '<root><three/></root>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/28/2013 01:49'!
testElementContentModelsStarEmpty
	| dtd |

	dtd := '<!!DOCTYPE root [',
		(self elementDeclarationsNamed: #('one' 'two' 'three')),
		'<!!ELEMENT root (one*,two)*>]>'.

	self
		shouldnt: [
			SAXHandler
				parse: dtd, '<root><one/><one/><two/><two/></root>';
				parse: dtd, '<root><two/><one/><two/></root>';
				parse: dtd, '<root><two/><two/></root>';
				parse: dtd, '<root></root>']
		raise: XMLValidationException.

	self
		should: [SAXHandler parse: dtd, '<root><one/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><three/></root>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/4/2015 07:02'!
testElementDeclarationWhitespace
	self
		should: [SAXHandler parse: '<!!DOCTYPE test [<!!ELEMENTname (#PCDATA)>]>']
		raise: XMLWellFormednessException.
	self
		should: [SAXHandler parse: '<!!DOCTYPE test [<!!ELEMENT name(#PCDATA)>]>']
		raise: XMLWellFormednessException.
	self
		shouldnt: [SAXHandler parse: '<!!DOCTYPE test [<!!ELEMENT name (	#PCDATA	)   >]>']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/3/2014 16:23'!
testElementEmptyDeclarations
	self
		shouldnt: [
			SAXHandler parse: 
				'<!!DOCTYPE root [<!!ELEMENT root EMPTY>]>',
				'<root> <!!--empty--> <?pi data?> </root>']
		raise: XMLValidationException.
	self
		should: [
			SAXHandler parse: 
				'<!!DOCTYPE root [
					<!!ELEMENT root EMPTY>
					<!!ELEMENT non-empty ANY>]><root><non-empty/></root>']
		raise: XMLValidationException.
	self
		should: [
			SAXHandler parse: 
				'<!!DOCTYPE root [<!!ELEMENT root EMPTY>]><root>non-empty</root>']
		raise: XMLValidationException.
	self
		should: [
			SAXHandler parse: 
				'<!!DOCTYPE root [<!!ELEMENT root EMPTY>]><root>&#32;</root>']
		raise: XMLValidationException.
	self
		should: [
			SAXHandler parse: 
				'<!!DOCTYPE root [<!!ELEMENT root EMPTY>]><root><!![CDATA[non-empty]]></root>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/8/2014 13:15'!
testElementMixedContentDeclaration
	| dtd |

	dtd := '
		<!!DOCTYPE root [
			<!!ELEMENT root (#PCDATA | one | two | three)*>
			<!!ELEMENT one EMPTY>
			<!!ELEMENT two (#PCDATA)>
			<!!ELEMENT three (#PCDATA)*>
			<!!ELEMENT four EMPTY>]>'.
	self
		shouldnt: [
			XMLDOMParser parse:
				dtd, '<root>text<one/><two><!![CDATA[text]]></two></root>']
		raise: XMLValidationException.
	self
		shouldnt: [XMLDOMParser parse: dtd, '<root><three>text<!!--comment--></three></root>']
		raise: XMLValidationException.
	self
		should: [XMLDOMParser parse: dtd, '<root><four/></root>']
		raise: XMLValidationException.
	self
		should: [XMLDOMParser parse: dtd, '<root><two><three/></two></root>']
		raise: XMLValidationException.
	self
		should: [
			XMLDOMParser parse: "missing *"
				'<!!DOCTYPE root [<!!ELEMENT root (#PCDATA|one)>]><root/>']
		raise: XMLWellFormednessException.
	'+*?,' do: [:each |
		self
			should: [
				XMLDOMParser parse:
					'<!!DOCTYPE root [<!!ELEMENT two (#PCDATA', each asString, ')>]><root/>']
			raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 1/13/2014 00:16'!
testElementWellFormedness
	| error |

	error := XMLWellFormednessException.
	self
		should: [SAXHandler parse: '<root1>'] raise: error;
		should: [SAXHandler parse: '</root1>'] raise: error;
		should: [SAXHandler parse: '<root1/><root2/>'] raise: error;
		should: [SAXHandler parse: '<root></unopened></root>'] raise: error;
		should: [SAXHandler parse: '<root><unclosed></root>'] raise: error;
		should: [SAXHandler parse: '<root><first><second></first></second></root>'] raise: error.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/4/2015 06:56'!
testElementWhitespace
	self
		should: [SAXHandler parse: '<root name1="value1"name2="value2"/>']
		raise: XMLWellFormednessException.
	self
		should: [SAXHandler parse: '<root name1=''value1''name2="value2"/>']
		raise: XMLWellFormednessException.
	self
		shouldnt: [SAXHandler parse: '<root name1="value1" name2="value2"/>']
		raise: XMLWellFormednessException.
	self
		shouldnt: [SAXHandler parse: '<root name1   =   "value1"    name2   =   "value2"    />']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/4/2015 07:08'!
testEntityDeclarationWhitespace
	#('<!!DOCTYPE test [<!!ENTITYname "value">]>'
		'<!!DOCTYPE test [<!!ENTITY name"value">]>'
		'<!!DOCTYPE test [<!!ENTITY name PUBLIC"publicid" "systemid">]>'
		'<!!DOCTYPE test [<!!ENTITY name PUBLIC "publicid""systemid">]>'
		'<!!DOCTYPE test [<!!ENTITY name SYSTEM"systemid">]>'
		'<!!DOCTYPE test [<!!ENTITY name PUBLIC "publicid" "systemid"NDATA GIF>]>'
		'<!!DOCTYPE test [<!!ENTITY name SYSTEM "systemid"NDATA GIF>]>'
		'<!!DOCTYPE test [<!!ENTITY% name "value">]>'
		'<!!DOCTYPE test [<!!ENTITY %name "value">]>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException].
	#('<!!DOCTYPE test [<!!ENTITY  name 	"value"   >]>'
		'<!!DOCTYPE test [<!!ENTITY   % 	 name "value"	>]>'
		'<!!DOCTYPE test [<!!ENTITY   name   PUBLIC   "publicid"    "systemid"   >]>'
		'<!!DOCTYPE test [<!!ENTITY   name   SYSTEM    "systemid"   >]>')
		do: [:each |
			self
				shouldnt: [SAXHandler parse: each]
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/28/2014 09:41'!
testEntityEmptyReplacements
	| xml document |

	xml := '
	<?xml version="1.0"?>
	<!!DOCTYPE entities [
		<!!ENTITY % inner "">
		%inner;
		<!!ENTITY % outer ''%inner;''>
		%outer;
		<!!ENTITY inner  "%outer;"> 
		<!!ENTITY outer ''&inner;''>]>
	<entities one="&outer;" two="&inner;" three=''&outer;'' four=''&inner;''>&outer;&inner;</entities>'.

	self
		shouldnt: [document := XMLDOMParser parse: xml]
		raise: XMLWellFormednessException.
	self
		assert: (document root attributeAt: 'one') isEmpty;
		assert: (document root attributeAt: 'two') isEmpty;
		assert: (document root attributeAt: 'three') isEmpty;
		assert: (document root attributeAt: 'four') isEmpty;
		assert: document root contentString isEmpty.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/28/2014 09:35'!
testEntityLiteralContextNesting
	| xml inner outer document |

	xml := '
	<?xml version="1.0"?>
	<!!DOCTYPE entities [
		<!!ENTITY % inner " '' inner &#34; ">
		<!!ENTITY % outer '' "%inner;&#39; ''>
		<!!ENTITY inner  "%outer;"> 
		<!!ENTITY outer '' &#39; " &inner; &#39; " ''>]>
	<entities one="&outer;" two="&inner;" three=''&outer;'' four=''&inner;''>&outer;&inner;</entities>'.
	inner := ' " '' inner " '' '.
	outer := ' '' " ', inner, ' '' " '.

	self
		shouldnt: [document := XMLDOMParser parse: xml]
		raise: XMLWellFormednessException.
	self
		assert: (document root attributeAt: 'one') = outer;
		assert: (document root attributeAt: 'two') = inner;
		assert: (document root attributeAt: 'three') = outer;
		assert: (document root attributeAt: 'four') = inner;
		assert: (document root contentString) = (outer, inner).! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/8/2013 01:54'!
testEntityReplacement
	| document |

	document := XMLDOMParser parse: '
		<!!DOCTYPE root [
			<!!ENTITY % partialDeclaration "name1 &#39;replacement1&#x27;">
			<!!ENTITY % name1Declaration "<!!ENTITY %partialDeclaration;>">
			%name1Declaration;
			<!!ENTITY name2 "replacement2 &name1;" >
			<!!ENTITY name3 "replacement3 &name2;" >
			<!!ENTITY quotes "&#x27;quoted &#x22;value&#34;&#39;">
		]>
		<root name="&quotes;">&name1; &name2; &name3; ',
		'%name1Declaration;</root>'.
	self assert:
		document root contentString =
			('replacement1 ',
			'replacement2 replacement1 ',
			'replacement3 replacement2 replacement1 ',
			'%name1Declaration;').
	self assert:
		(document root attributeAt: 'name') =
			(('quoted "value"' copyWithFirst: $') copyWith: $').! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/2/2015 11:14'!
testEntityURIInheritance
	| xml parser driver |

	xml := '<!!DOCTYPE root [%first;]><root xml:base="/new/xml">&second;</root>'.
	parser :=
		(SAXHandler
			on: xml
			documentURI: 'test.xml') parser.
	(driver := parser driver)
		doctypeDefinition parameterEntities
			at: 'first'
			put:
				(DTDExternalParameterEntity
					name: 'first'
					replacement: '<!!ENTITY second "<!!--comment-->">'
					uri: 'test.ent').

	self assert: driver currentURI = 'test.xml'.

	3 timesRepeat: [parser parseToken].
	self assert: driver currentURI = 'test.ent'.

	2 timesRepeat: [parser parseToken].
	self assert: driver currentURI = 'test.xml'.

	2 timesRepeat: [parser parseToken].
	self assert: driver currentURI = '/new/xml'.

	3 timesRepeat: [parser parseToken].
	self
		assert: driver currentURI = 'test.xml';
		assert: parser atEnd.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 1/22/2014 23:27'!
testIncompleteCDataTokens
	#('<test><!![' '<test><!![CDATA[' '<test><!![CDATA[ test'
		'<test><!![CDATA[ test ]' '<test><!![CDATA[ test ]]')
		do: [:each | 
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 1/22/2014 23:20'!
testIncompleteCommentTokens
	#('<!!--' '<!!-- comment' '<!!-- comment -' '<!!-- comment --')
		do: [:each | 
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 1/23/2014 03:12'!
testIncompleteDoctypeTokens
	#('<!!DOCTYPE' '<!!DOCTYPE >'
		'<!!DOCTYPE test' '<!!DOCTYPE test PUBLIC' '<!!DOCTYPE test PUBLIC "pubid'
		'<!!DOCTYPE test PUBLIC "pubid" "sysid' '<!!DOCTYPE test PUBLIC "pubid" "sysid"'
		'<!!DOCTYPE test SYSTEM' '<!!DOCTYPE test SYSTEM "sysid' '<!!DOCTYPE test SYSTEM "sysid"'
		'<!!DOCTYPE test [' '<!!DOCTYPE test []')
		do: [:each | 
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/21/2015 10:25'!
testIncompleteEndTagTokens
	#('<test></' '<test></test' '<test></ test' '<test></ test>')
		do: [:each | 
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/13/2015 00:07'!
testIncompletePITokens
	#('<?' '<??' '<??>' '<?name' '<?name value' '<?name value?' '<?name value>')
		do: [:each | 
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 1/22/2014 23:19'!
testIncompleteStartTagTokens
	#('<' '<test' '<test name'
		'<test name=' '<test name="value' '<test name="value"'
		'<test name="value" /')
		do: [:each | 
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 1/22/2014 23:17'!
testIncompleteXMLDeclarationTokens
	#('<?xml' '<?xml ?' '<?xml ?>'
		'<?xml version' '<?xml version=' '<?xml version="1.0'
		'<?xml version="1.0" encoding' '<?xml version="1.0" encoding="UTF-8'
		'<?xml version="1.0" encoding="UTF-8" standalone'
		'<?xml version="1.0" encoding="UTF-8" standalone="yes'
		'<?xml version="1.0" encoding="UTF-8" standalone="yes"'
		'<?xml version="1.0" encoding="UTF-8" standalone="yes"?')
		do: [:each | 
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/4/2015 21:06'!
testInternalDeclarationParameterEntityReference
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE root [
					<!!ENTITY % name "root">
					<!!ENTITY % contentModel "EMPTY">
					<!!ELEMENT %name; %contentModel;>
				]><root/>']
		raise: XMLWellFormednessException.
	self
		shouldnt: [
			SAXHandler parse:
				'<!!DOCTYPE root [
					<!!ENTITY % element "<!!ELEMENT root EMPTY>">
					%element;
				]><root/>']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/8/2014 12:35'!
testInvalidElementContentModels
	self
		should: [SAXHandler parse: '<!!DOCTYPE root [<!!ELEMENT root ()>]>']
		raise: XMLWellFormednessException.
	self
		should: [SAXHandler parse: '<!!DOCTYPE root [<!!ELEMENT root (one,)>]>']
		raise: XMLWellFormednessException.
	self
		should: [SAXHandler parse: '<!!DOCTYPE root [<!!ELEMENT root (one|)>]>']
		raise: XMLWellFormednessException.
	self
		should: [SAXHandler parse: '<!!DOCTYPE root [<!!ELEMENT root (one)(two)>]>']
		raise: XMLWellFormednessException.
	self
		should: [SAXHandler parse: '<!!DOCTYPE root [<!!ELEMENT root (one|,two)>]>']
		raise: XMLWellFormednessException.
	'|,?*+' do: [:each |
		self
			should: [SAXHandler parse: '<!!DOCTYPE root [<!!ELEMENT root (', each asString, 'one)>]>']
			raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/17/2015 13:10'!
testInvalidNameChar
	#(16rBF 16rD7 16rF7 16r37E
		16r2000 16r200B 16r200E 16r206F
		16r2190 16r2BFF 16r2FFF 16r3000
		16rD800 16rF8FF 16rFDD0 16rFDEF
		16rFFFE 16r0FFFF 16rF0000) do: [:each | | charString |
		charString := each asCharacter asString.
		self
			should: [SAXHandler parse: '<test', charString, '/>']
			raise: XMLWellFormednessException.
		self
			should: [SAXHandler parse: '<test name', charString, '="value"/>']
			raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/17/2015 12:29'!
testInvalidNameStartChar
	#($- $. $0 $9 16rB7 16r0300 16r036F 16r203F 16r2040) do: [:each | | charString |
		charString := each asCharacter asString.
		self
			should: [SAXHandler parse: '<', charString, 'test/>']
			raise: XMLWellFormednessException.
		self
			should: [SAXHandler parse: '<test ', charString, 'name="value"/>']
			raise: XMLWellFormednessException.
		self
			shouldnt: [SAXHandler parse: '<test', charString, ' name', charString, '="value"/>']
			raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/19/2015 15:58'!
testInvalidPublicIDChar
	| validChars |

	validChars :=
		'!!#$%''()*+,-./0123456789:;=?@ABCDEFGHIJKLMNOPQRSTUVWXYZ_abcdefghijklmnopqrstuvwxyz',
		(Character xmlParserSeparators copyWithout: Character tab).
	0 to: 255 do: [:each | | char charString |
		char := each asCharacter.
		(validChars includes: char)
			ifFalse: [
				charString := char asString.
				self
					should: [
						SAXHandler parse:
							'<!!DOCTYPE test PUBLIC "//public//', charString, '" "external.dtd">']
					raise: XMLWellFormednessException]].
	self
		shouldnt: [
			SAXHandler parse:
				'<!!DOCTYPE test PUBLIC "//public//', validChars, '" "external.dtd">']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/21/2015 11:55'!
testInvalidXMLEncodingNameChar
	| validChars |

	validChars := '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_.-'.
	0 to: 255 do: [:each | | char charString |
		char := each asCharacter.
		(validChars includes: char)
			ifFalse: [
				charString := char asString.
				self
					should: [SAXHandler parse: '<?xml version="1.0" encoding="ISO', charString, '"?>']
					raise: XMLWellFormednessException]].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/21/2015 12:57'!
testInvalidXMLStandaloneAttribute
	#('<?xml version="1.0" standalone=""?>'
		'<?xml version="1.0" standalone="YES"?>'
		'<?xml version="1.0" standalone="Yes"?>'
		'<?xml version="1.0" standalone=" yes "?>'
		'<?xml version="1.0" standalone="NO"?>'
		'<?xml version="1.0" standalone="No"?>'
		'<?xml version="1.0" standalone=" no "?>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException].

	#('<?xml version="1.0" standalone="no"?>'
		'<?xml version="1.0" standalone="yes"?>')
		do: [:each |
			self
				shouldnt: [SAXHandler parse: each]
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/21/2015 14:27'!
testInvalidXMLVersionAttribute
	#('<?xml version=""?>'
		'<?xml version="1"?>'
		'<?xml version="1."?>'
		'<?xml version="1.0."?>'
		'<?xml version="1.0.1"?>'
		'<?xml version="10"?>'
		'<?xml version="10."?>'
		'<?xml version="10.00."?>'
		'<?xml version="10.00.10"?>'
		'<?xml version="one"?>'
		'<?xml version="one."?>'
		'<?xml version="one.zero."?>'
		'<?xml version="one.zero.one"?>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException].

	#('<?xml version="1.0"?>'
		'<?xml version="1.1"?>'
		'<?xml version="1.00"?>'
		'<?xml version="1.10"?>')
		do: [:each |
			self
				shouldnt: [SAXHandler parse: each]
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/24/2015 20:33'!
testIsInContent
	| xml handler parser |

	xml := '<?xml version="1.0"?>
			<!!--comment-->
			<?target data?>
			<!!DOCTYPE root [<!!ELEMENT root EMPTY>]>
			<!!--comment-->
			<?target data?>
			<root/>'.
	handler := SAXHandler on: xml.
	parser := handler parser.
	9 timesRepeat: [
		parser parseToken.
		self deny: handler isInContent].
	parser parseToken.
	self assert: handler isInContent.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/22/2015 03:34'!
testLineEndingsDoNotMatter
	| source docFromSourceWithCRs docFromSourceWithLFs docFromSourceWithCRLFs |

	source := '<root>{1}one{1}two{1}</root>'.
	docFromSourceWithCRs := XMLDOMParser parse: (source format: (Array with: String cr)).
	docFromSourceWithLFs := XMLDOMParser parse: (source format: (Array with: String lf)).
	docFromSourceWithCRLFs := XMLDOMParser parse: (source format: (Array with: String crlf)).
	self
		assert: (docFromSourceWithCRs root contentString) = (docFromSourceWithLFs root contentString);
		assert: (docFromSourceWithLFs root contentString) = (docFromSourceWithCRLFs root contentString).! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/6/2015 05:00'!
testMultipleDoctypeDeclarations
	#('<!!DOCTYPE test><!!DOCTYPE test>'
		'<!!DOCTYPE test><!!--comment--><!!DOCTYPE test>'
		'<!!DOCTYPE test><!!pi data?><!!DOCTYPE test>'
		'<!!DOCTYPE test [<!!DOCTYPE test>]>'
		'<test><!!DOCTYPE test></test>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/6/2015 05:19'!
testMultipleXMLDeclarations
	#('<?xml version="1.0"?><?xml version="1.0"?>'
		'<?xml version="1.0"?><!!--comment--><?xml version="1.0"?>'
		'<?xml version="1.0"?><!!DOCTYPE test [<?xml version="1.0"?>]>'
		'<?xml version="1.0"?><test><?xml version="1.0"?></test>'
		'<test><?xml version="1.0"?></test>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 1/31/2014 00:15'!
testNamespacePrefixAliasing
	| declarations |

	declarations := '<test xmlns:alias1="ns" xmlns:alias2="ns" '.
	self
		shouldnt: [
			SAXHandler
				parse: declarations, ' alias1:name="value" />'
				usingNamespaces: true]
		raise: XMLNamespaceException.
	self
		should: [
			SAXHandler
				parse: declarations, ' alias1:name="value" alias2:name="value"/>'
				usingNamespaces: true]
		raise: XMLNamespaceException.
	self
		shouldnt: [
			SAXHandler
				parse: declarations, ' alias1:name="value" alias2:name2="value"/>'
				usingNamespaces: true]
		raise: XMLNamespaceException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/28/2014 19:50'!
testNamespacePrefixInheritance
	self
		shouldnt: [
			SAXHandler
				parse:
					'<one xmlns:prefix1="ns">
						<prefix1:two xmlns:prefix2="ns2">
							<prefix2:three><prefix1:four /></prefix2:three>
						</prefix1:two>
					</one>'
				usingNamespaces: true]
		raise: XMLNamespaceException.
	self
		should: [
			SAXHandler
				parse:
					'<one xmlns:prefix1="ns">
						<prefix1:two xmlns:prefix2="ns2" />
						<prefix2:three />
					</one>'
				usingNamespaces: true]
		raise: XMLNamespaceException.
	self
		should: [
			SAXHandler
				parse:
					'<one xmlns:prefix1="ns">
						<prefix1:two xmlns:prefix2="ns2">
							<prefix2:three xmlns:prefix3="ns3" />
						</prefix1:two>
						<prefix3:four />
					</one>'
				usingNamespaces: true]
		raise: XMLNamespaceException.
	self
		shouldnt: [
			SAXHandler
				parse:
					'<one xmlns:prefix1="ns">
						<prefix1:two xmlns:prefix2="ns2">
							<prefix2:three xmlns:prefix3="ns3" />
						</prefix1:two>
						<prefix2:four />
						<prefix3:five />
					</one>'
				usingNamespaces: false]
		raise: XMLNamespaceException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/4/2015 07:23'!
testNotationDeclarationWhitespace
	#('<!!DOCTYPE test [<!!NOTATIONname PUBLIC "publicid">]>'
		'<!!DOCTYPE test [<!!NOTATION name PUBLIC"publicid">]>'
		'<!!DOCTYPE test [<!!NOTATION name PUBLIC "publicid""systemid">]>'
		'<!!DOCTYPE test [<!!NOTATION name SYSTEM"systemid">]>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException].

	#('<!!DOCTYPE test [<!!NOTATION     name  PUBLIC  "publicid"   >]>'
		'<!!DOCTYPE test [<!!NOTATION name PUBLIC        "publicid"   "systemid"   >]>'
		'<!!DOCTYPE test [<!!NOTATION name SYSTEM        "systemid"		>]>')
		do: [:each |
			self
				shouldnt: [SAXHandler parse: each]
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'StephaneDucasse 12/27/2013 16:52'!
testParserLittleDocument

	| doc |
	doc := XMLDOMParser parse: 
'<?xml version="1.0" encoding="UTF-8"?>
<!!--an example-->
<example:user xmlns:example="urn://example">
    <username>jsmith</username>
    <real-name>John Smith</real-name>
    <age>25</age>
    <id>101</id>
</example:user>' readStream.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 2/10/2014 02:43'!
testPredefinedEntityReplacement
	| document references replacements |

	references := String new writeStream.
	replacements := String new writeStream.
	XMLWellFormedParserTokenizer predefinedEntities keysAndValuesDo: [:name :char |
		references
			nextPut: $&;
			nextPutAll: name;
			nextPut: $;.
		replacements nextPut: char].

	document :=
		XMLDOMParser parse:
			('<!!DOCTYPE root [
				<!!ENTITY nonRecursive "&amp;nonRecursive;">]>
			<root name=''{1}''>
				<one>{1}</one>
				<two>&nonRecursive;</two>
			</root>' format: (Array with: references contents)).
	self
		assert: (document root attributeAt: 'name') = replacements contents;
		assert: (document findElementNamed: 'one') contentString = replacements contents;
		assert: (document findElementNamed: 'two') contentString = '&nonRecursive;'.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/18/2013 23:49'!
testPrefixedAttributeDeclarations
	| dtd |

	dtd := '<!!DOCTYPE root [
		<!!ELEMENT root EMPTY>
		<!!ATTLIST root
			prefix:name CDATA #IMPLIED
			unprefixed CDATA #IMPLIED>]>'.
	self
		shouldnt: [
			SAXHandler parse:
				dtd, '<root xmlns:prefix="ns" prefix:name="value" unprefixed="value"/>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root name="value" unprefixed="value" />']
		raise: XMLValidationException.
	self
		should: [
			SAXHandler parse:
				dtd, '<root xmlns:prefix="ns" prefix:name="value" prefix:unprefixed="value"/>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/18/2013 23:44'!
testPrefixedElementDeclarations
	| dtd |

	dtd := '<!!DOCTYPE prefix:root [
		<!!ELEMENT prefix:root ANY>
		<!!ELEMENT unprefixed EMPTY>]>'.
	self
		shouldnt: [SAXHandler parse: dtd, '<prefix:root xmlns:prefix="ns"><unprefixed/></prefix:root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><unprefixed/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<prefix:root xmlns:prefix="ns"><prefix:unprefixed/></prefix:root>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 2/15/2014 00:51'!
testProcessingInstructions
	| document |

	document :=
		XMLDOMParser parse:
			'<?xml version="1.1" standalone="yes"?><?firstTarget first>Data?>',
			'<root><?secondTarget second?Data?></root> '.

	self
		assert: document version = 1.1;
		assert: document nodes size = 2;
		assert: document firstNode isPI;
		assert: document firstNode target = 'firstTarget';
		assert: document firstNode data = 'first>Data';
		assert: document root firstNode target = 'secondTarget';
		assert: document root firstNode data = 'second?Data'.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/6/2015 05:21'!
testProcessingInstructionsReservedTargets
	self
		should: [SAXHandler parse: '<test><?xml version="1.0"?></test>']
		raise: XMLWellFormednessException.
	self
		should: [SAXHandler parse: '<test><?XML version="1.0"?></test>']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/4/2015 06:57'!
testProcessingInstructionsWhitespace
	self
		should: [SAXHandler parse: '<pi><?target?data?></pi>']
		raise: XMLWellFormednessException.
	self
		shouldnt: [SAXHandler parse: '<pi><?target ?data  ?></pi>']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/13/2015 00:17'!
testRequiredDTDDeclarations
	self
		shouldnt: [
			(SAXHandler on: '<!!DOCTYPE root [<!!ELEMENT root EMPTY>]><root/>')
				requiresDocumentConstraints: true;
				parseDocument]
		raise: XMLValidationException.
	self
		should: [
			(SAXHandler on: '<root/>')
				requiresDocumentConstraints: true;
				parseDocument]
		raise: XMLValidationException.
	self
		should: [
			(SAXHandler on: '
				<!!DOCTYPE root [
					<!!ENTITY one "two">
					<!!ENTITY % three "four">
					<!!NOTATION five PUBLIC "six">
					<!!--seven-->]>
				<root/>')
				requiresDocumentConstraints: true;
				parseDocument]
		raise: XMLValidationException.
	! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 6/21/2015 03:04'!
testReusingParser
	| parser oldConfiguraiton |

	parser :=
		SAXHandler
			on: self addressBookXML
			documentURI: 'oldURI'.
	oldConfiguraiton := parser configuration.
	parser parseDocument.
	parser on: self addressBookXMLWithDTD.
	self
		assert: parser input = self addressBookXMLWithDTD;
		deny: parser documentURI = 'oldURI';
		deny: parser configuration == oldConfiguraiton.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/13/2015 03:21'!
testSelfReferentialEntityReplacement
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE root [<!!ENTITY first "&first;">]><root>&first;</root>']
		raise: XMLWellFormednessException.
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE root [<!!ENTITY % first "&#37;first;">%first;]><root/>']
		raise: XMLWellFormednessException.
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE root [
					<!!ENTITY first "&second;">
					<!!ENTITY second "&first;">]><root>&first;</root>']
		raise: XMLWellFormednessException.
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE root [
					<!!ENTITY % first "&#37;second;">
					<!!ENTITY % second "&#37;first;">
					%first;]><root/>']
		raise: XMLWellFormednessException.
	self
		shouldnt: [
			SAXHandler parse:
				'<!!DOCTYPE root [
					<!!ENTITY first "&second;">
					<!!ENTITY second "<!!--replacement-->">]><root>&first;</root>']
		raise: XMLWellFormednessException.
	self
		shouldnt: [
			SAXHandler parse:
				'<!!DOCTYPE root [
					<!!ENTITY % first "&#37;second;">
					<!!ENTITY % second "<!!--replacement-->">
					%first;]><root/>']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/22/2015 03:35'!
testStandalone
	| dtdXML standaloneDeclXML |

	dtdXML := self addressBookXMLWithDTD.
	self
		shouldnt: [
			SAXHandler
				parse: dtdXML
				usingNamespaces: true
				validation: true
				externalEntities: false]
		raise: XMLFileException.

	standaloneDeclXML :=
		(dtdXML copyUpTo: $>) allButLast, ' standalone="yes" ?>', (dtdXML copyAfter: $>).
	self
		shouldnt: [
			SAXHandler
				parse: standaloneDeclXML
				usingNamespaces: true
				validation: false
				externalEntities: true]
		raise: XMLFileException.
	self
		shouldnt: [
			SAXHandler
				parse: standaloneDeclXML
				usingNamespaces: true
				validation: true
				externalEntities: false]
		raise: XMLFileException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 1/12/2014 23:20'!
testSubsetEndingEntityReplacement
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE root [
					<!!ENTITY % endOfSubset "]>">
					%endOfSubset;
					<root/>']
		raise: XMLWellFormednessException! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/18/2013 21:53'!
testUndeclaredAttributes
	self
		shouldnt: [
			SAXHandler
				parse: '<!!DOCTYPE root [<!!ENTITY ignored "ignored">]><root name="value"/>'
				usingNamespaces:true
				validation: true]
		raise: XMLValidationException.
	self
		shouldnt: [
			SAXHandler parse:
				'<!!DOCTYPE root [
					<!!ELEMENT root ANY>
					<!!ATTLIST root name CDATA #IMPLIED>]><root name="value"></root>']
		raise: XMLValidationException.
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE root [<!!ELEMENT root ANY>]><root name="value"></root>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/18/2013 20:04'!
testUndeclaredElements
	self
		shouldnt: [
			SAXHandler
				parse: '<!!DOCTYPE root [<!!ENTITY ignored "">]><root/>'
				usingNamespaces:true
				validation: true]
		raise:XMLValidationException.
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE root [<!!ELEMENT root ANY>]><root><undeclared/></root>']
		raise: XMLValidationException.
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE root [<!!ATTLIST root name CDATA #IMPLIED>]><root/>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/6/2013 19:04'!
testUndeclaredEntities
	| document dtd content |

	dtd := '<!!DOCTYPE root [<!!ENTITY declared "%undeclared;">]>'.
	content := '<root>&undeclared;test&undeclared;</root>'.
	self should: [XMLDOMParser parse: content] raise: XMLValidationException.
	self should: [XMLDOMParser parse: dtd, '<root/>'] raise: XMLValidationException.
	self
		shouldnt: [
			document :=
				XMLDOMParser
					parse: dtd, content
					usingNamespaces: false
					validation: false]
		raise: XMLValidationException.
	self assert: document allNodes second contentString = 'test'.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 1/6/2015 05:17'!
testUndeclaredEntitiesPreserved
	| xml parser document |

	xml := '<!!DOCTYPE root [
		<!!ENTITY unreferenced "%undeclaredOne;">
		%undeclaredOne;]>
		<root name="&#34;&undeclaredTwo;&#34;">&lt;&undeclaredThree;&gt;</root>'.
	(parser := XMLDOMParser on: xml)
		isValidating: false;
		preservesUndeclaredEntityReferences: true.
	document := parser parseDocument.

	self
		assert: document doctypeDeclaration nodes size = 1;
		assert: document doctypeDeclaration firstNode replacement = '%undeclaredOne;';
		assert: (document root attributeAt: 'name') = '"&undeclaredTwo;"';
		assert: (document root contentString) = '<&undeclaredThree;>'.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/6/2013 17:39'!
testUndeclaredNamespaces
	self
		shouldnt: [SAXHandler parse: '<prefix:root prefix:name="test"/>' usingNamespaces: false]
		raise: XMLNamespaceException.
	self
		should: [SAXHandler parse: '<prefix:root/>']
		raise: XMLNamespaceException.
	self
		should: [SAXHandler parse: '<root prefix:name="test"/>']
		raise: XMLNamespaceException.

	"xml is OK as a prefix, xmlns is not"
	self
		shouldnt: [SAXHandler parse: '<xml:root xml:name="test"/>']
		raise: XMLNamespaceException.
	self
		should: [SAXHandler parse: '<xmlns:root />']
		raise: XMLNamespaceException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/22/2015 03:35'!
testUnparsedEntities
	| dtd |

	dtd := '
		<!!DOCTYPE root [
			<!!NOTATION note PUBLIC "-//ext//note//EN">
			<!!ENTITY unparsedEntity SYSTEM "note.txt" NDATA note>
			<!!ELEMENT root EMPTY>
			<!!ATTLIST root notation ENTITY #REQUIRED>
		]>'.
	self
		shouldnt: [SAXHandler parse: dtd, '<root notation="unparsedEntity" />']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root notation="undeclaredUnparsedEntity" />']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 6/17/2015 22:17'!
testUnparsedEntitiesUndeclaredNotations
	| beforeNotation afterNotation |

	beforeNotation := '
		<!!DOCTYPE entity [
			<!!ELEMENT entity EMPTY>
			<!!ATTLIST entity name ENTITY #REQUIRED>
			<!!ENTITY notationEntity SYSTEM "note.txt" NDATA note>'.
	afterNotation := ']><entity name="notationEntity"/>'.
	self
		should: [SAXHandler parse: beforeNotation, afterNotation]
		raise: XMLValidationException.
	self
		shouldnt: [
			SAXHandler
				parse: beforeNotation, afterNotation
				usingNamespaces: true
				validation: false]
		raise: XMLValidationException.
	self
		shouldnt: [
			SAXHandler parse:
				beforeNotation, '<!!NOTATION note SYSTEM "note.txt">', afterNotation]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 1/6/2015 05:13'!
testUnreplacedContentEntities
	| xml document |

	xml := '
		<!!DOCTYPE one [<!!ENTITY declared "replacement">]>
		<one two="&quot;&declared;&quot;">&#60;&declared;&#62;</one>'.
	document :=
		(XMLDOMParser on: xml)
			replacesContentEntityReferences: false;
			parseDocument.
	self
		assert: (document root attributeAt: 'two') = '&quot;&declared;&quot;';
		assert: document root contentString = '&#60;&declared;&#62;'.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 1/7/2015 01:14'!
testUnreplacedContentEntitiesParameterEntities
	| beforeSubset subset afterSubset xml document |

	beforeSubset := '<?xml version="1.1"?> <!!DOCTYPE entity ['.
	subset :=
		'<!!ENTITY % first "<!!ENTITY second &#34;replacement&#34;>">
		%first;'.
	afterSubset := ']><entity>&second;</entity>'.
	xml := beforeSubset, subset, afterSubset.
	self assert: (XMLDOMParser parse: xml) root contentString = 'replacement'.
	
	document :=
		(XMLDOMParser on: xml)
			replacesContentEntityReferences: false;
			parseDocument.
	self assert: document root contentString = '&second;'.
	self
		should: [
			(SAXHandler on: (beforeSubset, '%first;]>'))
				replacesContentEntityReferences: false;
				parseDocument]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 1/6/2015 05:12'!
testUnreplacedContentEntitiesUndeclared
	| xml document |

	xml := '<one two="&quot;&undeclared;&quot;">&#60;&undeclared;&#62;</one>'.
	self
		should: [
			(SAXHandler on: xml)
				replacesContentEntityReferences: false;
				parseDocument]
		raise: XMLValidationException.
	self
		shouldnt: [
			document :=
				(XMLDOMParser on: xml)
					isValidating: false;
					replacesContentEntityReferences: false;
					parseDocument]
		raise: XMLValidationException.
	self
		assert: (document root attributeAt: 'two') = '&quot;&undeclared;&quot;';
		assert: document root contentString = '&#60;&undeclared;&#62;'.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/29/2013 02:49'!
testValidationAndConstraintsToggle
	self assert:
		((SAXHandler on: '')
			isValidating: false;
			requiresDocumentConstraints: true;
			isValidating).
	self deny:
		((SAXHandler on: '')
			requiresDocumentConstraints: true;
			isValidating: false;
			requiresDocumentConstraints).! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 1/6/2015 06:11'!
testValidationAndEntityReferenceToggle
	self deny:
		((SAXHandler on: '')
			isValidating: true;
			preservesUndeclaredEntityReferences: true;
			isValidating).
	self deny:
		((SAXHandler on: '')
			preservesUndeclaredEntityReferences: true;
			isValidating: true;
			preservesUndeclaredEntityReferences).! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 1/3/2015 00:48'!
testWhitespacePreservation
	| xml root notPreserved preserved |

	xml := '
		<root xml:space="preserve">
			<not-preserved xml:space="default">
				<preserved xml:space="preserve">
				</preserved>
			</not-preserved>
		</root>'.
	root := (XMLDOMParser parse: xml) root.
	self
		assert: root nodes size = 3;
		assert: root stringNodes size = 2.
	root stringNodesDo: [:each | self assert: each isWhitespace].

	notPreserved := root nodes second.
	self assert: notPreserved nodes size = 1.

	preserved := notPreserved firstElement.
	self
		assert: preserved firstNode isStringNode;
		assert: preserved firstNode isWhitespace.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/22/2015 05:49'!
testWhitespacePreservationValidation
	| dtd |

	dtd := '
		<!!DOCTYPE whitespace [
			<!!ELEMENT whitespace EMPTY>
			<!!ATTLIST whitespace xml:space (default|preserve) ''preserve''>]>'.
	self
		shouldnt: [SAXHandler parse: dtd, '<whitespace></whitespace>']
		raise: XMLValidationException.
	self
		shouldnt: [SAXHandler parse: dtd, '<whitespace xml:space="default"> </whitespace>']
		raise: XMLValidationException.
	self
		shouldnt: [
			SAXHandler parse:
				(dtd copyReplaceAll: '(default|preserve)' with: '(preserve|default)')]
		raise: XMLValidationException.
	self
		shouldnt: [SAXHandler parse: (dtd copyReplaceAll: '(default|preserve)' with: '(preserve)')]
		raise: XMLValidationException.
	self
		should: [
			SAXHandler parse:
				(dtd copyReplaceAll: '(default|preserve)' with: '(default|preserve|other)')]
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: (dtd copyReplaceAll: '(default|preserve)' with: 'CDATA')]
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<whitespace> </whitespace>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<whitespace><!![CDATA[ ]]></whitespace>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<whitespace xml:space="default"><!![CDATA[ ]]></whitespace>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: (dtd copyReplaceAll: '(default|preserve)' with: '(not|valid)')]
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: (dtd copyReplaceAll: '(default|preserve)' with: 'CDATA')]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/4/2015 06:55'!
testXMLDeclarationWhitespace
	#('<? xml version="1.0" encoding="UTF-8" standalone="yes"?>'
		'<?xml version="1.0"standalone="yes"?>'
		'<?xml version="1.0"encoding="UTF-8" standalone="yes"?>'
		'<?xml version="1.0" encoding="UTF-8"standalone="yes"?>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException].
	self
		shouldnt: [
			SAXHandler parse:
				'<?xml version="1.0" 	encoding="UTF-8"	standalone="yes"	?>']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/22/2015 03:36'!
testXMLIDAttributeValidation
	| xml xmlWithDuplicateID |

	xml := '<a xml:id="one"><b xml:id="two"/></a>'.
	xmlWithDuplicateID := '<a xml:id="one"><b xml:id="one"/></a>'.
	self
		shouldnt: [SAXHandler parse: xml]
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: xmlWithDuplicateID]
		raise: XMLValidationException.
	self
		shouldnt: [
			(SAXHandler on: xmlWithDuplicateID)
				isValidating: false;
				parseDocument]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/23/2014 21:08'!
testXMLIDAttributeValidationDTD
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE one [
					<!!ELEMENT one ANY>
					<!!ATTLIST one xml:id CDATA #IMPLIED>]>']
		raise: XMLValidationException.
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE one [
					<!!ELEMENT one ANY>
					<!!ATTLIST one xml:id ID #IMPLIED>]>
				<one xml:id="invalid:id"/>']
		raise: XMLValidationException.
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE one [
					<!!ELEMENT one ANY>
					<!!ELEMENT two ANY>
					<!!ATTLIST one xml:id ID #IMPLIED>
					<!!ATTLIST two xml:id ID #IMPLIED>]>
				<one xml:id="valid"><two xml:id="valid"/></one>']
		raise: XMLValidationException.
	self
		shouldnt: [
			SAXHandler parse:
				'<!!DOCTYPE one [
					<!!ELEMENT one ANY>
					<!!ELEMENT two ANY>
					<!!ATTLIST one xml:id ID #IMPLIED>
					<!!ATTLIST two xml:id ID #IMPLIED>]>
				<one xml:id="valid1"><two xml:id="valid2"/></one>']
		raise: XMLValidationException.
	self
		shouldnt: [
			SAXHandler
				parse:
					'<!!DOCTYPE one [
						<!!ELEMENT one ANY>
						<!!ELEMENT two ANY>
						<!!ATTLIST one xml:id CDATA #IMPLIED>
						<!!ATTLIST two xml:id ID #IMPLIED>]>
					<one xml:id="invalid:id"><two xml:id="invalid:id"/></one>'
				usingNamespaces: true
				validation: false]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/2/2014 18:09'!
testXMLPrefixedAttributes
	| xml document |

	xml := '<a xml="one" xmll="two" xml:="three" xmlnss="four"></a>'.
	document := XMLDOMParser parse: xml usingNamespaces: true.

	self
		assert: (document root attributeAt: 'xml') = 'one';
		assert: (document root attributeAt: 'xmll') = 'two';
		assert: (document root attributeAt: 'xml:') = 'three';
		assert: (document root attributeAt: 'xmlnss') = 'four'.! !

TestCase subclass: #XMLStringMethodsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLStringMethodsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 20:00'!
testHasPrefixBeforeLocalName
	self
		deny: 'name' hasPrefixBeforeLocalName;
		deny: ':name' hasPrefixBeforeLocalName;
		assert: 'prefix:name' hasPrefixBeforeLocalName;
		assert: '::name' hasPrefixBeforeLocalName;
		assert: 'invalid:prefix:name' hasPrefixBeforeLocalName;
		assert: ':::name' hasPrefixBeforeLocalName;
		assert: ':invalid:prefix:name' hasPrefixBeforeLocalName.! !

!XMLStringMethodsTest methodsFor: 'tests' stamp: 'monty 10/24/2014 15:07'!
testIsQualifiedNameOrLocalName
	self
		assert: ('name' isQualifiedName: 'name' orLocalName: 'name');
		assert: ('name' isQualifiedName: 'prefix:name' orLocalName: 'name');
		assert: ('prefix:name' isQualifiedName: 'prefix:name' orLocalName: 'name');
		deny: ('name' isQualifiedName: 'different' orLocalName: 'different');
		deny: ('name' isQualifiedName: 'prefix:different' orLocalName: 'different');
		deny: ('prefix:name' isQualifiedName: 'prefix:different' orLocalName: 'different').! !

!XMLStringMethodsTest methodsFor: 'tests' stamp: 'monty 11/16/2014 20:22'!
testLocalNameAfterPrefix
	self
		assert: 'name' localNameAfterPrefix = 'name';
		assert: ':name' localNameAfterPrefix = ':name';
		assert: 'prefix:name' localNameAfterPrefix = 'name';
		assert: '::name' localNameAfterPrefix = 'name';
		assert: 'invalid:prefix:name' localNameAfterPrefix = 'name';
		assert: ':::name' localNameAfterPrefix = 'name';
		assert: ':invalid:prefix:name' localNameAfterPrefix = 'name'.! !

!XMLStringMethodsTest methodsFor: 'tests' stamp: 'monty 10/24/2014 10:27'!
testParseXML
	| xml |

	xml := XMLParserTest addressBookXML.
	self assert: xml parseXML printString = (XMLDOMParser parse: xml) printString.
	self assert: '' parseXML printString = (XMLDOMParser parse: '') printString.! !

!XMLStringMethodsTest methodsFor: 'tests' stamp: 'monty 11/17/2014 06:36'!
testPrefixBeforeLocalName
	self
		assert: 'name' prefixBeforeLocalName = '';
		assert: ':name' prefixBeforeLocalName = '';
		assert: 'prefix:name' prefixBeforeLocalName = 'prefix';
		assert: '::name' prefixBeforeLocalName = ':';
		assert: 'invalid:prefix:name' prefixBeforeLocalName = 'invalid:prefix';
		assert: ':::name' prefixBeforeLocalName = '::';
		assert: ':invalid:prefix:name' prefixBeforeLocalName = ':invalid:prefix'.! !

TestCase subclass: #XMLTokenizerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLTokenizerTest methodsFor: 'source' stamp: 'monty 1/12/2014 23:38'!
addressBookXML
	^ XMLParserTest addressBookXML! !

!XMLTokenizerTest methodsFor: 'source' stamp: 'monty 1/12/2014 23:38'!
addressBookXMLWithDTD
	^ XMLParserTest addressBookXMLWithDTD! !

!XMLTokenizerTest methodsFor: 'tests' stamp: 'monty 1/16/2014 09:08'!
testChangingNormalizedLineEnding
	| xml domParser parser tokenizer |

	xml :=
		'<root>{1}one{2}two{3}three{1}</root>'
			format: (Array with: String lf with: String cr with: String crlf).
	domParser := XMLDOMParser on: xml.

	parser := domParser parser.
	tokenizer := parser tokenizer.
	self assert: tokenizer normalizedLineEndingChar == Character lf.
	
	tokenizer normalizedLineEndingChar: $N.
	self assert: tokenizer normalizedLineEndingChar == $N.

	parser parseDocument.
	self assert: domParser document root contentString = 'NoneNtwoNthreeN'.! !

!XMLTokenizerTest methodsFor: 'tests' stamp: 'monty 4/3/2015 04:37'!
testNextMatchAll
	| xml tokenizer streamReader readLimit |

	xml := '<test>
test
</test>'.
	readLimit := xml size.
	tokenizer :=
		XMLWellFormedParserTokenizer
			driver: nil
			on: xml readStream
			readLimit: readLimit.
	streamReader := tokenizer streamReader.
	self
		deny: (streamReader nextMatchAll: '!!<test>');
		assert: streamReader currentLineNumber = 1;
		assert: streamReader readLimit = readLimit.
	self
		deny: (streamReader nextMatchAll: '<test>!!');
		assert: streamReader currentLineNumber = 1;
		assert: streamReader readLimit = readLimit.
	self
		assert: (streamReader nextMatchAll: '<test>');
		assert: streamReader currentLineNumber = 1;
		assert: streamReader readLimit = (readLimit - '<test>' size).

	tokenizer :=
		XMLWellFormedParserTokenizer
			driver: nil
			on: xml readStream
			readLimit: nil.
	streamReader := tokenizer streamReader.
	self
		deny: (streamReader nextMatchAll: '!!<test>');
		assert: streamReader currentLineNumber = 1;
		assert: streamReader readLimit isNil.
	self
		assert: (streamReader nextMatchAll: '<test>');
		assert: streamReader currentLineNumber = 1;
		assert: streamReader readLimit isNil.! !

!XMLTokenizerTest methodsFor: 'tests' stamp: 'monty 4/3/2015 03:37'!
testSkipSeparators
	| xml tokenizer streamReader readLimit |

	xml := '
	<test/>'.
	readLimit := xml size.
	tokenizer :=
		XMLWellFormedParserTokenizer
			driver: nil
			on: xml readStream
			readLimit: readLimit.
	streamReader := tokenizer streamReader.
	2 timesRepeat: [
		streamReader skipSeparators.
		self
			assert: streamReader currentLineNumber = 2;
			assert: streamReader readLimit = (readLimit - ((xml copyUpTo: $<) size))].

	tokenizer :=
		XMLWellFormedParserTokenizer
			driver: nil
			on: xml readStream
			readLimit: nil.
	streamReader := tokenizer streamReader.
	2 timesRepeat: [
		streamReader skipSeparators.
		self
			assert: streamReader currentLineNumber = 2;
			assert: streamReader readLimit isNil].! !

!XMLTokenizerTest methodsFor: 'tests' stamp: 'monty 10/13/2014 23:51'!
testStreamReadingPortability
	| tokenizer stream |

	tokenizer :=
		XMLWellFormedParserTokenizer
			driver: nil
			on: (stream := XMLExceptionRaisingReadStream on: self addressBookXML).
	self
		shouldnt: [
			[tokenizer streamReader
				peek;
				next]
				doWhileFalse: [tokenizer streamReader atEnd]]
		raise: Error.
	self should: [stream peek] raise: Error.
	self should: [stream next] raise: Error.! !

!XMLTokenizerTest methodsFor: 'tests' stamp: 'monty 10/13/2014 22:06'!
testTokenizerAddressBook
	| tokenizer |

	tokenizer :=
		XMLWellFormedParserTokenizer
			driver: nil
			on: self addressBookXML readStream.
	self
		shouldnt: [[tokenizer streamReader next notNil] whileTrue]
		raise: XMLParserException.! !

!XMLTokenizerTest methodsFor: 'tests' stamp: 'monty 10/13/2014 22:06'!
testTokenizerAddressBookWithDTD
	| tokenizer |

	tokenizer :=
		XMLWellFormedParserTokenizer
			driver: nil
			on: self addressBookXMLWithDTD readStream.
	self
		shouldnt: [[tokenizer streamReader next notNil] whileTrue]
		raise: XMLParserException.! !

!XMLTokenizerTest methodsFor: 'tests' stamp: 'monty 2/10/2014 02:43'!
testTokenizerCharacters
	| tokenizer |
	"This test is actually not that useful. This is not the proper way of using the parser.
	This test is here just for specification purpose"
	"self debug: #testParsingCharacters"

	tokenizer := XMLWellFormedParserTokenizer driver: nil on: self addressBookXML readStream.

	self
		assert: tokenizer streamReader next == $<;
		assert: ('address' allSatisfy: [:each | tokenizer streamReader next == each]);
		assert: tokenizer streamReader peek == $b.

	tokenizer streamReader pushBack: 'test'.
	self
		assert: ('test' allSatisfy: [:each | tokenizer streamReader next == each]);
		assert: tokenizer streamReader peek == $b;
		assert: ('book' allSatisfy: [:each | tokenizer streamReader next == each]).

	tokenizer streamReader
		pushBack: 'book';
		pushBack: 'test'.
	self
		assert: ('test' allSatisfy: [:each | tokenizer streamReader next == each]);
		assert: ('book' allSatisfy: [:each | tokenizer streamReader next == each]).! !

TestCase subclass: #XMLURITest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLURITest class methodsFor: 'private' stamp: 'monty 3/22/2015 03:15'!
generateStandardURICombiningTest
	"self generateStandardURICombiningTest"
	| readStream isFirstTest source |

	readStream := self standardURICombiningTestTemplate readStream.
	isFirstTest := true.
	source :=
		String streamContents: [:writeStream |
			writeStream nextPutAll: 'testStandardURICombining
	| baseURI |

	baseURI := ''', self standardURICombiningTestBaseURI, ''' asXMLURI.
	self'.
			[readStream atEnd]
				whileFalse: [| argument result |
					readStream skipTo: $".
					argument := readStream upTo: $".
					readStream skipTo: $".
					result := readStream upTo: $".
					(argument isEmpty and: [result isEmpty])
						ifFalse: [
							isFirstTest
								ifTrue: [isFirstTest := false]
								ifFalse: [writeStream nextPut: $;].
							writeStream nextPutAll: '
		assert: (baseURI / ''', argument, ''' asXMLURI) = ''', result, ''' asXMLURI']]].

	self
		compile: source
		classified: 'tests'.! !

!XMLURITest class methodsFor: 'private' stamp: 'monty 2/9/2015 07:06'!
standardURICombiningTestBaseURI
	^ 'http://a/b/c/d;p?q'! !

!XMLURITest class methodsFor: 'private' stamp: 'monty 2/9/2015 07:06'!
standardURICombiningTestTemplate
	^ '
      "g:h"           =  "g:h"
      "g"             =  "http://a/b/c/g"
      "./g"           =  "http://a/b/c/g"
      "g/"            =  "http://a/b/c/g/"
      "/g"            =  "http://a/g"
      "//g"           =  "http://g"
      "?y"            =  "http://a/b/c/d;p?y"
      "g?y"           =  "http://a/b/c/g?y"
      "#s"            =  "http://a/b/c/d;p?q#s"
      "g#s"           =  "http://a/b/c/g#s"
      "g?y#s"         =  "http://a/b/c/g?y#s"
      ";x"            =  "http://a/b/c/;x"
      "g;x"           =  "http://a/b/c/g;x"
      "g;x?y#s"       =  "http://a/b/c/g;x?y#s"
      ""              =  "http://a/b/c/d;p?q"
      "."             =  "http://a/b/c/"
      "./"            =  "http://a/b/c/"
      ".."            =  "http://a/b/"
      "../"           =  "http://a/b/"
      "../g"          =  "http://a/b/g"
      "../.."         =  "http://a/"
      "../../"        =  "http://a/"
      "../../g"       =  "http://a/g"

      "../../../g"    =  "http://a/g"
      "../../../../g" =  "http://a/g"


      "/./g"          =  "http://a/g"
      "/../g"         =  "http://a/g"
      "g."            =  "http://a/b/c/g."
      ".g"            =  "http://a/b/c/.g"
      "g.."           =  "http://a/b/c/g.."
      "..g"           =  "http://a/b/c/..g"

      "./../g"        =  "http://a/b/g"
      "./g/."         =  "http://a/b/c/g/"
      "g/./h"         =  "http://a/b/c/g/h"
      "g/../h"        =  "http://a/b/c/h"
      "g;x=1/./y"     =  "http://a/b/c/g;x=1/y"
      "g;x=1/../y"    =  "http://a/b/c/y"

      "g?y/./x"       =  "http://a/b/c/g?y/./x"
      "g?y/../x"      =  "http://a/b/c/g?y/../x"
      "g#s/./x"       =  "http://a/b/c/g#s/./x"
      "g#s/../x"      =  "http://a/b/c/g#s/../x"

      "http:g"        =  "http:g"
'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2014 18:17'!
absolute
	^ '/absolute/path'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2014 18:17'!
absoluteDir
	^ '/absolute/path/'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2014 18:17'!
absoluteDirRelativeCombined
	^ '/absolute/path/relative/path'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2014 18:17'!
absoluteRelativeCombined
	^ '/absolute/relative/path'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2014 18:17'!
domain
	^ 'http://www.example.com'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 10/22/2014 07:44'!
domainWithPort
	^ self domain, ':80'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 2/7/2015 21:58'!
emailURIString
	^ 'mailto:', self userInfo, '@', self host! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/29/2015 16:19'!
escaped
	^ '%20%22%3c%3E%25+'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2014 18:17'!
fileHostURIString
	^ 'file://', self host, self absolute! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2014 18:17'!
fileURIString
	^ 'file://', self absolute! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2014 18:17'!
fragment
	^ '#fragmentID'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2014 18:17'!
fullURIString
	^ self domain, self absolute, self queryString, self fragment! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 10/22/2014 09:31'!
fullURIWithPortString
	^ self domainWithPort, self absolute, self queryString, self fragment! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2014 18:17'!
host
	^ self domain copyAfterLast: $/! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 10/22/2014 07:40'!
port
	^ 80! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2014 18:17'!
queryString
	^ '?name1=value1&name2=value2'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2014 18:17'!
relative
	^ 'relative/path'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 2/9/2015 00:47'!
relativeAbsoluteCombined
	^ 'relative/absolute/path'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2014 18:17'!
scheme
	^ self domain copyUpTo: $:! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2014 18:17'!
schemelessURIString
	^ (self domain copyAfter: $:), self absolute, self queryString, self fragment! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 10/24/2014 06:17'!
schemelessURIWithPortString
	^ (self domainWithPort copyAfter: $:), self absolute, self queryString, self fragment! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 3/22/2015 03:18'!
testCombiningAbsoluteURIs
	| domainURI fullURI fileURI |

	domainURI := self domain asXMLURI.
	fullURI := self fullURIString asXMLURI.
	fileURI := self fileURIString asXMLURI.
	self
		assert: domainURI / self fullURIString = fullURI;
		assert: domainURI / self domain = domainURI;
		assert: domainURI / self fileURIString = fileURI;
		assert: fullURI / self fullURIString = fullURI;
		assert: fullURI / self domain = domainURI;
		assert: fullURI / self fileURIString = fileURI;
		assert: fileURI / self fullURIString = fullURI;
		assert: fileURI / self domain = domainURI;
		assert: fileURI / self fileURIString = fileURI.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 3/22/2015 03:18'!
testCombiningDotPathURIs
	| relativePathURI absolutePathURI fullURI |

	relativePathURI := self relative asXMLURI.
	self
		assert: relativePathURI / '.' = 'relative/' asXMLURI;
		assert: relativePathURI / './.' = 'relative/' asXMLURI;
		assert: relativePathURI / './path' = relativePathURI;
		assert: relativePathURI / ('.' , self absolute) = self relativeAbsoluteCombined asXMLURI.

	absolutePathURI := self absolute asXMLURI.
	self
		assert: absolutePathURI / '.' = '/absolute/' asXMLURI;
		assert: absolutePathURI / './.' = '/absolute/' asXMLURI;
		assert: absolutePathURI / './path' = absolutePathURI;
		assert: absolutePathURI / ('./' , self relative) = self absoluteRelativeCombined asXMLURI.

	fullURI := self fullURIString asXMLURI.
	self
		assert: fullURI / '.' = (self domain , '/absolute/') asXMLURI;
		assert: fullURI / './.' = (self domain , '/absolute/') asXMLURI;
		assert: fullURI / './path' = (self domain , self absolute) asXMLURI;
		assert: fullURI / ('./' , self relative) = (self domain , self absoluteRelativeCombined) asXMLURI.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 3/22/2015 03:19'!
testCombiningDoubleDotPathURIs
	| relativePathURI absolutePathURI fullURI |

	relativePathURI := self relative asXMLURI.
	self
		assert: (relativePathURI / '..') isEmpty;
		assert: (relativePathURI / '../..') isEmpty;
		assert: relativePathURI / ('..' , self absolute) = 'absolute/path' asXMLURI;
		assert: relativePathURI / ('../..' , self absolute) = 'absolute/path' asXMLURI;
		assert: relativePathURI / ('../..' , self absolute , '/..') = 'absolute/' asXMLURI;
		assert: (relativePathURI / ('../..' , self absolute , '/../..')) isEmpty.

	absolutePathURI := self absolute asXMLURI.
	self
		assert: (absolutePathURI / '..') hasRootPath;
		assert: (absolutePathURI / '../..') isEmpty;
		assert: absolutePathURI / ('..' , self absolute) = absolutePathURI;
		assert: absolutePathURI / ('../..' , self absolute) = 'absolute/path' asXMLURI;
		assert: absolutePathURI / ('../..' , self absolute , '/..') = 'absolute/' asXMLURI;
		assert: (absolutePathURI / ('../..' , self absolute , '/../..')) isEmpty.

	fullURI := self fullURIString asXMLURI.
	self
		assert: (fullURI / '..') hasRootPath;
		deny: (fullURI / '../..') hasPath;
		assert: fullURI / ('..' , self absolute) = (self domain , self absolute) asXMLURI;
		assert: fullURI / ('../..' , self absolute) = (self domain , self absolute) asXMLURI;
		assert: fullURI / ('../..' , self absolute , '/..') = (self domain , '/absolute/') asXMLURI;
		assert: fullURI / ('../..' , self absolute , '/../') = (self domain , '/absolute/') asXMLURI.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 3/22/2015 03:19'!
testCombiningRelativeURIs
	| domainURI domainURIWithPort absolutePathURI absoluteDirPathURI |

	domainURI := self domain asXMLURI.
	domainURIWithPort := self domainWithPort asXMLURI.
	absolutePathURI := (self domain , self absolute) asXMLURI.
	absoluteDirPathURI := (self domain , self absoluteDir) asXMLURI.
	self
		assert: domainURI / self relative = (self domain , '/' , self relative) asXMLURI;
		assert: domainURI / self absolute = (self domain , self absolute) asXMLURI;
		assert: domainURI / self absoluteDir = (self domain , self absoluteDir) asXMLURI;
		assert: domainURIWithPort / self relative = (self domainWithPort , '/' , self relative) asXMLURI;
		assert: domainURIWithPort / self absolute = (self domainWithPort , self absolute) asXMLURI;
		assert: domainURIWithPort / self absoluteDir = (self domainWithPort , self absoluteDir) asXMLURI;
		assert: absolutePathURI / self relative = (self domain , self absoluteRelativeCombined) asXMLURI;
		assert: absoluteDirPathURI / self relative = (self domain , self absoluteDirRelativeCombined) asXMLURI;
		assert: absolutePathURI / self queryString = (self domain , self absolute , self queryString) asXMLURI;
		assert: absolutePathURI / self fragment = (self domain , self absolute , self fragment) asXMLURI;
		assert: domainURI / self schemelessURIString = self fullURIString asXMLURI.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 3/22/2015 03:19'!
testConverting
	| fullURI |

	fullURI := XMLURI fromString: self fullURIString.
	self
		assert: self fullURIString asXMLURI = fullURI;
		assert: fullURI asXMLURI == fullURI.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/6/2015 23:07'!
testIsEmpty
	self
		assert: '' asXMLURI isEmpty;
		deny: '/' asXMLURI isEmpty;
		deny: self relative asXMLURI isEmpty;
		deny: self absolute asXMLURI isEmpty;
		deny: self domain asXMLURI isEmpty;
		deny: self queryString asXMLURI isEmpty;
		deny: self fragment asXMLURI isEmpty! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/9/2015 06:45'!
testParsingAbsolutePathURI
	| uri |

	uri := self absolute asXMLURI.
	self
		deny: uri isFileURI;
		assert: uri isRelative;
		assert: uri isLocalURI;
		assert: uri scheme isEmpty;
		assert: uri userInfo isEmpty;
		assert: uri host isEmpty;
		assert: uri port isNil;
		assert: uri path = self absolute;
		assert: uri queryString isEmpty;
		assert: uri fragment isEmpty.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/9/2015 06:45'!
testParsingDomainURI
	| uri |

	uri := self domain asXMLURI.
	self
		deny: uri isFileURI;
		deny: uri isRelative;
		deny: uri isLocalURI;
		assert: uri scheme = self scheme;
		assert: uri userInfo isEmpty;
		assert: uri host = self host;
		assert: uri port isNil;
		assert: uri path isEmpty;
		assert: uri queryString isEmpty;
		assert: uri fragment isEmpty.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/9/2015 06:45'!
testParsingDomainURIWithPort
	| uri |

	uri := self domainWithPort asXMLURI.
	self
		deny: uri isFileURI;
		deny: uri isRelative;
		deny: uri isLocalURI;
		assert: uri scheme = self scheme;
		assert: uri userInfo isEmpty;
		assert: uri host = self host;
		assert: uri port = self port;
		assert: uri path isEmpty;
		assert: uri queryString isEmpty;
		assert: uri fragment isEmpty.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/9/2015 06:46'!
testParsingEmailURI
	| uri |

	uri := self emailURIString asXMLURI.
	self
		deny: uri isFileURI;
		deny: uri isRelative;
		deny: uri isLocalURI;
		assert: uri scheme = 'mailto';
		assert: uri userInfo = self userInfo;
		assert: uri host = self host;
		assert: uri port isNil;
		assert: uri path isEmpty;
		assert: uri queryString isEmpty;
		assert: uri fragment isEmpty.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/9/2015 06:46'!
testParsingFileHostURI
	| uri |

	uri := self fileHostURIString asXMLURI.
	self
		deny: uri isRelative;
		assert: uri isFileURI;
		assert: uri isLocalURI;
		assert: uri scheme = 'file';
		assert: uri userInfo isEmpty;
		assert: uri host = self host;
		assert: uri port isNil;
		assert: uri path = self absolute;
		assert: uri queryString isEmpty;
		assert: uri fragment isEmpty.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/9/2015 06:46'!
testParsingFileURI
	| uri |

	uri := self fileURIString asXMLURI.
	self
		deny: uri isRelative;
		assert: uri isFileURI;
		assert: uri isLocalURI;
		assert: uri scheme = 'file';
		assert: uri userInfo isEmpty;
		assert: uri host isEmpty;
		assert: uri port isNil;
		assert: uri path = self absolute;
		assert: uri queryString isEmpty;
		assert: uri fragment isEmpty.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/9/2015 06:46'!
testParsingFullURI
	| uri |

	uri := self fullURIString asXMLURI.
	self
		deny: uri isFileURI;
		deny: uri isRelative;
		deny: uri isLocalURI;
		assert: uri scheme = self scheme;
		assert: uri userInfo isEmpty;
		assert: uri host = self host;
		assert: uri port isNil;
		assert: uri path = self absolute;
		assert: uri queryString = self queryString allButFirst;
		assert: uri fragment = self fragment allButFirst.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/9/2015 06:46'!
testParsingFullURIWithPort
	| uri |

	uri := self fullURIWithPortString asXMLURI.
	self
		deny: uri isFileURI;
		deny: uri isRelative;
		deny: uri isLocalURI;
		assert: uri scheme = self scheme;
		assert: uri userInfo isEmpty;
		assert: uri host = self host;
		assert: uri port = self port;
		assert: uri path = self absolute;
		assert: uri queryString = self queryString allButFirst;
		assert: uri fragment = self fragment allButFirst.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/9/2015 06:46'!
testParsingRelativePathURI
	| uri |

	uri := self relative asXMLURI.
	self
		deny: uri isFileURI;
		assert: uri isRelative;
		assert: uri isLocalURI;
		assert: uri scheme isEmpty;
		assert: uri userInfo isEmpty;
		assert: uri host isEmpty;
		assert: uri port isNil;
		assert: uri path = self relative;
		assert: uri queryString isEmpty;
		assert: uri fragment isEmpty.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/9/2015 06:46'!
testParsingSchemelessURI
	| uri |

	uri := self schemelessURIString asXMLURI.
	self
		deny: uri isFileURI;
		assert: uri isRelative;
		assert: uri isLocalURI;
		assert: uri scheme isEmpty;
		assert: uri userInfo isEmpty;
		assert: uri host = self host;
		assert: uri port isNil;
		assert: uri path = self absolute;
		assert: uri queryString = self queryString allButFirst;
		assert: uri fragment = self fragment allButFirst.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/9/2015 06:46'!
testParsingSchemelessURIWithPort
	| uri |

	uri := self schemelessURIWithPortString asXMLURI.
	self
		deny: uri isFileURI;
		assert: uri isRelative;
		assert: uri isLocalURI;
		assert: uri scheme isEmpty;
		assert: uri userInfo isEmpty;
		assert: uri host = self host;
		assert: uri port = self port;
		assert: uri path = self absolute;
		assert: uri queryString = self queryString allButFirst;
		assert: uri fragment = self fragment allButFirst.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/21/2014 02:11'!
testPathUnescaping
	| uri |

	uri := (self escaped, self relative, self escaped) asXMLURI.
	self
		assert: uri path = (self escaped, self relative, self escaped);
		assert: uri unescapedPath = (self unescaped, self relative, self unescaped);
		assert: '%' asXMLURI unescapedPath = '%'! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 3/22/2015 03:20'!
testSchemeAndHostCaseSensitivity
	| uri uppercaseURI |

	uri := self fullURIString asXMLURI.
	uppercaseURI := self fullURIString asUppercase asXMLURI.
	self
		assert: uri scheme = uppercaseURI scheme;
		assert: uri host = uppercaseURI host;
		deny: uri path = uppercaseURI path;
		deny: uri queryString = uppercaseURI queryString;
		deny: uri fragment = uppercaseURI fragment.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 3/22/2015 03:15'!
testStandardURICombining
	| baseURI |

	baseURI := 'http://a/b/c/d;p?q' asXMLURI.
	self
		assert: (baseURI / 'g:h' asXMLURI) = 'g:h' asXMLURI;
		assert: (baseURI / 'g' asXMLURI) = 'http://a/b/c/g' asXMLURI;
		assert: (baseURI / './g' asXMLURI) = 'http://a/b/c/g' asXMLURI;
		assert: (baseURI / 'g/' asXMLURI) = 'http://a/b/c/g/' asXMLURI;
		assert: (baseURI / '/g' asXMLURI) = 'http://a/g' asXMLURI;
		assert: (baseURI / '//g' asXMLURI) = 'http://g' asXMLURI;
		assert: (baseURI / '?y' asXMLURI) = 'http://a/b/c/d;p?y' asXMLURI;
		assert: (baseURI / 'g?y' asXMLURI) = 'http://a/b/c/g?y' asXMLURI;
		assert: (baseURI / '#s' asXMLURI) = 'http://a/b/c/d;p?q#s' asXMLURI;
		assert: (baseURI / 'g#s' asXMLURI) = 'http://a/b/c/g#s' asXMLURI;
		assert: (baseURI / 'g?y#s' asXMLURI) = 'http://a/b/c/g?y#s' asXMLURI;
		assert: (baseURI / ';x' asXMLURI) = 'http://a/b/c/;x' asXMLURI;
		assert: (baseURI / 'g;x' asXMLURI) = 'http://a/b/c/g;x' asXMLURI;
		assert: (baseURI / 'g;x?y#s' asXMLURI) = 'http://a/b/c/g;x?y#s' asXMLURI;
		assert: (baseURI / '' asXMLURI) = 'http://a/b/c/d;p?q' asXMLURI;
		assert: (baseURI / '.' asXMLURI) = 'http://a/b/c/' asXMLURI;
		assert: (baseURI / './' asXMLURI) = 'http://a/b/c/' asXMLURI;
		assert: (baseURI / '..' asXMLURI) = 'http://a/b/' asXMLURI;
		assert: (baseURI / '../' asXMLURI) = 'http://a/b/' asXMLURI;
		assert: (baseURI / '../g' asXMLURI) = 'http://a/b/g' asXMLURI;
		assert: (baseURI / '../..' asXMLURI) = 'http://a/' asXMLURI;
		assert: (baseURI / '../../' asXMLURI) = 'http://a/' asXMLURI;
		assert: (baseURI / '../../g' asXMLURI) = 'http://a/g' asXMLURI;
		assert: (baseURI / '../../../g' asXMLURI) = 'http://a/g' asXMLURI;
		assert: (baseURI / '../../../../g' asXMLURI) = 'http://a/g' asXMLURI;
		assert: (baseURI / '/./g' asXMLURI) = 'http://a/g' asXMLURI;
		assert: (baseURI / '/../g' asXMLURI) = 'http://a/g' asXMLURI;
		assert: (baseURI / 'g.' asXMLURI) = 'http://a/b/c/g.' asXMLURI;
		assert: (baseURI / '.g' asXMLURI) = 'http://a/b/c/.g' asXMLURI;
		assert: (baseURI / 'g..' asXMLURI) = 'http://a/b/c/g..' asXMLURI;
		assert: (baseURI / '..g' asXMLURI) = 'http://a/b/c/..g' asXMLURI;
		assert: (baseURI / './../g' asXMLURI) = 'http://a/b/g' asXMLURI;
		assert: (baseURI / './g/.' asXMLURI) = 'http://a/b/c/g/' asXMLURI;
		assert: (baseURI / 'g/./h' asXMLURI) = 'http://a/b/c/g/h' asXMLURI;
		assert: (baseURI / 'g/../h' asXMLURI) = 'http://a/b/c/h' asXMLURI;
		assert: (baseURI / 'g;x=1/./y' asXMLURI) = 'http://a/b/c/g;x=1/y' asXMLURI;
		assert: (baseURI / 'g;x=1/../y' asXMLURI) = 'http://a/b/c/y' asXMLURI;
		assert: (baseURI / 'g?y/./x' asXMLURI) = 'http://a/b/c/g?y/./x' asXMLURI;
		assert: (baseURI / 'g?y/../x' asXMLURI) = 'http://a/b/c/g?y/../x' asXMLURI;
		assert: (baseURI / 'g#s/./x' asXMLURI) = 'http://a/b/c/g#s/./x' asXMLURI;
		assert: (baseURI / 'g#s/../x' asXMLURI) = 'http://a/b/c/g#s/../x' asXMLURI;
		assert: (baseURI / 'http:g' asXMLURI) = 'http:g' asXMLURI! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 3/22/2015 03:20'!
testURIEquality
	| fullURI string emailURI |

	string := self fullURIString.
	fullURI := string asXMLURI.
	self
		assert: fullURI = fullURI;
		assert: fullURI = string asXMLURI;
		deny: fullURI = (string copyReplaceAll: self scheme with: 'new') asXMLURI;
		deny: fullURI = (string copyReplaceAll: '://' with: ':') asXMLURI;
		deny: fullURI = (string copyReplaceAll: self host with: 'new') asXMLURI;
		deny: fullURI = (string copyReplaceAll: self absolute with: 'new') asXMLURI;
		deny: fullURI = (string copyReplaceAll: self queryString with: 'new') asXMLURI;
		deny: fullURI = (string copyReplaceAll: self fragment with: 'new') asXMLURI.

	string := self emailURIString.
	emailURI := string asXMLURI.
	self
		assert: emailURI = emailURI;
		assert: emailURI = string asXMLURI;
		deny: fullURI = (string copyReplaceAll: self userInfo with: 'new') asXMLURI.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 3/22/2015 03:20'!
testURIPrinting
	self
		assert: self fullURIString asXMLURI printString = self fullURIString;
		assert: self fullURIWithPortString asXMLURI printString = self fullURIWithPortString;
		assert: self schemelessURIString asXMLURI printString = self schemelessURIString;
		assert: self domain asXMLURI printString = self domain;
		assert: self domainWithPort asXMLURI printString = self domainWithPort;
		assert: self absolute asXMLURI printString = self absolute;
		assert: self relative asXMLURI printString = self relative;
		assert: self absoluteDir asXMLURI printString = self absoluteDir;
		assert: self fileURIString asXMLURI printString = self fileURIString;
		assert: self fileHostURIString asXMLURI printString = self fileHostURIString;
		assert: self emailURIString asXMLURI printString = self emailURIString;
		assert: '/' asXMLURI printString = '/';
		assert: '' asXMLURI printString isEmpty! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/29/2015 16:20'!
unescaped
	"the + is not an escape in paths, only in query strings"
	^ ' "<>%+'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 2/7/2015 21:55'!
userInfo
	^ 'user.name'! !

Object subclass: #SAXHandlerProxy
	instanceVariableNames: 'saxHandler messageRecorder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!SAXHandlerProxy commentStamp: 'monty 6/18/2015 00:54' prior: 0!
This class wraps a SAXHandler and records handler event messages using a message recorder. Non-handler messages are forwarded to the SAXHandler.!

SAXHandlerProxy subclass: #SAXHandlerPluggableProxy
	instanceVariableNames: 'handlerCallbacks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!SAXHandlerPluggableProxy commentStamp: 'monty 6/18/2015 00:43' prior: 0!
A pluggable version that allows blocks to be used to respond to handlers.!

!SAXHandlerPluggableProxy methodsFor: 'reflective operations' stamp: 'monty 11/26/2014 06:34'!
doesNotUnderstand: aMessage
	| result |

	result := super doesNotUnderstand: aMessage.

	^ (self handlerCallbacks
		at: aMessage selector
		ifAbsent: [^ result]) value: aMessage! !

!SAXHandlerPluggableProxy methodsFor: 'accessing' stamp: 'monty 11/26/2014 06:25'!
handle: aSelector with: aBlock
	self handlerCallbacks
		at: aSelector
		put: aBlock! !

!SAXHandlerPluggableProxy methodsFor: 'accessing' stamp: 'monty 11/26/2014 06:24'!
handlerCallbacks
	^ handlerCallbacks ifNil: [handlerCallbacks := Dictionary new]! !

!SAXHandlerProxy class methodsFor: 'instance creation' stamp: 'monty 11/26/2014 06:28'!
on: aStringOrStream
	^ self saxHandler: (SAXHandler on: aStringOrStream)! !

!SAXHandlerProxy class methodsFor: 'instance creation' stamp: 'monty 12/6/2013 22:23'!
saxHandler: aSaxHandler
	^ self new saxHandler: aSaxHandler! !

!SAXHandlerProxy methodsFor: 'accessing' stamp: 'monty 4/12/2015 08:22'!
allSentMessagesNamed: aName
	^ self messageRecorder messagesSelect: [:each | each selector = aName asSymbol]! !

!SAXHandlerProxy methodsFor: 'accessing' stamp: 'monty 4/12/2015 08:23'!
argumentsSentWith: aSelector
	self messageRecorder messagesDo: [:each |
		each selector = aSelector
			ifTrue: [^ each arguments]].
	^ #().! !

!SAXHandlerProxy methodsFor: 'reflective operations' stamp: 'monty 4/12/2015 08:09'!
doesNotUnderstand: aMessage
	| result |

	(self handlerCategories includes:
		(saxHandler class whichCategoryIncludesSelector: aMessage selector))
		ifTrue: [self messageRecorder recordMessage: aMessage].

	^ (result := aMessage sendTo: saxHandler) == saxHandler
		ifTrue: [self]
		ifFalse: [result].! !

!SAXHandlerProxy methodsFor: 'accessing' stamp: 'monty 4/12/2015 10:23'!
handlerCategories
	^ #(
		#'handling - content'
		#'handling - lexical'
		#'handling - declarations'
	)! !

!SAXHandlerProxy methodsFor: 'accessing' stamp: 'monty 4/12/2015 08:09'!
messageRecorder
	^ messageRecorder ifNil: [messageRecorder := XMLMessageRecorder new]! !

!SAXHandlerProxy methodsFor: 'parsing' stamp: 'monty 12/6/2013 22:38'!
parseDocument
	self parser parseDocument! !

!SAXHandlerProxy methodsFor: 'parsing' stamp: 'monty 12/6/2013 22:37'!
parser
	^ XMLParser
		driver: (self driverClass saxHandler: self)
		on: saxHandler input! !

!SAXHandlerProxy methodsFor: 'accessing' stamp: 'monty 12/6/2013 22:23'!
saxHandler: aSaxHandler
	saxHandler := aSaxHandler! !

!SAXHandlerProxy methodsFor: 'testing' stamp: 'monty 4/13/2015 02:45'!
wasSentSelectors: aSelectorArray
	^ (self messageRecorder messagesCollect: [:each | each selector]) asArray =
		aSelectorArray asArray! !

Object subclass: #XMLExceptionRaisingReadStream
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLExceptionRaisingReadStream commentStamp: 'monty 6/18/2015 00:58' prior: 0!
This is a read stream that raises errors if sent peek or next when atEnd like streams on other platforms . Used to test portability.!

!XMLExceptionRaisingReadStream class methodsFor: 'instance creation' stamp: 'monty 10/13/2014 21:55'!
on: aString
	^ self new stream: aString readStream! !

!XMLExceptionRaisingReadStream methodsFor: 'testing' stamp: 'monty 10/13/2014 21:56'!
atEnd
	^ stream atEnd! !

!XMLExceptionRaisingReadStream methodsFor: 'closing' stamp: 'monty 10/13/2014 22:00'!
close
	stream close! !

!XMLExceptionRaisingReadStream methodsFor: 'testing' stamp: 'monty 5/26/2015 01:46'!
isBinary
	^ false! !

!XMLExceptionRaisingReadStream methodsFor: 'testing' stamp: 'monty 10/13/2014 22:00'!
isStream
	^ true! !

!XMLExceptionRaisingReadStream methodsFor: 'accessing' stamp: 'monty 10/13/2014 21:57'!
next
	stream atEnd
		ifTrue: [Error signal: 'Cannot call next on this stream when atEnd'].
	^ stream next.! !

!XMLExceptionRaisingReadStream methodsFor: 'accessing' stamp: 'monty 10/13/2014 22:01'!
peek
	stream atEnd
		ifTrue: [Error signal: 'Cannot call peek on this stream when atEnd'].
	^ stream peek.! !

!XMLExceptionRaisingReadStream methodsFor: 'accessing' stamp: 'monty 10/13/2014 21:56'!
stream: aStream
	stream := aStream! !

Object subclass: #XMLMessageRecorder
	instanceVariableNames: 'messageQueue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLMessageRecorder commentStamp: 'monty 4/12/2015 08:28' prior: 0!
This class records sent messages in a queue.!

!XMLMessageRecorder methodsFor: 'accessing' stamp: 'monty 4/12/2015 07:56'!
clearMessages
	^ self messageQueue removeAll! !

!XMLMessageRecorder methodsFor: 'testing' stamp: 'monty 4/12/2015 07:56'!
hasMessages
	^ self messageQueue notEmpty! !

!XMLMessageRecorder methodsFor: 'private' stamp: 'monty 4/12/2015 07:53'!
messageQueue
	^ messageQueue ifNil: [messageQueue := OrderedCollection new]! !

!XMLMessageRecorder methodsFor: 'enumerating' stamp: 'monty 4/12/2015 08:24'!
messagesCollect: aBlock
	^ self messageQueue collect: aBlock! !

!XMLMessageRecorder methodsFor: 'enumerating' stamp: 'monty 4/12/2015 08:21'!
messagesDo: aBlock
	self messageQueue do: aBlock! !

!XMLMessageRecorder methodsFor: 'enumerating' stamp: 'monty 4/12/2015 08:22'!
messagesSelect: aBlock
	^ self messageQueue select: aBlock! !

!XMLMessageRecorder methodsFor: 'accessing' stamp: 'monty 4/12/2015 07:56'!
nextMessage
	^ self messageQueue removeFirst! !

!XMLMessageRecorder methodsFor: 'recording' stamp: 'monty 4/12/2015 08:05'!
recordMessage: aMessage
	self messageQueue addLast: aMessage! !

!XMLMessageRecorder methodsFor: 'recording' stamp: 'monty 4/12/2015 08:05'!
recordMessageReceiver: anObject selector: aSelector arguments: anArgumentCollection
	self recordMessage:
		(MessageSend
			receiver: anObject
			selector: aSelector
			arguments: anArgumentCollection)! !

Object subclass: #XMLRecordingListObserver
	instanceVariableNames: 'messageRecorder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLRecordingListObserver commentStamp: 'monty 4/12/2015 08:27' prior: 0!
This observer records notifications using an XMLMessageRecorder.!

XMLRecordingListObserver subclass: #XMLRecordingAttributeListObserver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLRecordingAttributeListObserver commentStamp: 'monty 1/17/2015 11:03' prior: 0!
This observer records notifications from XMLAttributeLists.!

!XMLRecordingAttributeListObserver methodsFor: 'notifying' stamp: 'monty 4/12/2015 08:02'!
addedAttribute: anAttribute
	self messageRecorder
		recordMessageReceiver: self
		selector: #addedAttribute:
		arguments: (Array with: anAttribute)! !

!XMLRecordingAttributeListObserver methodsFor: 'notifying' stamp: 'monty 4/12/2015 08:02'!
addingAttribute: anAttribute
	self messageRecorder
		recordMessageReceiver: self
		selector: #addingAttribute:
		arguments: (Array with: anAttribute)! !

!XMLRecordingAttributeListObserver methodsFor: 'notifying' stamp: 'monty 4/12/2015 08:03'!
removedAttribute: anAttribute
	self messageRecorder
		recordMessageReceiver: self
		selector: #removedAttribute:
		arguments: (Array with: anAttribute)! !

!XMLRecordingListObserver methodsFor: 'notifying' stamp: 'monty 4/12/2015 08:00'!
added: anObject to: aList
	self messageRecorder
		recordMessageReceiver: self
		selector: #added:to:
		arguments: (Array with: anObject with: aList)! !

!XMLRecordingListObserver methodsFor: 'notifying' stamp: 'monty 4/12/2015 08:01'!
adding: anObject to: aList
	self messageRecorder
		recordMessageReceiver: self
		selector: #adding:to:
		arguments: (Array with: anObject with: aList)! !

!XMLRecordingListObserver methodsFor: 'accesing' stamp: 'monty 4/12/2015 07:59'!
clearNotifications
	self messageRecorder clearMessages! !

!XMLRecordingListObserver methodsFor: 'testing' stamp: 'monty 4/12/2015 08:01'!
hasNotifications
	^ self messageRecorder hasMessages! !

!XMLRecordingListObserver methodsFor: 'accesing' stamp: 'monty 4/12/2015 07:59'!
messageRecorder
	^ messageRecorder ifNil: [messageRecorder := XMLMessageRecorder new]! !

!XMLRecordingListObserver methodsFor: 'accesing' stamp: 'monty 4/12/2015 07:59'!
nextNotification
	^ self messageRecorder nextMessage! !

!XMLRecordingListObserver methodsFor: 'notifying' stamp: 'monty 4/12/2015 08:02'!
removed: anObject from: aList
	self messageRecorder
		recordMessageReceiver: self
		selector: #removed:from:
		arguments: (Array with: anObject with: aList)! !

XMLRecordingListObserver subclass: #XMLRecordingNodeListObserver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLRecordingNodeListObserver commentStamp: 'monty 1/17/2015 10:45' prior: 0!
This observer records notifications from XMLNodeLists.!

!XMLRecordingNodeListObserver methodsFor: 'notifying' stamp: 'monty 4/12/2015 08:03'!
addedElement: anElement
	self messageRecorder
		recordMessageReceiver: self
		selector: #addedElement:
		arguments: (Array with: anElement)! !

!XMLRecordingNodeListObserver methodsFor: 'notifying' stamp: 'monty 4/12/2015 08:03'!
addedNode: aNode
	self messageRecorder
		recordMessageReceiver: self
		selector: #addedNode:
		arguments: (Array with: aNode)! !

!XMLRecordingNodeListObserver methodsFor: 'notifying' stamp: 'monty 4/12/2015 08:03'!
addingNode: aNode
	self messageRecorder
		recordMessageReceiver: self
		selector: #addingNode:
		arguments: (Array with: aNode)! !

!XMLRecordingNodeListObserver methodsFor: 'notifying' stamp: 'monty 4/12/2015 08:03'!
removedElement: anElement
	self messageRecorder
		recordMessageReceiver: self
		selector: #removedElement:
		arguments: (Array with: anElement)! !

!XMLRecordingNodeListObserver methodsFor: 'notifying' stamp: 'monty 4/12/2015 08:02'!
removedNode: aNode
	self messageRecorder
		recordMessageReceiver: self
		selector: #removedNode:
		arguments: (Array with: aNode)! !
